******************************************************************************
      subroutine abnset
      implicit none
*sets initial abundances after parameters are entered by reading input
      include "ncell.par"
      include "limelm.par"
      include "itrdim.par"
      include "AbunTablLG.com"
      include "hmi.com"
      include "IonFracs.com"
      include "solar.com"
      include "scalem.com"
      include "deplon.com"
      include "dmetal.com"
      include "h.com"
      include "he.com"
      include "phycon.com"
      include "called.com"
      include "trace.com"
      include "pwind.com"
      include "wind.com"
      include "elmton.com"
      include "ElmntSym.com"
      include "radius.com"
      include "solarm.par"
      include "fluct.com"
      include "IOqq.com"
*
*     local variables
      integer i , nelem
      real fac , tababun
*
*     rescale so that abundances are H=1
      do i=2,limelm
        solar(i) = solar(i) / solar(1)
      end do
      solar(1) = 1.
*
*     set current abundances to "solar" times metals scale factor
*     and grain depletion factor
      solar(2) = solar(2) * depset(2) * scalem(2)
      if( lgDenFluc ) then
*       usual case - either density flucuations or none at all
        fac = 1.
      else
        fac = cfirst * cos( flcPhase ) + csecnd
      endif
*     >>chng 96 july 12, added fac for possible abundance fluctuations
      do i=3,limelm
        solar(i) = solar(i) * ScaleMetals * depset(i) * scalem(i)*fac
      end do
*
*     now fix abundance of any element with element table set
      if( lgAbTaON ) then
        do nelem=2,limelm
          if( lgAbunTabl(nelem) ) then
            solar(nelem) = tababun( radius , depth , nelem )
*            write(6,*) radius,depth , nelem, solar(nelem)
          endif
        end do
      endif
*
      if( lgTalk ) then
        call PrintElem( 'init','  ',0. )
        do i=1,limelm
          if(lgElmtOn(i))  then
            call PrintElem('fill',chElementSym(i),solar(i))
          endif
        end do
        call PrintElem( 'flus','  ',0. )
        write(qq,'('' '')')
      endif
*
*     xIonFracs(nelem,0) contains total abundance of element
      do nelem=1,limelm
        xIonFracs(nelem,0) = solar(nelem) * hden
        if( xIonFracs(nelem,0).le.0. ) then
          write(qq,'('' Abundances must be greater than zero.  '',
     1    ''Check entered abundance for element'',i3,1x,'' = '',a2)')
     2    nelem, chElementSym(nelem)
          stop
        endif
      end do
*
      ahe = solar(2) * hden
      heiii = ahe
      heii = 0.
      hei = 0.
*
*     alith =    solar(3) * hden
*     aberyl =   solar(4) * hden
*     aboron =   solar(5) * hden
*     afluorine =solar(9) * hden
*     ane =      solar(10) * hden
*     ana =      solar(11) * hden
*     amg =      solar(12) * hden
*     aal =      solar(13) * hden
*     asil =     solar(14) * hden
*     aphos =    solar(15) * hden
*     asul =     solar(16) * hden
*     aclor =    solar(17) * hden
*     aargon =   solar(18) * hden
*     apotas =   solar(19) * hden
*     aca =      solar(20) * hden
*     ascand =   solar(21) * hden
*     atitan =   solar(22) * hden
*     avana =    solar(23) * hden
*     achrom =   solar(24) * hden
*     amanga =   solar(25) * hden
*     afe =      solar(26) * hden
*     acobl =    solar(27) * hden
*     ani =      solar(28) * hden
*     acopp =    solar(29) * hden
*     azinc =    solar(30) * hden
*
*     usually computed in PRESUR, but not called before first zone
      agrav = (6.67e-8 * comass) * (solarm / radius ) / radius
*
      if( lgTrace ) then
        write(qq,'('' ABNSET sets following densities; '')')
        write(qq,'(1p,14(1x,a2,e8.2))') 
     1  (chElementSym(nelem), xIonFracs(nelem,0),nelem=1,limelm)
      endif
*
      end
