******************************************************************************
      subroutine alcol
      implicit none
*compute aluminum cooling
      include "nta.par"
      include "ipLnArry.par"
      include "limLevelN.par"
      include "limelm.par"
      include "dcool.com"
      include "PopLevls.com"
      include "embesq.com"
      include "TePowers.com"
      include "TLineEXP.com"
      include "logte.com"
      include "TauDmmy.com"
      include "coolal.com"
      include "IonFracs.com"
*
*     local variables
      real cs , cs2s2p,cs2s3p,pop3,p2
*
*     Al I 3957
      call MakeCS( AlI3957 )
      call level2( AlI3957 )
*
*     Al I 3090
      call MakeCS( AlI3090 )
      call level2( AlI3090 )
*
*     AlII  1670.787
*     >>chng 96 may 09 put back into level 2 for array processor speed up
*     cs from 
*     >>refer Tayal, S.S., Burke, P.G., Kingston, A.E. 1985, JPhB, 18, 4321
*     cs = min( 5.0 , 0.0125 * sqrte*te10*te003 )
*     call PutCS( cs , al1671 )
*     call level2( al1671 )
*
*     Al 2, all data summarized in 
*     >>refer Keenan, F.P., Harra, L.K., Aggarwal, K.M., Feibelman, W.A. 1992,
*     >>refer ApJ, 385, 375
*     doublet at 2660, 2669
      call PutCS( 3.56 , t2670 )
*     C2670 = beseq( 1.67,2.00,6.54, T2670 , 3.67E-3 )  * 7.45E-12
      call beseq( 1.67,2.00,6.54, t2670 , 3.67e-3 )
      em2669 = PopLevels(3) * 3.67e-3 * 7.45E-12
*
*     Aluminum al 3, 1854, 1862 doublet, 3s ^2 S gnd, ^2P^o 1/2 3/5 exc
*     f=0.854 from 
*     >>refer Dufton, P.L., Brown, P.J.F., Lennon, D.J., Lynas-Gray, A.E. 1986,
*     >>refer MNRAS, 222, 713
*     cs from 
*     >>refer Dufton, P.L., & Kingston, A.E. 1987, JPhB, 20, 3899
      cs = 4.407* te10 * te03*te01
      cs = min( 25.0 , cs )
      call PutCS( cs*0.667 , t1855 )
      call PutCS( cs*0.333 , t1863 )
      call PutCS(  1.0 , TauDummy )
      call level3( t1863,TauDummy, t1855)
*
*     Al V 2.905, cs 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = min( 0.524 , 1.113/(te10/te02/te003) )
      call PutCS( cs , Al529 )
      call level2( Al529 )
*
*     Al VI 3.66, 9.12 microns
      cs = min( 5.5 , 639.1 / (sqrte*te03**te003*te001) )
      call PutCS( cs , Al6366 )
      cs = min( 1.10 , 49.37/(sqrte/te10*te02/te001 ) )
      call PutCS( cs , Al6912 )
      cs = min( 2.0 , 319.11/(sqrte*te10/te02/te001 ) )
      call PutCS( cs , TauDummy )
      call level3( Al6366 , Al6912 , TauDummy )
*
*     [Al VI] 2428.4, 2601, 1169.8, 2124.9
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     cs from 
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
*     >>refer As from NIST
      c1170 = pop3(9.,5.,1., 1.044 ,0.145 ,0.463 , 6.63,72.9,7.79 ,
     1 5.92E4 , 6.767E4 , p2 , xIonFracs(13,6) , 0. ) * 72.9 * 1.70E-11
      c2428 = p2 * 6.63 * 8.19e-12
      c2125 = c1170 * (7.79/72.9)*(1169.5/2124.9)
      call coladd( 'Al 6' , 1170 , c1170  )
      call coladd( 'Al 6' , 2428 , c2428  )
      call coladd( 'Al 6' , 2125 , c2125  )
*
*     Al VIII 5.85, 3.72 microns
*     collision strength 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      cs = min(0.39, 0.0459*te20/te003/te003 )
      call PutCS( cs , Al8575 )
      cs = min( 1.062 , 0.0407 * te30/te003/te003 )
      call PutCS( cs , Al8370 )
      cs = min( 0.27, 2.694e-3*te20*te20*te01*te003 )
      call PutCS( cs , TauDummy )
      call level3( Al8575 , Al8370 , TauDummy )
*
*     [Al IX] 2.04 micron, no collision strength, A NIST
      call PutCS( 1. , Al09204 )
      call level2( Al09204 )
*
*     Al 10 639, CS 
*     >>refer Keenan, F.P. Berrington, K.A., Burke, P.G., Dufton, P.L.,
*     >>refer Kingston, A.E. 1986, PhyS 34, 216
*     A is extrapolation along iso seq
      cs = 0.73492 - 0.16964*alogte + 0.0096631*alogte**2
      cs = max( 0.01, cs )
      call PutCS( cs , t639 )
      call level2( t639 )
*
*     Al 11 Li seq 2s2p 556
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 13 , tAl550, tAl48, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , tAl550 )
      call PutCS( cs2s2p*0.5 , tAl568 )
      call PutCS(  1.0 , TauDummy )
      call level3( tAl568,TauDummy, tAl550)
*
      call PutCS( cs2s3p , tAl48 )
      call level2( tAl48 )
*
      end
