****************************************************************
      real function bnfun( n1 , n2 , ip , thresh , ainduc , rcool )
      implicit none
*evaluate photoionization rate for single shell with induced recomb
      integer n1 , n2 , ip
      real thresh , ainduc , rcool
*
      include "ncell.par"
      include "en1ryd.par"
      include "nopsv.par"
      include "corind.com"
      include "fluors.com"
      include "ots.com"
      include "shullc.com"
      include "opsv.com"
      include "rfield.com"
      include "SummdCon.com"
      include "ipSecIon.com"
      include "heat.com"
*     include "phtpiece.com"
      include "IOqq.com"
*
*     local variables
      integer k , i , iup , ilo
      real g , pinduc , phisig , prod , HeatHi , GamHi,emin
*
*     special version of GAMFUN for arbitrary threshold, and induc rec
*     compute ainduc, rate of inducted recombinations, rcool, induc rec cool
      if(n1.ge.nflux . or. n1.ge.n2 ) then
        bnfun = 0.
        secion = 0.
        h = 0.
        secla = 0.
        ainduc = 0.
        rcool = 0.
        return
      endif
*
*     >>chng 96 oct 25, first photo elec energy may have been negative
*     possible for first any point to be below threshold due to
*     finite resolution of continuum mesh
      emin = max( thresh,anu(n1) )
*
      h = 0.
      g = 0.
      pinduc = 0.
      rcool =  0.
      ilo = n1
      iup = min( n2 , nflux )
*
      secion = 0.
      secla = 0.
*     do first point without otscon, which may have diffuse cont
      i = ilo
      k = n1
      phisig = (flux(i)+otslin(i))* OpacStack(i-k+ip)
*     integral part of induced rec rate
      prod = phisig * ContBoltz(i)
      pinduc = pinduc + prod
      g = g + phisig
      h = h + phisig * anu(i)
*     incuded rec cooling
      rcool = rcool + prod*(anu(i)-emin)
*
      do i=k+1,min(iup,ipSecIon-1)
        phisig = SummedCon(i) * OpacStack(i-k+ip)
*       integral part of induced rec rate
        prod = phisig * ContBoltz(i)
        pinduc = pinduc + prod
        g = g + phisig
        h = h + phisig * anu(i)
*       incuded rec cooling
        rcool = rcool + prod*(anu(i)-emin)
      end do
*
*     heating in Rydbergs, no secondary ionization
      h = ( h - g*thresh )
*
*     now do part where secondary ionization is possible
      HeatHi = 0.
      GamHi = 0.
*     make sure we don't count twice when ipSecIon = n1
      ilo = max( n1+1 , ipSecIon )
      do i=ilo,iup
        phisig = SummedCon(i) * OpacStack(i-k+ip)
*       integral part of induced rec rate
        prod = phisig * ContBoltz(i)
        pinduc = pinduc + prod
        GamHi = GamHi + phisig
        HeatHi = HeatHi + phisig * anu(i)
*       incuded rec cooling
        rcool = rcool + prod*(anu(i)-emin)
      end do
*
*     this is total photo rate, low and high energy parts
      bnfun = g + GamHi
*     heating in Rydbergs, uncorrected for secondary ionization
      HeatHi = ( HeatHi - GamHi*thresh )
*
*     this is all the secondary ionization stuff
      h = h + HeatHi * heatef
      secion = HeatHi * efionz
      secla = HeatHi * exctef * 1.3333
*
*     final product is heating in erg
      h = h * en1ryd
*
*     this is an option to turn off induced processes
      if( lgFluor) then
        rcool = rcool * en1ryd
        ainduc = pinduc
      else
*       the "no induced" command was given
        rcool = 0.
        ainduc = 0.
      endif
*
      end
