********************************************************
*>>>>>CDEXTRA.F
********************************************************
      subroutine cdGett( io , lgEOF )
      implicit none
*get input parameters from Cloudy header, used when analyzing stored output
*     parameters are not converted from logs, results of this
*     routine are as they appear on the header
      integer io
      logical lgEOF
*
      include "nlines.par"
      include "sum.com"
      include "sumlab.com"
      include "nsumtt.com"
      include "getpar.com"
      include "getres.com"
      include "cldnEXP.com"
      include "limelm.par"
      include "IonMeans.com"
*
*     local variables
      logical lgEOL , lgMatch , lgDone
      character*4 chKey , chCard*80
      real fread
      integer i , n0 , ierr
*
*     this routine reads the output generated with the 
*     punch results command
*     if parameter was not entered then zero set
*
*     these are the parameters which may be read off the input stream
*     all must be initialized here
*
*     radius
      getradius = 0.
*     table command, possible parameter
      gettab = 0.
*     turbulence command
      gettrb = 0.
*     stop column density command
      gthcol = 0.
*     black body temperature command
      getbbt = 0.
*     ratio command parameter, probably alpha ox
      getaox = 0.
*     the input hydrogen density, from hden command
      gethdn = 0.
*     the input photon flux, from phi(h) command
      getflx = 0.
*     the input ionization parameter, from ionization par command
      getu = 0.
*     the deduced electron scattering optical depth
      gttaue = 0.
*     these are the parameters on the power law command
      getpl(1) = 0.
      getpl(2) = 0.
      getpl(3) = 0.
*     parameters for agn command
      getagn(1) = 0.
      getagn(2) = 0.
*     this will be flag saying if we hit normal end of model
      lgDone = .false.
*
*2    read(io,'(a80)',end=999) chCard
      read(io,'(a80)',iostat=ierr) chCard
      do while( ierr.eq.0 .and. .not.lgDone)
*       change chCard to all caps
        call caps( chCard )
*       this will be the key to search on
        chKey = chCard(1:4)
*>>>>>>>>make sure all zeroed above
        if( chKey.eq.'BLAC' ) then
*         temperature on blackbody line, leave as is
          i = 4
          getbbt = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'AGN ' ) then
*         agn command
          i = 3
          getagn(1) = fread( chCard , i , 76 , lgEOL )
          getagn(2) = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'POWE' ) then
*         power law command
          i = 4
          getpl(1) = fread( chCard , i , 76 , lgEOL )
          getpl(2) = fread( chCard , i , 76 , lgEOL )
          getpl(3) = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'RADI' ) then
*         radius command
          i = 4
          getradius = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'RATI' ) then
*         ratio command
          i = 4
          getaox = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'HDEN' ) then
*         this is an hden command, scan off density
          i = 4
          gethdn = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'STOP' .and.lgMatch('COLU',chCard) ) then
*         this is hydrogen column density
          i = 4
          gthcol = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'TABL' ) then
*         table command
          i = 4
          gettab = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'PHI(' ) then
*         this is a flux command, scan off flux
          i = 4
          getflx = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'IONI' ) then
*         this is a ionization parameter command, scan off U
          i = 4
          getu = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'C*OP' ) then
*         this is a line of deduced optical depths
          i = 4
          gttaue = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'TURB' ) then
*         this is a turbulence
          i = 4
          gettrb = fread( chCard , i , 76 , lgEOL )
*
        else if( chCard(1:20).eq.'BEGIN EMISSION LINES' ) then
          read(io,'(6(1x,a4,i6,1p,e10.3))',iostat=ierr) (chALab(i) ,
     1    lin(i) , sumlin(i),i=1,6)
          n0 = 6
          do while(chALab(n0-5).ne.'   '.and. ierr.eq.0 )
             read(io,'(6(1x,a4,i6,1p,e10.3))',iostat=ierr) (chALab(i) ,
     1       lin(i) , sumlin(i),i=1+n0,6+n0)
             n0 = n0 + 6
          end do
          nsumtt = n0 - 6
       else if( chCard(1:20).eq.'BEGIN COLUMN DENSITI' ) then
*         real in all column densities
*         make sure this is kept parallel with CDCOLM, which uses it
*         do nelem=1,limelm
*     >>chng 97 mar 20, get whole thing
            read(io,'(4x,1p,12e10.3)') xIonMeans
*    1      (xIonMeans(nelem,i,1),i=1,nelem+1)
*         end do
*
*       following is normal way to exit
        else if( chCard(1:14) .eq. 'END OF RESULTS' ) then
          lgDone = .true.
        endif
*
        read(io,'(a80)',iostat=ierr) chCard
      end do
*
*999  continue
      if( lgDone ) then
        lgEOF = .false.
      else
        lgEOF = .true.
      endif
*
      end
