******************************************************************************
      subroutine ChkRate( nelem , dDestRate , istage )
      implicit none
*called by nextdr to check how rates of destruction of various species changes
      integer nelem, istage  
      real dDestRate
*
      include "itrdim.par"
      include "limelm.par"
      include "ZoneCnt.com"
      include "IonFracs.com"
      include "IOqq.com"
      include "DestCrt.com"
      include "elmton.com"
*
*     local variables
      integer i
      real OldDest(limelm,limelm) , average , dDest
      save OldDest
*
      if( .not.lgElmtOn(nelem) ) then
        dDestRate = 1e-3
        return
      endif
*
*     write(90,'(i3,1x,1p,2e10.2)')
*    1 (i,destroy(i,i),create(i,i),i=1,limelm)
      dDestRate = 0.
      if( nzone.le.1 ) then
        do i=1,nelem
          OldDest(nelem,i) = destroy(nelem,i)
        end do
      else if( xIonFracs(nelem,1)/xIonFracs(nelem,0).lt.0.9 ) then
*       do not use this method if everything is atomic
        do i=1,nelem-1
*         last check below, .5 chosen so that do not key off
*         predominantly neutral species where self-opacity
*         could cause oscillations
          if( xIonFracs(nelem,i)/xIonFracs(nelem,0).gt.0.01.and.
     1      xIonFracs(nelem,i)/xIonFracs(nelem,0).lt.0.9 .and.
     2      xIonFracs(nelem,i+1)/xIonFracs(nelem,0).gt..05 .and.
     3      OldDest(nelem,i).gt.0. ) then
*           last check on old dest in case just lowered ionization
*           stage, so no history
*begin sanity check
            if( destroy(nelem,i).le.0. ) then
              write(qq,'('' ChkRate gets insane destruction rate for ''
     1        ''ion'',2i4,1p,e10.2)') nelem,i,destroy(nelem,i)
              stop
            endif
*end sanity check
*           do not consider unless of middling ionization, and
*           rate is going down (to prevent dr osciallating)
*           no absolute value in following since do not want to
*           consider cases where ionization rate increases
            average = (OldDest(nelem,i) + destroy(nelem,i))*0.5
            dDest = (OldDest(nelem,i) - real(destroy(nelem,i)))/ average
*           ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ term + if rate going down
            if( dDestRate.lt.dDest ) then
              dDestRate = dDest
              istage = i
            endif
*           dDestRate = max(dDestRate,
*    1      (OldDest(nelem,i) - real(destroy(nelem,i)))/ average)
*           ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ term + if rate going down
          endif
          OldDest(nelem,i) = destroy(nelem,i)
        end do
      endif
*     write(nelem,'(1p,10e10.2)') (destroy(nelem,i),i=1,5)
*
      end
