******************************************************************************
      subroutine chromi
      implicit none
*do ionization balance for chromium
      include "limelm.par"
      include "elmton.com"
      include "TePowers.com"
      include "timed.com"
      include "h.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (nelem=24)
      parameter (ndim=25)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) 
*     REAL fyield(NELEM) , grdeff(NELEM)
*
*     chromium nelem=24
*     based on iron
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.26E-10,4.97E-11,1.49E-10,3.90E-11,1.66E-11,7.16E-12,
     1 3.00E-12,1.02E-12,2.54E-12,1.70E-12,1.11E-12,6.42E-13,3.59E-13,
     2 9.30E-14,1.62E-14,5.97E-14,8.44E-14,5.92E-14,4.72E-14,3.79E-14,
     3 2.60E-14,1.61E-14,1.16E-14,5.39E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /9.13E4,1.88E5,3.56E5,6.36E5,8.70E5,1.15E6,1.45E6,1.75E6,
     2 2.73E6,3.04E6,3.37E6,3.84E6,4.19E6,4.55E6,5.30E6,5.68E6,
     3 1.47E7,1.58E7,1.69E7,1.84E7,1.96E7,2.09E7,2.26E7,2.35E7/
*
*     DATA FYIELD/2*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47,2*.48,.49, 3*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/nelem*0.2/
*
*     Fe rates from Woods et al. Ap.J. 249, 399.
*     rec from +23, 24 25 from Arnauld et al 85
      data rec,pl
     1/ 5.2E-10 , 2.40E-9 , 3.20E-9 , 4.17E-9 , 9.44E-9 , 2.14E-8
     2, 4.48E-8 , 8.75E-8 , 1.41E-7 , 2.26E-7 , 2.73E-7 , 3.56E-7
     3, 4.42E-7 , 5.52E-7 , 7.00E-7 , 8.59E-7 , 8.55E-7 , 8.93E-7
     4, 9.64E-7 , 1.06E-6 , 1.19E-6 , 1.22E-6 , 2.94E-6 ,
     1  -0.891  , -0.843  , -0.746  , -0.682  , -0.699  , -0.728
     2, -0.759  , -0.790  , -0.810  , -0.829  , -0.828  , -0.834
     3, -0.836  , -0.840  , -0.846  , -0.850  , -0.836  , -0.824
     4, -0.816  , -0.811  , -0.808  , -0.800  , -0.852  /
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.28e-10 , -0.686 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.58E-3  , 8.38E-3  , 1.54E-2, 3.75E-2, 0.117   , 0.254
     2, 0.291   , 0.150   , 0.140   , 0.100   , 0.200   , 0.240
     3, 0.260   , 0.190   , 0.120   , 0.350   , 0.066   , 0.10
     4, 0.13    , 0.23    , 0.14    , 0.11    , 0.041  
     5, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/ .456    , .323    , .310    , .411    , .359    , .0975
     1, .229    , 4.20    , 3.30    , 5.30    , 1.50    , 0.700
     1, .600    , .5      , 1.      , 0.      , 7.8     , 6.3 
     1, 5.5     , 3.6     , 4.9     , 1.6     , 4.2   
     1, 0./
      data (dite(i,1),i=1,ndim-1)
     1/ 6.00E4  , 1.94E5  , 3.31E5  , 4.32E5  , 6.28E5  , 7.50E5
     2, 7.73E5  , 2.62E5  , 2.50E5  , 2.57E5  , 2.84E5  , 8.69E5
     3, 4.21E5  , 4.57E5  , 2.85E5  , 8.18E5  , 1.51E6  , 1.30E6
     4, 1.19E6  , 1.09E6  , 9.62E5  , 7.23E5  , 4.23E5
     5, 0./
      data (dite(i,2),i=1,ndim-1)
     1/8.97E4   , 1.71E5  , 2.73E5  , 3.49E5  , 5.29E5  , 4.69E5
     2,6.54E5   , 1.32E6  , 1.33E6  , 1.41E6  , 1.52E6  , 1.51E6
     3,1.82E6   , 1.84E6  , 2.31E6  , 0.      , 9.98E6  , 9.98E6
     4,1.00E7   , 1.10E7  , 8.34E6  , 1.01E7  , 1.07E7
     5 , 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4  
     5, 1E20    /
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
*
      IF( .NOT.lgElmtOn(nelem) ) THEN
        RETURN
      ENDIF
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
