******************************************************************************
      subroutine clcol
      implicit none
*compute chlorine cooling
      include "nta.par"
      include "limelm.par"
      include "dcool.com"
      include "TePowers.com"
      include "coolcl.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "logte.com"
      include "TauDmmy.com"
      include "TLineEXP.com"
      include "IonFracs.com"
*
*     local variables
      real gcl3(5) , p(5) , excl3(4)
      real a21,a31,a32,p3,p2,pop3,cs12,cs13,cs14,a41,cs15,a51,
     1 cs23,cs24,a42,cs25,a52,cs34,a43,cs35,a53,cs45
      real a54,pop2 , cs
      data gcl3/4.,4.,6.,2.,4./ , excl3/18053.,66.,11693.,95./
*
*     cooling due to clorine lines
*
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      a21 = 0.133
      a31 = 1.33
      a32 = 2.06
      p3 = pop3( 9.,5.,1. , 3.86,0.456,1.15,a21,a31,a32,
     1 1.576e4,23344.,p2,xIonFracs(17,2),0.)
*     [Cl II] 8581, 9127 doublet
      c8579 = p2 * a21 * 2.32e-12
      call coladd( 'Cl 2' , 8579 , c8579  )
*     [Cl II] 6164 auroral line
      c6164 = p3 * a32 * 3.23e-12
      call coladd( 'Cl 2' , 6164 , c6164  )
*     [Cl II] 3679
      c3679 = p3 * a31 * 5.41e-12
      call coladd( 'Cl 2' , 3679 , c3679  )
*
*     [SII] - like doublet, vac lam=5519, 5539
*     all data from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
      cs12 = 1.26
      a21 = 4.83e-3
*
      cs13 = 1.88
      a31 = 7.04e-4
*
      cs14 = 0.627
      a41 =  0.305
*
      cs15 = 1.26
      a51 = 0.754
*
      cs23 = 3.19
      a32 = 3.22e-6
*
      cs24 = 1.24
      a42 = 0.303
*
      cs25 = 1.91
      a52 = 0.323
*
      cs34 = 1.38
      a43 = 0.100
*
      cs35 = 3.33
      a53 = 0.316
*
      cs45 = 1.34
      a54 = 7.65e-6
*
      call fivel(gcl3, excl3 , cs12 , cs13 , cs14 , cs15 , cs23 ,
     1 cs24 , cs25 , cs34 , cs35 , cs45 , a21,a31,a41,a51,a32,a42,a52,
     2 a43, a53, a54, p , xIonFracs(17,3) )
*
      Cl5539 = p(2)*a21 *3.59e-12
      Cl5519 = p(3)*a31 *3.61e-12
      Cl3354 = p(4)*a41 *5.93e-12
      Cl3344 = p(5)*a51 *5.95e-12
      Cl8504 = p(4)*a42 *2.34e-12
      Cl8436 = p(5)*a42 *2.36e-12
      Cl8552 = p(4)*a43 *2.33e-12
      Cl8483 = p(5)*a53 *2.35e-12
*
*     following are whole multiplets
      c5525 = Cl5539 + Cl5519
      c3350 = Cl3354 + Cl3344
      c8494 = Cl8504+Cl8436+Cl8552+Cl8483
      dCooldT = dCooldT + c5525 * (2.14e4*tsq1 - halfte)
      call coladd( 'Cl 3' , 5525 , c5525  )
      call coladd( 'Cl 3' , 3354 , c3350  )
      call coladd( 'Cl 3' , 8494 , c8494  )
*
*     [Cl III] IR lines
*     As from 
*     >>refer Mendoza, C., & Zeippen, C.J. 1983, MNRAS, 202, 981
*     cs 
*     >>refer Krueger, T.K., & Czyzak, S.J. 1970, Pro Roy Soc Lond, 318, 531
      call PutCS( 2.17 , fsCl214 )
      call PutCS( 0.93 , fsCl233 )
      call PutCS( 1.00 , TauDummy )
*     level3(  t10,t21,t20)
      call level3(fsCl214,fsCl233,TauDummy)
*
*     [CL IV], like [OIII]
*     cs from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      a21 = 0.251
      cs12 = 6.437
      a32 = 2.80
*>>>chng 98 dec 25, had been cs32
      cs23 = min(2.1, 0.0450 * te30*te03*te03)
      a31 = 2.50
*>>>chng 98 dec 25, had been cs31
      cs13 = 1.922
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      p3 = pop3( 9.,5.,1., cs12,cs13,cs23, a21,a31,a32,
     1 2.24e4 , 3.11e4 , pop2 ,xIonFracs(17,3),0.)
*     whole 2-1 transition
      c8047 = pop2 * a21 * 2.48e-12
      call coladd( 'Cl 4' , 8047 , c8047  )
      dCooldT = dCooldT + c8047 * (2.24e4*tsq1 - halfte)
*     3-1 transition
      c3119 = p3 * a31 * 6.38e-12
      call coladd( 'Cl 4' , 3119 , c3119  )
*     3-2 transition
      c5324 = p3 * a32 * 3.74e-12
      call coladd( 'Cl 4' , 5324 , c5324  )
*
*     [Cl IV] fine structure lines, 20.354, 11.741 microns
      cs = max(1.6,min(2.7,6.637/(te10*te03*te01) ) )
      call PutCS( cs, Cl04203 )
      cs = min( 8.0, 15.65/te10 )
      call PutCS( cs, Cl04117 )
      cs = min( 2.0, 5.805/(te10*te03) ) 
      call PutCS( cs, TauDummy )
*     level3(  t10,t21,t20)
      call level3(Cl04203,Cl04117,TauDummy)
*
*     [Cl IX] 7335 A, 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.28 , Cl973 )
      call level2( Cl973 )
*
*     [Cl X] 3.05m, 9223A
      cs = max(0.096 , min(0.187,6.686e-3*te30/te001 ) )
      call PutCS( cs , Cl1030 )
      cs = max(0.229 , min(0.568,9.432e-3*te30*te03*te03/te003/te001 ) )
      call PutCS( cs , Cl1092 )
      cs = max(0.048 , min(0.148,7.088e-4*sqrte/te03/te003/te003) )
      call PutCS( cs , TauDummy )
      call level3( Cl1092 , Cl1030 , TauDummy )
*
      end
