******************************************************************************
      subroutine clrine
      implicit none
*ionization balance for chlorine
      include "limelm.par"
      include "elmton.com"
      include "h.com"
      include "TePowers.com"
      include "timed.com"
      include "chargt.com"
      include "phycon.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=18)
      parameter (nelem=17)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) 
*     REAL GRDEFF(17)  , yYIELD(15) , yYIELDL(7)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/17*0.2/ , yYIELD/15*0./ , yYIELDL/7*0./
*
*     chlorine nelem=17
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
*     these are for argon, but no better can be done today
      data (cion(i,1),i=1,ndim-1)
     1 /1.20E-10,3.50E-11,3.80E-11,6.47E-12,1.72E-12,
     1 2.20E-12,6.95E-13,7.57E-13,4.75E-13,3.45E-13,2.48E-13,1.57E-13,
     2 9.10E-14,6.05E-14,2.62E-14,2.60E-15,1.13E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /1.83E5,3.21E5,4.75E5,6.94E5,8.70E5,1.06E6,1.44E6,1.66E6,4.90E6,
     2 5.56E6,6.25E6,7.17E6,7.96E6,8.77E6,9.92E6,1.07E7,4.78E7/
*
*     fits to Aldrovandi and Pequignot Rev Bras Fisica 4, 491
      data rec / 4.81e-10, 1.08e-09, 2.39e-09, 4.33e-09, 6.59e-09,
     1 1.04E-08, 1.63E-08, 1.82E-08, 2.27E-08, 2.67E-08, 3.17E-08,
     2 3.73E-08, 4.42E-08, 5.24E-08, 5.95E-08, 6.43E-08/
      data pl / -0.702, -0.697, -0.678, -0.669, -0.659,
     1 -0.681, -0.711, -0.670, -0.668, -0.646, -0.640,
     2 -0.629, -0.631, -0.647, -0.641, -0.616/
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1 / 5.5E-5, 1.0E-2,1.1E-2, 1.0E-2, 5.0E-2, 3.2E-2,
     1 3.4E-2, 1.6E-2, 2.4E-2, 4.0E-2, 4.0E-2, 3.8E-2, 6.8E-2, 2.6E-2,
     2 4.6E-1, 11.,0./
      data (dite(i,1),i=1,ndim-1)
     1 /1.3E5, 1.4E5, 1.4E5, 1.4E5, 2.0E5, 1.8E5, 2.3E5,
     1 7.2E5, 6.4E5, 6.0E5, 4.9E5, 4.6E5, 5.3E5, 3.2E5, 2.6E7, 2.8E7,0./
      data ditcrt
     3/3.0E4  , 2.5E4  , 2.5E4  , 1.8E4  , 1.8E4  , 2.2E4
     3,5.0E5  , 1.6E5  , 1.5E5  , 1.5E5  , 1.3E5  , 1.3E5  , 1.1E5
     3,7.6E4  , 6.5E6  , 1.4E7  , 1E20  /
      data (dicoef(i,2),i=1,ndim-1)/nelem*0./
      data (dite(i,2),i=1,ndim-1)/nelem*0./
*
      data aa/17*0./,bb/17*0./,cc/17*0./,dd/17*0./,ff/17*0./
*
*     clorine, atomic number 17
      IF( .NOT.lgElmtOn(17) ) THEN
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     charge transfer, rate from Pradhan and Dalarno Phys Rev A 49, 960 1994
*     Cl+ + H0 => H+ + Clo,
*     R = 6.85E-13 *TE70*TE10/TE01*SEXP(6920./TE)
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(1,2) = CTHeavy(1,2) + HI*R
*     R = 1.45E-12 *TE70*TE03*SEXP(232./TE)
*     CTHeavy(1,1) = CTHeavy(1,1) + HII*R
*     Cl+2 + Ho => Cl+1 + H+
*     CTHeavy(2,2) = CTHeavy(2,2) + HI*1.E-14
*     Cl+3 + Ho => Cl+2 + H+
*     CTHeavy(3,2) = CTHeavy(3,2) + HI*1.5E-9
*
      if( itime .eq. -1 ) then
        call theavy( nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
