*****************************************
      real function conpmp( tarray )
      implicit none
*local continuum pumping rate radiative transfer for all lines
      include "nta.par"
      real tarray(nta)
*
      include "ipLnArry.par"
      include "pmpdmp.com"
      include "pmptau.com"
      include "fluors.com"
      include "dRdVeff.com"
      external opfun
*
*     local variables
      real break , y1,y2 , tau
      parameter (break=3.)
      real fitted,t , a0
*
*     fit to results for tau less than 10
      fitted(t) = (0.98925439 + 0.084594094 *t) /
     1  (1.+t*(0.64794212+t*0.44743976))
*
      if( .not. lgFluor ) then
*       option to turn of continuum pumping with no fluorescense
        conpmp = 0.
      else
*       tau used will be optical depth in center of next zone
*     >>chng 96 july 6, had been ipLnTauIn, did not work when sphere static set
        tau = tarray(ipLnTauCon) + tarray(ipLnDTau)*dRNeff
*       compute pumping probability
        if( tau.le.10. ) then
*         for tau<10 a does not matter, and one fit for all
          conpmp = fitted(tau)
        else if( tau.gt. 1e6 ) then
*         this far in winds line opacity well below electron scattering
*         so ignore for this problem
          conpmp = 0.
        else
*         following two are passed on to later subs
          if( tarray(ipLnRedis).gt.0. ) then
            pmpdmp = tarray(ipLnDamp)
          else
            pmpdmp = 0.
          endif
          pmptau = tau
          a0 = 0.886227 * (1. + pmpdmp)
          call qg32 (0., break, opfun, y1)
          call qg32 (break, 100., opfun, y2)
          conpmp = (y1+y2)/a0
        endif
      endif
*
*     EscProb is escape probability, will not allow conpmp to be greater than it
*     on second iteration with thick lines, pump prob=1 and esc=0.5
*     conpmp = min( conpmp , tarray(ipLnEscP) )
*
      end
