******************************************************************************
      subroutine constn( chCard )
      implicit none
*parse parameters from the 'constant ...' command
      character chCard*80
*
      include "limpar.par"
      include "limext.par"
      include "ncell.par"
      include "tseton.com"
      include "forcte.com"
      include "cpres.com"
      include "prspow.com"
      include "phycon.com"
      include "prad.com"
      include "conprs.com"
      include "nvary.com"
      include "vparm.com"
      include "vformt.com"
      include "nvfpnt.com"
      include "varon.com"
      include "ninput.com"
      include "IOqq.com"
*
      logical lgEOL , lgMatch
      real fread
      integer i
*
      if( lgMatch( 'TEMP', chCard ) ) then
*       force a constant temperature model
        lgTSetOn = .true.
        i = 5
        ForceTemp = fread( chCard , i , 76 , lgEOL )
        if(.not.lgMatch( 'LINE' , chCard ) ) then
          if( ForceTemp.le.10. ) ForceTemp = 10. ** ForceTemp
        endif
        if( lgEOL ) then
          write(qq,'('' There should be a number here, sorry.'')')
          stop
        endif
        if( ForceTemp.lt.3. ) then
          write(qq,'('' TE<3K, reset to 3K.'')')
          ForceTemp = 3.
        endif
        te = ForceTemp
*       vary option
        if( lgVarOn ) then
           nparm = nparm + 1
*          no luminosity options on vary
           nvarxt(nparm) = 1
           chVarFmt(nparm) = '(''CONStant TEMP'',F15.5)'
*          pointer to where to write
           nvfpnt(nparm) = nRead
*          log of temp will be pointer
           vparm(nparm,1) = log10( te )
           vincr(nparm) = 0.1
        endif
*
*     constant density
      else if( lgMatch( 'DENS',chCard) ) then  
        chCPres = 'CDEN'
*       turn off radiation pressure
        lgRadPresON = .false.
*
      else if( lgMatch('PRES',chCard) ) then
*       constant pressure 
        chCPres = 'CPRE'
        if( lgMatch(' GAS',chCard) ) then
*          constant gas pressure (no radiation)
*          turn off radiation pressure
           lgRadPresON = .false.
*          turn off incident continuum
           lgConPres = .false.
*          optional second number is power law index
           i = 4
           prspow = fread( chCard , i , 76 , lgEOL )
        else
*          constant total pressure, gas+rad+incident continuum
*          turn on radiation pressure
           lgRadPresON = .true.
*          option to turn off continuum pressure
           if( lgMatch('O CO', chCard ) ) then
             lgConPres = .false.
           else
              lgConPres = .true.
           endif
*          no power law option for constant total pressure
           prspow = 0.
        endif
*
      else
*       no keys were recognized
        write(qq,'('' The keyword should be TEMPerature, DENSity, GAS''
     1  ,'' or PRESsure, sorry.'')')
        stop
      endif
*
      end
