******************************************************************************
      subroutine ContRate( freqm, opacm )
      implicit none
*called by nextdr to find energy of maximum continuum-gas interaction
      real freqm , opacm
      include "ncell.par"
      include "nhlvl.par"
      include "limelm.par"
      include "ndust.par"
      include "nh.com"
      include "opac.com"
      include "ots.com"
      include "widflx.com"
      include "rfield.com"
      include "Heavy.com"
      include "dstop.com"
      include "phycon.com"
      include "ffheat.com"
      include "tff.com"
      include "heat.com"
      include "IOqq.com"
*
*     local variables
      real xMaxH , FreqH , OpacH , xMaxSub , FreqSub , OpacSub
*    1 xMaxC , FreqC , OpacC
      integer i , iplow
*
*     in all following changed from anu2 to anu  july 25 95
*
*     find maximum continuum interaction rate
      xMaxSub = 0.
*     do up to carbon photo edge
      do i=2,ipHeavy(6,1)-1
*       this does not have grain opacity since grains totally passive
*       at energies below CI edge
        if( anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden).gt.xMaxSub
     1    ) then
          xMaxSub = anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden)
          FreqSub = anu(i)
          OpacSub = opac(i)-dstab(i)*hden
        endif
      end do
*
*     not every continuum extends beyond C edge-this whole loop can add to zero
*     use total opacity here
*     test is to put in fir continuum if free free heating is important
      if( FreeFreeHeat/htot.gt.0.05 ) then
*       this is pointer to energy where cloud free free optical depth is unity
        iplow = ntff
      else
        iplow = ipHeavy(6,1)
      endif
      do i=iplow,min(nflux,ipHn(1)-1)
        if( anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden).gt.xMaxSub)
     1    then
          xMaxSub = anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden)
          FreqSub = anu(i)
          OpacSub = opac(i)-dstab(i)*hden
        endif
      end do
*
*     not every continuum extends beyond 1 Ryd-this whole loop can add to zero
      xMaxH = 0.
      OpacH = 0.
      FreqH = 0.
      do i=ipHn(1),nflux
        if( anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden).gt.xMaxH)
     1    then
*         xMaxH = anu(i)*flux(i)/widflx(i)*opac(i)
          xMaxH = anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden)
          FreqH = anu(i)
          OpacH = opac(i)-dstab(i)*hden
        endif
      end do
*
*     use lyman continuum if its opacity is larger than non-h ion
*666  write(11,'(1p,3e10.2)') freqh,opach,xmaxh,
*    1 freqsub,opacsub,xmaxsub
      if( xMaxSub.lt.1e-30 ) then
*       this happens for laser source - use Lyman continuum
        opacm = OpacH
        freqm = FreqH 
      else if( OpacH.gt.OpacSub .and. xMaxH/xMaxSub.gt.1e-10 ) then
*       use Lyman continuum
        opacm = OpacH
        freqm = FreqH 
      else
        opacm = OpacSub
        freqm = FreqSub
      endif
*
      if( xMaxH.gt.xMaxSub ) then
        opacm = OpacH
        freqm = FreqH 
      else
        opacm = OpacSub
        freqm = FreqSub
      endif
*
*begin sanity check
      if( opacm.le.0. .or. freqm.le.0. ) then
        write(qq,'('' ContRate found non positive interaction, or '',
     1  ''energy.'')')
        write(qq,'('' This is impossible.'')')
        call ShowMe
        stop
      endif
*end sanity check
*
      end
