****************************************************************
      subroutine ConvIoniz
      implicit none
*called by ionte and cholup, it calls ionize until converged
      include "nhlvl.par"
      include "iondun.com"
      include "tcool.com"
      include "heat.com"
      include "shullc.com"
      include "newion.com"
      include "ntry.com"
      include "TrConvg.com"
      include "phlevl.com"
      include "InCvgRsn.com"
      include "DoPhoto.com"
      include "phycon.com"
      include "LevTrace.com"
      include "search.com"
      include "IOqq.com"
*
*     local variables
      integer loopi , LoopMax
      real dc
      parameter (LoopMax=10)
*
*     this routine is called by ionte, it calls ionize
*     until it converges
*
      loopi = 0
      lgNewIon = .true.
      lgIonDone = .false.
      chInCvgRsn = ' NONE!!!!!'
*     this is ionization convergence loop
*     keep calling ionize until lgIonDone is true
      do while( .not.lgIonDone .and. loopi.lt.LoopMax )
        if( lgTrConvg .and. nLevTrace.lt.2 ) then
*         cooling has not been evaluated yet
          write(qq,'(''   ConvIoniz ionization loop'',I4,'' Htot:'',
     1    1p,e9.2,'' lgDoPhoto='',l2,'' eden='',e9.2)')
     2    loopi, htot , lgDoPhoto , eden
        endif
        lgIonDone = .true.
        ntry = ntry + 1
        call ionize
*     >>chng 97 mar 27, add following call to coolr
*       reevaluate cooling when far from solution, since some coolants
*       can be powerful heating agents
        if( lgSearch ) call coolr( ctot, dc)
        if( lgTrConvg .and. nLevTrace.lt.2 ) then
          if( lgIonDone ) then
            write(qq,'(''     ConvIoniz ionization converged, heat='',
     1      1p,e9.2,'' Cool='',e9.2)')htot,ctot
          else
            write(qq,'(''     ConvIoniz ionization not converged:''
     1      ,a10)') chInCvgRsn
          endif
        endif
        loopi = loopi + 1
      end do
*
      end
