******************************************************************************
      subroutine coolr(tot,dc)
      implicit none
*main routine to call others, to evaluate total cooling
      real tot , dc
*
*     returns tot, the total cooling,
*     and dc, the derivative of the cooling
*
      include "ndfst.par"
      include "nhlvl.par"
      include "nwindline.par"
      include "ipLnArry.par"
      include "nta.par"
      include "en1ryd.par"
      include "itrdim.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "limelm.par"
      include "te1ryd.par"
      include "bltzman.par"
      include "tff.com"
      include "wind.com"
      include "pwind.com"
      include "coolng.com"
      include "cmeion.com"
      include "tseton.com"
      include "radius.com"
      include "dclgas.com"
      include "ffsum.com"
      include "hcolrt.com"
      include "htau.com"
      include "trace.com"
      include "rh2dis.com"
      include "cnegtk.com"
      include "freeon.com"
      include "colneg.com"
      include "called.com"
      include "NumDeriv.com"
      include "nomole.com"
      include "DoppVel.com"
      include "cionhe.com"
      include "hetrpEXP.com"
      include "prad.com"
      include "densty.com"
      include "hlvcol.com"
      include "teinv.com"
      include "phlevl.com"
      include "comptn.com"
      include "logte.com"
      include "he3tuEXP.com"
      include "hmi.com"
      include "TePowers.com"
      include "he.com"
      include "cyclot.com"
      include "hem.com"
      include "h.com"
      include "phycon.com"
      include "hex.com"
      include "he1ex.com"
      include "he2ex.com"
      include "ZoneCnt.com"
      include "hmihet.com"
      include "he2cin.com"
      include "heat.com"
      include "dndt.com"
      include "covib.com"
      include "cextra.com"
      include "heating.com"
      include "h2pcng.com"
      include "dcool.com"
      include "hstat.com"
      include "telogn.com"
      include "He1deltaT.com"
      include "He2deltaT.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "he1stat.com"
      include "he2stat.com"
      include "he1blt.com"
      include "he2blt.com"
      include "dtrans.com"
      include "chrex.com"
      include "IonFracs.com"
      include "bit32.com"
      include "he1crt.com"
      include "he2crt.com"
      include "WindEtc.com"
      include "IOqq.com"
*
*     local variables
      real x,rothi,sexp,qn, rotlow,he1ion,he2ion,factor,
     1 brems,hold,edhe3,tripcl,pgrd,
     2 widlin,recem , he2line , he2lmax , he2lone , he1line,
     3 he1lmax , he1lone , dhe1l , dhe2l
      real oldcool , oldtemp,deriv
      integer nzSave , nhit
      integer i , l , iu , n , j
      save nzSave , oldcool , oldtemp , nhit
*
*     routine level2( t10 )
*     routine level3( abund , t10,t21,t20)
*     tsq1 = 1. / (te**2)
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     beseq(cs23,cs24,cs34,tarray,a41)
*     FIVEL( G(1-5) , ex(wn,1-5), cs12,cs13,14,15,23,24,25,34,35,45,
*            A21,31,41,51,32,42,52,43,53,54, pop(1-5), abund)
*
*     free statement lables, >=6
*
      if( lgTrace ) write(qq,'(''   COOLR called, TE='',1P,E12.4)') te
*     possibly update temperature variables
*     edensqte = eden/sqrte
*     cdsqte = 8.629e-6*eden/sqrte
*
      call tfidle
*
*     now zero out the cooling stack
      call colzro
*
*     grain recombination cooling, evaluated elsewhere
*     can either heat or cool the gas, do cooling here
      call coladd( 'dust' , 0 , max(0.,DustCoolGas) )
*
*     grain cooling proportional to temperature ^3/2
      dCooldT = dCooldT + max(0.,DustCoolGas)* 3./(2.*te)
*
*     molecular cooling
      if( lgNoMole ) then
         hmfb = 0.
         h2line = 0.
         h2dis = 0.
*        H + H+ => H2+ cooling
         H2PlsCool = 0.
      else
*        H- FB
         hmfb = hmicol
*        H- FF is in with H ff
*        rate for rotation lines from 
*        >>refer Lepp, S., & Shull, J.M. 1983, ApJ, 270, 578
         x = alogte - 4.
         if( te.gt.1087. ) then
            rothi = 3.90e-19 * sexp( 6118./te )
         else
            rothi = 10.**( -19.24 + 0.474*x - 1.247*x*x )
         endif
*        low density rotation cooling
         qn = max(htwo,1e-37)**0.77 + 1.2*max(hi,1e-37)**0.77
         if( te.gt.4031. ) then
            rotlow = 1.38e-22 * sexp( 9243./te ) * qn
         else
            rotlow = 10.**( -22.90 - 0.553*x - 1.148*x*x ) * qn
         endif
         if( rotlow.gt.0. ) then
            h2line = htwo * rothi / (1. + rothi / rotlow )
         else
            h2line = 0.
         endif
         h2dis = rh2dis * hi * htwo * 7.19e-12 * 0.
*        H + H+ => H2+ cooling
         H2PlsCool = max((2.325*te-1875.)*1e-20,0.)*hi*hii*1.66e-11
      endif
      call coladd( 'H-fb' , 0 , hmfb )
*     >>chng 96 nov 15, fac of 2 in deriv to help convergence in very dense
*     models where H- is important, this takes change in eden into
*     partial account
      dCooldT = dCooldT + 2.*hmfb * teinv
      call coladd( 'H2ln' , 0 , h2line )
      dCooldT = dCooldT + h2line * teinv
      call coladd( 'H2ds' , 0 , h2dis )
      dCooldT = dCooldT + h2dis * teinv
      call coladd( 'H2+ ' , 0 , H2PlsCool )
      dCooldT = dCooldT + H2PlsCool * teinv
*
*     carbon monoxide (CO) vib-rot cooling
      call coladd( 'CO C' , 0 , COVibCool )
      dCooldT = dCooldT + dCOVdT
*
*     atomic hydrogen cooling
      call HydroCool
*
*     charge exchange cooling 
*     ChargExc = c
*     chrexCool = chrener
*     write(6,'('' chra'',1p,e10.2)') chrexCool/htot
*     call coladd( 'Hchr' ,  0 , chrexCool )
*
*     net cooling for helium, HeI
*     HE1X evaluated in HE1LEV
      he1ion = he1ex * heii
      call coladd( 'He1i' ,  0 , he1ion )
      dCooldT = dCooldT + he1ion * 3.9e4 * tsq1
*
*     all cooling due to hei lines
      if( heii.gt.0. ) then
        he1line = 0.
        he1lmax = 0.
        dhe1l = 0.
*       first do 1s-2s and 1s-2p collisions
        he1line = eden*heiii * Boltzmann*He1deltaTe(2,1) *
     1  (he1n(1)*he1bol(1,2)* ( he1c2s1s+3.*he1cll(2,1) )
     1 - he12s*he1c2s1s - he12p*he1cll(2,1) )
        he1lmax = he1line
        he1lone = he1line
        if( he1lone .gt.0. ) then
*         line is coolant, note derivative counted from ground
          dhe1l = he1lone *(He1deltaTe(2,1)*tsq1-halfte)
        else
*         line is a heating agent
          dhe1l = -he1lone*halfte
        endif
        i = 1
        n = 2
*       upper limits changed to 5 and 6 due to strong cooling from
*       highest psuedo state
        do l=1,5
          do iu=max(3,l+1),6
            he1lone = he1cll(iu,l)*
     2      (he1n(l)*he1bol(l,iu)*he1stat(iu)/he1stat(l)-he1n(iu))*
     3      eden*heii* (Boltzmann * He1deltaTe(iu,l) )
*    3      eden*heii* (1.384e-16 * HdeltaT(iu,l)*4. )
*           >>chng 97 mar 4, above heii was heiii
            if( abs(he1lone).gt.abs(he1lmax) ) then
              he1lmax = he1lone
              i = l
              n = iu
            endif
            he1line = he1line + he1lone
*           >>chng 97 july 1, add in cooling derivative
            if( he1lone .gt.0. ) then
*             line is coolant, note derivative counted from ground
              dhe1l = dhe1l + he1lone *(He1deltaTe(iu,1)*tsq1-halfte)
            else
*             line is a heating agent
              dhe1l = dhe1l - he1lone*halfte
            endif
          end do
        end do
      else
        dhe1l = 0.
        he1line = 0.
      endif
*     all HeI line collisional excitation
      call coladd( 'He1l' ,  0 , he1line )
      dCooldT = dCooldT + dhe1l
*
*     net cooling for helium ionization, HeII
*     HE2X evaluated in HE2LEV
* 666 error! really should break this up into separate heating and cooling
      he2ion = he2ex * heiii
      call coladd( 'He2i' ,  0 , he2ion )
      dCooldT = dCooldT + he2ion * 3.9e4 * tsq1
*
*     all cooling due to heii lines
      if( heiii.gt.0. ) then
*       >>chng 97 july 2, 1s-2s collision had not been in
*       first do 1s-2s and 1s-2p collisions
        he2line = eden*heiii * Boltzmann*He2deltaTe(2,1) *
     1  (he2n(1)*he2bol(1,2)* ( he2c2s1s+3.*he2cll(2,1) )
     1 - he22s*he2c2s1s - he22p*he2cll(2,1) )
        he2lmax = he2line
        he2lone = he2line
        if( he2lone .gt.0. ) then
*         line is coolant, note derivative counted from ground
          dhe2l = he2lone *(He2deltaTe(2,1)*tsq1-halfte)
        else
*         line is a heating agent
          dhe2l = -he2lone*halfte
        endif
        i = 1
        n = 2
*
*       upper limits changed to 5 and 6 due to strong cooling from
*       highest psuedo state
        do l=1,5
          do iu=max(3,l+1),6
            he2lone = he2cll(iu,l)*
     2      (he2n(l)*he2bol(l,iu)*he2stat(iu)/he2stat(l)-he2n(iu))*
     3      eden*heiii* (Boltzmann * He2deltaTe(iu,l) )
*           >>chng 97 mar 5, const to par boltzmann, hdeltat*4 to He2deltaTe
*    3      eden*heiii* (1.384e-16 * HdeltaT(iu,l)*4. )
            if( abs(he2lone).gt.abs(he2lmax) ) then
              he2lmax = he2lone
              i = l
              n = iu
            endif
            he2line = he2line + he2lone
*           >>chng 97 july 1, add in cooling derivative
            if( he2lone .gt.0. ) then
*             line is coolant, note derivative counted from ground
              dhe2l = dhe2l + he2lone *(He2deltaTe(iu,1)*tsq1-halfte)
            else
*             line is a heating agent
              dhe2l = dhe2l - he2lone*halfte
            endif
          end do
        end do
      else
        he2line = 0.
        dhe2l = 0.
      endif
*     all HeII line collisional excitation
      call coladd( 'He2l' ,  0 , he2line )
*666  write(67,'(1p,3e12.4)')  te,he2line,dhe2l
      dCooldT = dCooldT + dhe2l
*
*     total Compton cooling
      tccool = cmcool * te
      call coladd( 'Comp' ,  0 , tccool )
      dCooldT = dCooldT + cmcool
*
*     option for "extra" cooling, expressed as power-law
      if( lgCExtraOn ) then
        cextxx = CoolExtra * ( te/1e4)** cextpw
      else
        cextxx = 0.
      endif
      call coladd( 'Extr' ,  0 , cextxx )
*
*     cooling due to wind expansion, only for winds expansion cooling
      if( windv.gt.0. ) then
        dDensityDT = AccelTot/windv + 2.*windv/radius
        expans = pden*te*Boltzmann * dDensityDT
      else
        dDensityDT = 0.
        expans = 0.
      endif
      call coladd( 'Expn' ,  0 , expans )
      dCooldT = dCooldT + expans/te
*
*     cyclotron cooling
      cyntrn = CycloCoolCoef * eden * te
      call coladd( 'Cycl' ,  0 , cyntrn )
      dCooldT = dCooldT + CycloCoolCoef * eden
*
*     electron-electron brems, approx form from 
*     >>refer Stepney and Guilbert, MNRAS 204, 1269 (1983)
*     ok for T<10**9
      eebrm = dble(eden * te * 1.84e-21 ) ** 2
*     >>chng 97 mar 12, added deriv
      dCooldT = dCooldT + eebrm*halfte
      call coladd( 'eeff' ,  0 , eebrm )
*
*     ionized helium induced recombination cooling
      edhe3 = eden * heiii
      c3ind = he2cin(1)*edhe3
      dCooldT = dCooldT + c3ind*(1.58e5*4.*teinv-1.5)*teinv
      do i=1,nhe2lvl-1
        hold = he2cin(i) * edhe3
        c3ind = c3ind + hold
        dCooldT = dCooldT + hold*(1.58e5*4./(i*i*te) - 1.5 ) * teinv
      end do
      call coladd( 'Hein' ,  0 , c3ind )
*
*     collisional ionization of triplet helium 
      call coladd( 'HeI3' , 0 , max(0.,He3IonCool))
      dCooldT = dCooldT + max(0.,He3IonCool) * 5.53e4*tsq1
*     net three body heating
*     >>chng 96 july 15, had always been cooling
      heating(2,5) = max( 0., -He3IonCool )
*
*     collisional excitation of all triplet lines, done in he3lev
*     can heat or cool
      if( hei3.gt. 0. ) then
        tripcl = he3clx
      else
        tripcl = 0.
      endif
      call coladd( 'Hetr' , 0 , max(0.,tripcl) )
      heating(2,4) = max( 0., -tripcl )
*
*     >>chng 96 nov 19, to following expression for HeI Lya cooling
*     c584 = hei * eden * 3.1e-19 * sexp(2.3e5/te)
*666 error! break out 2s and 2p, really should write entire he cooling rout
      c584 = eden*heii * 3.41e-11*he1cll(2,1) *
     1 ( he1bol(1,2)*he1n(1)*4.  - he1n(2) )
      dCooldT = dCooldT + c584 * 2.46e5 * tsq1
      call coladd( 'He I' ,  584 , c584 )
*
*     radiation pressure due to HE I 10830
      pgrd = p2s - p2p / 3.
      if( pgrd.ne.0. )  then
        plines(4) = 2.69e-10 *p2p/( p2s-p2p/3.) * 
     1  widlin( t10830(ipLnTauIn) , t10830(ipLnTauTot) , 1.37e-4 ,
     2  doppler(2) )
      else
        plines(4) = 0.
      endif
*
*     He I, He II brems (free-free) and recombination
      factor = 0.9 + 1.2/(2.2+abs(alogte-5.398))
*     if( chDffTrns.eq.'OTS' ) then
*     >>chng 95 dec 23 always do ots for brems for stability
*       ots continuum transport - do not count optically thick part
        brems = 1.42e-27 * eden * sqrte * factor * sexp( tff*te1ryd/te)
*     else if( chDffTrns(1:2).eq.'OU' ) then
*       brems = 1.42e-27 * eden * sqrte * factor
*     else
*       write(qq,'('' COOLR: insane chDffTrns='',a3)') chDffTrns
*       stop
*     endif
      if( lgFreeOn ) then
        bhe = brems  * (4.*heiii + heii)
	else
        bhe = 0.
      endif
      call coladd( 'Heff' ,  0 , bhe )
*
      recem = 9.52e-26 * te10 * eden
      herec = recem  * (heiii*6. + heii)
      dCooldT = dCooldT + bhe*halfte + herec*0.27*teinv
      call coladd( 'Hefb' ,  0 , herec )
*
*     heavy element brems and recombination,
*     EdenFFSum set in ESUM, given by Harrington et al. 82
* 666 error! put in charge dependent rec term
      heavfb = 0.
      do i=3,limelm
        do j=2,i+1
          heavfb = heavfb + xIonFracs(i,j)
        end do
      end do
      heavfb = recem*heavfb
      call coladd( 'hvFB' ,  0 , heavfb )
*
      heavff = EdenFFSum * 1.44e-27 * sqrte * eden * factor
      dCooldT = dCooldT + heavfb * .113*teinv
      call coladd( 'Hvff' ,  0 , heavff )
*
*     heavy element collisional ionization
*     derivative should be zero since increased coll ion rate
*     decreases neutral fraction by proportional amount
      colmet = HeavIonCool
      call coladd( 'Hvin' ,  0 , colmet )
*
*     following flag will tell level2 these are level 1 lines
      ipWEtc = 0
*
*     Carbon cooling
      call carcol
*
*     Nitrogen cooling
      call nitcol
*
*     Oxygen cooling
      call oxycol
*
*     Fluorine cooling
      call flucol
*
*     Neon cooling
      call necol
*
*     Magnesium cooling
      call mgcol
*
*     Sodium cooling
      call nacol
*
*     Aluminum cooling
      call alcol
*
*     Silicon cooling
      call silcol
*
*     Phosphorus
      call PhosCol
*
*     Sulphur cooling
      call sulcol
*
*     Chlorine cooling
      call clcol
*
*     Argon cooling
      call arcol
*
*     Potasium cooling
      call PotCol
*
*     Calcium cooling
      call calcol
*
*     Scandium cooling
      call ScCol
*
*     Titanium cooling
      Call TiCol
*
*     Vanadium cooling
      Call VanCol
*
*     Chromium cooling
      Call CrCol
*
*     Iron cooling
      call fecol
*
*     Manganese cooling
      call MnCol
*
*     Cobalt cooling
      call CoCol
*
*     Nickel cooling
      call NiCol
*
*     do all the thousands of lines Dima added with g-bar approximation
      call DimaCool
*
*     now add up all the coolants
      call SumCool( tot )
*
      dc = dCooldT
*     negative cooling
      if( tot.le.0. ) then
        write(qq,'('' COOLR; cooling is <=0, this is impossible.'')')
        call fndstr( tot , dc )
        call ShowMe
        stop
      endif
*
*     bad derivative
      if( dc.eq.0. ) then
        write(qq,'('' COOLR; cooling slope is 0, this is impossible'')')
        if( tot.gt.0. .and. lgBit32 .and. eden.lt.1e-4 ) 
     1  write(qq,'('' Probably due to very low density.'')')
        call fndstr( tot , dc )
        call ShowMe
        stop
      endif
*
      if( lgTrace ) call fndstr( tot , dc )
*
*     lgTSetOn true for constant temperature model
      if( (.not.lgTSetOn).and.tot.lt.0..and.lgTalk.and.lgColNeg.and.
     1   lgCNegChk .and. nzone.gt.0 ) then
         write(qq,'('' Negative cooling, zone'',I4,'', ='',
     2   1P,E9.2,'' coola='',E9.2,'' CHION='',E9.2,
     3   '' Te='',E9.2)') nzone , tot , coola ,chion , te
         call fndneg
      endif
*
*     possibility of getting emperical cooling derivative
*     normally false, set true with 'set numerical derivatives' command
      if( lgNumDeriv ) then
        if( nzone.gt.2 .and. nzone.eq.nzSave .and. oldtemp.ne.te
     1    .and. nhit.gt.4) then
*         hnit is number of trys on this zone - use to stop numerical problems
*         do not evaluate numerical deriv until well into solution
          deriv = (oldcool - tot)/(oldtemp-te)
          dc = deriv
        else
          deriv = dc
        endif
        if(nzone.ne.nzSave) nhit = 0
        nzSave = nzone
        nhit = nhit + 1
        oldcool = tot
        oldtemp = te
      endif
*
      end
