******************************************************************************
      subroutine cratio( chCard , nqh )
      implicit none
*derive continuum luminosity of this continuum relative to previous
      character chCard*80
      integer nqh
*
      include "limspc.par"
      include "range.com"
      include "spec.com"
      include "spnorm.com"
      include "nvary.com"
      include "limext.par"
      include "limpar.par"
      include "vformt.com"
      include "vparm.com"
      include "nvfpnt.com"
      include "varon.com"
      include "ninput.com"
      include "bounds.com"
      include "IOqq.com"
*
*     local variables
      logical lgMatch , lgEOL , lgAoxOn
      integer i
      real aox , fread
*
*     enter a continuum luminosity as a ratio of
*     nuFnu for this continuum relative to a previous continuum
*     format; first number is ratio of second to first continuum
*     second number is energy for this ratio
*     if third numbewr on line, then 2nd number is energy of
*     first continuum, while 3rd number is energy of second continuum
      nqh = nqh + 1
      if( nqh.eq.1 ) then
        write(qq,'('' Cant form ratio since this is first '',
     1  ''continuum.'')')
        stop
      else if( nqh.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
*     per sq cm or luminosity is really irrelevant
      chRSpec(nqh) = 'SQCM'
      chSpNorm(nqh) = 'RATI'
      if( lgMatch( 'ALPH' , chCard ) ) then
        lgAoxOn = .true.
*       only one parameter to be recognized, alpha ox
        i = 5
        aox = fread( chCard , i , 76 , lgEOL )
*       403.3 is ratio of energies where alpha ox defined,
*       assumed to be 2500A and 2keV
        totpow(nqh) = 403.3**aox
        range(nqh,1) = 0.3645
        range(nqh,2) = 147.
      else
        lgAoxOn = .false.
*       specify ratio, two energies
        i = 5
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
*       assumed to be a log if negative or zero
        if( totpow(nqh).le. 0. .or. lgMatch(' LOG',chCard) ) then
          totpow(nqh) = 10.**totpow(nqh)
        endif
        if( lgEOL ) then
          write(qq,'('' There must be a number on this line.'')')
          stop
        endif
        range(nqh,1) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' There must be at least 2 numbers on '',
     1    ''this line.'')')
          write(qq,'('' The ratio, and two energies'')')
          stop
        endif
        range(nqh,2) = fread( chCard , i , 76 , lgEOL )
*       if only one number then assume same for each
        if( lgEOL ) range(nqh,2) = range(nqh,1)
        if( range(nqh,1).lt.emm .or.  range(nqh,2).lt.emm ) then
          write(qq,'('' One of the energies is too low, outside''
     1    ,'' the range of the code.'')')
          stop
        else if( range(nqh,1).gt.egamry .or.  range(nqh,2).gt.egamry 
     1   ) then
          write(qq,'('' One of the energies is too high, outside''
     1    ,'' the range of the code.'')')
          stop
        endif
      endif
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
*       pointer to where to write
        nvfpnt(nparm) = nRead
        if( lgAoxOn ) then
*         this is the number of parameters to feed onto the input line
          nvarxt(nparm) = 1
*         vary alpha ox
          write(chVarFmt(nparm),'(''(''''RATIO alphox'''',F9.5)'')') 
*         param is linear scale factor
          vparm(nparm,1) = aox
          vincr(nparm) = 0.2
        else 
*         this is the number of parameters to feed onto the input line
          nvarxt(nparm) = 3
          write(chVarFmt(nparm),'(''(''''RATIO LOG '''',3F11.5)'')')
*         param is log of abundance by number relative to hydrogen
          vparm(nparm,1) = log10( totpow(nqh) )
          vparm(nparm,2) = range(nqh,1)
          vparm(nparm,3) = range(nqh,2)
          vincr(nparm) = 0.2
        endif
      endif
*
      end
