******************************************************************************
      subroutine DielSupres
      implicit none
*derive scale factors for suppression of Burgess dielectronic recombination
      include "limelm.par"
      include "supdie.com"
      include "phycon.com"
      include "supprs.com"
      include "ioreco.com"
      include "TePowers.com"
*
*     local variables
      real effden
      integer i
*
*     dielectronic burgess recombination suppresion
*     default is this to be true
      if( lgSupDie(1) ) then
        do i=1,limelm
*         following is effective density for scaling from Davidson's plot
*         first do temperature scaling, term in () is sqrt(te/15,000)
          effden =  eden / (sqrte / 122.47)
*         this is rough charge dependence, z^7 from Davidson
          effden = effden / ((float(i)/3.)**7)
          supprs(i,1) = min(1.,  (1.-0.092*log10(effden) )  )
          supprs(i,1) = max( 0.08, supprs(i,1) )
        end do
      else
        do i=1,limelm
          supprs(i,1) = 1.
        end do
      endif
*
*     nussbaumer and storey recombination
*     default is this to be false
      if( lgSupDie(2) ) then
        do i=1,limelm
*         assume same factors as above
          supprs(i,2) = supprs(i,1)
        end do
      else
        do i=1,limelm
          supprs(i,2) = 1.
        end do
      endif
*
      if( ioreco.gt.0 ) then
        write(ioreco,'('' DielSupres finds following dielectronic '',
     1 ''recom suppression factors.'')')
        write(ioreco,'('' Z   fac '')')
        do i=1,limelm
          write(ioreco,'(i3,1p,2e10.3)') i ,supprs(i,1),supprs(i,2)
        end do
      endif
*
      end
