******************************************************************************
      subroutine dont( chCard )
      implicit none
*parse the dont command - do not do something
      character chCard*80
*
      include "nhlvl.par"
      include "nta.par"
      include "limelm.par"
      include "nwindline.par"
      include "gionrc.com"
      include "physok.com"
      include "otsmin.com"
      include "secoff.com"
      include "fston.com"
      include "scaton.com"
      include "radpon.com"
      include "freeon.com"
      include "WindData.com"
      include "c2pson.com"
      include "HPhoto.com"
      include "comptn.com"
      include "rcota.com"
      include "nomole.com"
      include "strkon.com"
      include "recoil.com"
      include "fe2on.com"
      include "fluors.com"
      include "yield.com"
      include "PhotScale.com"
      include "HCTOnOff.com"
      include "CharExc.com"
      include "IOqq.com"
*
*     local variables
      logical lgMatch , lgNoVary
      integer nelem , nstage , nshell
*
      if( lgMatch('AUGE',chCard) ) then
*        turn off auger effect
         lgPhysOK = .false.
         do nelem=1,limelm
           do nstage=1,nelem
             do nshell=1,7
*              only one electron comes out
               nyield(nelem,nstage,nshell) = 1
               vyield(nelem,nstage,nshell,1) = 1.
             end do
           end do
         end do
*
      else if( lgMatch('CHAR',chCard) ) then
*        turn off both recoil ionization and compton heating of free electron
         HCTOn = 0.
         lgPhysOK = .false.
*
      else if( lgMatch('CTHE',chCard) ) then
*        turn off charge transfer heating
         HCharHeatOn = 0.
         lgPhysOK = .false.
*
      else if( lgMatch('COMP',chCard) ) then
*        turn off both recoil ionization and compton heating of free electron
         comoff = 0.
         lgPhysOK = .false.
*
      else if( lgMatch('FEII',chCard) ) then
*        turn off feii ly-alpha pumping
         lgFe2On = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('FINE',chCard) ) then
*        turn off fine structure optical depths
         lgFstOn = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('FREE',chCard) ) then
*        turn off free free heating
         lgFreeOn = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('GRAI',chCard) ) then
         if( lgMatch( 'NEUT' , chCard ) ) then
*        turn off ion grain recombination "NO GRAIN NEUTRALIZATION"
           grecon = 0.
           lgPhysOK = .false.
         else
           write(qq,'('' No key recognized on this line.'')')
           stop
         endif
*
      else if( lgMatch('INDU',chCard ) ) then
*        turn off induced recombination and stimulated emission
         lgPhysOK = .false.
*        turn off continuum fluorescent excitation of lines
         lgFluor = .false.
*
      else if( lgMatch('LEVE',chCard) ) then
*        disable level 2 lines
         nWindOn = 0
*
      else if( lgMatch('MOLE',chCard) ) then
*        disable molecule formation
         lgNoMole = .true.
         lgPhysOK = .false.
*
      else if( lgMatch('PHOT',chCard) ) then
*        disable photoionization
         PhotScaleOn = 0.
         lgPhysOK = .false.
*
      else if( lgMatch('RADI',chCard) ) then
*        don't include line radiation pressure
         lgRadPrsON = .false.
*
      else if( lgMatch('RECO',chCard) ) then
*        disable compton recoil of bound electrons - "no recoil ioniz"
         lgCompRecoil = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('SCAT',chCard) ) then
*        no scattering opacity, for Compton thick spherical geometry
         lgScatON = .false.
*
      else if( lgMatch('SECO',chCard) ) then
*        turn off secondary electron ionizations
         lgSecOFF = .true.
         lgPhysOK = .false.
*
      else if( lgMatch('SPOT',chCard) ) then
*        no on-the-spot; turn on all ground state rec
         otsmin = 1.
*
      else if( lgMatch('STAR',chCard) ) then
*        no stark broadening
         lgStarkON = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('THRE',chCard) ) then
*        turn off Cota's three body rec subroutine
         lgNoCota = .true.
         lgPhysOK = .false.
*
      else if( chCard(1:7).eq.'NO VARY') then
*        this is a no-nothing, picked up in optimizer
         lgNoVary = .true.
*
      else if( lgMatch('2S2P',chCard).or.lgMatch('2P2S',chCard) ) then
*        turn off collisions between 2s and 2p
         lgC2psOn = .false.
         lgPhysOK = .false.
*
      else
*        end of else if trap
         write(qq,'('' I dont understand what not to do.  STOP'')')
         stop
      endif
*
      end
