******************************************************************************
      subroutine DoPunch( chTime )
      implicit none
*produce punch output during calculation
      character*4 chTime
*     chTime is 'MIDL' during calculation, 'LAST' at the end
      include "limpun.par"
      include "ndust.par"
      include "bltzman.par"
      include "en1ryd.par"
      include "nlines.par"
      include "limelm.par"
      include "ncell.par"
      include "evryd.par"
      include "itrdim.par"
      include "mapdim.par"
      include "nGrid.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nhe3lvl.par"
      include "dstop.com"
      include "iphl.com"
      include "iphop.com"
      include "tautot.com"
      include "shullc.com"
      include "cldnEXP.com"
      include "hvmolEXP.com"
      include "flxsav.com"
      include "cover.com"
      include "tedust.com"
      include "dstdft.com"
      include "heating.com"
      include "presok.com"
      include "PhotRate.com"
      include "ioptri.com"
      include "sphere.com"
      include "GrainPot.com"
      include "dqs.com"
      include "called.com"
      include "punlst.com"
      include "lastit.com"
      include "scatop.com"
      include "opac.com"
      include "prad.com"
      include "pinteg.com"
      include "gaunts.com"
      include "rfield.com"
      include "reflec.com"
      include "occnum.com"
      include "diffus.com"
      include "widflx.com"
      include "cpunch.com"
      include "pnunit.com"
      include "phycon.com"
      include "radius.com"
      include "h.com"
      include "he.com"
      include "ZoneCnt.com"
      include "tcool.com"
      include "pwind.com"
      include "heat.com"
      include "mapr.com"
      include "condif.com"
      include "ots.com"
      include "nh.com"
      include "htau.com"
      include "htnext.com"
*     include "hdamp.com"
      include "DoppVel.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "heopfr.com"
      include "hyas.com"
      include "ndston.com"
      include "dclgas.com"
      include "maxcor.com"
      include "wind.com"
      include "comexc.com"
      include "deptau.com"
      include "r1r0sq.com"
      include "hmi.com"
      include "hem.com"
      include "levery.com"
      include "raten3.com"
      include "ipvfil.com"
      include "tlast.com"
      include "NumUpper.com"
      include "PunchSkip.com"
      include "LineLabl.com"
      include "HeatCool.com"
      include "Heavy.com"
*     include "facexp.com"
      include "dRdVeff.com"
      include "sum.com"
      include "sumlab.com"
      include "fourpi.com"
      include "iphe1l.com"
      include "hcaseb.com"
      include "pnow.com"
      include "IonFracs.com"
      include "PresInit.com"
      include "hesc.com"
      include "hfrcin.com"
      include "DestCrt.com"
      include "hnet.com"
      include "tpred.com"
      include "he3rate.com"
      include "he3pht.com"
      include "he1rate.com"
      include "herec.com"
      include "he3gams.com"
      include "tmn.com"
      include "he2rate.com"
      include "nhe1.com"
      include "iophe1.com"
      include "anusave.com"
      include "nsShells.com"
      include "photo.com"
      include "ElmntSym.com"
      include "Shell.com"
      include "SumOutInc.com"
      include "PLWidth.com"
      include "HPhoto.com"
      include "densty.com"
      include "AgeMole.com"
      include "TePowers.com"
      include "IOqq.com"
*
*     local variables
      character*6 chEner(limelm)
      integer j,ipoint,jj,nd , i1,isav,i, nelem,ion
      real fref,fout,fsum,sum,flxcor,damp,eps,stage,
     1 pop,texc,av,refac,flxin,flxatt,conem, opConSum ,
     2 flxtrn,flxref , plankf , HCTIon , HCTRecom, opLinSum ,
     3 ConMax , xLinMax , RateInter , AnuUnit
      integer ipConMax , ipLinMax , ips ,n

      logical lgOK , lgTlkSav
*
*     free statement labels, >= 13
*
*     the LAST option on punch command is parsed at the top of the loop
*     in only one place.  No action is needed at all for PUNCH LAST to work
*     ok throughout this routine
*
*     each branch can have a test whether chTime is or is not 'LAST'
*     if 'LAST' then this is last call to routine after calc complete
*     punch only if 'LAST' when results at end of cal are needed
*     test for .not.'LAST' is for every zone result, where you do not
*     want to punch last zone twice
*
*     punch results on unit ipPnunit 
      if( npunch.lt.1 ) return 
*
      do i=1,npunch
*       lgPunLstIter set true if 'last' key occured on punch command
*       normally is false.  This will skip punching if last set and
*       this is not last iteration
*       >>chng 97 june 8, get rid of go to
        if( lgLastIt .or. (.not.lgPunLstIter(i)) ) then 
*
        if( chPunch(i).eq.'ABUN' ) then
*         punch abundances vs depth
          if(chTime.ne.'LAST') write(ipPnunit(i),'(0p,30f6.2)')
     1    (log10(xIonFracs(j,0)),j=1,limelm)
*
        else if( chPunch(i).eq.'ASSE' ) then
*         punch asserts does not do anything
          continue
*
        else if( chPunch(i).eq.'AGES' ) then
*         punch abundances vs depth
          if(chTime.ne.'LAST') write(ipPnunit(i),'(1p,9e9.2)')
     1    depth ,
     2    pden*Boltzmann*1.5*te/htot ,
     2    AgeH2MoleForm,
     2    AgeCOMoleForm ,
     3    1./( eden * 2.90e-10 /(te70*te10/te03) )
*
        else if( chPunch(i).eq.'CHAR' ) then
*         charge exchange rate coefficients
          do j=2,limelm
            write(ipPnunit(i),'(i3,1p,6e10.2)')
     1      j,(HCTRecom(jj,j),jj=1,min(6,j))
          end do
          do j=2,limelm
            write(ipPnunit(i),'(i3,1p,6e10.2)')
     1      j,(HCTIon(jj,j),jj=1,min(6,j))
          end do
*
        else if( chPunch(i).eq.'CTHE' ) then
*         charge transfer heating and cooling
          call PunCTHeat( ipPnunit(i) )
*
        else if( chPunch(i).eq.'COOL' )then
          if(chTime.ne.'LAST')call PunCool(ipPnunit(i) )
*
        else if( chPunch(i).eq.'COMP' ) then
*         compton energy exchange coefficients
          if(chTime.ne.'LAST')write(ipPnunit(i),'(1x,1p,3e10.2)') 
     1    (anu(jj),comup(jj)/widflx(jj),comdn(jj)/widflx(jj),
     2    jj=1,nflux,ncPunchSkip)
*
         else if( chPunch(i).eq.'CON ') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
           if( lgSphere ) then
             refac = 0.
           else
             refac = 1.
           endif
           do j=1,nflux,ncPunchSkip
*            four continua predicted here;
*            incident, attenuated incident, emitted,
*            then attenuated incident + emitted, last reflected
*            reflected continuum is stored relative to inner radius
*            others are stored for this radius
*
*            NB this code also used in punch emitted,
*            transmitted continuum commands
             flxref = (anu2(j)*refcon(j)/widflx(j)+
     1       anu(j)*PunchLWidth*reflin(j))*
     1       refac* en1ryd 
             flxin = FluxSave(j)*anu2(j)*en1ryd/widflx(j)
             flxatt = flux(j) * anu2(j) * en1ryd / widflx(j) * r1r0sq
             conem = (  (ContDiff(j)+outcon(j))/widflx(j)*anu2(j) +
     1       PunchLWidth*outlin(j)*anu(j) ) * r1r0sq*en1ryd*covgeo
             flxtrn = conem + flxatt
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1p,e11.5,6e10.3,1x,2(a4,1x))')
     1       AnuUnit(j),
     1       flxin, flxatt, conem,flxtrn,flxref, flxref+flxtrn,
     2       chLineLabel(j), chContLabel(j)
           end do
           endif
*
         else if( chPunch(i).eq.'CONC') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*          incident continuum
           do j=1,nflux,ncPunchSkip
             flxin = FluxSave(j)*anu2(j)*en1ryd/widflx(j)
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1p,e11.5,6e10.3,1x,2(a4,1x))')
     1       AnuUnit(j), flxin
           end do
           endif
*
         else if( chPunch(i).EQ.'CONR') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
           if( lgSphere ) then
             write(ipPnunit(i),'('' Reflected continuum not predicted ''
     1       ,''when SPHERE is set.'')')
             stop
           endif
           do j=1,nflux,ncPunchSkip
*            reflected continuum
             flxref = anu2(j)*refcon(j)/widflx(j)* en1ryd
*            reflected lines
             fref = anu(j)*PunchLWidth*reflin(j)* en1ryd
*            ratio of reflected to incident continuum, the albedo
             if( FluxSave(j).gt.1e-25 ) then
               av = reflux(j)/FluxSave(j)
             else
               av = 0.
             endif
*            >>chng 96 oct 22, format of anu to 12.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1p,5e12.5,1x,a4)') AnuUnit(j), flxref,
     1       fref, flxref+fref , av , chContLabel(j)
           end do
           endif
*
         else if( chPunch(i).EQ.'CONB') then
*          this option to punch continuum binning
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if(chTime.ne.'LAST')
     1     write(ipPnunit(i),'(1p,2e14.5)') (AnuUnit(j),widflx(j),
     1     j=1,nupper,ncPunchSkip)
*
         else if( chPunch(i).eq.'COND') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*          this option to punch diffuse continuum
           do j=1,nflux,ncPunchSkip
*            >>chng 96 oct 22, format of anu to 12.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1p,2e12.5)') AnuUnit(j),
     1       DiffCont(j)*anu2(j)*en1ryd/widflx(j)
           end do
           endif
*
         else if( chPunch(i).eq.'CONE') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*          punch emitted continuum
           if( lgSphere ) then
             refac = 0.
           else
             refac = 1.
           endif
           do j=1,nflux,ncPunchSkip
*            this is the reflected component
             flxref = (anu2(j)*refcon(j)/widflx(j)+
     1       anu(j)*PunchLWidth*reflin(j))*
     1       refac* en1ryd
*            fref = (anu2(j)*refcon(j)/widflx(j)+anu(j)*PunchLWidth*reflin(j))*
*    1       en1ryd
*            this is the total emission in the outward direction
             conem = (ContDiff(j)+outcon(j))/widflx(j)*anu2(j) +
     1       PunchLWidth*outlin(j)*anu(j)
             conem = conem*r1r0sq*en1ryd*covgeo
*            output: photon energy, reflected, outward, total emission
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1P,e11.5,3E11.3,1x,2(a4,1x))')
     1       AnuUnit(j),
     1       flxref, conem, flxref+conem,
     2       chLineLabel(j), chContLabel(j)
           end do
           endif
*
         else if( chPunch(i).eq.'CONi') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
*          continuum interactions
           if( chTime.ne.'LAST' ) then
             fref = 0.
             fout = 0.
             fsum = 0.
             sum = 0.
             flxin = 0.
*            this is option to set lowest energy
             if( punarg(i,1).le.0. ) then
               i1 = 1
             else if( punarg(i,1).lt.100. ) then
               i1 = ipoint( punarg(i,1) )
             else
               i1 = punarg(i,1)
             endif
             do j=i1,nflux
               fref = fref + flux(j)*opac(j)
               fout = fout + otslin(j) * opac(j)
               fsum = fsum + otscon(j) * opac(j)
               sum = sum + outcon(j)*opac(j)
               flxin = flxin + outlin(j)*opac(j)
             end do
             write(ipPnunit(i),'(1p,5e10.2)') fref,fout,fsum,sum,flxin
           endif
*
         else if( chPunch(i).eq.'CONI') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*          punch ionizing continuum command
*          this is option to set lowest energy
           if( punarg(i,1).le.0. ) then
             i1 = 1
           else if( punarg(i,1).lt.100. ) then
             i1 = ipoint( punarg(i,1) )
           else
             i1 = punarg(i,1)
           endif
           sum = 0.
           do j=i1,nflux
             flxcor = flux(j) + otslin(j)+otscon(j)+outcon(j)+outlin(j)
             sum = sum + flxcor * opac(j)
           end do
           if( sum.gt.0. ) then
             sum = 1. / sum
           else
             sum = 1.
           endif
           fsum = 0.
           do j=i1,nflux,ncPunchSkip
             flxcor = flux(j) + otslin(j)+otscon(j)+outcon(j)+outlin(j)
             fsum = fsum + flxcor * opac(j)
*            punched quantities are freq, flux, flux*cross sec,
*            fraction of total, integral fraction of total
             RateInter = flxcor*opac(j)*sum
*            punage(i,2) is lowest interaction rate to consider, def=0
             if( RateInter.gt. punarg(i,2)) then
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
               write(ipPnunit(i),'(1p,e11.5,2e9.2,0p,4f5.2,1p,2e10.2,1x,
     1         2(a4,1x))')
     1         AnuUnit(j),flxcor, flxcor * opac(j) , 
     2         flux(j)/flxcor,otslin(j)/flxcor,otscon(j)/flxcor,
     3         (outcon(j)+outlin(j))/flxcor , RateInter , fsum*sum ,
     1         chLineLabel(j), chContLabel(j)
             endif
           end do
           endif
*
         else if( chPunch(i).eq.'CORA') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*            this option to punch all raw ionizing continuum
             do j=1,nflux,ncPunchSkip
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
               write(ipPnunit(i),'(1P,e11.5,8E11.3)') AnuUnit(j),
     1         flux(j),
     1         otslin(j),otscon(j),refcon(j),outcon(j),outlin(j),
     2         ContDiff(j)
             end do
           endif
*
         else if( chPunch(i).eq.'COLO' ) then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*            option to punch out outward continuum here
             do j=1,nflux,ncPunchSkip
*              >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1ryd
               write(ipPnunit(i),'(1p,e11.5,8e10.2)')
     1         AnuUnit(j),SavOutCon(j) ,outcon(j)+outlin(j),
     2         SavOutCon(j)*opac(j)*anu(j) ,
     1         (flux(j)+otscon(j)+otslin(j)+outcon(j)+outcon(j) ) *
     1         opac(j)* anu(j)
             end do
           endif
*
         else if( chPunch(i).eq.'CONO' ) then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*            option to punch out outward continuum
             do j=1,nflux,ncPunchSkip
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
               write(ipPnunit(i),'(1p,e11.5,8e10.2)')
     1         AnuUnit(j),
     2         flux(j)*anu2(j)*en1ryd/widflx(j)*r1r0sq,
     3         outcon(j)/widflx(j)*anu2(j)*r1r0sq*en1ryd,
     4         PunchLWidth*outlin(j)*anu(j)*r1r0sq*en1ryd,
     5         (outcon(j)/widflx(j)*anu2(j)+
     6         PunchLWidth*outlin(j)*anu(j))*r1r0sq*en1ryd
             end do
           endif
*
         else if( chPunch(i).eq.'CONT') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*            this option to punch transmitted continuum
             do j=1,nflux,ncPunchSkip
*              contin = flux(j)+
*    1         ((ContDiff(j)+outcon(j))*anu2(j)/widflx(j)+
*    2         PunchLWidth*outlin(j)*anu(j)) 
*              attenuated incident continuum
*              >>chng 97 jul 10, remove PunchLWidth from this one only since
*              we must conserve energy even in lines
               flxatt = flux(j) * anu2(j) * en1ryd / widflx(j) * r1r0sq
               conem = (ContDiff(j)+outcon(j)+outlin(j))/widflx(j)*
     1         anu2(j)
               conem = conem*r1r0sq*en1ryd*covgeo
               flxtrn = conem + flxatt
*              >>chng 96 july 11, had been below, had big bug
*              flxcor = contin *en1ryd* r1r0sq*covgeo
*              use AnuOrg here instead of anu since probably
*              going to be used by table read
*              and we want good anu array for sanity check
*              >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1ryd
               write(ipPnunit(i),'(1p,3e12.5)') AnuUnit(j),flxtrn
             end do
           endif
*
         else if( chPunch(i).eq.'DUSO' ) then
*          >>chng 97 july 2, from ne last to eq last
*          punch grain opacity
           if(chTime.eq.'LAST')write(ipPnunit(i),'(1p,e12.4,3e9.2)')
     1     (anu(j),(dstab(j)+dstsc(j)),dstab(j),dstsc(j),j=1,nflux)
*
         else if( chPunch(i).eq.'DUSP' ) then
            write(ipPnunit(i),'(1p,14e9.2)') 
     1      (tedust(ipdon(j)),j=1,ndston),(dstpot(ipdon(j))*evryd,j=1,
     1      ndston),
     2      (DustDftVel(ipdon(j)),j=1,ndston) , heating(1,14)/htot,
     3      DustCoolGas/htot
*
         else if( chPunch(i).eq.'ELEM' ) then
           if( chTime.ne.'LAST' ) then
*          this is the pointer to atomic number
           jj = punarg(i,1)
           write(ipPnunit(i),'(1x,1p,e11.4,31i5)') depth , 
     1     (int(-1000.*log10(max(5e-10,xIonFracs(jj,j)/
     2     xIonFracs(jj,0)))),j=1,jj+1)
           endif
*
         else if( chPunch(i).eq.'RECE' ) then
*           recombination efficiencies
            write(ipPnunit(i),'(1p,8e12.4)')  hrec(1,2),
     1      he1rec(1,2),he1rec(1,3),ophe1f(1),he2rec(1,2)
*
         else if( chPunch(i).eq.'FEII' ) then
            if(chTime.ne.'LAST')call pfeii(ipPnunit(i) )
*
         else if( chPunch(i).eq.'GAMM' ) then
            if(chTime.ne.'LAST')call PunGamma(ipPnunit(i) )
*
         else if( chPunch(i).eq.'GAUN' ) then
           if(chTime.ne.'LAST')call pgaunt(ipPnunit(i) )
*
         else if( chPunch(i).eq.'HEAT' )then
           if(chTime.ne.'LAST')call PunHeat(ipPnunit(i) )
*
*        punch helium
         else if( chPunch(i).eq.'HEL1' ) then
           if( chTime.ne.'LAST' ) then
             if( smhe2ov1.gt.1e-30 ) then
               fref = ( heii / smhe2ov1 ) / ahe
             else
               fref = 0.
             endif
*            second number is ratio of predicted HeII/AheII to simple
*            clhe2ov1 is computed He1/He1
             write(ipPnunit(i),'(''he1'',1p,9e10.2)') hei/ahe,
     1       fref ,clhe2ov1,smhe2ov1,reci*eden, he1gam(1),hei3/ahe
             call PrtGamma(nhe1(1) ,nflux ,iophe1(1),ipPnunit(i),
     1       he1gam(1),he1gam(1)*0.05)
           endif
*
         else if( chPunch(i).eq.'HEL2' ) then
           if( chTime.ne.'LAST' ) then
*          sheiov2 is He++ over He+
           if( heii.gt.0. ) then
             fref = heiii / heii
           else
             fref = 0.
           endif
           write(ipPnunit(i),'(1x,i4,1p,9e10.2)') nzone, fref ,
     1     sheiov2 ,recii, he2gam(1),  collhe2,csupra
           endif
*
         else if( chPunch(i).eq.'HEL3' ) then
           if( chTime.ne.'LAST' ) then
           if( she2ov3.gt.0. ) then
             fref = ( heii / she2ov3 ) / ahe
           else
             fref = 0.
           endif
           write(ipPnunit(i),'(''HeTrip'',1p,9e10.2)') hei3/ahe,
     1     fref ,rectri*eden, he3gam(1),  collhe3
           call PrtGamma(nhei3 ,nhe1(1) ,ioptri,ipPnunit(i),
     1     he3gam(1) , he3gam(1)*0.05 )
           endif
*
         else if( chPunch(i).eq.'HUMM' ) then
           damp = hdamp(2) / doppler(1) / 0.75
           eps = hyas(2,1) / (hcol(2,1)*eden)
           write(ipPnunit(i),'(1x,1p,13e10.3)')depth,htau(2,1),
     1     hn(1)*hii,hn2p*hii, te ,  damp , eps
*
         else if( chPunch(i).eq.'HYDc' ) then
*          punch hydrogen physical conditions
           write(ipPnunit(i),'(1x,1p,13e9.2)') depth,te,hden,
     1     eden,hi/hden,hii/hden,htwo/hden,h2plus/hden,h3plus/hden,
     2     hminus/hden
*
         else if( chPunch(i).eq.'HYDi' ) then
           if( chTime.ne.'LAST' ) then
*          punch hydrogen ionization
*          this will be total decays to ground
           RateInter = 0.
           stage = hcolnc(1)*eden * hn(1)
           fref = hgamnc(1) * hn(1)
           fout = hn(1)
           do ion=2,nhlvl
*            this is total decays to ground
             RateInter = RateInter + hnet(ion,1)
*            total photo from all levels
             fref = fref + hgamnc(ion) * hn(ion)
*            total col ion from all levels
             stage = stage + hcolnc(ion)*eden * hn(ion)
             fout = fout + hn(ion)
           end do
           write(ipPnunit(i),'(i4,1p,14e9.2)')nzone,
     1     hgamnc(1) , HRecEffec,HRecRad,hii/hi,
     1     hgamnc(1)/(eden*HRecEffec),hrec(1,3),RateInter,
     1     fref/max(1e-37,fout) , stage/max(1e-37,fout),
     1     hgamnc(1)*hi/(eden*hii)
           call PrtGamma(ipHn(1),nflux,iphop(1),ipPnunit(i),hgamnc(1),
     1     hgamnc(1)*0.05)
           endif
*
         else if( chPunch(i).eq.'HYDp' ) then
*          punch hydrogen populations
           write(ipPnunit(i),'(1x,1p,13e9.2)') depth,hi, hii,
     1     (hn(j),j=1,6),hn2s,hn2p
*
         else if( chPunch(i) .eq. ' IP ') then
           if( chTime.eq.'LAST' ) then
*          punch valence shell ip's
           do nelem=1,limelm
             do n=0,15,15
               if(n+1.le.nelem ) then
                 write(ipPnunit(i),'(1x)')
                 write(ipPnunit(i),'(a2,i4,29i6)')
     1           chElementSym(nelem),(ion,ion=n+1,min(n+15,nelem))
               endif
               if( n+1.le.nelem ) then
                 do ips=1,nsShells(min(n+15,nelem),1+n)
                   do j=n+1,min(n+15,nelem)
                     sum = PH1(1,nelem,nelem+1-j,ips)
                     if( sum.lt.2. ) then
                       chEner(j) = '      '
                     else if( sum.lt.10. ) then
                       write(chEner(j),'(f6.3)') sum
                     else if( sum.lt.100. ) then
                       write(chEner(j),'(f6.2)') sum
                     else if( sum.lt.1000. ) then
                       write(chEner(j),'(f6.1)') sum
                     else
                       write(chEner(j),'(i6)') int(sum)
                     endif
                   end do
                   write(ipPnunit(i),'(a2,30a6)') 
     1             chShell(ips), (chEner(j),j=n+1,min(n+15,nelem))
                 end do
               endif
             end do
           end do
           endif
*
         else if( chPunch(i).eq.'LINC') then
*          punch line cumulative
           if(chTime.ne.'LAST')call punlin( ipPnunit(i) , 'PUNC' ,lgOK)
*
         else if( chPunch(i).eq.'LINL' ) then
*          punch line labels, then stop
           call pllabels( ipPnunit(i) )
           stop
*
         else if( chPunch(i).eq.'LIND' ) then
*          punch line data, then stop
           call pldata( ipPnunit(i) )
           stop
*
         else if( chPunch(i).eq.'LINS' ) then
*          punch line structure
           if(chTime.ne.'LAST')call punlin( ipPnunit(i) , 'PUNS' , lgOK)
*
         else if( chPunch(i).eq.'LINA' ) then
           if( chTime.eq.'LAST' ) then
*          punch out all lines with energies
           do j=1,nsum
             if( xLineEnergy(j).gt.0. .and.sumlin(j).gt.0. ) then
               write(ipPnunit(i),'(1p,e12.5,0p,f8.3,2x,a4)')
     1         xLineEnergy(j)  , log10(sumlin(j))+pirsq , chALab(j)
*              write(ipPnunit(i),'(a4,1p,2e12.4)') 
*    1         chALab(j), xLineEnergy(j) , log10(sumlin(j))+pirsq
             endif
           end do
           endif
*
         else if( chPunch(i).eq.'LINI' ) then
           if( chTime.eq.'LAST'.and.
     1       (nzone/LinEvery)*LinEvery.ne.nzone) then
*            this is the last zone
*            punch line intensities - but do not do last zone twice
*            >>chng 97 july 24, following had (npunch) rather than (i)
             call plinin( ipPnunit(i) )
           else if( chTime.ne.'LAST' ) then
*            following so we only punch first zone if LinEvery reset
             if( (lgLinEvery .and. nzone.eq.1) .or.
     1         (nzone/LinEvery)*LinEvery.eq.nzone ) then
*              this is middle of calculation
*              punch line intensities
*              >>chng 97 july 24, following had (npunch) rather than (i)
               call plinin( ipPnunit(i) )
             endif
           endif
*
         else if( chPunch(i).eq.'LYMA' ) then
           pop = (hn2p/6.) / (hn(1)/2.)
           if( pop.gt.0. ) then
             texc = -1.183e5 / log(pop )
           else
             texc = 0.
           endif
           write(ipPnunit(i),'(1p,8e10.2)') depth,htau(2,1),pop,texc,te,
     1     texc/te,hdest(1,2),opac(iphl(2,1))
*
         else if( chPunch(i).eq.'MAP ' ) then
           if( chTime.eq.'LAST' ) then
             lgTlkSav = lgTalk
             lgTalk = .true.
             isav = qq
             qq = ipPnunit(i)
             call punt(' map')
             qq = isav
             lgTalk = lgTlkSav
           endif
*
         else if( chPunch(i).eq.'MOLE' ) then
           write(ipPnunit(i),'(1x,1p,7e10.2)') depth,
     1     htwo/hden , co/hden , h2o/hden, oh/hden, ch/hden , otwo/hden
*
         else if( chPunch(i).eq.'OPAC' ) then
*          punch opacity - routine will parse which type of opacity punch to do
           if(chTime.eq.'LAST')call PunOpac( ipPnunit(i) , i)
*
         else if( chPunch(i).eq.'OPTI' ) then
           if(chTime.ne.'LAST')write(ipPnunit(i),'(1p,4e12.4)') (anu(j),
     1     tautot(j,1) , tauabs(j,1) , tausct(j,1), j=1,nflux)
*
         else if( chPunch(i).eq.' OTS' ) then
           ConMax = 0.
           xLinMax = 0.
           opConSum = 0.
           opLinSum = 0.
           ipLinMax = 1
           ipConMax = 1
           do j=1,nflux
             opConSum = opConSum + otscon(j)*opac(j)
             opLinSum = opLinSum + otslin(j)*opac(j)
             if(otslin(j)*opac(j).gt.xLinMax ) then
               xLinMax = otslin(j) * opac(j)
               ipLinMax = j
             endif
             if(otscon(j)*opac(j).gt.ConMax ) then
               ConMax = otscon(j) * opac(j)
               ipConMax = j
             endif
           end do
           write(ipPnunit(i),'(1p,''tot con lin='',2e9.2,'' lin='',a4,
     1     e11.4,e9.2,'' con='',a4,e11.4,e9.2)')opConSum,opLinSum,
     2     chLineLabel(ipLinMax), anu(ipLinMax),xLinMax,
     1     chContLabel(ipConMax), anu(ipConMax),ConMax
*
         else if( chPunch(i).eq.'OVER' ) then
*          overview of model results,
*          depth, te, hden, eden, ion fracs H, He, c, O
           if(chTime.ne.'LAST')
     1     write(ipPnunit(i),'(1p,e10.4,0p,f6.3,f8.3,2f7.3,16f6.3)')
     1     depth,log10(te), log10(htot),log10(hden), log10(eden),
     1     -log10(max(5e-10,hi/hden)) ,-log10(max(5e-10,hii/hden)),
     2     (-log10(max(5e-10,xIonFracs(2,j)/xIonFracs(2,0))),j=1,3),
     2     (-log10(max(5e-10,xIonFracs(6,j)/xIonFracs(6,0))),j=1,4),
     2     (-log10(max(5e-10,xIonFracs(8,j)/xIonFracs(8,0))),j=1,6)
*
        else if( chPunch(i).eq.' PDR' ) then
         if( chTime.ne.'LAST' ) then
           av = tautot(ipVFilter,1) * 1.08574
           write(ipPnunit(i),'(1p,e8.2,8e9.2)') depth,colden,av,te,
     1     hi/hden, htwo/hden, xIonFracs(6,1)/xIonFracs(6,0),
     2     co/xIonFracs(6,0) ,
     2     h2o/xIonFracs(8,0)
         endif
*
        else if( chPunch(i).eq.' QS ' ) then
          if(chTime.eq.'LAST') then
            do j=1,nflux
              write(ipPnunit(i),'(1p,e11.4,10e9.1)')
     1        anu(j),
     1        (dqabs(j,ipdon(nd)), dqscat (j,ipdon(nd)),
     1        nd=1,ndston)
            end do
          end if
*    1    write(ipPnunit(i),'(1p,5e12.4)') (anu(j),(dqabs(j,nd),
*    1    dqscat (j,nd), nd=1,ndust),j=1,nflux)
*
        else if( chPunch(i).eq.'PHYS' ) THEN
          if(chTime.ne.'LAST')
     1    write(ipPnunit(i),'(1x,i4,1p,6e11.3)') nzone,depth,te,hden,
     1    eden, htot,AccelTot
*
        else if( chPunch(i).eq.'PRES' ) then
*         subtract continuum rad pres which has already been added on
          write(ipPnunit(i),'(1x,1p,7e10.2,l3)') depth, pnow,
     2    PressureInit+pinteg, PressureInit, GasPres, RadPres,
     2    pinteg-pinzon, lgPresOK
*
         else if( chPunch(i).eq.'RADI' ) then
           if(chTime.ne.'LAST')
     1     write(ipPnunit(i),'(1x,i4,1p,4e12.4)') nzone,radius,depth,
     1     drad
*
         else if( chPunch(i) .eq. 'RESU' ) then
*           punch results of the calculation
            if(chTime.eq.'LAST')call result( ipPnunit(i) )
*
         else if( chPunch(i).eq.'SOUS') then
*          full spectrum of continuum source function at 1 depth
*          command was "punch source spectrum"
           if(chTime.ne.'LAST')
     1     write(ipPnunit(i),'(1p,5e12.4)') (anu(j),
     1     DiffCont(j)/widflx(j),
     1     opac(j), DiffCont(j)/widflx(j)/max(1e-35,opac(j)) ,
     2     DiffCont(j)/widflx(j)/max(1e-35,opac(j))/plankf(j),
     3     j=1,min(maxcor,nflux))
*
        else if( chPunch(i).eq.'SOUD' ) then
*         parts of continuum source function vs depth
*         command was source depth
          j = ipHn(1) + 2
          write(ipPnunit(i),'(1p,5e12.4)') depabs(j),
     1    DiffCont(j)/widflx(j)/max(1e-35,opac(j)) , otscon(ipHn(1)),
     1    otscon(ipHn(1))/opac(ipHn(1))
*
*       this is punch special option
        else if( chPunch(i).eq.'SPEC' ) then
*        ne does not punch last zone, change to eq to only punch last zone
         call PunSpec(ipPnunit(i),chTime)
*
        else if( chPunch(i).eq.'TEGR' ) then
*         punch history of heating and cooling
          if(chTime.ne.'LAST')write(ipPnunit(i),'(1x,i4,1p,3e11.3)')
     1    (nZonGrid(j),TeGrid(j) , HtGrid(j),ClGrid(j),
     2    j=1,nGrid)
*
        else if( chPunch(i).eq.'TEMP' ) then
*         temperature and its derivative
          write(ipPnunit(i),'(1x,i4,1p,2e12.4)') nzone,te,
     1    (te-tlast)/drad
*
        else if( chPunch(i).eq.'TPRE' ) then
*         temperature and its predictors
          write(ipPnunit(i),'(i5,1p,3e11.4)') nzone, TeInit,TeProp,te
*
        else if( chPunch(i) .eq. 'VERN' ) then
*         work actually done in routine Fe2Lines in KatyaFe2
          continue
*
        else if( chPunch(i).eq.'WIND' ) then
*         wind velocity, radiative accel, and ratio total to e- accel
          write(ipPnunit(i),'(1p,5e12.4)') radius,depth,windv,AccelTot,
     1    fmul
*
        else
*         this is insanity, internal flag set in getpunch not seen here
          write(qq,'('' DOPUNCH does not recognize flag '',a4,
     1    '' set by GETPUNCH.  This is impossible.'')') chPunch(i)
          call ShowMe
          stop
        endif
*       at start of loop, broke to here if not last iteration,
*       and punch last was set
*       throw special line if punching every iteration
        if( chTime.eq.'LAST' .and. .not.lgLastIt ) then
          write(ipPnunit(i),'('' ###########################'')')
        endif
*999  continue
      endif
      end do
*
      end
