********************************************************************
      real function drecom( nd )
      implicit none
*compute electron recombination onto grains surface
      integer nd
*
      include "evryd.par"
      include "ndust.par"
      include "GrainPot.com"
      include "phycon.com"
      include "TePowers.com"
*
*     local variables
*     electron sticking prob
      real stick
      parameter (stick=1.)
      real psi , eta , sexp , ve , recoef
*
*     coef is qe(esu) / 300 / k to convert potential in volts to PSI 
*     in eV here
*     this is defined for impact by electrons
      psi = -1.*(dstpot(nd)*evryd) * 1.1606e4 / te
      if( psi .le.0. ) then
        eta = 1. - psi
      else
        eta = sexp( psi )
      endif
*
*     this is rec coef for neutral grain; corr fac next
*     VE is mean electron velocity
      ve = sqrte * 6.2124e5
*     this is neutral surface recomb rate for electrons
      recoef = ve * eden * stick
*
*     now do charge
      drecom = recoef * eta
*
      end
