******************************************************************************
      real function ee1(x)
      implicit none
*first exponential integral
      include "IOqq.com"
*
*     computes the exponential integral E1(x),
*     from abramowitz and stegun
*
      real x,a(6),b(4),c(4),ans,top,bot,alog
      data a/-.57721566,.99999193,-.24991055,.05519968,
     1 -.00976004,.00107857/
      data b/8.57332874,18.059016973,8.634760893,.267773734/
      data c/9.573322345,25.632956149,21.099653083,3.95849692/
*
      if(x.le.0) then
        write(qq,'('' Problem in function ee1, x<0'')')
        stop
      endif
*     
      if(x.lt.1.) then
        ans = a(1) + a(2)*x + a(3)*x*x + a(4)*x**3 + a(5)*x**4
     1      + a(6)*x**5 - alog(x)
      endif   
*
      if(x.ge.1.) then
        top = x**4 + b(1)*x**3 + b(2)*x*x + b(3)*x + b(4)
        bot = x**4 + c(1)*x**3 + c(2)*x*x + c(3)*x + c(4)
        ans = top/bot/x
      endif   
*
      ee1 = ans
      end
