******************************************************************************
      real function escla( esin , dest , abund )
      implicit none
*escape prob for hydrogen atom Lya, using Hummer and Kunasz results
      real esin , dest , abund
*
      include "sqrtpi.par"
      include "limelm.par"
      include "ncell.par"
      include "nhlvl.par"
      include "DoppVel.com"
      include "hesc.com"
      include "hfrcin.com"
      include "htau.com"
      include "htnext.com"
      include "iphl.com"
      include "opac.com"
      include "redis.com"
      include "twoway.com"
      include "h.com"
      include "IOqq.com"
      include "phlevl.com"
*
*     local variables
      real beta , conopc , dstin, dstout,damp,escsub
*
*     this is one of the three fundamental escape probability functions
*     the three are esccom, escinc, and escla
*     evaluate esc prob for LA
*     optical depth in outer direction always defined
*
      if( htlim(2,1)-htnext(2,1) .lt.0. ) then
*       this is the case if we overrun the optical depth scale
*       just leave things as they are
        escla = hesc(2,1)
        fracin = hfrcin(2,1) 
        esin = fracin
        dest = hdest(1,2)
        return
      endif
*
      if( chRedis.eq.'INCO' ) then
*       incomplete redistribution
        conopc = opac( iphl(2,1) )
*       abund = hn(1)*hii
        if( abund.gt.0. ) then
          beta = conopc / ( abund/sqrtpi *hopac(2,1)/doppler(1)+conopc)
        else
          beta = 1.
        endif
*
*       WAYIN will be escape prob in inward direction
        call humla( htnext(2,1) , beta , wayin, dstin)
        if( wayin.gt.1..or.wayin.lt.0. .or. dstin.gt.1. .oR.
     1    dstin.lt.0. ) then
          write(qq,'('' HUMLA returns inwd prob out of bounds; '',
     1    '' esc='',1P,E10.2,'' dst='',E10.2,'' beta='',E10.2,
     2    '' tau='',E10.2)')
     3    wayin , dstin , beta , htnext(2,1)
          stop
        endif
*
        call humla( max(htlim(2,1)/100.,htlim(2,1)-htnext(2,1))
     1  , beta , wayout, dstout )
        if( wayout.gt.1..or.wayout.lt.0. .or. dstout.gt.1. .or.
     1    dstout.lt.0. ) then
          write(qq,'('' HUMLA returns outwd prob out of bounds; '',
     1    '' esc='',1P,E10.2,'' dst='',E10.2,'' beta='',E10.2,
     2    '' tau='',E10.2)')
     3    wayout , dstout , beta , 
     4    max(htlim(2,1)/100.,htlim(2,1)-htnext(2,1))
          stop
        endif
        escla = (wayin + wayout) / 2.
*666    write(8,'('' ein ot din ot='',1p,4e10.2,'' beta'',e10.2)')
*    1  wayin,wayout, dstin,dstout,beta
        esin = wayin
        dest = (dstin + dstout ) / 2.
        fracin = wayin / (wayin + wayout )
      else
*       wind or complete redis
        escla = escsub( htnext(2,1) , htlim(2,1) , damp )
        esin = wayin
        fracin = 0.5
        dest = 0.
      endif
*666  write(6,'('' Lya prob'',1p,9e11.4)') escla,dest,beta,conopc
*
      if( escla.lt.0. ) then
        write(qq,'('' ESCLA returns a negative value, of'',1P,E10.2)')
     1  escla
        write(qq,'('' ESCLA: the redistribution type was '',A4)')chRedis
        write(qq,'('' The optical depths are '',1P,2E10.2)') 
     1     htnext(2,1) , htlim(2,1)
        call ShowMe
        stop
      endif
*
      end
