******************************************************************************
      subroutine esum
      implicit none
*sum free electron density over all species, sets variable EdenTrue
*called by ionize which actually controlls the electron density updates
      include "edxtra.com"
      include "TrueEden.com"
      include "ffsum.com"
      include "trace.com"
      include "h.com"
      include "he.com"
      include "limelm.par"
      include "IonFracs.com"
      include "phycon.com"
      include "hvmolEXP.com"
      include "hmi.com"
      include "EdenOther.com"
      include "nebug.com"
      include "search.com"
      include "IOqq.com"
*
*     local variables
      integer nelem,i
      real csum , osum , edsave(limelm) , edmole
*
*     free statement number >=14
*
*     EdenExtra is normally zero, set with EDEN command, to add extra e-
      EdenTrue = hii + heii + 2.*heiii + EdenExtra
*     add on molecules
      edmole = EdenTrue
      EdenTrue = EdenTrue + h2plus + chp + ohp + cop + h2op + o2p +
     1 c2p + h3op + ch2p + h3plus
*     remember electron density from molecules
      edmole = EdenTrue - edmole
*     >>chng 97 mar 18, some extreme models have H- density very large during
* 666 Error! cap below should be elsewhere, this sub should return TrueEden
*search phase when far from solution.  do not let eden go neg
      if( lgSearch ) then
        EdenTrue = EdenTrue - min(EdenTrue*0.05,hminus)
      else
        EdenTrue = EdenTrue - min(EdenTrue/100.,hminus)
      endif
*
*     sum over all metals
      EdenMet = 0.
      EdenFFSum = 0.
      do nelem=3,limelm
        edsave(nelem) = 0.
        do i=1,nelem
*         >>chng 96 oct 27, save all contributors to electron density
          edsave(nelem) = edsave(nelem) + float(i)*xIonFracs(nelem,i+1)
          EdenFFSum = EdenFFSum + float(i*i)*xIonFracs(nelem,i+1)
        end do
        EdenMet = EdenMet + edsave(nelem)
      end do
*
      EdenTrue = EdenTrue + EdenMet
*     FFSUM is sum of effective contribution to heavy element free-free
*     >>chng 97 sep 4, get rid of extra variable, should make no change
*     ffsum = EdenFfsum
*
*     get all electrons not due to hydrogen
      EdenNotH = EdenTrue - hii
*
      if( lgTrace ) then
        csum = 0.
        do i=1,6
          csum = csum + float(i)*xIonFracs(6,i+1)
        end do
        osum = 0.
        do i=1,8
          osum = osum + float(i)*xIonFracs(8,i+1)
        end do
        write(qq,'(5X,''ESUM: TrueEden'',1P,E11.4,'' old'',
     1  E11.4,'' ff sum'',E10.3,'' H'',E8.2,'' He'',
     2  E8.2,'' C'',E8.2,'' O'',E8.2,'' met'',e8.2,'' mol'',e8.2)') 
     3  EdenTrue , eden , EdenFFSum , hii , heii+2.*heiii,
     4  csum,osum,EdenMet,edmole
        if(lgNeBug) write(qq,'(4x,1p,15e8.1)') edsave
      endif
*
      if( EdenTrue.le. 0. ) then
        write(qq,'(''ESUM finds non-positive electron density.'')')
        write(qq,'(5X,''ESUM: EdenTrue to'',1P,E12.4,'' fm'',
     1  E12.4,'' ff sum;'',E10.3,'' Ne(H):'',E9.2,'' Ne(He):'',
     2  E9.2,'' Ne(C):'',E9.2,'' Ne(O):'',E9.2)') 
     3  EdenTrue , eden , EdenFFSum , hii , heii+2.*heiii
        call ShowMe
        stop
      endif
*
      end
