***********************************************************************
       subroutine fe14cs(te1,csfe14)
       implicit none
* compute collision strengths for forbidden transitions 
* w/in Fe XIV ground term. From 
*      >>refer Storey, P.J., Mason, H.E., Saraph, H.E., 1996, A&A, 309, 677
*
       real csfe14
       real a,b,c,d
       real telog1,telog2,telog3,te1

* limit range in log T:

       telog1 = te1
       telog1 = min(9.0, telog1)
       telog1 = max(4.0, telog1)
*
* compute square and cube
*
       telog2 = telog1 * telog1
       telog3 = telog1 * telog1 * telog1
*
* compute cs:
*
       if (telog1 .le. 5.0) then
         a = 557.05536
         b = -324.56109
         c = 63.437974
         d = -4.1365147
         csfe14 = a + b*telog1 + c*telog2 + d*telog3
       else
         a = 0.19515493
         b = 2.9404407
         c = 4.9578944
         d = 0.79887506
         csfe14 = a + b*exp(-0.5*((telog1-c)*(telog1-c)/d))
       endif
       end
