******************************************************************************
      subroutine fe2ir( totir , fe2 )
      implicit none
*cooling due to FIR lines of ground term of FeII
      real totir , fe2
      double precision zz(6,6) 
      include "h.com"
      include "phycon.com"
      include "teinv.com"
      include "edsqte.com"
      include "called.com"
      include "dcool.com"
      include "IOqq.com"
*
*     local variables
      real a21 , a32 , a43 , a54 , fexp , x
      real e12,e23,e34,e45,c21,c12,c31,c13,c41,c14,c15,c51
      real c32,c23,c42,c24,c52,c25,c43,c34,c53,c35,c54,c45
      integer i , ner
      real p2,p3,p4,p5 , dirdt
      data a21/2.13e-3/ , a32/1.57e-3/ , a43/7.18e-4/ ,
     1 a54/1.88e-4/
*
      fexp(x) = 1. + x * ( -0.9664 + 0.3536*x )
*
*     compute emission from 6D ground term of FeII
*     collision data from Pradhan and Zhang Ap.J. Let 409, L77
*     trans prob from Nussbaumer and Storey 1988 AstAp 193, 327.
*
      if( (fe2.le.0.) .or. (eden.gt.1e10) ) then
        totir = 0.
        return
      endif
*
*     five levels within ground term
*     level  J  excit energy
*     1      9/2   0
*     2      7/2 385
*     3      5/2 668
*     4      3/2 863
*     5      1/2 977
*
      if( te.gt.800. ) then
        e12 = fexp(553.6*teinv)
        e23 = fexp(407.*teinv)
        e34 = fexp(280.*teinv)
        e45 = fexp(164.*teinv)
      else
        e12 = exp(-553.6*teinv)
        e23 = exp(-407.*teinv)
        e34 = exp(-280.*teinv)
        e45 = exp(-164.*teinv)
      endif
*
*     extra neutral collisions from Tielens and Hollenbach 1985
      c21 = cdsqte * 5.8 / 8. + 9.5e-10*hi
      c12 = c21 * 0.8 * e12
      c31 = cdsqte * 1.6 / 6.
      c13 = c31 * 0.6 * e12*e23
      c41 = cdsqte * 0.75 / 4.
      c14 = c41 * 0.4 * e12*e23*e34
      c51 = cdsqte * 0.32 / 2.
      c15 = c51 * 0.2 * e12*e23*e34*e45
*
      c32 = cdsqte * 5.6 / 6. + 4.7e-10*hi
      c23 = c32 * 0.75 * e23
      c42 = cdsqte * 1.25 / 4.
      c24 = c42 * 0.5 * e23*e34
      c52 = cdsqte * 0.45 / 2.
      c25 = c52 * 0.25 * e23*e34*e45
*
      c43 = cdsqte * 4.46 / 4. + 5.7e-10*hi
      c34 = c43 * 0.6667 * e34
      c53 = cdsqte * 0.74 / 2.
      c35 = c53 * 0.3333 * e34*e45
*
      c54 = cdsqte * 2.72 / 2.
      c45 = c54 * 0.5 * e45
*
*---------------------------------------------------------
*
      do i=1,5
        zz(5,i) = 1.0
        zz(i,6) = 0.
      end do
      zz(5,6) = fe2
*
*     level one balance equation
      zz(1,1) = c12+c13+c14+c15
      zz(1,2) = -a21 - c21
      zz(1,3) = -c31
      zz(1,4) = -c41
      zz(1,5) = -c51
*
*     level two
      zz(2,1) = -c12
      zz(2,2) = a21+c21+c23+c24+c25
      zz(2,3) = -c32 - a32
      zz(2,4) = -c42
      zz(2,5) = -c52
*
*     level three
      zz(3,1) = -c13
      zz(3,2) = -c23
      zz(3,3) = a32+c31+c32+c34+c35
      zz(3,4) = -a43 - c43
      zz(3,5) = -c53
*
*     level four
      zz(4,1) = -c14
      zz(4,2) = -c24
      zz(4,3) = -c34
      zz(4,4) = a43+c43+c42+c41+c45
      zz(4,5) = -c54 - a54
*
      call matin1(zz,6,5,1,ner)
      if( ner.ne.0 ) then
        if( lgTalk ) write(qq,'('' fe2 ir matrix error'')')
        if( lgCalled ) then
          lgBusted = .true.
          return
        else
          stop
        endif
      endif
*
      p2 = zz(2,6)
      p3 = zz(3,6)
      p4 = zz(4,6)
      p5 = zz(5,6)
*
*     transition wavelengths =25.98mic, 35.34, 51.29, 87.36 
*                              2-1      3-2    4-3    5-4
*     this is the total cooling
      totir = p2*a21*7.66e-14 + p3*a32*5.63e-14
     1      + p4*a43*3.88e-14 + p5*a54*2.26e-14
*     now put into cooling array
      call coladd( 'Fe 2' , 1 , totir  )
*
*     this is its derivative
      dirdt = p2*a21*7.66e-14*(553.6*tsq1 - halfte) +
     1 p3*a32*5.63e-14*(960.6*tsq1-halfte)  +
     2 p4*a43*3.88e-14*(1240.6*tsq1-halfte) +
     3 p5*a54*2.26e-14*(1404.6*tsq1-halfte)
      dCooldT = dCooldT + dirdt
*
      end
