****************************************************************
      subroutine Fe2Lines( chFunction, renorm )
      implicit none
*save accumulated FeII intensities, punch out at end of run
      real renorm
      character chFunction*3
*
      include "nta.par"
      include "nFe2LevN.par"
      include "ipLnArry.par"
      include "ioVerner.com"
      include "Fe2LevN.com"
      include "dRdVeff.com"
      include "linsum.com"
      include "fourpi.com"
      include "called.com"
      include "ipdr.com"
      include "lastit.com"
      include "feiipar.com"
      include "IOqq.com"
*
*     local variables
      logical lgPunch , lgOK
      real TauMase , hbeta, absint , thresh
      real Fe2SavN(nFe2LevN,nFe2LevN )
      save Fe2SavN
*
*     local variables
      integer iup, low , MaseLow , MaseHi , limit
*
*     this routine puts the emission from Katya's FeII atom
*     into a line array, and eventually will punch it out
*
*     this is test for whether option is enabled with "punch feii"
      if( ioVerner.eq.0 ) return
      if( ipHiVernFe2 .eq.0 ) then
        limit = nFe2LevN
      else
        limit = ipHiVernFe2
      endif
*
      if(  chFunction.eq.'add' ) then
        if( ipass.eq.0 ) then
*         we were called by lines, and we want to zero out Fe2SavN
          do low=1,limit-1
            do iup=low+1,limit
              Fe2SavN(iup,low) = 0.
            end do
          end do
        else if( ipass.eq.1 ) then
*         total emission from vol
          do low=1,limit-1
            do iup=low+1,limit
              Fe2SavN(iup,low) = Fe2SavN(iup,low) +
     1        dVeff * Fe2LevN(ipLnInten,iup,low)
            end do
          end do
        else
*         this cannot happen
          write(qq,'('' Fe2Lines called with insane ipass='',i3)')
     1    ipass
          stop
        endif
*
*     here is where punch really takes place
      else if( chFunction.eq.'pun' ) then
        if( lgLastIt ) then
          lgPunch = .true.
        else
          if( lgFe2PLst ) then
            lgPunch = .false.
          else
            lgPunch = .true.
          endif
        endif
        if( lgPunch ) then
          write(ioVerner,'('' up low log I, I/I(norm), Tau'')')
*         first check on masing lines
          TauMase = 0.
          do low=1,limit-1
            do iup=low+1,limit
              if( Fe2LevN(ipLnTauIn,iup,low).lt.TauMase ) then
                TauMase = Fe2LevN(ipLnTauIn,iup,low)
                MaseLow = low
                MaseHi = iup
              endif
            end do
          end do
          if( TauMase.lt.0. ) write(ioVerner,'('' Most negative '',
     1    ''optical depth was '',2i4,1p,e10.2)') MaseHi,MaseLow,TauMase
*         actual line intensities, Hbeta first
          call cdLine( 'TOTL',4861, hbeta, absint, lgOK )
          write(ioVerner,'(2i3,f7.3,1p,2e9.2)') 4,2,
     1    absint+pirsq , hbeta
          thresh = fe2thresh / renorm
          do low=1,limit-1
            do iup=low+1,limit
*             fe2ener(1) and (2) are lower and upper limits to range of
*             wavelengths of interest.  entered in ryd with
*             punch feii verner range command, where they are converted
*             to wavenumbers
              if( Fe2SavN(iup,low).gt.thresh .and.
     1          Fe2LevN(ipLnEnrWN,iup,low).gt.fe2ener(1).and.
     2          Fe2LevN(ipLnEnrWN,iup,low).lt.fe2ener(2) ) then
                if( lgShortFe2 ) then
*                 short printout does not include rel intensity or optical dep
                  write(ioVerner,'(2i3,f7.3,1p,2e9.2)') iup,low,
     1            log10(max(1e-37,Fe2SavN(iup,low)))+pirsq 
                else
*                 long printout does
                  write(ioVerner,'(2i3,f7.3,f9.4,1p,e10.2)') iup,low,
     1            log10(max(1e-37,Fe2SavN(iup,low)))+pirsq ,
     1            Fe2SavN(iup,low) * renorm , Fe2LevN(ipLnTauIn,iup,low)
                endif
              endif
            end do
          end do
        endif
      else
        write(qq,'('' Fe2Lines called with insane job='',a3)')
     1  chFunction
        stop
      endif
*
      end
