******************************************************************************
      subroutine fecol
      implicit none
*compute iron cooling
      include "itrdim.par"
      include "limLevelN.par"
      include "limelm.par"
      include "ncell.par"
      include "nta.par"
      include "nfeii.par"
      include "nhlvl.par"
      include "ndfst.par"
      include "ipLnArry.par"
      include "dcool.com"
      include "coolfe.com"
      include "PopLevls.com"
      include "resion.com"
      include "IterCnt.com"
      include "TLineEXP.com"
*     include "fe2pop.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "h.com"
      include "escdst.com"
      include "opac.com"
      include "occnum.com"
      include "ots.com"
      include "dstfe2.com"
      include "phlevl.com"
      include "hyas.com"
      include "logte.com"
      include "TauDmmy.com"
      include "Fe2Neg.com"
      include "FeIIAtom.com"
      include "ZoneCnt.com"
      include "search.com"
      include "PLyaFeII.com"
      include "heating.com"
      include "holod.com"
      include "KatyaDat.com"
      include "cooltr.com"
      include "trace.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      integer nlFe2
      logical lgNegPop
      parameter (nlFe2=6)
      real popFe2(nlFe2) , data(nlFe2,nlFe2) , gFe2(nlFe2) , ex(nlFe2),
     1 dest(nlFe2,nlFe2) , pump(nlFe2,nlFe2) 
      integer ipdest(nlFe2,nlFe2)
      integer i , j , nzsave
      save nzsave , tesave
      real dFe2dt , tused
      real sexp ,  p2,pop3,popexc,cs, cs2s2p,cs2s3p , tesave
*
      data nzsave/-1/ , tesave/-1./
*
*     stat weights for Fred's 6 level model FeII atom
      data gFe2/6*1./ 
*     excitation energies (Kelvin) for Fred's 6 level model FeII atom
      data  ex/0. , 3.32e4 , 5.68e4 , 6.95e4 , 1.15e5 , 1.31e5 /
*
*     series of FeI lines from Dima Verner's list, each 2-lev atom
*
*     Fe I 3884
      call MakeCS( FeI3884 )
      call level2( FeI3884 )
*
*     Fe I 3729
      call MakeCS( FeI3729 )
      call level2( FeI3729 )
*
*     Fe I 3457
      call MakeCS( FeI3457 )
      call level2( FeI3457 )
*
*     Fe I 3021
      call MakeCS( FeI3021 )
      call level2( FeI3021 )
*666  write(6,'('' fei3021'',i4,1p,10e10.2)')
*    1 nzone,te,fe(1),fei3021(ipLnHeat),
*    1 fei3021(ipLnCool),fei3021(ipLnPump),fei3021(ipLnAovTOT),
*    2 fei3021(ipLnColovTOT)
*
*     Fe I 2966
      call MakeCS( FeI2966 )
      call level2( FeI2966 )
*
*
      if( chFeIIAtom.eq.'Verner' ) then
*       this is the Verner's 371 level FeII atom
*666    error! evaluate this destruction probability!!
        dstfe2lya = 0.
        escfe2 = 0.
*       >>chng 97 jan 17, evaluate Katya cooling every time temp changes
*       if( nzone.ne.nzsave .or. lgSearch ) then
*       >>chng 97 jan 31, added check on zone since must reeval even const temp
        if( lgSimKatya ) then
          nzsave = nzone
          tesave = te
          Fecool = 0.
          feheat = 0.
        else if( tesave.ne.te .or. nzone.ne.nzsave .or. lgSearch ) then
*         only call pop371 one time per temperature or zone
          call KatyaFe2
          nzsave = nzone
          tesave = te
          Fecool = fcool
*         counts as heating derivative if negative cooling
          if( Fecool.gt.0. ) dCooldT = dCooldT + dfcool
          call coladd( 'Fe 2' , 0 , max(0.,fcool) )
          heating(26,28) = max(0.,-fcool)
*         >>chng 97 mar 27 add sumheat call
*         likely that total heating was affected by feii atom
          call SumHeat
          if( lgTrace.and.lgCoolTr ) then
            write(qq,'('' Katya FeII returns te, cooling, dc='',
     1      1p,4e11.3)') te,Fecool,dfcool
          endif
        else
*         this is case where temp is unchanged, so heating and cooling same too
          Fecool = fcool
          dCooldT = dCooldT + dfcool
          call coladd( 'Fe 2' , 0 , max(0.,fcool) )
          heating(26,28) = max(0.,-fcool)
        endif
      else
        feheat = 0.
*
*       following treatment of Fe II follows
*       >>refer Wills, B.J., Wills, D., Netzer, H. 1985, ApJ, 288, 143
*       all elements are used, and must be set to zero if zero
        do i=1,nlFe2
          do j=1,nlFe2
            data(i,j) = 0.
            dest(i,j) = 0.
            pump(i,j) = 0.
            ipdest(i,j) = 0
          end do
        end do
        data(2,1) = 1.
         data(3,1) = tuv3(ipLnEscP)*tuv3(ipLnAul)
         dest(3,1) = tuv3(ipLnDesP)*tuv3(ipLnAul)
         pump(3,1) = tuv3(ipLnPump)
        ipdest(3,1) =tuv3(ipLnIpCont)
*
        data(6,1) = tFe16(ipLnEscP)*tFe16(ipLnAul)
        dest(6,1) = tFe16(ipLnDesP)*tFe16(ipLnAul)
*       continuum pumping of n=6
        pump(6,1) = tFe16(ipLnPump)
*       Ly-alpha pumping
        if( xIonFracs(26,2).gt.0. ) then
          PumpLyaFeII = hn2p*hii*hyas(2,1)*dstfe2lya/xIonFracs(26,2)
          pump(6,1) = pump(6,1) + PumpLyaFeII
        else
          PumpLyaFeII = 0.
        endif
        ipdest(6,1) = tFe16(ipLnIpCont)
*
        data(3,2) = tr48(ipLnEscP)*tr48(ipLnAul)
        dest(3,2) = tr48(ipLnDesP)*tr48(ipLnAul)
        pump(3,2) = tr48(ipLnPump)
        ipdest(3,2) = tr48(ipLnIpCont)
*
        data(6,2) = tFe26(ipLnEscP)*tFe26(ipLnAul)
        dest(6,2) = tFe26(ipLnDesP)*tFe26(ipLnAul)
        pump(6,2) = tFe26(ipLnPump)
        ipdest(6,2) = tFe26(ipLnIpCont)
*
        data(4,3) = tFe34(ipLnEscP)*tFe34(ipLnAul)
        dest(4,3) = tFe34(ipLnDesP)*tFe34(ipLnAul)
        pump(4,3) = tFe34(ipLnPump)
        ipdest(4,3) = tFe34(ipLnIpCont)
*
        data(5,3) = tFe35(ipLnEscP)*tFe35(ipLnAul)
        dest(5,3) = tFe35(ipLnDesP)*tFe35(ipLnAul)
        pump(5,3) = tFe35(ipLnPump)
        ipdest(5,3) = tFe35(ipLnIpCont)
*
        data(6,4) = tFe46(ipLnEscP)*tFe46(ipLnAul)
        dest(6,4) = tFe46(ipLnDesP)*tFe46(ipLnAul)
        pump(6,4) = tFe46(ipLnPump)
        ipdest(6,4) = tFe46(ipLnIpCont)
*
        data(6,5) = tFe56(ipLnEscP)*tFe56(ipLnAul)
        dest(6,5) = tFe56(ipLnDesP)*tFe56(ipLnAul)
        pump(6,5) = tFe56(ipLnPump)
        ipdest(6,5) = tFe56(ipLnIpCont)
*
*       these are collision strengths
        data(1,2) = 1.
        data(1,3) = 12.
        data(1,4) = 1.
        data(1,5) = 1.
        data(1,6) = 12.
        data(2,3) = 6.
        data(2,4) = 1.
        data(2,5) = 1.
        data(2,6) = 12.
        data(3,4) = 6.
        data(3,5) = 12.
        data(3,6) = 1.
        data(4,5) = 1.
        data(4,6) = 12.
        data(5,6) = 6.
*
        call LevelN(nlFe2,nlFe2,xIonFracs(26,2),gFe2,ex , popFe2,data,
     1   dest,pump, ipdest, Fecool,dFe2dt,'FeII', lgNegPop)
        if( lgNegPop ) nFe2Neg = nFe2Neg + 1
        call coladd( 'Fe 2' , 0 , max(0.,Fecool) )
        heating(26,28) = max(0.,-Fecool)
        dCooldT = dCooldT + dFe2dt
        tuv3(ipLnPopl) = popFe2(1)
        tuv3(ipLnPopOpc) = popFe2(1) - popFe2(3)
        emuv3 = popFe2(3) * data(3,1)*tuv3(ipLnEnrErg)
        tuv3(ipLnNPhots) = popFe2(3) * data(3,1)
        otsfe2 = popFe2(3) * tuv3(ipLnDesP)*tuv3(ipLnAul)
*
        tr48(ipLnPopl) = popFe2(2)
        tr48(ipLnPopOpc) = popFe2(2) - popFe2(3)
        rmt48 = popFe2(3) * data(3,2)* tr48(ipLnEnrErg)
        tr48(ipLnNPhots) = popFe2(3) * data(3,2)
*
        for7 = popFe2(2)*data(2,1)*4.65e-12
*
        tFe16(ipLnPopl) = popFe2(1)
        tFe16(ipLnPopOpc) = popFe2(1) - popFe2(6)
        tFe16(ipLnNPhots) = popFe2(6)*data(6,1)
        cFe16 = tFe16(ipLnNPhots)*tFe16(ipLnEnrErg)
*
        tFe26(ipLnPopl) = popFe2(2)
        tFe26(ipLnPopOpc) = popFe2(2) - popFe2(6)
        tFe26(ipLnNPhots) = popFe2(6)*data(6,2)
        cFe26 = tFe26(ipLnNPhots) *tFe26(ipLnEnrErg)
*
        tFe34(ipLnPopl) = popFe2(3)
        tFe34(ipLnPopOpc) = popFe2(3) - popFe2(4)
        tFe34(ipLnNPhots) = popFe2(4)*data(4,3)
        cFe34 = tFe34(ipLnNPhots) *tFe34(ipLnEnrErg)
*
        tFe35(ipLnPopl) = popFe2(3)
        tFe35(ipLnPopOpc) = popFe2(3) - popFe2(5)
        tFe35(ipLnNPhots) = popFe2(5)*data(5,3)
        cFe35 = tFe35(ipLnNPhots) *tFe35(ipLnEnrErg)
*
        tFe46(ipLnPopl) = popFe2(4)
        tFe46(ipLnPopOpc) = popFe2(4) - popFe2(6)
        tFe46(ipLnNPhots) = popFe2(6)*data(6,4)
        cFe46 = tFe46(ipLnNPhots) *tFe46(ipLnEnrErg)
*
        tFe56(ipLnPopl) = popFe2(5)
*       tFe56(ipLnPopOpc) = popFe2(5) - popFe2(6)
*       >>chng 96 apr 23 this levels mases due to Lya pump
        tFe56(ipLnPopOpc) = popFe2(5) - popFe2(6)*0.
        tFe56(ipLnNPhots) = popFe2(6)*data(6,5)
        cFe56 = tFe56(ipLnNPhots) *tFe56(ipLnEnrErg)
*
*       Jack's funny FeII lines, data from 
*       >>refer Johansson, S., Brage, T., Leckrone, D.S., Nave, G. &
*       >>refer Wahlgren, G.M. 1995, ApJ 446, 361
        call PutCS( 10., t191 )
        call level2( t191 )
*
*       do 16 level ground + first two terms
        call Fe2Lev16
      endif
*
*     lump 3p and 3f together; cs=
*     >>refer Garstang, R.H., Robb, W.D., Rountree, S.P. 1978, ApJ, 222, 384
*     A from
*     >>refer Garstang, R.H., 1957, Vistas in Astronomy, 1, 268
*     FE III 5270, is 20.9% of total
      c5270 = popexc(5.53,25.,30.,0.435,2.948e4,xIonFracs(26,3))*
     1 3.78e-12
      call coladd( 'Fe 3' , 5270 , c5270 )
*
*     FeIII 1122 entire multiplet - atomic data=A's Dima, CS = guess
      call PutCS( 25., t1122 )
      call level2( t1122 )
*
*     call 12 level atom
      call Fe4Lev12
*
*     FE V 3892 + 3839, data from Shields
      c3892 = popexc(7.4,25.,5.,0.6,3.7e4,xIonFracs(26,5))*5.11e-12
      call coladd( 'Fe 5' , 3892 , c3892 )
*
*     FE VI 5177+5146+4972+4967
*     data from 
*     >>refer Garstang, R.H., Robb, W.D., Rountree, S.P. 1978, ApJ, 222, 384
      c5177 = popexc(1.9,28.,18.,0.52,2.78e4,xIonFracs(26,6))*3.84E-12
      call coladd( 'Fe 6' , 5177 , c5177 )
*
*     >>chng 97 jan 6 added fir lines, cs from 
*     >>refer Keenan, F.P., & Norrington, P.H. 1987 A&A, 181, 370
*     [FeVII] 9.51, 7.81 micron lines
      if( te.lt.1.5e4 ) then
        cs = min(1.49, 374.8/(sqrte*te10) )
        call PutCS( cs , Fe0795 )
        cs = min(1.57, 188.5/(sqrte*te02) )
        call PutCS( cs , Fe0778 )
        cs = min(0.389, 51.32/(sqrte*te03) )
        call PutCS( cs , TauDummy )
      else
        cs = min(1.17, 7.929/(te20/te001) )
        call PutCS( cs , Fe0795 )
        cs = min(1.27, 5.638/(te10*te05*te005) )
        call PutCS( cs , Fe0778 )
        cs = min(0.314, 1.491/(te10*te05*te01*te001*te001) )
        call PutCS( cs , TauDummy )
      endif
      call level3(  Fe0795,Fe0778,TauDummy )
*
*     FE VII 6087, A from 
*     >>refer Nussbaumer, H., & Storey, P.J. 1982, A&A, 113, 21
*     cs from 
*     >>refer Keenan, F.P., & Norrington, P.H. 1987 A&A, 181, 370
      tused = max(4.0,alogte)
      tused = min( 5.1, tused )
      cs = 2.2684 - tused* (0.60893 - 0.052004*tused)
*     >>chng 97 jan 27, should have been total collision strength of multiplet
*     thanks for Tino Oliva for finding this problem
      cs = cs * 2.96
      c6087 = popexc(cs ,21.,5.,0.94,2.32e4,xIonFracs(26,7))*3.27E-12
     1 * 0.577/0.94
      Fe5722 = c6087 * 0.629 * 6087./5722.
      dCooldT = dCooldT + c6087 * 2.37e4*tsq1
      call coladd( 'Fe 7' , 6087 , c6087 )
      call coladd( 'Fe 7' , 5722 , Fe5722 )
*
*     Fe IX 245,242
*     all atomic data from 
*     >>refer Flower, D.R. 1976, A&A, 56, 451
      call PutCS( 0.123 , t245 )
*     beseq(cs23,cs24,cs34,tarray,a41)
*     C245 = BESEQ( .087 ,.038 ,.188 , t245 ,71. )  * 8.14E-11
      call beseq( .087 ,.038 ,.188 , t245 ,71. )
      c242 = PopLevels(3) * 8.22E-11 * 71.
*
*     Fe X 6374, A from 
*     >>refer Mason, H. 1975, MNRAS 170, 651
*     cs 
*     >>refer Mohan, M., Hibbert, A., & Kingston, A.E. 1994, ApJ, 434, 389
*     not used newer cs from 
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
*     does not agree with Mohan et al. by factor of 4
*     20x larger than Mason numbers used pre 1994
      cs = max(0.1, 13.3 - 2.*min(7.0,alogte ) )
* 666 error! following to stop insane FeX strengths
*     >>chng 96 july 11, removed 1/10 factor, so using real data, 90.01
*     cs = cs * 0.1
*     >>chng 96 june 3, transferred following
*     >>chng 97 jan 31, give up on this mess, use cs of unity
      cs = 1.
      call PutCS( cs , Fe106375 )
      call level2( Fe106375 )
*     c6374 = popexc(cs ,4.,2.,69.5,2.26e4,xIonFracs(26,10))*3.12e-12
*     dCooldT = dCooldT + c6374 * 2.26e4 * tsq1
*     call coladd( 'Fe10' , 6374 , c6374 )
*
*     this is the E1 line that can pump [FeX]
      cs = max(0.05 , 0.85 * sexp( 0.045*1.259e6/te ) )
      call PutCS( cs , t352 )
      call level2( t352 )
*
*     Fe XI 7892, 6.08 mic, CS from 
*     >>refer Mason, H. 1975, MNRAS 170, 651
*     A from 
*     >>refer Mendoza, C., & Zeippen, C.J. 1983, MNRAS, 202, 981
      cs = 0.27
*     >>chng 97 jan 31, set cs to unity, above ignored resonances
      cs = 1.
      call PutCS( cs , tFe07 )
      call PutCS( 0.036 , tFe61 )
      call PutCS( 0.11 , TauDummy )
      call level3(tFe07,tFe61,TauDummy)
*
*     Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1467 = pop3(9.,5.,1., .24,.028,.342, 100.,1012.,9.3,
     1 5.43E4,6.19e4,p2,xIonFracs(26,11),0.) * 1012. * 1.36E-11
      call coladd( 'Fe11' , 1467 , c1467 )
      c2649 = p2 * 91.0 * 7.512E-12
      call coladd( 'Fe11' , 2469 , c2649 )
*
*     A's for 2-1 and 3-1 from 
*     >>refer Tayal, S.S., & Henry, R.J.W. 1986, ApJ, 302, 200
*     CS fro 
*     >>refer Tayal, S.S., Henry, R.J.W., Pradhan, A.K. 1987, ApJ, 319, 951
*     a(3-2) scaled from both ref
      c2568 = pop3( 4.,10.,6., 0.72,0.69,2.18 , 8.1E4,1.84E6,1.33E6,
     1 6.37e4,4.91e4 , p2 , xIonFracs(26,12) ,0. ) * 1.33E6 * 6.79E-12
      call coladd( 'Fe12' , 2568 , c2568 )
      c1242 = c2568 * 2.30 * 1.38
      call coladd( 'Fe12' , 1242 , c1242 )
      c2170 = p2 * 8.09e4 * 8.82E-12
      call coladd( 'Fe12' , 2170 , c2170 )
*
*     [Fe XIII] 1.07, 1.08 microns, no collision data available
      call PutCS( 1. , Fe1310 )
      call PutCS( 1. , Fe1311 )
      call PutCS( 1. , TauDummy )
      call level3(Fe1310,Fe1311,TauDummy)
*
*     Fe XIV 5303, cs from 
*     >>refer Storey, P.J., Mason, H.E., Saraph, H.E., 1996, A&A, 309, 677
      call fe14cs(alogte,cs)
*     >>chng 97 jan 31, set cs to unity, above is VERY large, >10
      cs = 1.
      c5303 = popexc(cs ,2.,4.,60.3,2.71e4,xIonFracs(26,14))*3.75E-12
      dCooldT = dCooldT + c5303 * 2.71e4*tsq1
      call coladd( 'Fe14' , 5303 , c5303 )
*
*     Fe 18 974.8A;, cs from 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = min( 0.143, 0.804/(te10*te05))
      call PutCS( cs , Fe18975 )
      call level2( Fe18975 )
*
      c7082 = pop3( 5.,1.,3., 0.0132,0.0404,0.0137 ,
     1 0.505,1.46E4,41.2, 1.083E5,2.03E4,p2,xIonFracs(26,19),0.) *
     2 41.2 * 2.81E-12
      c1118 = c7082 * 354.4 * 6.335
      c1328 = p2 * 0.505 * 1.50e-11
      call coladd( 'Fe19' , 7082 , c7082 )
      call coladd( 'Fe19' , 1118 , c1118 )
      call coladd( 'Fe19' , 1328 , c1328 )
*
      c592 = popexc(0.0913,9.,5.,1.64E4,2.428e5,xIonFracs(26,19))*
     1 3.36E-11
      call coladd( 'Fe19' , 592 , c592 )
*
*     following all from same ref
      call PutCS( 0.0151 , tFe13 )
      call PutCS( 0.0424 , tFe23 )
      call PutCS( 0.0147 , TauDummy )
      call level3(tFe13,tFe23, TauDummy)
*
*     FE 22 845.6, C.S.=guess, A from
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
      fs846 = popexc(0.2,2.,4.,1.5e4,1.701e5,xIonFracs(26,22))*2.35E-11
      call coladd( 'Fe22' , 846 , fs846 )
*
*     FE 23 262.6, 287A, 1909-LIKE, 
*     cs from 
*     >>refer Bhatia, A.K., & Mason, H.E. 1986, A&A, 155, 413
      c263 = popexc(0.04,1.,9.,1.6e7,5.484e5,xIonFracs(26,23))*7.58E-11
      call coladd( 'Fe23' , 262 , c263 )
*
*     FE 24, 255, 192 Li seq doublet
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 26 , t192, t11, cs2s2p , cs2s3p )
*
      call PutCS( cs2s2p , t192 )
      call level2( t192 )
*
*     funny factor (should have been 0.5) due to energy change
      call PutCS( cs2s2p*0.376 , t255 )
      call level2( t255 )
*
      call PutCS( cs2s3p , t11 )
      call level2( t11 )
*
* 666 error!
*     following not in cooling function
      t353(ipLnPopOpc) = xIonFracs(26,11)
      t353(ipLnPopl) = xIonFracs(26,11)
      t353(ipLnPopu) = 0.
      t347(ipLnPopOpc) = xIonFracs(26,14)
      t347(ipLnPopl) = xIonFracs(26,14)
      t347(ipLnPopu) = 0.
*
      end
