******************************************************************************
      subroutine FirstDR
      implicit none
*derive thickness of first zone
      include "ncell.par"
      include "itrdim.par"
      include "IterCnt.com"
      include "wind.com"
      include "sdrmin.com"
      include "ZoneCnt.com"
      include "tauend.com"
      include "colend.com"
      include "trace.com"
      include "drmnon.com"
      include "rfield.com"
      include "drmin.com"
      include "fluct.com"
      include "filfac.com"
      include "phycon.com"
      include "radius.com"
      include "opac.com"
      include "h.com"
      include "didz.com"
      include "TePowers.com"
      include "he.com"
      include "densty.com"
      include "cpres.com"
      include "IOqq.com"
*
*     local variables
      real z , a , accel,TotalPressure,winddr,dr912,drcol,dradf,
     1 big,drthrm , freqm , opacm , tabden , drTabDen,factor
      logical lgOK
      integer i
      parameter (z=1.0001)
*
*     wind, check acceleration length
      if( windv.gt.0. ) then
        a = TotalPressure()
        accel = 1.3e-10 * pden*wmole
        winddr = windv**2 /25. / accel
      else
        winddr = 1e30
      endif
*
*     key off of Lyman continuum optical depth
      if( taunu.gt.0.99.and.taunu.lt.3. ) then
        dr912 = tauend / 6.3e-18 / (hi * FillFac ) * z / 50.
      else
        dr912 = 1e30
      endif
*
*     key off of column density; total, neutral, or ionized
      if( HColStop.lt.5e29 ) then
*       this is useful for very thin columns, normally larger than 1st DR
        drcol = log10(HColStop ) - log10( hden * FillFac * 20. )
      else if( colpls.lt.5e29 ) then
        drcol = log10(colpls ) - log10( hii * FillFac * 20. )
      else if( colnut.lt.5e29 ) then
        drcol = log10(colnut ) - log10( hi * FillFac * 50. )
      else
        drcol = 30.
      endif
      drcol = 10.**min( 35., drcol )
*
*     find first DRAD using optical depths
*     drMinimum is smallest acceptable DRAD, and is 1/100 OF DRAD(1)
*
      if( flong .ne. 0. ) then
*       flong set => density fluctuations
        dradf = 6.283 / flong / 10.
        dradf = min( dradf , real(router(iter))*z , drcol , dr912 )
      else
        dradf = 1e37
      endif
*
*     following is usually the case
*     find largest opacity, keep first zone optical depth 1
      call AddOpac( lgOK )
      if( .not. lgOK ) then
        write(qq,'('' first opacity evaluation fails'')')
        stop
      endif
      big = 0.
      do i=1,nflux
        big = max( big , opac(i) )
      end do
*begin sanity check
      if( big.le.0. ) then
        write(qq,'('' largest opacity not >0 in FirstDR'')')
        stop
      endif
*end sanity check
*     >>chng 96 jan 8 following had dtau1, which was 0.001,
*     rather than rat drChange
      drad = (drChange/100.) / big / FillFac
      call ContRate( freqm, opacm )
*
*     rough guess of thermalization length
      drthrm = 1.5e31 / max( 1. , hden * hden )
*
*     >>chng 97 apr 2, added following logic to make sure we resolve initial
*     structure in tabden command
*     if interpolated table we need to make sure that we resolve the 
*     initial changes in the structure
      if( chCPres.eq.'DLW2' ) then
        drTabDen = 1.
        i = 1
        factor = 0.
        do while ( i.lt.100 .and. factor.lt.0.05 )
*         >>chng 97 july 24, convert to double had not been done
*         both arguments to tabden are double precision
          factor = hden/tabden( radius+drTabDen, dble(drTabDen) )
          factor = abs(factor - 1.)
          drTabDen = drTabDen * 2.
          i = i + 1
        end do
        drTabDen = drTabDen / 2.
      else
        drTabDen = 1e30
      endif
*
*     above is fraction of total thickness; now set fraction of R
*     >>chng 96 nov 22, radius now 20, had been 8, resulted in big change in
*     iron ionization for high ionization gas
      drad = min( real(drad) , real(radius)/20. ,real(router(iter))/10.,
     1 drcol , dr912 ,sdrmax, drthrm , winddr , dradf , drTabDen)
      drad = max( real(drad) , sdrmin )
*
*     this can be turned off by GLOB command
      if( lgDrMnOn ) then
        drMinimum = drad / 1e7
      else
        drMinimum = 0.
      endif
      if( lgSMinON ) then
        drMinimum = sdrmin
      endif
*
      if( lgTrace ) write(qq,'(1X,''FirstDR called, finds dr='',1P,E13.5
     1,'' drMinimum='',E12.3,'' sdrmin='',E10.2,'' sdrmax='',E10.2)') 
     2 drad, drMinimum , sdrmin , sdrmax
*
      end
