******************************************************************************
      real function forlin()
      implicit none
*derive radiative acceleration due to line absorption of incident continuum
      include "ncell.par"
      include "nta.par"
      include "en1ryd.par"
      include "ipLnArry.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nwindline.par"
      include "occnum.com"
      include "rfield.com"
      include "nh.com"
      include "TLineARR.com"
      include "FeIIAtom.com"
      include "htau.com"
      include "he1tau.com"
      include "he2tau.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "HEnrRyd.com"
      include "h.com"
      include "he.com"
      include "iphe2l.com"
      include "iphe1l.com"
      include "WindData.com"
      include "KatyaDat.com"
      include "IOqq.com"
*
*     this function finds the total rate the gas absorbs energy
*     this result is divided by the calling routine to find the
*     momentum absorbed by the gas, and eventually the radiative acceleration
*
*     the energy absorbed by the line is
*     Abundance * energy * A *(g_up/g_lo) * occnum * escape prob
*     where occnum is the photon occupation number, and the g's are
*     the ratios of statistical weights
*
*     local variable
*     character chLineLbl*10
      integer i , ihi , low , ihmax , ipRestMax
      real hydro , fe2drive , AllHeavy , he2l, he1l,AllRest,HeavMax,
     1 OneLine , hydromax  , RestMax
*     integer ipHeavMax
*     real HTauMax
*
* 666 error!
*     put helium triplets in
*
*     total energy absorbed in this zone, per cubic cm
*     do hydrogen first
      hydro = 0
      ihmax = 0
      hydromax = 0.
*     do not put in highest level since its not real
      do low=1,nhlvl-2
        do ihi=low+1,nhlvl-1
          OneLine = hn(low)*hcont(ihi,low)*HEnerRyd(ihi,low)
          hydro = hydro + OneLine
*         if( OneLine.gt.hydromax ) then
*           ihmax = ihi*100 + low
*           hydromax = Oneline
*           HTauMax = htau(ihi,low)
*         endif
        end do
      end do
      hydromax = hydromax * en1ryd * hii
      hydro = hydro * en1ryd * hii
*
*     total energy absorbed in this zone, per cubic cm
*     helium
      he1l = 0
      he2l = 0
      do low=1,7
        do ihi=low+1,8
          he2l = he2l +
     1    he2n(low)*he2con(ihi,low)*anu(iphe2l(ihi,low))
          he1l = he1l +
     1    he1n(low)*he1con(ihi,low)*anu(iphe1l(ihi,low))
        end do
      end do
      he2l = he2l * en1ryd * heiii
      he1l = he1l * en1ryd * heii
*
*     all heavy element lines in calculation of cooling
      AllHeavy = 0.
      HeavMax = 0.
      do i=1,nTauLines
        OneLine = TauLines(ipLnPump,i)*
     1  TauLines(ipLnEnrErg,i)* TauLines(ipLnPopOpc,i)
*       if( OneLine.gt.HeavMax ) then
*         HeavMax = OneLine
*         ipHeavMax = i
*       endif
        AllHeavy = AllHeavy + OneLine
      end do
*
*     all heavy element lines treated with g-bar
      AllRest = 0.
      RestMax = 0.
      ipRestMax = 0
      do i=1,NWINDLINE*nWindOn
        OneLine = WindLine(ipLnPump,i)*
     1  WindLine(ipLnEnrErg,i)* WindLine(ipLnPopOpc,i)
*       if( OneLine.gt.RestMax ) then
*         RestMax = OneLine
*         ipRestMax = i
*       endif
        AllRest = AllRest + OneLine
      end do
*
*     The Verner's model FeII atom
      fe2drive = 0.
      if( chFeIIAtom.eq.'Verner' .and..not.lgSimKatya ) then
        call AccelFe2( fe2drive )
      endif
*
      forlin = AllHeavy + hydro + fe2drive + he2l + he1l+AllRest
*
*     activate character chLineLbl above
*666  write(qq,'(1p,5e10.2)') hydro/forlin,he1l/forlin, he2l/forlin ,
*    1 AllHeavy/forlin, AllRest/forlin
*     write(qq,'(''Hyd '',i5,1p,2e10.2)') ihmax,HTauMax,hydromax/forlin
*
*     write(qq,'(''Heav'',1x,a10,1p,2e10.2)')
*    1 chLineLbl(TauLines(1,ipHeavMax)) ,
*    1 TauLines(ipLnTauIn,ipHeavMax), HeavMax/forlin
*
*     write(qq,'(''Rest'',1x,a4,1p,2e10.2)')
*    1 chLineLbl(WindLine(1,ipRestMax)) ,
*    1 WindLine(ipLnTauIn,ipRestMax) , RestMax/forlin
*      ipHeavMax = 105
*      write(6,*) ipHeavMax
*      write(6,'(1p,4e10.2)') TauLines(ipLnPump,ipHeavMax),
*    1  TauLines(ipLnEnrErg,ipHeavMax), TauLines(ipLnPopl,ipHeavMax),
*    2 TauLines(ipLnTauIn,ipHeavMax)
*
      end
