*********************************************************************
      real function func(param)
      implicit none
*actual function called during evaluation of optimization run
      include "limpar.par"
      real param(limpar)
*
      include "limext.par"
      include "nobslm.par"
      include "ncollm.par"
      include "nlines.par"
      include "nkrd.par"
      include "nvary.com"
      include "vformt.com"
      include "vparm.com"
      include "called.com"
      include "norm.com"
      include "sumlab.com"
      include "sum.com"
      include "sum2.com"
      include "noptim.com"
      include "obscol.com"
      include "colab.com"
      include "obsint.com"
      include "whtopm.com"
      include "obslin.com"
      include "varmax.com"
      include "vpused.com"
      include "fourpi.com"
      include "intopn.com"
      include "OptmFlow.com"
      include "varang.com"
      include "nvfpnt.com"
      include "input.com"
      include "IOqq.com"
*
*     local variables
      character chCAPLB*4 , chFind*4
      logical lgOK , lgHIT
      logical lgLinSet , lgLimOK
      integer ipobs(nobslm) , i , nfound,j,ii,np
      real chisq,scld,chi1,chi2,diffx,diff1,diff2,theocl,
     1 predin,resid
      save lgLinSet , ipobs
      data lgLinSet/.false./
*
*     This routine is called by AMOEBA (or POWELL) with values of the
*     variable parameters for CLOUDY in the array p(i). It returns
*     the value FUNC = SUM (obs-model)**2/sig**2 for the lines
*     specified in the observational data file, values held in the
*     common blocks /OBSLIN/ & /OBSINT/
*     replacement input strings for CLOUDY READR held in /chCardSav/
*     parameter information for setting chCardSav held in /parmv/
*     additional variables
*     Gary's variables
*
*     free statement numbers >=8
*
      if( lgOptimFlow ) then
        write(qq,'('' trace, func variables'',1p,10e10.2)')
     1  (param(i),i=1,nvary)
      endif
*
      do i=1,nvary
        vparm(i,1) = param(i)
      end do
*
*     call routine to pack /kardsv/ variable with appropriate
*     CLOUDY input lines given the array of variable parameters p(i)
      call setinp( lgLimOK )
*
      if( .not.lgLimOK ) then
*       these parameters are not within limits of parameter search
*       >>chng 96 apr 26, as per Peter van Hoof comment
        write(qq,'('' Iteration'',I4,'' not within range.'')') noptim
*       this is error; very bad since not within range of parameters
        func = 1e37
        return
      endif
*
      do i=1,nvary
        varmax(i) = max( varmax(i) , vpused(i) )
        varmin(i) = min( varmin(i) , vpused(i) )
      end do
*
      noptim = noptim + 1
      call cloudy
*
*     Line fluxes now in commn blocks, so extract and
*     compare with observations
      chisq = 0.0
      snorm = sumlin(NormWL)
      if( NormWL.le.0 ) then
         write(qq,'('' Normalization line pointer is bad.'',
     1   ''  What has gone wrong?'')')
         stop
      endif
      if( snorm.eq.0. ) then
         write(qq,'('' Normalization line has zero intensity.'',
     1   ''  What has gone wrong?'')')
         stop
      endif
*
*     first print all warnings
      call warnot( qq )
      write(qq,'(1X,'' ID '',13X,''Model'',4X,''Observed'',7X,
     1 ''error'',5X,'' chi**2'',5X,''Type'')')
*     cycle through the observational values
      nfound = 0
*
*     first is to optimize relative emission line spectrum
      if( lgOptLin ) then
*        set pointers to all optimized lines if first call
         if( .not.lgLinSet ) then
           lgLinSet = .true.
           do i=1,nlobs
             call cap4( chAmLab(i) , chFind )
             lgHIT = .false.
             j = 1
*            >>chng 97 june 13, get rid of go to, change to do while
             do while( .not.lgHIT .and. j.le. nsum )
*              check wavelength for a match
*              change label to all caps to be like input chAmLab
               call cap4( chALab(j) , chCAPLB )
               if(lin(j).eq.linam(i).and.chCAPLB.eq.chFind) then
*                 match, so set pointer
                  ipobs(i) = j
                  lgHIT = .true.
               endif
               j = j + 1
             end do
             if( .not.lgHIT ) then
               write(qq,'('' Optimizer could not find line with '',
     1         ''label'',1X,A4,'' and wavelength'',I5,''. Sorry.'')')
     2         chAmLab(i),linam(i)
             stop
             endif
           end do
         endif
*
         do i=1,nlobs
*           and find corresponding model value by straight search
            nfound = nfound + 1
            scld = sumlin(ipobs(i))/snorm*sclnrm
*           add (diff/amierr)**2 to overall chi**2
*           checking that AMIERR is .gt. 0 (negative means upper limit)
*           AMINT(I) is desired intensity
            if(amierr(i).gt.0.0) then
               if( scld.ne.0. ) then
                  chi1 = ( (scld-amint(i)) / scld / amierr(i) )**2
                  chi2 = ( (scld-amint(i)) / amint(i) / amierr(i) )**2
                  chi1 = max( chi1 , chi2 )
                  chisq = chisq + chi1
               else
                  chi1 = 1e36
                  chisq = chisq + chi1
               endif
            else
*              value quoted is an upper limit, so add to chisq
*              only if limit exceeded. Otherwise there is no information.
               if( scld.ne.0. ) then
                  diff1 = ( scld-amint(i) ) / scld
                  diff2 = ( scld-amint(i) ) / amint(i)
                  diffx = max( abs(diff1) , abs(diff2) )
                  diffx = sign( diffx , diff1 )
               else
                  diffx = ( scld-amint(i) ) / amint(i)
               endif
               if(diffx.gt.0.0) then
                  chi1 = (diffx/amierr(i))**2
                  chisq = chisq + chi1
               else
                  chi1 = 0.
               endif
            endif
            write(qq,'(1X,A4,I6,3F12.5,1P,E12.2,'' Relative intensity'')
     1      ')chALab(ipobs(i)),lin(ipobs(i)),scld,amint(i),amierr(i),
     2      chi1
         end do
      endif
*
*     option to optimize column densities
      if( lgOptCol ) then
         do i=1,ncobs
            call cdColm( chColmnLab(i) , ionam(i), theocl , lgOK )
            if( .not.lgOK ) then
               stop
            endif
            nfound = nfound + 1
*           add (diff/AMCERR)**2 to overall chi**2
*           checking that AMCERR is .gt. 0 (negative means upper
*           limit)
            if(amcerr(i).gt.0.0) then
               chi1 = ( (theocl-amcol(i)) / amcol(i) / amcerr(i) )**2
               if( theocl.gt.0.) then
                 chi2 = ( (theocl-amcol(i)) / theocl / amcerr(i) )**2
               else
                 chi2 = 0.
               endif
               chi1 = max( chi1 , chi2 )
               chisq = chisq + chi1
            else
*              value quoted is an upper limit, so add to chisq
*              only if limit exceeded. Otherwise there is no information.
               diffx = ( theocl-amcol(i) ) / amcol(i)
               if(diffx.gt.0.0) then
                  chi1 = (diffx/amcerr(i))**2
                  chisq = chisq + chi1
               else
                  chi1 = 0.
               endif
            endif
            write(qq,'(1X,A4,I6,1P,2E12.4,0P,2F12.5,
     1      '' Column density'')')
     2      chColmnLab(i),ionam(i),theocl,amcol(i),amcerr(i),chi1
         end do
      endif
*
*     option to optimize line flux
      if( lgOptLum ) then
        predin = log10(sumlin(NormWL)) + pirsq
        resid = 1. - 10.**abs(optint - predin )
        chi1 = (resid/optier)**2
        chisq = chisq + chi1
        write(qq,'(1X,A4,I6,3F12.5,1P,E12.2,'' Line intensity'')')
     1  chALab(NormWL),lin(NormWL),predin , optint , optier,chi1
        nfound = nfound + 1
      endif
*
      if( nfound.lt.nlobs ) then
        write(qq,'('' Lines were missed in optimization.'')')
        stop
      endif
*
      if( nfound.le.0 ) then
        write(qq,'('' WARNING; no line matches found'')')
        stop
      endif
*
*     only print this if output has been turned on
      if( lgTalk ) then
        do i=1,nvary
         vparm(i,1) = min( vparm(i,1) , varang(2,i) )
         vparm(i,1) = max( vparm(i,1) , varang(1,i) )
         param(i) = vparm(i,1)
         np = nvfpnt(i)
         write(chCardSav(np),chVarFmt(i)) (vparm(i,ii),ii=1,nvarxt(i))
         write(qq,'(1x,''Optimal command: '',A80)') chCardSav(np)
        end do
      endif
*
*     write out chisquared for this iteration
      write(qq,'('' Iteration'',I4,'' Chisq='',1P,E10.2)') noptim ,
     1 chisq 
*
      func = chisq
*
      end
