******************************************************************
      subroutine gbar1(ex,g)
      implicit none
*compute g-bar collision strength using Mewe approximations
      include "phycon.com"
      real ex , g
*
*     written by Dima Verner
*
* Calculation of the effective Gaunt-factor by use of Mewe (1972, A&A 20, 215)
* fits for permitted transitions in ions MgII, CaII, FeII (delta n = 0)
*    Input parameters: 
* ex - excitation energy in Ryd - now K
* te  - temperature in K
*    Output parameter:
* g  - effective Gaunt factor
*
*     local variables
      real y
*
*     y = ex*157813.7/te
      y = ex/te
      g = 0.6+0.28*(log(1.0+1.0/y)-0.4/(y+1.0)**2)
*
      end
