******************************************************************************
      subroutine getatl(temp,alogg,jval,tval,ierr,teff,xlogg)
      implicit none
*get one of the Atlas model atmospheres, coded by K. Volk
      real temp,alogg
      integer ierr
      include "ncell.par"
      include "called.com"
      include "rfield.com"
      include "StarSize.com"
      include "IOqq.com"
*
*     local variables
      integer nmods , j , i , j1,i1
      real xval,fr1,fr2,fr3,fr4,gval
*     parameter (ndata=865,nmods=412)
      parameter (nmods=412)
      real teff(nmods),xlogg(nmods)
      real tval(61)
      integer jval(11,61) ,ivals(ncell) , ierror
      real flux1(ncell),flux2(ncell)
      logical lgTHit
*
      do j=1,61
        do i=10,1,-1
          if( jval(i,j).eq.-1 ) jval(i,j) = jval(i+1,j)
        end do
      end do
*
*     determine which models are to be interpolated
*
      lgTHit = .false.
      do j=1,60
        if( tval(j).le.temp.and.tval(j+1).gt.temp ) then
          j1 = j
          lgTHit = .true.
        endif
      end do
*
      if( .not.lgTHit ) then
        if( tval(61).eq.temp ) then
          j1 = 60
        else
          write(qq,'('' Requested temperature of'',1P,E10.2,
     1    '' is not within the range'',1P,2E10.2)')
     2    temp, tval(1), tval(61)
          stop
        endif
      endif
*
      xval = 2.*alogg+1.0
      i1 = int(xval)
*
* Interpolation is carried out first in Teff and then in log(g).
* Two Kurucz models are read in for the lower log(g) value first, which
* I denote models A and B with B the higher T model [j1+1 rather than j1].
* unless alogg is 5.0 a second pair of Kurucz models are read in for the
* higher log(g) value, denoted models C and D.  Then the interpolation is
*
*  RESULT = fr2*(fr3*B+fr4*A)+fr1*(fr3*D+fr4*C)
*
* when one has 4 models and 
*
* RESULT = (fr3*B+fr4*A) 
*
* when one has just 2 models.
      fr1 = xval-float(i1)
      fr2 = 1.-fr1
      fr3 = (temp-tval(j1))/(tval(j1+1)-tval(j1))
      fr4 = 1.-fr3
*
*     read(92,'(4000i7)' ,rec=jval(i1,j1)+2,err=700)
*     >>chng 97 july 24, get rid of go to
      read(92,'(4000i7)' ,rec=jval(i1,j1)+2,iostat=ierror)
     1 (ivals(j),j=1,nAtlas)
      if( ierror.ne.0 ) then
        ierr = 1
        return
      endif
*     following must change if ncell changes
*999  format(4000I7)
      gval = xlogg(jval(i1,j1)-1)
*
      if(lgTalk)write(qq,'(23x,''*<<< K. Volk s Kurucz model '',I3,
     1 '' READ IN.  T_eff = '',F8.2,'' log(g) = '',F8.5,''  >>> *'')'
     2 ) jval(i1,j1)-1,teff(jval(i1,j1)-1),gval
*
      do j=1,nAtlas
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*       flux1(j)=10.**(-1.*float(ivals(j))/100000.)
        flux1(j) = (-1.*float(ivals(j))/100000.)
      end do
*
*     >>chng 97 july 24, get rid of go to
      read(92,'(4000i7)' ,rec=jval(i1,j1+1)+2,iostat=ierror)
     1 (ivals(j),j=1,nAtlas)
      if( ierror.ne.0 ) then
        ierr = 1
        return
      endif
      gval=xlogg(jval(i1,j1+1)-1)
      if(lgTalk)write(qq,'(23X,''*<<< K. Volk s Kurucz model '',I3,
     1 '' READ IN.  T_eff = '',F8.2,'' log(g) = '',F8.5,''  >>> *'')')
     2 jval(i1,j1+1)-1,teff(jval(i1,j1+1)-1),gval
*
      do j=1,nAtlas
*       flux2(j) = 10.**(-1.*float(ivals(j))/100000.)
        if( ivals(j).lt.9999999 ) then
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*         flux2(j) = 10.**(-1.*float(ivals(j))/100000.0)
          flux2(j) = (-1.*float(ivals(j))/100000.0)
        else
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*         flux2(j) = 0.
          flux2(j) = -35.
        endif
      end do
*
      do j=1,nAtlas
        flux(j) = fr4*flux1(j)+fr3*flux2(j)
      end do
*
      if (i1.lt.11) then
*         for log(g) < 5.0 repleat the interpolation at ht elarger log(g) then
*         carry out the interpolation in log(g)
*         >>chng 97 july 24, get rid of go to
          read(92,'(4000i7)' ,rec=jval(i1+1,j1)+2,iostat=ierror)
     1    (ivals(j),j=1,nAtlas)
          if( ierror.ne.0 ) then
            ierr = 1
            return
          endif
          gval = xlogg(jval(i1+1,j1)-1)
          if(lgTalk)write(qq,'(23X,''*<<< K. Volk s Kurucz model ''
     1    ,I3,'' READ''
     1    ,'' IN.  T_eff = '',F8.2,'' log(g) = '',F8.5,''  >>> *'')')
     2    jval(i1+1,j1)-1,teff(jval(i1+1,j1)-1),gval
*
          do j=1,nAtlas
*           flux1(j)=10.**(-1.*float(ivals(j))/100000.)
            if( ivals(j).lt.9999999 ) then
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*             flux1(j) = 10.**(-1.*float(ivals(j))/100000.0)
              flux1(j) = (-1.*float(ivals(j))/100000.0)
            else
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*             flux1(j) = 0.
              flux1(j) = -35.
            endif
          end do
*
*         >>chng 97 july 24, get rid of go to
          read(92,'(4000I7)' ,rec=jval(i1+1,j1+1)+2,iostat=ierror)
     1            (ivals(j),j=1,nAtlas)
          if( ierror.ne.0 ) then
            ierr = 1
            return
          endif
          gval = xlogg(jval(i1+1,j1+1)-1)
          if(lgTalk)write(qq,'(23X,''*<<< K. Volk s Kurucz model ''
     1    ,I3,'' READ''
     1    ,'' IN.  T_eff = '',F8.2,'' log(g) = '',F8.5,''  >>> *'')')
     1    jval(i1+1,j1+1)-1,teff(jval(i1+1,j1+1)-1),gval
*
          do j=1,nAtlas
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*his changes did not have this commented out - oversight??
*           flux2(j)=10.**(-1.*float(ivals(j))/100000.)
            if( ivals(j).lt.9999999 ) then
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*             flux2(j) = 10.**(-1.*float(ivals(j))/100000.0)
              flux2(j) = (-1.*float(ivals(j))/100000.0)
            else
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*             flux2(j) = 0.
              flux2(j) = -35.
            endif
          end do
*
          do j=1,nAtlas
            flux1(j)=flux1(j)*fr4+flux2(j)*fr3
          end do
*
          do j=1,nAtlas
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*           flux(j)=fr2*flux(j)+fr1*flux1(j)
            flux(j) = 10.**(fr2*flux(j)+fr1*flux1(j))
          end do
      else
*     One gets here if log(g) is 5.0 and there is no higher log(g) pair of 
*     models to interpolate.
*
        do j=1,nAtlas
          flux(j) = 10.**flux(j)
        end do
      endif
*
      ierr = 0
*     return
*700  continue
*     ierr = 1
*     return
      end
