************************************************************************
      subroutine GetFeII( chCard )
      implicit none
*parse the FeII command
      character chCard*80
      include "WavNRyd.par"
      include "FeIIAtom.com"
      include "KatyaDat.com"
      include "feiipar.com"
      include "IOqq.com"
*
*     local variables
      logical lgMatch , lgEOL
      integer i
      real fread
*
*     how to do feii atom
      if( lgMatch( 'NETZ' , chCard ) ) then
*       use netzer's simple few level atom
        chFeIIAtom = 'Netzer'
      else if( lgMatch( 'VERN' , chCard ) ) then
        if( lgMatch( 'SIMU' , chCard ) ) then
          lgSimKatya = .true.
        endif
        if( .not.lgKatyaData .and. .not.lgSimKatya ) then
          write(qq,'('' Katya Verner data not linked in.'')')
          write(qq,'('' This option not implemented.'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
*       check for theshold of weakest line
        if( lgMatch( 'THRE' , chCard ) ) then
          i = 5
          fe2thresh = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) call NoNumb(chCard )
          if( fe2thresh.lt.0. ) fe2thresh = 10.**fe2thresh
        endif
*       check for energy range of lines to be punched
        if( lgMatch( 'RANG' , chCard ) ) then
          i = 5
          fe2ener(1) = fread( chCard , i , 76 , lgEOL )
          fe2ener(2) = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) call NoNumb(chCard )
*         if either is negative then both are logs
          if( fe2ener(1).lt.0. .or. fe2ener(2).lt.0. ) then
            fe2ener(1) = 10.** fe2ener(1)
            fe2ener(2) = 10.** fe2ener(2)
          endif
*         entered in Ryd in above, convert to wavenumbers
          fe2ener(1) = fe2ener(1) / WavNRyd
          fe2ener(2) = fe2ener(2) / WavNRyd
        endif
        chFeIIAtom = 'Verner'
      else
        write(qq,'('' One of the keywords Verner or Netzer must'',
     1  '' appear on this line. '')')
        stop
      endif
*
      end
