******************************************************************************
      subroutine GetPrint( chCard , lgEOL )
      implicit none
*parse the print command 
      character chCard*80
      logical lgEOL
      include "itrdim.par"
      include "itrprt.com"
      include "plast.com"
      include "pshort.com"
      include "faint.com"
      include "fntset.com"
      include "only.com"
      include "parray.com"
      include "pheat.com"
      include "pstart.com"
      include "called.com"
      include "dump.com"
      include "prall.com"
      include "IOqq.com"
      include "pconon.com"
      include "pbn.com"
      include "PrtTau.com"
      include "PrnErr.com"
      include "PrnLine.com"
      include "PrnAges.com"
      include "PrtMaser.com"
*
*     local variables
      logical lgKeyIn , lgMatch 
      integer i,j,num1
      real fread,sum , a
*
      lgKeyIn = .false.
*
      if( lgMatch( ' ALL' , chCard ) ) then
*       print all lines including those from ratios
        prall = 1
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'AGES' , chCard ) ) then
*       print all estimates of cloud timescales
        lgPrnAges = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'ARRA' , chCard ) ) then
*       print arrays for ionization balance of heavy elements
        lgPrtArry = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'ERRO' , chCard ) ) then
*       turn on error printing to screen
        lgPrnErr = .true.
        lgKeyIn = .true.
        i = 5
        j = fread( chCard , i , 76 , lgEOL )
        if( .not.lgEOL ) ioPrnErr = j
        if( ioPrnErr.le.0 ) then
          write(qq,'('' io units must be positive.'')')
          stop
        endif
        write(ioPrnErr,'('' Errors will go to io'',i3)')ioPrnErr
      endif
*
      if( lgMatch( 'DEPA' , chCard ) ) then
*       print departure coef instead of hydrogen level populations
        lgPrtBN = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'FAIN' , chCard ) ) then
        lgKeyIn = .true.
*       faintest line, rel to norm line, to print; either linear of log
        i = 5
        a = fread( chCard , i , 76 , lgEOL )
*       option for, if no number, keyword=" OFF", to print all lines
        if( lgEOL ) then
          if( lgMatch( ' OFF' , chCard ) ) then
            lgFaintOn = .false.
          else
            write(qq,'('' There faintest line to print must be '',
     1      ''on this line, sorry.'')')
            stop
          endif
        endif
        lgFntSet = .true.
        if( a.le.0. ) then
          TooFaint = 10.** a
        else
          TooFaint = a
        endif
      endif
*
      if( lgMatch( 'HEAT' , chCard ) ) then
*       print heat arrays
        lgPrintHeating = .true.
        lgKeyIn = .true.
      endif
*
*     option to only print last iteration
      if( lgMatch( 'LAST' , chCard ) ) then
        lgPrtLastIt = .true.
        lgKeyIn = .true.
      endif
*
*     option to only print levels in c version
      if( lgMatch( 'LEVE' , chCard ) ) then
*       does not actually do anything 
        lgKeyIn = .true.
      endif
*
*     the print line command as several options
      if( lgMatch( 'LINE' , chCard ) ) then
        lgKeyIn = .true.
        if( lgMatch( ' ALL' , chCard ) ) then
*         turn on all printed componenets
          lgPrnPump = .true.
          lgPrnColl = .true.
          lgPrnHeat = .true.
        else if( lgMatch( 'PUMP' , chCard ) ) then
*         also print pump contributions
          lgPrnPump = .true.
        else if( lgMatch( 'INWA' , chCard ) ) then
*         also print inward contributions
          lgPrnInwd = .true.
        else if( lgMatch( 'COLL' , chCard ) ) then
*         also print collisional contributions
          lgPrnColl = .true.
        else if( lgMatch( 'HEAT' , chCard ) ) then
*         also print heating contributions
          lgPrnHeat = .true.
        else if( lgMatch( 'OPTI',chCard ).and.lgMatch('DEPT',chCard ) )
     1    then
*         print optical depths
          lgPrtTau = .true.
        else if( lgMatch(' SUM' , chCard ) ) then
*         option to read in set of lines to sum over
          call rdsum( sum , 'READ' )
        else
          write(qq,'('' One of the keys EXTRA, INWARD, COLL, HEAT, '',
     1    ''SUM, OPTICAL DEPTHS, ALL or PUMP should have appeared.'')')
          stop
        endif
      endif
*
*     print maser lines when TAV is called
      if( lgMatch( 'MASE' , chCard ) ) then
        lgPrtMaser = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'ONLY' , chCard ) ) then
        lgKeyIn = .true.
        if( lgMatch( 'ZONE' , chCard ) ) then
          lgOnlyZone = .true.
        else if( lgMatch( 'HEAD' , chCard ) ) then
          lgOnlyHead = .true.
        else
          write(qq,'('' There must be a keyword for the ONLY'',
     1    '' option.  They are HEAD and ZONE.  Sorry.'')')
          stop
        endif
      endif
*
      if( lgMatch( 'OPTI',chCard ).and.lgMatch('DEPT',chCard ) ) then
*       optical depths, with option for smallest to print
        lgKeyIn = .true.
        if( lgMatch( ' OFF',chCard ) ) then
*         turn off or on printing of optical depths - default off
          lgPrtTau = .false.
        else 
          lgPrtTau = .true.
        endif
        if( lgMatch('FAIN' , chCard ) ) then
*         log of faintest optical depth
          i = 5
          PrtTauFnt = 10.**fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) then
            write(qq,'('' There must be a number for the FAINT'',
     1      '' option.  They are HEAD and ZONE.  Sorry.'')')
            stop
          endif
        endif
      endif
*
      if( lgMatch( 'SORT' , chCard ) ) then
*       turn on sorting with respect to wavelength
        psort = 1
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'STAR' , chCard ) ) then
*       start printout at specified zone
        lgTalk = .false.
        lgPrtStart = .true.
        i = 5
        nstart = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' The zone on which the print is to start'',
     1    '' MUST be entered on this line.  Sorry.'')')
          stop
        endif
        lgKeyIn = .true.
      endif
*
      if( lgMatch('CONT' , chCard ) ) then
        if( lgMatch('DIFF' , chCard ) ) then
          lgPrnDiff = .true.
        else
*         option to print emergent continuum
          lgPrtCont = .true.
        endif
        lgKeyIn = .true.
      endif
*
      if( lgMatch('COOL' , chCard ) ) then
*       print cooling array for a specified one
        i = 5
        nzdump = fread( chCard , i , 76 , lgEOL )
*       dumpt all zones if argument is zero or not present 
        if( lgEOL ) nzdump = 0
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'QUIE',chCard) .or. 
     1  (lgMatch(' OFF',chCard) .and. .not. lgMatch('FAIN',chCard)) )
     2  then
*       in above, there is also a 'print faint off' command
*       QUIET or OFF means turn off printout
        lgTalk = .false.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( ' ON ',chCard) ) THEN
*       on means turn on printout
        lgTalk = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'SHOR' , chCard ) ) then
*       make short printout, don't print last
        lgPrtShort = .true.
        if(.not.lgFntSet) TooFaint = 0.001
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'EVER' , chCard ) ) then
        lgKeyIn = .true.
*       print every nth zone
        i = 5
        num1 = fread( chCard , i , 76 , lgEOL )
       if( lgEOL ) then
          write(qq,'('' The number of zones to print MUST be entered''
     1    ,'' on this line.  Sorry.'')')
          stop
        endif
        itrprt(1) = max( num1 , 1 )
        do j=2,itrdim
          itrprt(j) = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) itrprt(j) = itrprt(j-1)
        end do
      endif
*
*     check if no numbers, but only keywords.
      if( .not. lgKeyIn ) then
*       general catch-all for no number when there should have been
        write(qq,'('' There MUST be a keyword on the following '',
     1  ''line.  Sorry.'')')
        write(qq,'(1X,A80)') chCard
        stop
      endif
*
      end
