******************************************************************************
      subroutine GetSet( chCard )
      implicit none
*scan parameters off SET command
      character chCard*80
      include "itrdim.par"
      include "SpeedLgt.par"
      include "nhlvl.par"
      include "ZoneCnt.com"
      include "KshllEnr.com"
      include "colimt.com"
      include "path.com"
      include "pthset.com"
      include "OrgCard.com"
      include "flxfnt.com"
      include "MapPar.com"
      include "sdrmin.com"
      include "erredn.com"
      include "cspset.com"
      include "bounds.com"
      include "negoIO.com"
      include "PunchSkip.com"
      include "EndDflt.com"
      include "NumDeriv.com"
      include "didz.com"
      include "telow.com"
      include "PunDef.com"
      include "peimbt.com"
      include "trimstg.com"
      include "DstWght.com"
      include "PhFitOn.com"
      include "WkHtCl.com"
      include "HCTMin.com"
      include "LevTrace.com"
      include "Exemplar.com"
      include "PLWidth.com"
      include "Testit.com"
      include "IOqq.com"
*
*     local variables
      logical lgMatch
      character chC1*1 , chC2*1 , chC3*1
      logical lgEOL , lgHit
      real fread
      integer i , ip
      data chC1,chC2/'"',''''/ , chC3/'\\'/
*
*     free statement nubmers =>10
*
*     commands to set certain variables, "SET XXX="
      if( lgMatch('CHAR',chCard ) ) then
*       set log of minimum charge transfer rate for high ions and H
*       default of 1.92e-10 set in zero
        i = 5
        HCTAlex = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( HCTAlex.lt.0. ) HCTAlex = 10.**HCTAlex
*
      else if( lgMatch('CSUP',chCard ) ) then
*       force secondary ionization rate, log entered
        i = 5
        SetCsupra = fread( chCard , i , 76 , lgEOL )
        lgCSetOn = .true.
        if( lgEOL ) call NoNumb(chCard)
        SetCsupra = 10.**SetCsupra
*
      else if( lgMatch('DIDZ',chCard) ) then
*       set parameter to do with choice of dr;
*       par is the largest optical depth to allow in the zone. 
*       >>chng 96 jan 8 had been two numbers - dtau1 removed
        i = 5
        drChange = fread( chCard , i , 76 , lgEOL )
        if( drChange.le.0. ) drChange = 10. ** drChange
        if( lgEOL ) call NoNumb(chCard )
*
      else if( lgMatch('DSTW',chCard) ) then
*       set DestWght, fraction of new dest prob to take in 
*       average of old and new, for all lines
        i = 5
        DestWght = fread( chCard , i , 76 , lgEOL )
        DestWghtSave = DestWght
        if( lgEOL ) call NoNumb(chCard )
        if( DestWght.le.0. .or. DestWght.gt.1. ) then
          write(qq,'('' DestWght must be between 0 and 1'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
*
      else if( lgMatch('EXEM',chCard) ) then
*       exemplar fortran has bug in open statement, so special case
        lgExemplar = .true.
*
      else if( lgMatch('IPUN',chCard) ) then
*       set default punch unit for first punch with no unit given
        i = 5
        iPunDef = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( iPunDef.le.6 ) then
          write(qq,'('' Punch unit must be greater than 6'')')
          stop
        endif
*
      else if( lgMatch('COLI',chCard) ) then
*       set maximum CO/C ratio
        i = 5
        COLimit = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if(COLimit.lt.0. ) COLimit = 10.** COLimit
*
      else if( lgMatch(' DR ',chCard) ) then
*       set zone thickness by forcing drmax and drmin
        i = 5
        sdrmax = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        sdrmin = sdrmax
*
      else if( lgMatch('DRMA',chCard) ) then
*       set maximum zone thickness
        i = 5
        sdrmax = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
*
      else if( lgMatch('DRMI',chCard) ) then
*       set minimum zone thickness
        i = 5
        sdrmin = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        lgSMinON = .true.
*
      else if( lgMatch('FLXF',chCard ) ) then
*       faintest continuum flux to consider
        i = 5
        FluxFaint = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( FluxFaint.lt.0. ) FluxFaint = 10.**FluxFaint
*
      else if( lgMatch( 'LOWE',chCard)  ) then
*        set lowest te to constant
         i = 5
         telow = fread( chCard , i , 76 , lgEOL )
*        linear option
         if( telow.le.10. .and. .not.lgMatch('LINE',chCard) ) then
            telow = 10.**telow
         endif
         if( lgEOL ) call NoNumb(chCard )
         if( telow.lt.2.8) then
           write(qq,'('' TE < 3K, reset to 2.8K.'')')
           telow = 2.8
         endif
*
      else if( lgMatch('NERR',chCard) ) then
*       keyword is actually EdenError
*       set telerance in eden match
        i = 5
        EdenError = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( EdenError.lt.0.) EdenError = 10.**EdenError
*
      else if( lgMatch('TEST',chCard) ) then
*       set flag saying to turn on some test
        lgTestOn = .true.
*
      else if( lgMatch('TRAC',chCard) ) then
*       set level of trace convergence
        i = 5
        nLevTrace = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
*
      else if( lgMatch('TRIM',chCard ) ) then
*       set trim upper or lower, for ionization stage trimming
*       in routine TrimStage
        i = 5
        if( lgMatch('UPPE',chCard ) ) then
*         set trim upper
          trimhi = 10.**fread( chCard , i , 76 , lgEOL )
        else if( lgMatch('LOWE',chCard ) ) then
*         set trim lower
          trimlo = 10.**fread( chCard , i , 76 , lgEOL )
        else
*         set trim upper
          trimhi = 10.**fread( chCard , i , 76 , lgEOL )
*         set trim lower to same number
          trimlo = trimhi
        endif
        if( lgEOL ) call NoNumb(chCard)
        if( trimlo.ge.1. .or. trimhi.ge.1. ) then
          write(qq,'('' number must be negative since log'')')
          stop
        endif
*
      else if( lgMatch('SKIP',chCard ) ) then
*       skip punch command, for punching every n't point
        i = 5
        ncPunchSkip = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
*
      else if( lgMatch('EAKH',chCard ) ) then
*       set WeakHeatCool, threshold on punch heating and cooling, default 0.05
        i = 5
        WeakHeatCool = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( WeakHeatCool .lt.0. ) WeakHeatCool = 10.**WeakHeatCool
*
      else if( lgMatch('KSHE',chCard ) ) then
*       upper limit to opacities for k-shell ionizaiton
        i = 5
        EnergyKshell = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( EnergyKshell .eq.0. ) then
*         arg of 0 causes upper limit to energy array
          EnergyKshell = egamry
        else if( EnergyKshell .lt.194. ) then
          write(qq,'('' k-shell energy must be greater than 194 Ryd'')')
          stop
        endif
*
      else if( lgMatch('NEGO',chCard ) ) then
*       punch negative opacities if they occur, set negopac
        i = 5
        negoIO = fread( chCard , i , 76 , lgEOL )
        if(lgEOL) then
          negoIO = 10
        else if(negoIO.eq.0 ) then
          write(qq,'('' IO unit for punching negative opacities '',
     1    ''cannot be 0'')')
          stop
        endif
*
      else if( lgMatch('NEND',chCard ) ) then
*       default limit to number of zones to be computed
*       only do this if nend is NOT currently left at its default
*       nend is set to nEndDflt in routine zero
*       this command only has effect if stop zone not entered
        if( lgEndDflt ) then
          i = 5
          nEndDflt = fread( chCard , i , 76 , lgEOL )
          lgEndDflt = .false.
          if( lgEOL ) call NoNumb(chCard)
          do i=1,itrdim
            nend(i) = nEndDflt
          end do
        endif
*
      else if( lgMatch('TSQD',chCard ) ) then
*       upper limit for highest density considered in the 
*       Peimbert-style t^2 section of the printout
        i = 5
        tsqden = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        tsqden = 10.**tsqden
*
      else if( lgMatch('NMAP',chCard ) ) then
*       how many steps in plot or punch of heating-cooling map
        i = 5
        nMapStep = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
*
      else if( lgMatch('NUME',chCard ) .and. lgMatch('DERI',chCard) )
     1  then
*       this is an option to use numerical derivatives for heating and cooling
        lgNumDeriv = .true.
*
*     set path for certain files
      else if( lgMatch('PATH',chCard) ) then
*       set path for picking up files
*       format is for path to be within quotes
        lgPathSet = .true.
*       first clear out array
        do i=1,80
          chPath(i:i) = ' '
        end do
        lgHit = .false.
*       do i=5,80
        i = 1
        do while( .not.lgHit .and. i.lt.80 )
          if(chCard(i:i).eq.chC1 .or. chCard(i:i).eq.chC2 ) then
            ip = i
            lgHit = .true.
*           go to2
          endif
          i = i + 1
        end do
*       falls down to here if no " or '
        if( .not.lgHit ) then
          write(qq,'('' I couldnt find a path on this line.'')')
          write(qq,'('' Paths must begin or end with the characters '',
     1    A1,'' or '',A1)') chC1 , chC2
          write(qq,'('' Sorry.'')')
          stop
        endif
*2      continue
*       now look for end of path
        ip = ip + 1
        i = 1
        do while (ip.le.80 .and. chCard(ip:ip).ne.chC1 .and. 
     1    chCard(ip:ip).ne.chC2 .and.  chCard(ip:ip).ne.' ' )
*         use original form of chCard, before readr cap't it
          chPath(i:i) = chOrgCard(ip:ip)
          ip = ip + 1
          i = i + 1
        end do
*       make sure path ends with backslash - this only works on unix
*       if end was the ] char then this could be a vms machine,
*       do nothing in that case
*       >>chng 97 june 18, add test for / in case of win nt pc
        if( chPath(i-1:i-1).ne.'/' .and. chPath(i-1:i-1).ne.']' .and.
     1    chPath(i-1:i-1).ne.chC3 )
     1    chPath(i:i)='/'
*
      else if( lgMatch('PHFI',chCard ) ) then
*       which version of PHFIT to use, 1995 or 1996
        i = 5
        ip = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( ip.eq.1995 ) then
*         option to go back to old results, pre op
          lgPhFit = .true.
        else if( ip.eq.1996 ) then
*         default is to use newer results, including opacity project
          lgPhFit = .false.
        else
          write(qq,'('' Two possible values are 1995 and 1996.'')')
          stop
        endif
*
      else if( lgMatch('WIDT',chCard ) ) then
*       set line width for contrast in continuum plots
        i = 5
*       units are km/sec
        PunchLWidth = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( PunchLWidth.le.0. ) then
          write(qq,'('' line width must be greater than zero.'')')
          stop
        endif
        PunchLWidth = SpeedLight / (PunchLWidth*1e5)
*
      else
        write(qq,'('' I didnt recognize a key on this SET line.'')')
        stop
      endif
*
      end
