******************************************************************************
      subroutine gett2o3( tsqr)
      implicit none
*analyze computed [OIII] spectrum to get t^2
      real tsqr
*
      include "nzlim.par"
      include "struc.com"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "nzlmok.com"
*
      double precision as , a , b
      real tmean
      integer i
*
*     check that we didn't overrun zone scale
      if( nzone.ge.nzlim ) then
        lgZonLimOK = .false.
      else
        lgZonLimOK = .true.
      endif
*
*     get T, t^2
      a = 0.
      b = 0.
      do i=1,min(nzlim,nzone)
        as = dble(volstr(i))*dble(o3str(i))*dble(ednstr(i))
        a = a + dble(testr(i))*as
*       B is used twice below
        b = b + as
      end do
      if( b.le.0. ) then
        tsqr = 0.
      else
*       following is H+ weighted mean temp over vol
        tmean = a / b
        a = 0.
        do i=1,min(nzlim,nzone)
          as = dble(volstr(i))*dble(o3str(i))*ednstr(i)
          a = a + (dble(testr(i)-tmean)**2) *as
        end do
        tsqr = a / (b*(tmean**2))
      endif
*
      end
