*****************************************************************************
      subroutine grain
      implicit none
*main routine to converge grains thermal solution
      include "ndust.par"
      include "ncell.par"
      include "limelm.par"
      include "toler.com"
      include "heating.com"
      include "heat.com"
      include "NumUpper.com"
      include "dustheat.com"
      include "dstfac.com"
      include "dhla.com"
      include "tedust.com"
      include "dstdft.com"
      include "dclgas.com"
      include "InCvgRsn.com"
      include "iondun.com"
      include "dstop.com"
*
*     this is the main routine that drives the grain physics
*
*     local variables
      real SaveHeat , SaveCool , GrnVryDpth
      integer nd , i
*
*     free statement labels >=10, 6
*
*     these will sum heating agents over grain populations
      DustHeatLya = 0.
      dhcol = 0.
      dincon = 0.
*     dstotl will be total cooling by grains here
      dstotl = 0.
*     total heating due to absorption of diffuse fields, not Lya
      HDustDif = 0.
*
      if( .not.lgDustOn ) then
        dstsum = 0.
        heating(1,14) = 0.
        DustCoolGas = 0.
        do nd=1,ndust
          dheat(nd) = 0.
          tedust(nd) = 0.
          DustDftVel(nd) = 0.
        end do
        return
      endif
*
*     option to have grain abundance depend on depth
      do i=1,nupper
*       these are total absorption and scattering cross sections
        dstab(i) = 0.
        dstsc(i) = 0.
      end do
      do nd=1,ndust
*       refresh grain opacities if variable grain abundances enabled
        if( lgDustOn1(nd).and.lgDustVary(nd)) then
          dstAbund(nd) = dstfactor(nd) * GrnVryDpth(nd)
        endif
        do i=1,nupper
*         these are total absorption and scattering cross sections
          dstab(i) = dstab(i) + dstab1(i,nd) * dstAbund(nd)
          dstsc(i) = dstsc(i) + dstsc1(i,nd) * dstAbund(nd)
        end do
      end do
*
*     must redo grain solution all the time since they
*     generally have non-trivial contributions to heating-cooling
      SaveHeat = heating(1,14)
      SaveCool = DustCoolGas
      heating(1,14) = 0.
*
*     find dust charge
      call dcharg
*     find heating (gas and dust) and grain temperature
      call dtempr
*     find dust drift velocity
      call ddrift
      SaveHeat = max( abs(SaveHeat-heating(1,14)) ,
     1 abs( SaveCool-DustCoolGas) ) / max(1e-30,htot)
      if( SaveHeat.gt.toler/2. ) then
        lgIonDone = .false.
        chInCvgRsn = 'Grain dHdC'
      endif
*
      end
