******************************************************************************
      real function hbf(x,n,z)
      integer n
      real x , z
      include "IOqq.com"
*
*     calculates photoionisation cross sections for hydrogenic ions
*     routine obtained from Anil Pradhan, Nov 90
*
*     Z=nuclear charge
*     W=photon energy, W0=threshold photon energy
*     X=log10(W/W0)
*     N=principal quantum number
*     HBF=cross section in cm**(-2)
*
      real a(10),b(10),c(10),d(10),e(10),f(10)
      data a/
     +  -17.2004,-16.8584,-16.6670,-16.5339,-16.4319,-16.3491,
     +  -16.2795,-16.2194,-16.1666,-16.1195/
      data b/
     +   -2.6671, -2.8068, -2.8549, -2.8812, -2.8983, -2.9103,
     +   -2.9193, -2.9264, -2.9321, -2.9369/
      data c/
     +   -0.3228, -0.1323, -0.0931, -0.0735, -0.0612, -0.0527,
     +   -0.0465, -0.0418, -0.0380, -0.0350/
      data d/
     +    0.0608,  0.0224,  0.0224,  0.0204,  0.0181,  0.0163,
     +    0.0147,  0.0135,  0.0125,  0.0117/
      data e/
     +  -16.9991,-16.7709,-16.6188,-16.5012,-16.4069,-16.3289,
     +  -16.2624,-16.2046,-16.1536,-16.1078/
      data f/
     +   -3.1304, -3.0041, -2.9738, -2.9671, -2.9662, -2.9669,
     +   -2.9681, -2.9694, -2.9707, -2.9719/
*
      if( n.gt.10 .or. n.lt.1 ) then
        write(qq,'('' Quantum number'',I4,'' out of range of HBF.'')')
     1  n
        stop
      endif
*
      if(x.le.1.)then
        hbf=a(n)+x*(b(n)+x*(c(n)+x*d(n)))
      else
        hbf=e(n)+x*f(n)
      endif
*
*     the following two lines were out of order, swapped; yy 26-08-88
      hbf=10.**hbf
      hbf=hbf/(z**2)
*
      end
