******************************************************************************
      subroutine he1gma( gam22 , hela )
      implicit none
*evaluate photoionization rates for helium singlets
      real gam22,hela
      include "ncell.par"
      include "itrdim.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "limelm.par"
      include "he1crt.com"
      include "he1blt.com"
      include "he1ind.com"
      include "he1cin.com"
      include "rfield.com"
      include "phe1lv.com"
      include "heat.com"
      include "he.com"
      include "ip2gam.com"
      include "phycon.com"
      include "nhe2.com"
      include "TePowers.com"
      include "called.com"
      include "shullc.com"
      include "logte.com"
      include "otsmin.com"
      include "hebug.com"
      include "trace.com"
      include "heopfr.com"
      include "nhe1.com"
      include "iophe1.com"
      include "ZoneCnt.com"
      include "hhe1.com"
      include "DoPhoto.com"
      include "He1NIonRyd.com"
      include "PhotScale.com"
      include "PhotRate.com"
      include "iphe2l.com"
      include "ots.com"
      include "IOqq.com"
*
*     local variables
      real ghe1(9) ,he1cn(nhe1lvl)
      real bnfun,g2elec,rectot , p1 , p2
      integer i,n
      save ghe1 , he1cn , p1,p2
*     free statement labels >= 7
*
*     photoionization rates
*     He I ground state ionization
*
*     photoionization He
      if( lgDoPhoto ) then
*       with induced recombination, PhotScaleOn is 1, set to
*       zero with 'no photoionization' command
        ghe1(1) = bnfun( nhe1(1) , ip2gam-1,iophe1(1),1.808,
     1  he1qin(1), he1cn(1)) * PhotScaleOn
        hhe1(1) = h
        hela = secla
        gam22 = secion
*       now add on rest of integral; these energies can double photoionize
        g2elec = bnfun( ip2gam , nflux , iophe1(1)+ip2gam-nhe1(1) ,
     1  1.808 , p1 , p2) * PhotScaleOn
        if( lgTrace.and.lgHeBug ) then
          call PrtGamma(nhe1(1) ,nflux ,iophe1(1),qq,
     1    ghe1(1)+g2elec,(ghe1(1)+g2elec)*0.05)
        endif
        he1qin(1) = he1qin(1) + p1
        he1cn(1) = he1cn(1) + p2
        ghe1(1) = ghe1(1) + g2elec
*       gamma => 2 elec cross section - Brown (1970)
        g2elec = g2elec * 0.03
*       this used in helium
        gam22 = gam22 + secion
*       hela is used in helium to get total sec rate
        hela = hela + secla
        hhe1(1) = hhe1(1) + h
      endif
*
*     HeII LA and diffuse continua
      he1gam(1) = ghe1(1)
      PhotoRate(2,1,1,1) = ghe1(1)
      PhotoRate(2,1,1,2) = hhe1(1)
*
*     He I n>=2 state ionization
      if( lgDoPhoto ) then
*       F2 is related to induced rec rate, HE1CN(N) is related to cooling
        do n=2,nhe1lvl
          ghe1(n) = bnfun( nhe1(n),nhe1(1), iophe1(n), He1IonRyd(n) ,
     1    he1qin(n),he1cn(n)) * PhotScaleOn
          hhe1(n) = h
          he1gam(n) = ghe1(n)
        end do
      endif
*
*      induced recombination rate
       he1rin(1) = he1qin(1) * he1lte(1)
       he1rin(2) = he1qin(2) * (he1lte(2)+he1lte(10))
       he1cin(1) = he1cn(1) * he1lte(1)
       he1cin(2) = he1cn(2) * (he1lte(2)+he1lte(10))
       do n=3,nhe1lvl
*        induced recombination rate
         he1rin(n) = he1lte(n) * he1qin(n)
*        coooing due to induced recombination
         he1cin(n) = he1cn(n) * he1lte(n)
       end do
*
      if( lgTrace.and.lgHeBug ) then
         rectot = he1rec(1,2) * he1rec(1,1)
         do i=2,nhe1lvl
            rectot = rectot + he1rec(i,2) * he1rec(i,1)
         end do
         write(qq,'(5X,''He sin Gam:'',1P,E9.2,'' RadRec:'',E9.2,
     1   '' G eff'',E9.2,'' GndDrate'',E9.2,'' FrOp(other)'',E9.2,
     2   '' csup'',E9.2)')
     3   he1gam(1) , rectot , he1rec(1,2) , ghe1(1), ophe1f(1) , csupra
      endif
      if( lgTrace.and.(lgHe1Bug.or.lgHeBug) ) then
        if( he1gam(1).gt.0. ) then
          write(qq,'(5X,''HE1GAMgr ate'',1P,E9.2,'' pht frac Prim'',
     1    e9.2,'' ots304'',e9.2,'' ots228'',e9.2)')
     2    he1gam(1) ,
     3    ghe1(1)/he1gam(1) , otslin(iphe2l(2,1))*3.0e-18/
     3    he1gam(1), otscon(nhe2(1))*1.75e-18/he1gam(1) 
        else
          write(qq,'(5X,''HE1GAMgr pht frac = none.'')')
        endif
      endif
*
      if( lgTrace.and.lgHe1Bug ) then
        if( lgDoPhoto ) then
          write(qq,'(5X,''HE1GMA finds photo rates:'',1P,9(I2,E9.2))')
     1    (i,he1gam(i),i=1,9)
        else
          write(qq,'(5X,''HE1GMA does not reeval photoioniz rates.'')')
        endif
      endif
*
      end
