******************************************************************************
      subroutine he1lev( he2ov1 , sm2ov1 )
      implicit none
*evaluate ionization balance level populations for helium singlets
      double precision he2ov1
      real sm2ov1
      include "en1ryd.par"
      include "ipLnArry.par"
      include "ncell.par"
      include "nhe3lvl.par"
      include "nhe1lvl.par"
      include "itrdim.par"
      include "nta.par"
      include "limelm.par"
      include "rfield.com"
      include "herec.com"
      include "he1blt.com"
      include "he1crt.com"
      include "x12.com"
      include "shullc.com"
      include "he12on.com"
      include "he1ind.com"
      include "called.com"
      include "hebug.com"
      include "trace.com"
      include "TePowers.com"
      include "h.com"
      include "he.com"
      include "he1tau.com"
      include "phycon.com"
      include "phe1lv.com"
      include "he1ex.com"
      include "he1cbr.com"
      include "he1bn.com"
      include "he1rsp.com"
      include "he3n.com"
      include "che2sn.com"
      include "he1rb.com"
      include "the1lo.com"
      include "hhe1.com"
      include "ZoneCnt.com"
      include "nhe1.com"
      include "hvmolEXP.com"
      include "he1net.com"
      include "DestCrt.com"
      include "he1stat.com"
      include "he1rate.com"
      include "he3as.com"
      include "he3pht.com"
      include "He1NIonRyd.com"
      include "IOqq.com"
*
*     local variables
      real totcap(10)
      double precision z(11,11),c,r
*     real a2sg
*     this is in he3as.com
*     parameter (a2sg=1.13e-4)
      integer i, j, nerror
      real rdest,const,edp,rfac,gdist , hex12 , pop3n1,
     1 he1exx(nhe1lvl+1) , chk2ov1 , rtrip2s, rtrip2p, rtripg
*     real fudge
      save pop3n1 , rtrip2s,rtrip2p,rtripg
*
*     2S LEVEL IS LEVEL TEN; Z(2,I) IS 2P, Z(10,I) = 2S, HN(2) IS SUM
*     level 7 is actually 7 - 10;  8 is 11 - 20;  9 is 21 - 100
*     free statement labels >=12
*
*     last term is frac of trips that get photoionized
*     He1RecB is case b singlet rec coef
*     he1rtt is effect total rec coef
      reci = he1rtt + rectri * he3relax
*     do simple estimate of ionization balance
*     following assumes all trip recomb go to singlets
      sm2ov1 = (he1gam(1)+csupra*0.5+he1clc(1)*eden) /
     1 (eden*reci + co*1.10e-9 )
*     >>chng 96 dec 17, for HeI oscillations when pumped Lyman lines
*resulted in photoionization, simple estimate no good, so use
*previous solution
      if( nzone.gt.1 ) then
*       use previous matrix solution if it exists
        chk2ov1 = clhe2ov1
      else
*       use simple estimate for beginning of calculation
        chk2ov1 = sm2ov1
      endif
      smhe2ov1 = sm2ov1
      if( lgHe1Bug.and.lgTrace ) then
        write(qq,'(7X,''HE1LEV HE1GAM'',1P,E9.2,'' csupra'',E9.2,
     1  '' HE1CLC(1)'',E9.2,'' rec*re'',E9.2,
     2  '' smn2ov1'',e9.2)')
     3  he1gam(1) , csupra , he1clc(1),eden*reci,
     4  sm2ov1
      endif
      if( lgHeBug.and.lgTrace ) then
        write(qq,'(5X,''HE1LEV HE1GAM'',1P,'' tot ioniz'',E9.2,
     2  '' total reco'',E9.2,'' SM2OV1='',E9.2)')
     1  he1gam(1)+csupra*0.5+he1clc(1)*eden ,
     2  (eden*reci + co*1.10e-9 ) , sm2ov1
      endif
      create(2,1) = eden*reci + co*1.10e-9 
      destroy(2,1) = he1gam(1)+csupra*0.5+he1clc(1)*eden
*
*     >>chng 96 dec 17, from sm2ov1 to chk2ov1
      if( chk2ov1 .lt.1e-12 ) then
        lgHe1ON = .false.
        do i=1,nhe1lvl
          he1bn(i) = 0.
          he1n(i) = 0.
*         this will be heating
          hhe1(i) = 0.
        end do
        he1bn(nhe1lvl+1) = 0.
        he1n(nhe1lvl+1) = 0.
        he12p = 0.
        he12s = 0.
        he2ov1 = 0.
        clhe2ov1 = he2ov1
        he1ex = 0.
        reci = 0.
        return
      else
        lgHe1ON = .true.
      endif
*
*     check how low temperature is; departure coef tend to infinity
*     as TE goes to zero; matrix formalism won't work on a 32-bit machine
*     if EXP(H NU/KT) > 1E38 for 13.6EV.
*     also use this if very low ionization
*     >>chng 96 dec 17, from sm2ov1 to chk2ov1
      if( te.le.the1lo .or. he1lte(1).eq.0. .or. he1lte(2).eq.0. .or.
     1  chk2ov1.lt.1e-8 ) then
*       last part above added to prevent code from using following
*       when helium is highly COLLISIONALLY ionized
        he1ex = 0.
        he1bn(1) = 1.
        do i=2,nhe1lvl+1
          he1bn(i) = 1.
          he1n(i) = 0.
        end do
*       He1RecB is evaluated with rec coef, is case b sum
*       recexc = He1RecB +
*    1  (he3n(1)*(c2ss2p+c2ss2s) + he3n(2)*(c2ps2s+c2ps2p) ) / eden
*       reci = he1rec(1,1)*he1rec(1,2) + recexc +
*    1  (he3n(1)*(c2sg+a2sg) + he3n(2)*c2pg ) / eden
*
*       do simple two level for helium, then fill in HN(i) for rest
        rdest = he1gam(1) + csupra*0.5 + he1clc(1)*eden 
        if( rdest.gt.0. ) then
*         charge transfer with CO in here
          he1n(1) = (eden*reci + co*1.10e-9) / rdest
        else
          he1n(1) = 1e37
        endif
*       effective case B rec coef for low den limit Martin 1988
        he1n(4) = 1.44e-11 / (te70/te03/te03*te01) * eden / he1net(4,2)
        const = he1n(4) * he1net(4,2)
        he1n(3) = const * 14.5 / te10/te03/te03*te01 / he1net(3,2)
        he1n(5) = const * 0.291 * te03 * te01 / he1net(5,2)
        he1n(6) = const * 0.138 * te03*te01*te01 / he1net(6,2)
*       He1RecB is evaluated with rec coef, is case b sum
*       this needs to have a term for exchange collisions from trips,
*       as in recexc which is commented out above.  It is commented
*       out because of oscillations it caused.
        he12s = He1RecB * eden / (8.23+cs2s2p+he1c2s1s*eden) * 0.25
        he12p = He1RecB * eden / (he1cll(2,1)*eden+he1dst(2,1)+
     1  he1net(2,1))* 0.75
        he1n(2) = he12s + he12p
        he2ov1 = 1. / he1n(1)
        clhe2ov1 = he2ov1
        if(lgHeBug.and.lgTrace ) then
          write(qq,'(5X,''LOW TE, HE1N(1)='',1P,E12.3,
     1    '' rec='',E12.3,''HE1gam(1)='',E12.3)')
     2    he1n(1) , reci , he1gam(1)
        endif
        return
      endif
*-------------------------------------------------------------------
*
*     radiative and three body rec, fix 2s and 2p first
*     remember that HE1LTE(i) is only LTE pop when mult by Ne Nh
*
*     get rates from triplets
      if( he3n(2).gt.0. ) then
* 666 error! when going over to one eden change per iteration, get rid 
* of only updates when flag set
*       use this if we have a valid triplet solution, hn3n(2)>0
*       he3n is pop relative to heii
        rtrip2s = ( he3n(1)*c2ss2s+he3n(2)*c2ps2s ) /eden
      else
*       no triplet solution, so assume no recs come here
*       >>chng 96 feb 14, have been half of triplets here
        rtrip2s = 0.
      endif
*
      z(10,11) = (he1r2s*he1rec(2,2)+rtrip2s+he1rin(2)*0.25) /
     1 he1lte(10)+ he1clc(2)*eden
      totcap(10) = z(10,11) * he1lte(10)
      reci = totcap(10)
*
      if( he3n(2).gt.0. ) then
*       use this if we have a valid triplet solution
        rtrip2p = (he3n(1)*c2ss2p + he3n(2)*c2ps2p) / eden
      else
*       no triplet solution, so assume all recs come here
*     >>chng 96 feb 14, have been half of triplets here
        rtrip2p = 0.
      endif
      z(2,11) = (he1r2p*he1rec(2,2)+rtrip2p+he1rin(2)*0.75) / he1lte(2)+
     1 he1clc(2)*eden
      totcap(2) = z(2,11) * he1lte(2)
      reci = reci + totcap(2)
*
      if( nzone .gt.1 ) then
*       this atom couples with the triplets -
*       damp out oscillations here
        pop3n1 = (pop3n1 + he3n(1)) / 2.
      else
        pop3n1 = he3n(1)
      endif
*
      if( he3n(2).gt.0. ) then
        rtripg = (pop3n1 *(c2sg+a2sg)+he3n(2)*c2pg) / eden
      else
*       no triplet solution, so assume all recs come here
*     >>chng 96 feb 14, had been zero
        rtripg = rectri * he3relax
      endif
      z(1,11) = ( he1rec(1,1)*he1rec(1,2) + rtripg + he1rin(1) ) /
     1 he1lte(1) + he1clc(1)*eden
*
      totcap(1) = z(1,11) * he1lte(1)
      reci = reci + totcap(1)
*
      do i=3,nhe1lvl
        z(i,11) = (he1rec(i,1)*he1rec(i,2)+he1rin(i))/he1lte(i) +
     1  he1clc(i)*eden
        totcap(i) = z(i,11) * he1lte(i)
        reci = reci + totcap(i)
      end do
*
*     Janev et al show HeI 100 eV cross section is about 6 times
*     smaller than that for hydrogen
      hex12 = x12 / 6.
*---------------------------------------------------------------------
*     now set up matrix for dreaded b(i)'s
*
*     level 1 balance equation
*     HE1CLL(u,l), etc, are rates for downward collisions (cm^3 s^-1)
*     corr of hi*1.7e-4 accounts for col ion by HI; Drawin Zs Phys 225, 483.
      z(1,1) = csupra*0.5 + he1gam(1) + hex12 + he1coldn(1)*eden +
     1 he1clc(1)* (eden + hi*1.7e-4) + he1bul(1) + (csg2s+csg2p)
      z(1,2) = -( he1net(2,1) + he1con(2,1) +
     1 he1cll(2,1)*eden+hex12/3.)* he1lte(2) / he1lte(1)
      z(1,3) = -( he1net(3,1) + he1con(3,1) +
     1 he1cll(3,1)*eden ) * he1lte(3) / he1lte(1)
      z(1,4) = -( he1net(4,1) + he1con(4,1) +
     1 he1cll(4,1)*eden ) * he1lte(4) / he1lte(1)
      z(1,5) = -( he1net(5,1) + he1con(5,1) +
     1 he1cll(5,1)*eden ) * he1lte(5) / he1lte(1)
      z(1,6) = -( he1net(6,1) + he1con(6,1) +
     1 he1cll(6,1)*eden ) * he1lte(6) / he1lte(1)
      z(1,7) = -( he1net(7,1) + he1con(7,1) +
     1 he1cll(7,1)*eden ) * he1lte(7) / he1lte(1)
      z(1,8) = -( he1net(8,1) + he1con(8,1) +
     1 he1cll(8,1)*eden ) * he1lte(8) / he1lte(1)
      z(1,9) = -( he1net(9,1) + he1con(9,1) +
     1 he1cll(9,1)*eden ) * he1lte(9) / he1lte(1)
      z(1,10) = -( 8.23 + hex12 +    he1c2s1s*eden)*he1lte(10)/he1lte(1)
      gdist = z(1,1)
*
*     LEVEL 2P BALANCE EQUATION - 2p is higher energy than 2s
      edp = (eden * 0.1  +  hii * 0.9 )
      c = 0.75 / he1lte(2)
*     R is low density limit branching ratio for 2s-p (NOT l-mixed)
*     this is to simulate mixing of the n=3 level
      rfac = 0.32 - 0.07 * eden / ( eden + 1e7 )
      r = ( 1. - rfac ) / he1lte(2)
      z(2,1) = -( hex12*0.33 + he1cll(2,1)*eden+he1con(2,1)/he1bol(1,2))
      z(2,2) = he1gam(2)+ he1radn(2) + hex12/3. + he1coldn(2)*eden + 
     1 he1clc(2)*eden + he1c2p2s * edp + (he1bul(2)+he1con(2,1)) +
     2 ( cs2p2s + cs2p2p )
*
*666  write(90,'(1p,11e9.1)') he1gam(2), he1radn(2),hex12/3. ,
*    1  he1coldn(2)*eden ,
*    1 he1clc(2)*eden , he1c2p2s * edp + (he1bul(2)+he1con(2,1)) ,
*    2 ( cs2p2s + cs2p2p )
*
      z(2,3) = -(he1net(3,2)*r+(he1con(3,2)+he1cll(3,2)*eden)*c) *
     1 he1lte(3)
      z(2,4) = -(he1net(4,2)*r+(he1con(4,2)+he1cll(4,2)*eden)*c) *
     1 he1lte(4)
      z(2,5) = -(he1net(5,2)*r+(he1con(5,2)+he1cll(5,2)*eden)*c) *
     1 he1lte(5)
      z(2,6) = -(he1net(6,2)*r+(he1con(6,2)+he1cll(6,2)*eden)*c) *
     1 he1lte(6)
      z(2,7) = -(he1net(7,2)*r+(he1con(7,2)+he1cll(7,2)*eden)*c) *
     1 he1lte(7)
      z(2,8) = -(he1net(8,2)*r+(he1con(8,2)+he1cll(8,2)*eden)*c) *
     1 he1lte(8)
      z(2,9) = -(he1net(9,2)*r+(he1con(9,2)+he1cll(9,2)*eden)*c) *
     1 he1lte(9)
      z(2,10) = -he1c2p2s * edp
*
*     LEVEL 2S BALANCE EQUATION - define 2s as lower energy than 2p
      c = 0.25 / he1lte(10)
      r = rfac / he1lte(10)
*
      z(10,1) = -( hex12*0.33 + he1c2s1s*eden )
      z(10,2) = -(he1c2p2s*edp+t206(ipLnEscP)*t206(ipLnAul))*he1lte(2) /
     1  he1lte(10)
      z(10,3) = -(he1net(3,2)*r+(he1con(3,2)+he1cll(3,2)*eden)*c) *
     1  he1lte(3)
      z(10,4) = -(he1net(4,2)*r+(he1con(4,2)+he1cll(4,2)*eden)*c) *
     1  he1lte(4)
      z(10,5) = -(he1net(5,2)*r+(he1con(5,2)+he1cll(5,2)*eden)*c) *
     1  he1lte(5)
      z(10,6) = -(he1net(6,2)*r+(he1con(6,2)+he1cll(6,2)*eden)*c) *
     1  he1lte(6)
      z(10,7) = -(he1net(7,2)*r+(he1con(7,2)+he1cll(7,2)*eden)*c) *
     1  he1lte(7)
      z(10,8) = -(he1net(8,2)*r+(he1con(8,2)+he1cll(8,2)*eden)*c) *
     1 he1lte(8)
      z(10,9) = -(he1net(9,2)*r+(he1con(9,2)+he1cll(9,2)*eden)*c) *
     1 he1lte(9)
      z(10,10) = he1radn(10) + he1gam(2) + (he1coldn(10)+he1clc(2))*eden 
     1 + hex12 + he1c2p2s*3.*edp + he1bul(2) + (cs2s2s + cs2s2p)
*
*     LEVEL 3
      z(3,1) = -(he1cll(3,1)*eden + 
     1 ( he1con(3,1)*he1stat(3)/he1stat(1) ) *he1lte(1)/he1lte(3) )
      z(3,2) = -(he1cll(3,2)*eden + he1con(3,2)/he1bol(2,3) ) *0.75
      z(3,3) = he1gam(3)+he1radn(3)+ (he1clc(3)+he1coldn(3))*eden +
     1 he1bul(3)
      z(3,4) =-(he1net(4,3)+he1con(4,3)+he1cll(4,3)*
     1 eden)* he1lte(4)/he1lte(3)
      z(3,5) =-(he1net(5,3)+he1con(5,3)+he1cll(5,3)*eden)*he1lte(5)/
     1 he1lte(3)
      z(3,6) =-(he1net(6,3)+he1con(6,3)+he1cll(6,3)*eden)*he1lte(6)/
     1 he1lte(3)
      z(3,7) =-(he1net(7,3)+he1con(7,3)+he1cll(7,3)*eden)*he1lte(7)/
     1 he1lte(3)
      z(3,8) =-(he1net(8,3)+he1con(8,3)+he1cll(8,3)*eden)*he1lte(8)/
     1 he1lte(3)
      z(3,9) =-(he1net(9,3)+he1con(9,3)+he1cll(9,3)*eden)*he1lte(9)/
     1 he1lte(3)
      z(3,10) = -(he1cll(3,2) *eden + he1con(3,2)/he1bol(2,3))*0.25
*
*     level 4
      z(4,1) = -he1cll(4,1) * eden - he1con(4,1)/he1bol(1,4)
      z(4,2) =-(he1cll(4,2) * eden + he1con(4,2)/he1bol(2,4)) * 0.75
      z(4,3) = -he1cll(4,3) * eden - he1con(4,3)/he1bol(3,4)
      z(4,4) = (he1coldn(4)+he1clc(4))*eden + he1radn(4) + he1gam(4)
     1 + he1bul(4)
      z(4,5) =-(he1net(5,4)+he1con(5,4)+he1cll(5,4)*eden)*he1lte(5)/
     1 he1lte(4)
      z(4,6) =-(he1net(6,4)+he1con(6,4)+he1cll(6,4)*eden)*he1lte(6)/
     1 he1lte(4)
      z(4,7) =-(he1net(7,4)+he1con(7,4)+he1cll(7,4)*eden)*he1lte(7)/
     1 he1lte(4)
      z(4,8) =-(he1net(8,4)+he1con(8,4)+he1cll(8,4)*eden)*he1lte(8)/ 
     1 he1lte(4)
      z(4,9) =-(he1net(9,4)+he1con(9,4)+he1cll(9,4)*eden)*he1lte(9)/ 
     1 he1lte(4)
      z(4,10) = -(he1cll(4,2) * eden + he1con(4,2)/he1bol(2,4))*0.25
*
*     level 5
      z(5,1) = -he1cll(5,1) * eden - he1con(5,1)/he1bol(1,5)
      z(5,2) =-(he1cll(5,2) * eden + he1con(5,2)/he1bol(2,5) ) *0.75
      z(5,3) = -he1cll(5,3) * eden - he1con(5,3)/he1bol(3,5)
      z(5,4) = -he1cll(5,4) * eden - he1con(5,4)/he1bol(4,5)
      z(5,5) = he1gam(5) + he1radn(5) + (he1coldn(5)+he1clc(5))*eden
     1 + he1bul(5)
      z(5,6) = -(he1net(6,5)+he1con(6,5)+he1cll(6,5)*eden)*he1lte(6)/
     1 he1lte(5)
      z(5,7) = -(he1net(7,5)+he1con(7,5)+he1cll(7,5)*eden)*he1lte(7)/
     1 he1lte(5)
      z(5,8) = -(he1net(8,5)+he1con(8,5)+he1cll(8,5)*eden)*he1lte(8)/
     1  he1lte(5)
      z(5,9) = -(he1net(9,5)+he1con(9,5)+he1cll(9,5)*eden)*he1lte(9)/ 
     1 he1lte(5)
      z(5,10) = -(he1cll(5,2) * eden + he1con(5,2)/he1bol(2,5))*0.25
*
*     level 6
      z(6,1) = -he1cll(6,1) * eden - he1con(6,1)/he1bol(1,6)
      z(6,2) =-(he1cll(6,2) * eden + he1con(6,2)/he1bol(2,6))* 0.75
      z(6,3) = -he1cll(6,3) * eden - he1con(6,3)/he1bol(3,6)
      z(6,4) = -he1cll(6,4) * eden - he1con(6,4)/he1bol(4,6)
      z(6,5) = -he1cll(6,5) * eden - he1con(6,5)/he1bol(5,6)
      z(6,6) = (he1coldn(6)+he1clc(6))*eden + he1gam(6) + he1radn(6)
     1 + he1bul(6)
      z(6,7) = -(he1net(7,6)+he1con(7,6)+he1cll(7,6)*eden)*he1lte(7)/
     1 he1lte(6)
      z(6,8) = -(he1net(8,6)+he1con(8,6)+he1cll(8,6)*eden)*he1lte(8)/ 
     1 he1lte(6)
      z(6,9) = -(he1net(9,6)+he1con(9,6)+he1cll(9,6)*eden)*he1lte(9)/ 
     1 he1lte(6)
      z(6,10) = -(he1cll(6,2) * eden + he1con(6,2)/he1bol(2,6))* 0.25
*
*     level 7
      z(7,1) = -he1cll(7,1) * eden - he1con(7,1)/he1bol(1,7)
      z(7,2) =-(he1cll(7,2) * eden + he1con(7,2)/he1bol(2,7))* 0.75 
      z(7,3) = -he1cll(7,3) * eden - he1con(7,3)/he1bol(3,7)
      z(7,4) = -he1cll(7,4) * eden - he1con(7,4)/he1bol(4,7)
      z(7,5) = -he1cll(7,5) * eden - he1con(7,5)/he1bol(5,7)
      z(7,6) = -he1cll(7,6) * eden - he1con(7,6)/he1bol(6,7)
      z(7,7) = (he1coldn(7)+he1clc(7))*eden + he1gam(7) + he1radn(7)
     1 + he1bul(7)
      z(7,8) = -(he1net(8,7)+he1con(8,7)+he1cll(8,7)*eden)*he1lte(8)/
     1 he1lte(7)
      z(7,9) = -(he1net(9,7)+he1con(9,7)+he1cll(9,7)*eden)*he1lte(9)/
     1 he1lte(7)
      z(7,10) = -(he1cll(7,2) * eden + he1con(7,2)/he1bol(2,7))*0.25
*
*     level 8
      z(8,1) = -he1cll(8,1) * eden - he1con(8,1)/he1bol(1,8)
      z(8,2) =-(he1cll(8,2) * eden + he1con(8,2)/he1bol(2,8))* 0.75 
      z(8,3) = -he1cll(8,3) * eden - he1con(8,3)/he1bol(3,8)
      z(8,4) = -he1cll(8,4) * eden - he1con(8,4)/he1bol(4,8)
      z(8,5) = -he1cll(8,5) * eden - he1con(8,5)/he1bol(5,8)
      z(8,6) = -he1cll(8,6) * eden - he1con(8,6)/he1bol(6,8)
      z(8,7) = -he1cll(8,7) * eden - he1con(8,7)/he1bol(7,8)
      z(8,8) = (he1coldn(8)+he1clc(8))*eden +he1gam(8) +he1radn(8)
     1 +he1bul(8)
      z(8,9) =-(he1net(9,8)+he1con(9,8)+he1cll(9,8)*eden)*he1lte(9)/
     1 he1lte(8)
      z(8,10) = -(he1cll(8,2) * eden + he1con(8,2)/he1bol(2,8))*0.25 
*
*     level 9
      z(9,1) = -he1cll(9,1) * eden - he1con(9,1)/he1bol(1,9)
      z(9,2) =-(he1cll(9,2) * eden + he1con(9,2)/he1bol(2,9))* 0.75
      z(9,3) = -he1cll(9,3) * eden - he1con(9,3)/he1bol(3,9)
      z(9,4) = -he1cll(9,4) * eden - he1con(9,4)/he1bol(4,9)
      z(9,5) = -he1cll(9,5) * eden - he1con(9,5)/he1bol(5,9)
      z(9,6) = -he1cll(9,6) * eden - he1con(9,6)/he1bol(6,9)
      z(9,7) = -he1cll(9,7) * eden - he1con(9,7)/he1bol(7,9)
      z(9,8) = -he1cll(9,8) * eden - he1con(9,8)/he1bol(8,9)
      z(9,9) = (he1coldn(9)+he1clc(9)) *eden + he1gam(9) + he1radn(9)
     1 + he1bul(9)
      z(9,10) = -(he1cll(9,2) * eden +he1con(9,2)/he1bol(2,9))* 0.25
*
      if( lgTrace.and.lgHe1Bug ) then
        do i=1,nhe1lvl+1
          write(qq,'(7X,''HeIs'',I2,1P,11E10.2)') i,(z(i,j),
     1    j=1,nhe1lvl+2)
        end do
      endif
*
*     scale to largest number of order unity
      do j=1,nhe1lvl+1
        do i=1,nhe1lvl+2
          z(j,i) = z(j,i) * he1lte(j)
        end do
      end do
*
      call matin1( z,nhe1lvl+2,nhe1lvl+1,1,nerror)
      if(nerror.ne.0 ) then
        write(qq,'('' HE1LEV MATRIX ERROR, STOP.'')')
        stop
      endif
*
*     convert from departure coef in Z(I) to level pop rel to HeII
*     HE1EX is net cooling rate due to col ionization-three body rec (s-1 here)
      he1bn(1) = z(1,11)
      he1n(1) = he1bn(1) * he1lte(1) * eden
      he1bn(2) = z(2,11)
      he1n(2) = he1bn(2) * he1lte(2) * eden
*
      do i=3,nhe1lvl
        he1bn(i) = z(i,11)
*       HE1N(I) are pop per level rel to He+; i.e., N(n)/N(He+)
        he1n(i) = he1bn(i) * he1lte(i) * eden
      end do
*
      he1ex = 0.
      do i=1,nhe1lvl-2
*       units of HE1EX are erg/cm^3/s
        he1exx(i) = He1IonRyd(i) * he1clc(i) * eden *
     1  (he1n(i)-he1lte(i)*eden)
        he1ex = he1ex + he1exx(i)
      end do
      he1ex = he1ex * en1ryd
*
      he12p = he1n(2)
      he1bn(nhe1lvl+1) = z(nhe1lvl+1,11)
      he12s = he1bn(nhe1lvl+1) * he1lte(nhe1lvl+1) * eden
      he1n(nhe1lvl+1) = he12s
      he1n(2) = he1n(2) + he12s
      he2ov1 = he1n(1) + he1n(2) + he1n(3) + he1n(4) + he1n(5) + he1n(6)
*     HE2OV1 is He+ / He sin
      he2ov1 = 1. / he2ov1
      clhe2ov1 = he2ov1
      he1ex = he1ex + en1ryd*anu(nhe1(2)) * he1clc(2) * eden *
     1 (he12s-he1lte(nhe1lvl+1)* eden)
*
      if( lgHe1Bug.and.lgTrace ) then
         write(qq,'(7X,''HE1LEV HE1GAM'',1P,10E9.2)') he1gam
         write(qq,'(7X,''HE1LEV TOTCAP'',1P,10E9.2,'' tot='',E9.2)') 
     1   totcap , reci
         write(qq,'(7X,''HE1LEV IND Rc'',1P,10E9.2)') he1rin
         write(qq,'(7X,''HE1LEV IND As'',1P,10E9.2)') he1bul
         write(qq,'(7X,''HE1LEV HE1LTE'',1P,10E9.2)') he1lte
         write(qq,'(7X,''HE1LEV   HE1N'',1P,9E9.2,'' HN2s,p'',2E9.2)') 
     1   he1n,he12s,he12p
         write(qq,'(7X,''HE1LEV   b(n)'',1P,9E9.2,''   2s,p'',2E9.2)')
     1   (he1bn(i),i=1,nhe1lvl) , he1bn(10) , he1bn(2)
*
         write(qq,'(7X,''HE1LEV   X12'',1P,E9.2,
     1   '' Heat Exc'',E9.2,'' Grn dest:'',E9.2)')
     2   x12,he1ex,gdist
      endif
*
      do i=1,nhe1lvl+1
        if(he1n(i).le.0. ) then
          write(qq,'('' HE1LEV finds negative population,'',i3,1P,
     1    E10.2,'' simple='',E10.2,'' Te='',E10.2,'' NZONE='',I4)')
     2    i,he1n(i) , sm2ov1,te,nzone
          write(qq,'('' HE1LEV pops,'',1p,11e9.1)')
     1     (he1n(j),j=1,nhe1lvl+1)
          call negcon
          call ShowMe
          stop
        endif
      end do
      if( lgTrace ) then
        write(qq,'(7X,''HE1LEV returns, mtrx finds HE2OV1 ='',1P,E9.2,
     1  '' simple='',E9.2,'' Gamma1='',E9.2,'' rec1'',E9.2,'' rec3'',
     2  e9.2)') he2ov1,sm2ov1,he1gam(1), reci , rectri
      endif
*
      end
