******************************************************************************
      subroutine he1rad
      implicit none
*evaluate radiative rates for helium singlets
      include "nta.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "ipLnArry.par"
      include "newion.com"
      include "he1tau.com"
      include "hebug.com"
      include "trace.com"
      include "otsmin.com"
      include "touton.com"
      include "TePowers.com"
      include "phycon.com"
      include "phe1lv.com"
      include "he1rsp.com"
      include "logte.com"
      include "he1str.com"
      include "he1esc.com"
      include "he1nxt.com"
      include "he1as.com"
      include "he1cbr.com"
      include "heopfr.com"
      include "he1rb.com"
      include "tusedcom.com"
      include "nhe1.com"
      include "he1net.com"
      include "he1stat.com"
      include "caseb.com"
      include "IOqq.com"
*
*     local variables
*
      real t12old,t23old
      integer i , j , n
      real a,b,c,recf
      real receff,x,fac,sexp 
*
      data t12old,t23old/2*0./
*
      recf(a,b,c) = a + b * (alogte-c)**2
*
*     free statement numbers >=10
*
*     evaluate rec coef for H, HE1REC(I,2) is recombination efficiency
*     OTSMIN normally equal to zero
*
      if( lgNewIon ) then
        do n=1,nhe1lvl
          he1rec(n,3) = receff( nhe1(n) )
        end do
      endif
*
      if( lgCaseb ) then
        he1rec(1,3) = 1e-10
      endif
*
      do n=1,nhe1lvl
        he1rec(n,3) = max( he1rec(n,3) , otsmin )
*       last factor accounts for metal absorption of HeII diffuse
*       fields, computed in AddOpac, this is counted as recombination
        he1rec(n,2) = min(1.,he1rec(n,3)+(1.-he1rec(n,3))*
     1  ophe1f(n))
      end do
      he1rec(nhe1lvl+1,2) = he1rec(2,2)
      he1rec(nhe1lvl+1,3) = he1rec(2,3)
*
      if( lgTrace.and.lgHe1Bug ) then
        write(qq,'(7X,''HE1RAD geo recomb effic'',1p,9e10.3)')
     1  (he1rec(i,3),i=1,9)
        write(qq,'(7X,''HE1RAD net recomb effic'',1p,9e10.3)')
     1  (he1rec(i,2),i=1,9)
      endif
*
*     don't reevaluate coefficients if temp unchanged
      if( abs(he1tus-te)/he1tus.gt. 0.002 ) then
        he1tus = te
        he1rec(1,1) = 1.6e-11 / sqrte
*
        x = 157900. / te
*
        he1r2s =   3.84e-13 / sqrte * te03 * te01
        he1r2p =   7.768e-12 / te70 * te01
        he1rec(2,1) = he1r2p
        he1rec(nhe1lvl+1,1) = he1r2s
        fac = 4.0 * te
        if( te.le.1e5 ) then
           he1rec(3,1) = 1.256e-11 / (te70*te03*te03/te01)
        else
           he1rec(3,1) = 1.1*10.**(-recf( 9.2150 , .12898,4.9933))/fac
        endif
        fac = fac * 1.1
        he1rec(4,1) = 10.**(-recf( 9.4583 , .12236  , 4.7567 ))/fac
        he1rec(5,1) = 10.**(-recf( 9.6516 , .11481  , 4.5614 ))/fac
        he1rec(6,1) = 10.**(-recf( 9.8112 , .10747  , 4.3913 ))/fac
        he1rec(7,1) = 10.**(-recf( 9.4942 , .093811 , 4.0473 ))/fac
        he1rec(8,1) = 10.**(-recf( 9.5858 , .070572 , 3.2727 ))/fac
        he1rec(9,1) = 10.**(-recf( 9.5028 , .045593 , 1.4592 ))/fac
*
*       >>chng 96 june 5, big jump in rec coef at level7 (old cota level)
*       causes maser in 7 -6 - don't let this happen, add extro to top level
* 666 error! change this to true levels, like Jason's hydrogen
*       factor is to account for lowering  of rec coef with inc n
        b = 0.75
        do i=7,nhe1lvl-1
*         amount we will subtract from here, then add to highest level
          a = he1rec(i,1) - he1rec(i-1,1)*b
          he1rec(i,1) = he1rec(i,1) - a
          he1rec(nhe1lvl,1) = he1rec(nhe1lvl,1) + a
        end do
*
*       dielectronic recombination
        if( te.gt. 5e4 ) then
          he1rec(nhe1lvl,1) = he1rec(nhe1lvl,1) +
     1    1.9e-3/te32*sexp(4.7e5/te)*(1.+0.3*sexp(9.4e4/te))
*         >>chng 96 oct 22, first coef had been 4.5 below, change to 4.7 as
*in aldrovandi and pequignot
*    1    1.9e-3/te32*sexp(4.5e5/te)*(1.+0.3*sexp(9.4e4/te))*0.
        endif
*
        he1rtt = he1rec(1,1)*he1rec(1,2)
*       He1RecB is the case B singlet recombination rate coef
        He1RecB = 0.
        do i=2,nhe1lvl
          he1rtt = he1rtt + he1rec(i,1)*he1rec(i,2)
          He1RecB = He1RecB + he1rec(i,1)
        end do
        if( lgTrace.and.lgHe1Bug ) then
          write(qq,'(7X,''HE1RAD eval rec cof'',1P,9E10.3)') 
     1    (he1rec(i,1),i=1,9)
          write(qq,'(7X,''HE1RAD total effective recombination coef'',
     1    1P,E10.3,'' Case B, A='',2E10.3)')
     2    he1rtt , He1RecB , He1RecB+he1rec(1,1)
        endif
      else
        he1rtt = he1rec(1,1)*he1rec(1,2)
        He1RecB = 0.
        do i=2,nhe1lvl
          he1rtt = he1rtt + he1rec(i,1)*he1rec(i,2)
          He1RecB = He1RecB + he1rec(i,1)
        end do
        if( lgTrace.and.lgHe1Bug ) then
          write(qq,'(7X,''HE1RAD not reevel rec''
     1    ,'' cof total effective recombination coef is '',1P,E10.3)') 
     2    he1rtt
        endif
      endiF
*
      t12old = he1nxt(2,1)
      t23old = he1nxt(3,2)
*
*     following has min(1, removed may 12 96, is it in hydro and he2?
      do j=1,nhe1lvl-1
        do i=j+1,nhe1lvl
*         >>chng 96 may 13 cap of 1 prevented maser emission
*         he1mis(i,j) = He1EinA(i,j)*min(1.,(he1esc(i,j)+peshe1(i,j)))
          he1mis(i,j) = He1EinA(i,j)*(he1esc(i,j)+peshe1(i,j))
          he1net(i,j) = he1mis(i,j) + he1dst(i,j)
        end do
      end do
*
*     these are used in HLEVEL - total decay rates
      he1radn(2) = he1net(2,1) + t206(ipLnEscP) * t206(ipLnAul)
*     this is what the two photon integrates up to
      he1radn(10) = 8.23
      he1radn(3) = he1net(3,1) + he1net(3,2)
      he1radn(4) = he1net(4,1) + he1net(4,2) + he1net(4,3)
      he1radn(5) = he1net(5,1) + he1net(5,2) + he1net(5,3) +he1net(5,4)
      he1radn(6) = he1net(6,1) + he1net(6,2) + he1net(6,3) +he1net(6,4)+
     1 he1net(6,5)
      he1radn(7) = he1net(7,1) + he1net(7,2) + he1net(7,3) +he1net(7,4)+
     1 he1net(7,5) + he1net(7,6)
      he1radn(8) = he1net(8,1) + he1net(8,2) + he1net(8,3) +he1net(8,4)+
     1 he1net(8,5) + he1net(8,6) + he1net(8,7)
      he1radn(9) = he1net(9,1) + he1net(9,2) + he1net(9,3) +he1net(9,4)+
     1 he1net(9,5) + he1net(9,6) + he1net(9,7) + he1net(9,8)
*
*     total rates out of level due to induced processes
      he1bul(1) = (he1con(2,1)*he1stat(2) + he1con(3,1)*he1stat(3) + 
     1 he1con(4,1)*he1stat(4) + he1con(5,1)*he1stat(5) + he1con(6,1)*
     1 he1stat(6) + he1con(7,1)*he1stat(7)+ he1con(8,1)*he1stat(8)+
     2 he1con(9,1)*he1stat(9) ) / he1stat(1)
      he1bul(2) = (he1con(3,2)*he1stat(3) + he1con(4,2)*he1stat(4)
     1 + he1con(5,2)*he1stat(5) + he1con(6,2)*he1stat(6) +he1con(7,2)*
     1  he1stat(7) + he1con(8,2)*he1stat(8) + he1con(9,2)*he1stat(9))
     2 / ( he1stat(2) + he1stat(10) )
      he1bul(3) = he1con(3,1) + he1con(3,2) + ( he1con(4,3)*he1stat(4) +
     1 he1con(5,3)*he1stat(5) + he1con(6,3)*he1stat(6) + he1con(7,3)*
     1 he1stat(7) + he1con(8,3)*he1stat(8) + he1con(9,3)*he1stat(9))/
     2 he1stat(3)
      he1bul(4) = he1con(4,1) +he1con(4,2) +he1con(4,3)+
     1 (he1con(5,4)*he1stat(5) + he1con(6,4)*he1stat(6) +
     2 he1con(7,4)*he1stat(7)+he1con(8,4)*he1stat(8)+
     3 he1con(9,4)*he1stat(9)) / he1stat(4)
      he1bul(5) = he1con(5,1) + he1con(5,2) + he1con(5,3) + he1con(5,4)+
     1( he1con(6,5)*he1stat(6) + he1con(7,5)*he1stat(7) +
     2 he1con(8,5)*he1stat(8)+he1con(9,5)*he1stat(9) ) / he1stat(5)
      he1bul(6) = he1con(6,1) + he1con(6,2) + he1con(6,3) + he1con(6,4)+
     1 he1con(6,5) + (he1con(7,6)*he1stat(7) +he1con(8,6)*he1stat(8)
     2 + he1con(9,6)*he1stat(9) ) / he1stat(6)
      he1bul(7) = he1con(7,1) + he1con(7,2) + he1con(7,3) + he1con(7,4)+
     1 he1con(7,5) + he1con(7,6) +
     2 (he1con(8,7)*he1stat(8)+he1con(9,7)*he1stat(9) ) /he1stat(7)
      he1bul(8) = he1con(8,1)+he1con(8,2)+he1con(8,3)+he1con(8,4)+
     1 he1con(8,5)+he1con(8,6)+he1con(8,7)+
     2 he1con(9,8)*he1stat(9)/he1stat(8)
      he1bul(9) = he1con(9,1)+he1con(9,2)+he1con(9,3)+he1con(9,4)+
     1 he1con(9,5)+he1con(9,6)+he1con(9,7)+he1con(9,8)
*
      if( lgTrace.and.lgHe1Bug ) then
         write(qq,'(7X,''HE1RAD finds arrays, with optical depths defi''
     1   ,''ned? '',L1)') lgTauOutOn
        do i=2,nhe1lvl
          write(qq,'(6X,''up:'',I2,10I10)') i,(j,j=1,i-1)
          write(qq,'(9X,''A*esc'',1P,8E10.2)') (he1mis(i,j)  ,j=1,i-1)
          write(qq,'(9X,''A-net'',1P,8E10.2)') (he1net(i,j)  ,j=1,i-1)
          write(qq,'(9X,''tauin'',1P,8E10.2)') (he1nxt(i,j)  ,j=1,i-1)
          write(qq,'(9X,''t tot'',1P,8E10.2)') (he1lim(i,j)  ,j=1,i-1)
          write(qq,'(9X,''Esc  '',1P,8E10.2)') (he1esc(i,j)  ,j=1,i-1)
          write(qq,'(9X,''A*dst'',1P,8E10.2)') (he1dst(i,j)  ,j=1,i-1)
          write(qq,'(9X,''StrkE'',1P,8E10.2)') (peshe1(i,j)  ,j=1,i-1)
          write(qq,'(9X,''B(ul)'',1P,8E10.2)') (he1con(i,j)  ,j=1,i-1)
          write(qq,'(9X,''C(ul)'',1P,8E10.2)') (he1cll(i,j)*eden,
     1    j=1,i-1)
        end do
*
        write(qq,'(14X,10I9)') (i,i=1,10)
        write(qq,'(7X,''HE1RAD  rad'',1P,10E9.2)') 
     1  (he1radn(i),i=1,10)
      endif
*
      end
