******************************************************************************
      subroutine he2lev( heiov2 , smiov2 )
      implicit none
*evaluate ionization balance level population for model helium ion
      double precision heiov2
      real smiov2
      include "en1ryd.par"
      include "ncell.par"
      include "nhe2lvl.par"
      include "limelm.par"
      include "itrdim.par"
      include "rfield.com"
      include "herec.com"
      include "he2rb.com"
      include "he.com"
      include "he2blt.com"
      include "he2crt.com"
      include "x12.com"
      include "shullc.com"
      include "he12on.com"
      include "he2ind.com"
      include "called.com"
      include "hebug.com"
      include "trace.com"
      include "TePowers.com"
      include "h.com"
      include "he2tau.com"
      include "phycon.com"
      include "phe2lv.com"
      include "he2ex.com"
      include "he2cbr.com"
      include "he2bn.com"
      include "he2stat.com"
      include "nhe2.com"
      include "he2rsp.com"
      include "hhe2.com"
      include "the2lo.com"
      include "he2net.com"
      include "DestCrt.com"
      include "ZoneCnt.com"
      include "he2rate.com"
      include "He2NIonRyd.com"
      include "IOqq.com"
*
*     local variables
      integer i,j,nerror
      real cion,rdest,const,gdist,edp,rfac, he2exx(nhe2lvl+1)
      real totcap(10) , x12ef
      double precision effion(9) , sum
      double precision z(11,11),c,r
*
*     2S LEVEL IS LEVEL TEN; Z(2,I) IS 2P, Z(10,I) = 2S, HN(2) IS SUM
*     level 7 is actually 7 - 10;  8 is 11 - 20;  9 is 21 - 100
*     free statement labels >=13
*
*     don't bother if no ionizing radiation
      if( .not.lgHe2ON ) then
        smiov2 = 0.
        create(2,2) = 0.
        destroy(2,2) = 0.
      else
        cion = 1.17e-5/sqrte*he2cbt(1)*eden
*       this is He++ over He+ (He ion over HeII)
        smiov2 = (he2gam(1)+cion+csupra)/(he2rtt*eden)
        create(2,2) = he2rtt*eden
        destroy(2,2) = he2gam(1)+cion
      endif
      collhe2 = cion
      sheiov2 = smiov2
      if( nzone.gt.1 ) then
        rfac = heiov2
      else
        rfac = smiov2
      endif
*     >>chng 96 May 8, was checking on smiov2, change to old soln
*     if( .not.lgHe2ON .or. smiov2.lt.1e-6 ) then
      if( .not.lgHe2ON .or. rfac.lt.1e-6 ) then
        if(lgHeBug.and.lgTrace ) then
          write(qq,'(5X,''HE2 simple I/2='',1P,E10.2,
     1    '' so not doing equilibrium.'')') smiov2
        end if
        do i=1,nhe2lvl
          he2bn(i) = 1.
          he2n(i) = 0.
          hhe2(i) = 0.
        end do
        he2bn(nhe2lvl+1) = 0.
        he2n(nhe2lvl+1) = 0.
        he22p = 0.
        he22s = 0.
        heiov2 = 0.
        he2ex = 0.
        recii = 0.
        return
      endif
*
*     check how low temperature is; departure coef tend to infinity
*     as TE goes to zero; matrix formalism won't work on a 32-bit machine
*     if EXP(H NU/KT)too big for ground state
      if( te.le.the2lo .or. he2lte(1).eq.0. .or. he2lte(2).eq.0. ) then
        he2ex = 0.
        he2bn(1) = 1.
        do i=2,nhe2lvl+1
          he2bn(i) = 1.
          he2n(i) = 0.
        end do
*       he2rtt was derived here, is sum of rad rec and escape prob
        recii = he2rtt
*
*       do simple two level, then fill in HN(i) for rest
        rdest = he2gam(1) + csupra
        if( rdest.gt.0. ) then
          he2n(1) = eden * recii / rdest
        else
          he2n(1) = 1e37
        endif
*       effective case B rec coef for low den limit Martin 1988
        he2n(4) = 1.44e-11 / (te70/te03/te03*te01) * eden / he2net(4,2)
        const = he2n(4) * he2net(4,2)
        he2n(3) = const * 14.5 / te10/te03/te03*te01 / he2net(3,2)
        he2n(5) = const * 0.291 * te03 * te01 / he2net(5,2)
        he2n(6) = const * 0.138 * te03*te01*te01 / he2net(6,2)
        he22s = he2rtt * eden / (8.23*16.) * 0.25
        he22p = he2rtt * eden / he2net(2,1) * 0.75
        he2n(2) = he22s + he22p
        heiov2 = 1. / he2n(1)
        if(lgHeBug.and.lgTrace ) then
          write(qq,'(5x,''low te, he2n(1)='',1p,e12.3
     1    ,'' rec='',E12.3,''HE2gam(1)='',E12.3)')
     2    he2n(1) , recii , he2gam(1)
        endif
        return
      endif
*-------------------------------------------------------------------
*
*     radiative and three body rec, fix 2s and 2p first
*     remember that HE2LTE(i) is only LTE pop when mult by Ne Nh
      z(10,11) = (he2r2s*he2rec(2,2)+he2rin(2)*0.25) / he2lte(10) +
     1 he2clc(2)*eden
      totcap(10) = z(10,11) * he2lte(10)
      recii = totcap(10)
*
      z(2,11) = (he2r2p*he2rec(2,2)+he2rin(2)*0.75) / he2lte(2)+
     1 he2clc(2)*eden
      totcap(2) = z(2,11) * he2lte(2)
      recii = recii + totcap(2)
*
      z(1,11) = (he2rec(1,1)*he2rec(1,2)+he2rin(1))/he2lte(1)
     1 +he2clc(1)*eden
      totcap(1) = z(1,11) * he2lte(1)
      recii = recii + totcap(1)
*
      do i=3,nhe2lvl
        z(i,11) = (he2rec(i,1)*he2rec(i,2)+he2rin(i))/he2lte(i) +
     1  he2clc(i)*eden
        totcap(i) = z(i,11) * he2lte(i)
        recii = recii + totcap(i)
      end do
*
*---------------------------------------------------------------------
*     now set up matrix for dreaded b(i)'s
*
*     level 1 balance equation
*     HE2CLL(u,l), etc, are rates for downward collisions (cm^3 s^-1)
*     corr of hi*1.7e-4 accounts for col ion by HI; Drawin Zs Phys 225, 483.
*     following is from Janev at 100eV
      x12ef = x12 / 3.
      z(1,1) = csupra + he2gam(1) + x12ef + he2coldn(1)*eden +
     1 he2clc(1)* eden + he2bul(1)
      gdist = z(1,1)
*
      z(1,2) = -( he2net(2,1) + he2con(2,1) +
     1 he2cll(2,1)*eden+x12ef/3.) * he2lte(2) / he2lte(1)
      z(1,3) = -( he2net(3,1) + he2con(3,1) +
     1 he2cll(3,1)*eden ) * he2lte(3) / he2lte(1)
      z(1,4) = -( he2net(4,1) + he2con(4,1) +
     1 he2cll(4,1)*eden ) * he2lte(4) / he2lte(1)
      z(1,5) = -( he2net(5,1) + he2con(5,1) +
     1 he2cll(5,1)*eden ) * he2lte(5) / he2lte(1)
      z(1,6) = -( he2net(6,1) + he2con(6,1) +
     1 he2cll(6,1)*eden ) * he2lte(6) / he2lte(1)
      z(1,7) = -( he2net(7,1) + he2con(7,1) +
     1 he2cll(7,1)*eden ) * he2lte(7) / he2lte(1)
      z(1,8) = -( he2net(8,1) + he2con(8,1) +
     1 he2cll(8,1)*eden ) * he2lte(8) / he2lte(1)
      z(1,9) = -( he2net(9,1) + he2con(9,1) +
     1 he2cll(9,1)*eden ) * he2lte(9) / he2lte(1)
      z(1,10) = -((8.23*16.)+x12ef + he2c2s1s*eden)*he2lte(10)/he2lte(1)
*
*     LEVEL 2P BALANCE EQUATION - 2p is higher energy than 2s
      edp = (eden * 0.1  +  hii * 0.9 )
      c = 0.75 / he2lte(2)
*     R is low density limit branching ratio for 2s-p (NOT l-mixed)
*     this is to simulate mixing of the n=3 level
      rfac = 0.32 - 0.07 * eden / ( eden + 1e7 )
      r = ( 1. - rfac ) / he2lte(2)
      z(2,1) = -( x12ef*0.67+he2cll(2,1)*eden+he2con(2,1)/he2bol(1,2))
      z(2,2) = he2gam(2)+ he2radn(2) + x12ef/3. + he2coldn(2)*eden + 
     1 he2clc(2)*eden + he2c2p2se*eden + he2c2p2sp*hii + he2bul(2)+
     1 he2con(2,1)
*     >>chng 97 aug 2, break out 2s 2p protron and electron collisions
      z(2,3) = -(he2net(3,2)*r+(he2con(3,2)+he2cll(3,2)*eden)*c) *
     1 he2lte(3)
      z(2,4) = -(he2net(4,2)*r+(he2con(4,2)+he2cll(4,2)*eden)*c) *
     1 he2lte(4)
      z(2,5) = -(he2net(5,2)*r+(he2con(5,2)+he2cll(5,2)*eden)*c) *
     1 he2lte(5)
      z(2,6) = -(he2net(6,2)*r+(he2con(6,2)+he2cll(6,2)*eden)*c) *
     1 he2lte(6)
      z(2,7) = -(he2net(7,2)*r+(he2con(7,2)+he2cll(7,2)*eden)*c) *
     1 he2lte(7)
      z(2,8) = -(he2net(8,2)*r+(he2con(8,2)+he2cll(8,2)*eden)*c) *
     1 he2lte(8)
      z(2,9) = -(he2net(9,2)*r+(he2con(9,2)+he2cll(9,2)*eden)*c) *
     1 he2lte(9)
      z(2,10) = -he2c2p2se*eden - he2c2p2sp*hii
*
*     LEVEL 2S BALANCE EQUATION - define 2s as lower energy than 2p
      c = 0.25 / he2lte(10)
      r = rfac / he2lte(10)
*
      z(10,1) = -( x12ef*0.33 + he2c2s1s*eden )
      z(10,2) = -(he2c2p2se*eden + he2c2p2sp*hii)  * he2lte(2) /
     1  he2lte(10)
      z(10,3) = -(he2net(3,2)*r+(he2con(3,2)+he2cll(3,2)*eden)*c) *
     1  he2lte(3)
      z(10,4) = -(he2net(4,2)*r+(he2con(4,2)+he2cll(4,2)*eden)*c) *
     1  he2lte(4)
      z(10,5) = -(he2net(5,2)*r+(he2con(5,2)+he2cll(5,2)*eden)*c) *
     1  he2lte(5)
      z(10,6) = -(he2net(6,2)*r+(he2con(6,2)+he2cll(6,2)*eden)*c) *
     1  he2lte(6)
      z(10,7) = -(he2net(7,2)*r+(he2con(7,2)+he2cll(7,2)*eden)*c) *
     1  he2lte(7)
      z(10,8) = -(he2net(8,2)*r+(he2con(8,2)+he2cll(8,2)*eden)*c) *
     1 he2lte(8)
      z(10,9) = -(he2net(9,2)*r+(he2con(9,2)+he2cll(9,2)*eden)*c) *
     1 he2lte(9)
      z(10,10) = he2radn(10) + he2gam(2) + (he2coldn(10)+he2clc(2))*eden
     1 + x12ef + (he2c2p2se*eden+he2c2p2sp*hii)*3. + he2bul(2)
*
*     level 3
      z(3,1) = -(he2cll(3,1)*eden + 
     1 ( he2con(3,1)*he2stat(3)/he2stat(1) ) *he2lte(1)/he2lte(3) )
      z(3,2) = -(he2cll(3,2)*eden + he2con(3,2)/he2bol(2,3) ) *0.75
      z(3,3) = he2gam(3)+he2radn(3) + (he2clc(3)+he2coldn(3))*eden +
     1 he2bul(3)
      z(3,4) =-(he2net(4,3)+he2con(4,3)+he2cll(4,3)*
     1 eden)* he2lte(4)/he2lte(3)
      z(3,5) =-(he2net(5,3)+he2con(5,3)+he2cll(5,3)*eden)*he2lte(5)/
     1 he2lte(3)
      z(3,6) =-(he2net(6,3)+he2con(6,3)+he2cll(6,3)*eden)*he2lte(6)/
     1 he2lte(3)
      z(3,7) =-(he2net(7,3)+he2con(7,3)+he2cll(7,3)*eden)*he2lte(7)/
     1 he2lte(3)
      z(3,8) =-(he2net(8,3)+he2con(8,3)+he2cll(8,3)*eden)*he2lte(8)/
     1 he2lte(3)
      z(3,9) =-(he2net(9,3)+he2con(9,3)+he2cll(9,3)*eden)*he2lte(9)/
     1 he2lte(3)
      z(3,10) = -(he2cll(3,2) *eden + he2con(3,2)/he2bol(2,3))*0.25
*
*     LEVEL 4
      z(4,1) = -he2cll(4,1) * eden - he2con(4,1)/he2bol(1,4)
      z(4,2) =-(he2cll(4,2) * eden + he2con(4,2)/he2bol(2,4)) * 0.75
      z(4,3) = -he2cll(4,3) * eden - he2con(4,3)/he2bol(3,4)
      z(4,4) = (he2coldn(4)+he2clc(4))*eden + he2radn(4) + he2gam(4)
     1 + he2bul(4)
      z(4,5) =-(he2net(5,4)+he2con(5,4)+he2cll(5,4)*eden)*he2lte(5)/
     1 he2lte(4)
      z(4,6) =-(he2net(6,4)+he2con(6,4)+he2cll(6,4)*eden)*he2lte(6)/
     1 he2lte(4)
      z(4,7) =-(he2net(7,4)+he2con(7,4)+he2cll(7,4)*eden)*he2lte(7)/
     1 he2lte(4)
      z(4,8) =-(he2net(8,4)+he2con(8,4)+he2cll(8,4)*eden)*he2lte(8)/ 
     1 he2lte(4)
      z(4,9) =-(he2net(9,4)+he2con(9,4)+he2cll(9,4)*eden)*he2lte(9)/ 
     1 he2lte(4)
      z(4,10) = -(he2cll(4,2) * eden + he2con(4,2)/he2bol(2,4))*0.25
*
*     LEVEL 5
      z(5,1) = -he2cll(5,1) * eden - he2con(5,1)/he2bol(1,5)
      z(5,2) =-(he2cll(5,2) * eden + he2con(5,2)/he2bol(2,5) ) *0.75
      z(5,3) = -he2cll(5,3) * eden - he2con(5,3)/he2bol(3,5)
      z(5,4) = -he2cll(5,4) * eden - he2con(5,4)/he2bol(4,5)
      z(5,5) = he2gam(5) + he2radn(5) + (he2coldn(5)+he2clc(5))*eden +
     1 he2bul(5)
      z(5,6) = -(he2net(6,5)+he2con(6,5)+he2cll(6,5)*eden)*he2lte(6)/
     1 he2lte(5)
      z(5,7) = -(he2net(7,5)+he2con(7,5)+he2cll(7,5)*eden)*he2lte(7)/
     1 he2lte(5)
      z(5,8) = -(he2net(8,5)+he2con(8,5)+he2cll(8,5)*eden)*he2lte(8)/
     1  he2lte(5)
      z(5,9) = -(he2net(9,5)+he2con(9,5)+he2cll(9,5)*eden)*he2lte(9)/ 
     1 he2lte(5)
      z(5,10) = -(he2cll(5,2) * eden + he2con(5,2)/he2bol(2,5))*0.25
*
*     level 6
      z(6,1) = -he2cll(6,1) * eden - he2con(6,1)/he2bol(1,6)
      z(6,2) =-(he2cll(6,2) * eden + he2con(6,2)/he2bol(2,6))* 0.75
      z(6,3) = -he2cll(6,3) * eden - he2con(6,3)/he2bol(3,6)
      z(6,4) = -he2cll(6,4) * eden - he2con(6,4)/he2bol(4,6)
      z(6,5) = -he2cll(6,5) * eden - he2con(6,5)/he2bol(5,6)
      z(6,6) = (he2coldn(6)+he2clc(6))*eden + he2gam(6) + he2radn(6) +
     1 he2bul(6)
      z(6,7) = -(he2net(7,6)+he2con(7,6)+he2cll(7,6)*eden)*he2lte(7)/
     1 he2lte(6)
      z(6,8) = -(he2net(8,6)+he2con(8,6)+he2cll(8,6)*eden)*he2lte(8)/ 
     1 he2lte(6)
      z(6,9) = -(he2net(9,6)+he2con(9,6)+he2cll(9,6)*eden)*he2lte(9)/ 
     1 he2lte(6)
      z(6,10) = -(he2cll(6,2) * eden + he2con(6,2)/he2bol(2,6))* 0.25
*
*     level 7
      z(7,1) = -he2cll(7,1) * eden - he2con(7,1)/he2bol(1,7)
      z(7,2) =-(he2cll(7,2) * eden + he2con(7,2)/he2bol(2,7))* 0.75 
      z(7,3) = -he2cll(7,3) * eden - he2con(7,3)/he2bol(3,7)
      z(7,4) = -he2cll(7,4) * eden - he2con(7,4)/he2bol(4,7)
      z(7,5) = -he2cll(7,5) * eden - he2con(7,5)/he2bol(5,7)
      z(7,6) = -he2cll(7,6) * eden - he2con(7,6)/he2bol(6,7)
      z(7,7) = (he2coldn(7)+he2clc(7))*eden + he2gam(7) + he2radn(7) +
     1 he2bul(7)
      z(7,8) = -(he2net(8,7)+he2con(8,7)+he2cll(8,7)*eden)*he2lte(8)/
     1 he2lte(7)
      z(7,9) = -(he2net(9,7)+he2con(9,7)+he2cll(9,7)*eden)*he2lte(9)/
     1 he2lte(7)
      z(7,10) = -(he2cll(7,2) * eden + he2con(7,2)/he2bol(2,7))*0.25
*
*     level 8
      z(8,1) = -he2cll(8,1) * eden - he2con(8,1)/he2bol(1,8)
      z(8,2) =-(he2cll(8,2) * eden + he2con(8,2)/he2bol(2,8))* 0.75 
      z(8,3) = -he2cll(8,3) * eden - he2con(8,3)/he2bol(3,8)
      z(8,4) = -he2cll(8,4) * eden - he2con(8,4)/he2bol(4,8)
      z(8,5) = -he2cll(8,5) * eden - he2con(8,5)/he2bol(5,8)
      z(8,6) = -he2cll(8,6) * eden - he2con(8,6)/he2bol(6,8)
      z(8,7) = -he2cll(8,7) * eden - he2con(8,7)/he2bol(7,8)
      z(8,8) = (he2coldn(8)+he2clc(8))*eden +he2gam(8) + he2radn(8) +
     1 he2bul(8)
      z(8,9) =-(he2net(9,8)+he2con(9,8)+he2cll(9,8)*eden)*he2lte(9)/
     1 he2lte(8)
      z(8,10) = -(he2cll(8,2)* eden + he2con(8,2)/he2bol(2,8))* 0.25 
*
*     level 9
      z(9,1) = -he2cll(9,1) * eden - he2con(9,1)/he2bol(1,9)
      z(9,2) =-(he2cll(9,2) * eden + he2con(9,2)/he2bol(2,9))* 0.75
      z(9,3) = -he2cll(9,3) * eden - he2con(9,3)/he2bol(3,9)
      z(9,4) = -he2cll(9,4) * eden - he2con(9,4)/he2bol(4,9)
      z(9,5) = -he2cll(9,5) * eden - he2con(9,5)/he2bol(5,9)
      z(9,6) = -he2cll(9,6) * eden - he2con(9,6)/he2bol(6,9)
      z(9,7) = -he2cll(9,7) * eden - he2con(9,7)/he2bol(7,9)
      z(9,8) = -he2cll(9,8) * eden - he2con(9,8)/he2bol(8,9)
      z(9,9) = (he2coldn(9)+he2clc(9)) *eden + he2gam(9) + he2radn(9)
     1 + he2bul(9)
      z(9,10) = -(he2cll(9,2) * eden +he2con(9,2)/he2bol(2,9))* 0.25
*
      if( lgTrace.and.lgHe2Bug ) then
        do i=1,10
          write(qq,'(7X,''HeII'',I2,1P,11E10.2)') i,(z(i,j),j=1,11)
        end do
      endif
*
*     scale to largest number of order unity
      do j=1,nhe2lvl+1
        do i=1,nhe2lvl+2
          z(j,i) = z(j,i) * he2lte(j)
        end do
      end do
*
      call matin1( z,nhe2lvl+2,nhe2lvl+1,1,nerror)
      if(nerror.ne.0 ) then
        write(qq,'('' HE2LEV MATRIX ERROR, STOP.'')')
        stop
      endif
*
*     convert from departure coef in Z(I) to level pop rel to HeII
      he2bn(1) = z(1,11)
      he2n(1) = he2bn(1) * he2lte(1) * eden
      he2bn(2) = z(2,11)
      he2n(2) = he2bn(2) * he2lte(2) * eden
      do i=3,nhe2lvl
        he2bn(i) = z(i,11)
*       HE2N(I) are pop per level rel to HII; i.e., N(n)/N(HII)
        he2n(i) = he2bn(i) * he2lte(i) * eden
      end do
*
*     HE2EX is net cooling rate due to col ionization-three body rec (s-1 here)
      he2ex = 0.
      do i=1,nhe2lvl-2
*       units of HE2EX are erg/cm^3/s
        he2exx(i) = He2IonRyd(i) * he2clc(i) * eden *
     1  (he2n(i)-he2lte(i)*eden)
        he2ex = he2ex + he2exx(i)
      end do
      he2ex = he2ex * en1ryd
      sum = 0.
      do i=1,nhe2lvl
        effion(i) = (he2clc(i)*eden+he2gam(i))*(he2n(i)-he2lte(i)*eden)
        sum = sum + effion(i)
      end do
*
      he22p = he2n(2)
      he2bn(nhe2lvl+1) = z(nhe2lvl+1,11)
      he22s = he2bn(nhe2lvl+1) * he2lte(10) * eden
*     >>chng 96 apr 24, had not been set, hence was 0
      he2n(nhe2lvl+1) = he22s
      he2n(2) = he2n(2) + he22s
      heiov2 = he2n(1) + he2n(2) + he2n(3) + he2n(4) + he2n(5) + he2n(6)
*     HEIOV2 is He++ / He+
      heiov2 = 1. / heiov2
      he2ex = he2ex + en1ryd*anu(nhe2(2)) * he2clc(2) *
     1 eden*(he22s-he2lte(nhe2lvl+1)* eden)
*
      if( lgHe2Bug.and.lgTrace ) then
         write(qq,'(7X,''HE2LEV HE2GAM'',1P,10E9.2)') he2gam
         write(qq,'(7X,''HE2LEV TOTCAP'',1P,10E9.2,'' tot='',E9.2)') 
     1   totcap , recii
         write(qq,'(7X,''HE2LEV IND Rc'',1P,10E9.2)') he2rin
         write(qq,'(7X,''HE2LEV IND As'',1P,10E9.2)') he2bul
         write(qq,'(7X,''HE2LEV HE2LTE'',1P,10E9.2)') he2lte
         write(qq,'(7X,''HE2LEV   HE2N'',1P,9E9.2,'' HeN2s,p'',2E9.2)') 
     1   (he2n(i),i=1,nhe2lvl),he22s,he22p
         write(qq,'(7X,''HE2LEV   b(n)'',1P,9E9.2,''   2s,p'',2E9.2)')
     1   (he2bn(i),i=1,nhe2lvl) , he2bn(10) , he2bn(2)
*
         write(qq,'(7X,''HE2LEV   X12'',1P,E9.2,
     1   '' Heat Exc'',E9.2,'' Grn dest:'',E9.2)')
     2   x12ef,he2ex,gdist
      endif
*
      do i=1,nhe2lvl+1
        if( he2n(i).le.0. ) then
          write(qq,'('' HE2LEV finds negative population, ='',i3,1P
     1    ,E10.2,'' simple='',E10.3,'' Te='',E10.3)') 
     1    i, he2n(i) , smiov2 ,te
          write(qq,'('' Populations were'',1p,10e10.2)') he2n
          call negcon
          call ShowMe
          stop
        endif
      end do
      if( lgTrace ) then
        write(qq,'(7X,''HE2LEV returns, HEIOV2 ='',1P,E10.2,
     1  '' simple='',E10.2,'' Gamm1='',E10.2,'' rec'',E10.2)')
     2  heiov2,smiov2,he2gam(1) , recii
      endif
*
      end
