******************************************************************************
      subroutine he3gma
      implicit none
*compute photoionization rates for helium triplets
      include "nhlvl.par"
      include "nhe3lvl.par"
      include "itrdim.par"
      include "nhe1lvl.par"
      include "ncell.par"
      include "iphl.com"
      include "heat.com"
      include "he3lte.com"
      include "ots.com"
      include "rfield.com"
      include "he.com"
      include "he3hsv.com"
      include "edsqte.com"
      include "TePowers.com"
      include "phycon.com"
      include "he3rr.com"
      include "he3gams.com"
      include "phe1lv.com"
      include "trace.com"
      include "hebug.com"
      include "ioptri.com"
      include "nhe1.com"
      include "iophe1.com"
      include "herec.com"
      include "DoPhoto.com"
      include "PhotScale.com"
      include "ZoneCnt.com"
      include "IOqq.com"
*
*     local variables
      real ghe32s,f1,r,bnfun,he3h,hirate, oldrate,csphot
      save ghe32s , he3h , f1, oldrate
*
      if( lgTrace.and.lgHe3Bug ) write(qq,'('' HE3GMA called.'')')
*
*     following are corrected radiative recombination coefficient
*     not actual ones
*     >>chng 96 oct 25, removed eden from edensqte, so not cancel of eden below
*     some evidence that eden and edensqte not updated together
      r2s = 1.31e-12 / sqrte * te10
      r2p = 3.09e-11 /(te10*te03)/sqrte
      r3s = 7.1e-13 / sqrte
      r3p = 2.24e-11 / (te10*te10*te03)/sqrte
      r3d = 1.25e-9 / te / te10
      rectri = r2s + r2p + r3s + r3p + r3d
*
*     with induced recombination
      if( lgDoPhoto ) then
*       ghe32s = bnfun( nhei3,nhe1(1),ioptri,0.3506,f1,r)* PhotScaleOn
        oldrate = bnfun( nhei3,nhe1(1),ioptri,0.3506,f1,r)* PhotScaleOn
*       >>chng 97 july 6, damp out Lya oscillations
*       call broken
*       if( nzone.le.1 ) then
*         ghe32s = oldrate
*       else
*         ghe32s = oldrate*0.5 + ghe32s*0.5
*       endif
        ghe32s = oldrate
        he3h = h
        if( lgTrace.and.lgHeBug ) then
          call PrtGamma(nhei3 ,nhe1(1) ,ioptri,qq,
     1    ghe32s , ghe32s*0.05 )
        endif
      endif
*     induced recombination rates
      r2s = r2s + f1 * he3lte(1)/ eden
      r2p = r2p + f1 * he3lte(2)/ eden
      he3hsv(1) = he3h
*     put in rest of flux integral
      if( nhe1(1).lt.nflux ) then
*       ratio of trip cross to singlet ground
        hirate = he1gam(1) *
     2  csphot(nhe1(1),nhei3,ioptri)/
     3  max(1e-37,csphot(nhe1(1),nhe1(1),iophe1(1)) )
*       >>chng 97 jul 12, get rid of direct access to opsv
*       hirate = he1gam(1) *OpacStack(nhe1(1)-nhei3+ioptri) /
*    1  max(1e-37,OpacStack(iophe1(1)))
      else
        hirate = 0.
      endif
*
*     now save total rates for 2^3S and 2^3P
      he3gam(1) = ghe32s + hirate
      he3gam(2) = he3gam(1) * 3.
*
*     >>chng 97 jul 11, save proportion of total rate due to Lya
      He3FrLya = otslin(iphl(2,1))* csphot(iphl(2,1),nhei3,ioptri)
      if( he3gam(1).gt.1e-30 ) then
        He3FrLya = He3FrLya / he3gam(1)
      else
        He3FrLya = 0.
      endif
*666  write(66,'(1p,2e10.2)') heii/ahe,He3FrLya
*
      end
