******************************************************************************
      subroutine HeDiff
      implicit none
*compute diffuse fields due to helium atom, ion, triplets
      include "itrdim.par"
      include "limelm.par"
      include "ncell.par"
      include "nta.par"
      include "ndust.par"
      include "nhe3lvl.par"
      include "nhe2lvl.par"
      include "nhe1lvl.par"
      include "nhlvl.par"
      include "tautot.com"
      include "radius.com"
      include "ots.com"
      include "exptau.com"
      include "opac.com"
      include "herec.com"
      include "he3n.com"
      include "h.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "he.com"
      include "phycon.com"
      include "he3tuEXP.com"
      include "heots.com"
      include "TePowers.com"
      include "DoppVel.com"
      include "trace.com"
      include "hebug.com"
      include "opacon.com"
      include "prad.com"
      include "phela.com"
*     include "facexp.com"
      include "pbowen.com"
      include "he1tau.com"
      include "he2tau.com"
      include "TLineEXP.com"
      include "nh.com"
      include "nhe1.com"
      include "nhe2.com"
      include "kapots.com"
      include "capots.com"
      include "hetrpEXP.com"
      include "d10830.com"
      include "iphe1l.com"
      include "iphe2l.com"
      include "ZoneCnt.com"
      include "ip626.com"
      include "he2net.com"
      include "he2rb.com"
      include "IOqq.com"
      include "dstop.com"
      include "he3as.com"
      include "HPhoto.com"
      include "sphere.com"
*
*     local variables
      real bowen
      parameter( bowen=0.3 )
      integer n,j,i
      real he1lsave(10,10) , otshere , he2lsave(10,10)
      save he1lsave , he2lsave
      real escfac,bwnfac,dam584,widlin,dam304,otsfac,
     1 ttpath,delta ,t , damper , otsnew
      real totline , outward , ots911 , ots660
*
*     free statement labels  >= 7
*
*     calculate opacity for He LA lines
*     used before opacity arrays have been computed.
*
      if( .not.lgOpacOn ) then
*       AddOpac has yet to be called, opacities are not defined
        opac(ipHn(1)) = hi * 6.30e-18 + dstab(ipHn(1))
        opac(ipHn(1)+1) = hi * 6.3e-18 + dstab(ipHn(1)+1)
        opac(ipHn(1)+2) = hi * 6.3e-18 + dstab(ipHn(1)+2)
        opac(iphe1l(2,1)) =  hi * 1.85e-18 + dstab(iphe1l(2,1))
        opac(ip374) = hi * 5.3e-19 + hei * 3.7e-18 + dstab(ip374)
        opac(ip660) = hi * 2.4e-18 + dstab(ip660)
        opac(iphe2l(2,1)) = hn(1)*hii*2.85e-19 + hei*3.0e-18 +
     1  dstab(iphe2l(2,1))
        opac(nhe1(1)) = hi*1.06e-18 + hei1*7.83e-18 + dstab(nhe1(1))
        opac(nhe2(1)) = hi*9.84e-20 + hei1*1.75e-18 +
     1  heii*1.58e-18 + dstab(nhe2(1))
      endif
*
*     OTS background
*
* HeI He I
*     He I recombination continuum
      damper = 0.5
      do n=1,6
        if( opac(nhe1(n)).gt.0. ) then
          otsnew = (1.-damper) *
     1    he1rec(n,1)*(1.-he1rec(n,3)) / opac(nhe1(n))*eden*heii + 
     2    otscon(nhe1(n)) * damper
          otsnew = otsnew * opac(nhe1(n) )
          if( otsnew.lt.0. ) then
            write(qq,'('' HeDiff found negative OTS He1 CON, n='',i4,
     1      '' val='',1p,e10.1)')n , otsnew
            call ShowMe
            stop
          endif
          call AddOTSCon( otsnew , nhe1(n) )
        else
          otsnew = 0.
          call AddOTSCon( otsnew , nhe1(n) )
        endif
      end do
      n = 1
*
*     HeI recombination continua at 1.81 Ryd
      esc504 = he1rec(1,1) * he1rec(1,3) * eden * heii
*
*     HeI Ly-alpha He I ly a
*     escaping part of HeI Ly-alpha lya ly a
      esc584 = heii*he12p * he1mis(2,1)*ExpmTau(iphe1l(2,1))
*     do not want to add much outward HeI Lya since it is so important
*     use inward looking optical depth to decide outward flux
      otshere = he12p*heii*he1dst(2,1) + 
     1 heii*he12p * he1mis(2,1)*(1.-ExpmTau(iphe1l(2,1)))
      if( nzone.le.1 ) then
        he1lsave(2,1) = otshere
      endif
      damper = 0.5
      otshere = he1lsave(2,1)*(1.-damper) + damper* otshere
      he1lsave(2,1) = otshere
      if( otshere.lt.0. ) then
        write(qq,'('' HeDiff found negative OTS He1 alhpa,'',i4,
     1  '' val='',1p,e10.1)')1 , otshere
        call ShowMe
        stop
      endif
      call AddOTSLin( otshere , iphe1l(2,1) , 1.0 )
*
*     all other lines of HeI - tests show this is very small effect
      do j=3,7
        do i=1,j-1
          otshere = he1n(j)*heii*he1dst(j,i)
          if( nzone.le.1 ) then
            he1lsave(j,i) = otshere
          endif
          damper = 0.5
          otshere = he1lsave(j,i)*(1.-damper) + damper* otshere
          he1lsave(j,i) = otshere
          if( otshere.lt.0. ) then
            write(qq,'('' HeDiff found negative OTS He1l'',2i4,
     1      '' val='',1p,e10.1)')j,i , otshere
            call ShowMe
            stop
          endif
          call AddOTSLin( otshere , iphe1l(j,i) , 1.0 )
        end do
      end do
*
*     HeI 2tripS to ground - one photon decay
*     this is a major source of ionization for parishii
      totline = heii*he3n(1)*a2sg
      if( lgSphere ) then
*       all goes outward or ots
        escfac = 0.
      else
        escfac = 0.5*ExpmTau( ipHe23sGrnd )
      endif
*     number of phots escaping from illuminated face of cloud
      esc626 = totline *escfac
*     otsfac = 1. - ExpZone(ipHe23sGrnd)
*     when optically thin, this goes to zero, when thick, to 100%
      otsfac = 1. - 2.*escfac
*     >>chng 96 mar 7, above had been 1-escfac, so 50% ots when thin to cont
      call AddOTSLin( totline*otsfac , ipHe23sGrnd , 0.5 )
*     following is zero when thick to cont, 0.5 when thin
      outward = max(0., 1.-otsfac-escfac )
*     outward escaping line
      out626 = totline * outward
*
*     HeI 10830 OTS
      call AddOTSLin( p2p*DR10830 , ipHe3l(1) , 1.0 )
*
**********************************************************************
*
*     OTS part of He II recombination continuum
*     OTS part is total absorbed in nebula
*     by definition escaping part is not considered further
*     emission also computed in routine DIFFEM
      do n=1,6
        if( opac(nhe2(n)).gt.0. ) then
          otsnew = he2rec(n,1)*(1.-he2rec(n,3))*eden*heiii /
     1    opac(nhe2(n))
          otsnew = ( otsnew + otscon(nhe2(n)) ) /2.
          otsnew = otsnew * opac(nhe2(n))
          if( otsnew.lt.0. ) then
            write(qq,'('' HeDiff found negative OTS He2 CON, n='',i4,
     1      '' val='',1p,e10.1)')n , otsnew
            call ShowMe
            stop
          endif
          call AddOTSCon( otsnew , nhe2(n) )
        else
          otsnew = 0.
          call AddOTSCon( otsnew , nhe2(n) )
        endif
      end do
*
*     OTS He rec continua, these are only used to check on importance
*     of he ionization
*     HeIII => HeII recombination continua
      esc228 = he2rec(1,1) * he2rec(1,3) * eden * heiii
*
*     find amount of He II rec to n=2 OTS
*     default value of OTSCap is 1.5
      ots911 = otscon(nhe2(2))
      if( ots911.gt.(hgamnc(1)/6.30e-18*OTSCap) ) then
        ots911 = hgamnc(1) / 6.30e-18 * OTSCap
        if( otsnew.lt.0. ) then
          write(qq,'('' HeDiff found negative OTS 911 CON'',
     1    '' val='',1p,e10.1)')ots911
          call ShowMe
          stop
        endif
*
        call AddOTSCon( ots911*opac(nhe2(2)) , nhe2(2) )
        kap911 = kap911 + 1
      endif
      esc911 = heiii*eden * he2rec(2,1) * he2rec(2,3)
*
******************************************************************
*VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
*
*     HeII ly a Ly-a ots destruction rate
*     this is escaping part of Ly-a
      esc304 = heiii*he22p*(1.-bowen) * he2mis(2,1)*ExpmTau(iphe2l(2,1))
*
      bwnfac = bowen * (1. - t304(3) )
      otshere = he22p*(1.-bwnfac)*heiii*he2dst(2,1)  +
     1 heiii*he22p*(1.-bowen) * he2mis(2,1)*(1.-ExpmTau(iphe2l(2,1)))
      if( nzone.le.1 ) then
        he2lsave(2,1) = otshere
      endif
      damper = 0.5
      otshere = he2lsave(2,1)*(1.-damper) + damper* otshere
      call AddOTSLin( otshere , iphe2l(2,1) , 1.0 )
      he2lsave(2,1) = otshere
*
*     this caps ots rate to prevent ots runaway
*     comment is printed if this is ever used
*     default value of OTSCap is 1.5
      if( otslin(iphe2l(2,1)) .gt.(hgamnc(1)/2.85e-19*OTSCap) ) then
        t = hgamnc(1) / 2.85e-19 * OTSCap
        t = t * opac(iphe2l(2,1))
        call AddOTSLin( t , iphe2l(2,1) , 1.0 )
        kapots = kapots + 1
      endif
*
*     two photons, but with branching ratio, very important
*     for setting H-beta lum in parispn.in
      esc660 = heiii*he22p*bowen*he2mis(2,1) * 2. * 0.8
*     ots660 is set of bowen OIII lines near 660
      ots660 = heiii*he22p*he2dst(2,1)*bowen  * 2. * 0.8
*     >>chng 96 nov 21, damping from 1 to 0.5
      call AddOTSLin( ots660 , ip660 , 0.5 )
*
*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
******************************************************************
*
*     higher n lines of HeII
      do j=3,7
        do i=1,j-1
          otshere = he2n(j)*heiii*he2dst(j,i)
          if( nzone.le.1 ) then
            he2lsave(j,i) = otshere
          endif
          damper = 0.5
          otshere = he2lsave(j,i)*(1.-damper) + damper* otshere
          he2lsave(j,i) = otshere
          if( otshere.lt.0. ) then
            write(qq,'('' HeDiff found negative OTS He2l'',2i4,
     1      '' val='',1p,e10.1)')j,i , otshere
            call ShowMe
            stop
          endif
          call AddOTSLin( otshere , iphe2l(j,i) , 1.0 )
        end do
      end do
*
*     HeI Ly-a 584 radiation pressure
      if( he1n(1).gt.1e-20.and. he1tau(2,1).gt.1.1 .and.
     1  opac(iphe1l(2,1)).gt.0. ) then
        dam584 = 0.0921 / sqrte
        plines(6) = 9.54e-5* he12p/6. / (he1n(1)/2.) *
     1  widlin( he1tau(2,1) , he1lim(2,1) , dam584 , doppler(2) )
      else
        plines(6) = 0.
      endif
*
*     HeII Ly-a 304 radiation pressure
*     lgPresHeLya usually false, can be set true with HELIUM RADIAT PRESS comnd
      t = min( he2tau(2,1) , he2lim(2,1) )
      if( lgPresHeLya .and. t.gt.1.1.and.opac(iphe2l(2,1)).gt.0. )then
*       roughly Bohnila et al; first term cor for 912 to 304, sec is path
        dam304 = 0.376 / sqrte
        ttpath = t * (1. + 2.*log(t) / (1.+0.3*dam304*t)**0.67 +
     1  (6.5*dam304*t)**0.33 )
        delta = tauabs(ipHn(1),1) *0.03704 * ttpath / t
        plines(5) = (he22p *heiii) * (he2mis(2,1) * 6.546e-11) *
     1  ttpath / ( 1.90e-8/doppler(2)*heii) / (1.+0.9*delta)**0.97
      else
        plines(5) = 0.
      endif
*
      end
