*****************************************************************************
      subroutine helium( seche , helax )
      implicit none
*solve ionization balance helium ion, helium singlets, helium triplets
      real seche , helax
      include "limelm.par"
      include "itrdim.par"
      include "nhe3lvl.par"
      include "nhe2lvl.par"
      include "nhe1lvl.par"
      include "phe1lv.com"
      include "phe2lv.com"
      include "h.com"
      include "herec.com"
      include "he12on.com"
      include "trace.com"
      include "hebug.com"
      include "IonFracs.com"
      include "heating.com"
      include "newion.com"
      include "workf.com"
      include "he.com"
      include "phycon.com"
      include "he1bn.com"
      include "he2bn.com"
      include "he3n.com"
      include "he3bn.com"
      include "hhe1.com"
      include "hhe2.com"
      include "he3hsv.com"
      include "ZoneCnt.com"
      include "hetrpEXP.com"
      include "elmton.com"
      include "ioreco.com"
      include "TrConvg.com"
      include "LevTrace.com"
      include "IOqq.com"
*
*     local variables
      real gam22,hela,sm2ov1,dtri,sum,he3old,gam32,he2la, smiov2
      integer n,i,loop3 , loophe
       double precision heiov2 , he2ov1, he2ov3 , r1ov2
      save heiov2 , he2ov1, he2ov3 , r1ov2
*
      save hela , gam22 , gam32 , he2la
      real ssav(7)
      logical lgHelOn 
*
*     free statement numbers >=9
*
*     option to "turn off" helium
      if( .not.lgElmtOn(2) ) then
        hei3 = 0.
        heii = 0.
        heiii = 0.
        hei1 = 0.
        hei = 0.
        return
      endif
*
*     evaluate helium optical depths, and destruction prob
      call HeTran
      he3old = hei3
      loop3 = 0
 7    continue
*
*     do relative ionization balance for adjacent stages of ionization
*
*     do ionized helium first, get ratio He++ / He+
      call he2col
      if( lgNewIon.and.lgHe2ON ) then
        call he2rad
        call he2gma( gam32 , he2la )
      else if( .not.lgHe2ON ) then
        gam32 = 0.
        he2la = 0.
        do i=1,7
          hhe2(i) = 0.
        end do
      endif
*
      if( lgHe2ON ) then
*       HEIOV2 is HeIII (ion) /HeII
        call he2lev( heiov2 , smiov2 )
*       >>chng 93, feb added so that he not turned back on
*       at very small electron fraction
        if(nzone.gt.1 .and.heiov2.eq.0. ) then
          lgHe2ON = .false.
          if(lgTrace) write(qq,'(5X,''HELIUM turns off ion 3.'')')
        endif
      else
        heiov2 = 0.
        smiov2 = 0.
        if(lgTrace) write(qq,'(5X,''HELIUM ion 3 is turned off.'')')
      endif
*
*     loop counter
      loophe = 0
      lgHelOn = .false.
 5    continue
*
*     do trip before singlets since need rec coef to singlets from trip
*     R2OVT is HeII/He(trip)
      call he3col
      if( lgNewIon ) then
        call he3rad
        call he3gma
      endif
      call he3lev( he2ov3 )
*
*     do singlets; HE2OV1 is HeII/He(sin)
      call he1col
      call he1rad
      if( lgNewIon ) then
        call he1gma( gam22 , hela )
      endif
      call he1lev( he2ov1 , sm2ov1 )
      if( he2ov1.eq.0. ) then
        gam22 = 0.
        hela = 0.
      endif
*
      if( lgTrConvg .and.nLevTrace.eq.0 ) then
        write(qq,'(7X,''HELIUM I/2'',1P,E10.3,'' simple='',E10.3
     1  ,'' 2/1'',E10.3,'' simple='',E10.3,
     2  '' 2/3'',E10.3)') heiov2, smiov2 , he2ov1, sm2ov1 , he2ov3
      endif
*
*     this check Jan 93, for hion to work, first soln very neutral,
*     but trace ionized helium.  Must iterate on triplets and singlets
*     to get goth ionized in solution
      if( he2ov3.eq.0. .and. he2ov1.gt.0. .or. lgHelOn ) then
*       this is the problem, triplets zero, but singlets populated
        lgHelOn = .true.
        loophe = loophe + 1
        if( loophe.lt.4 ) then
          if(lgTrace.and.lgHeBug) write(qq,'(5X,''HELIUM loops since ''
     1    ,''trip=0 but singlets not.'')')
          goto5
        endif
      endif
*
      if( lgTrace.and.lgHeBug ) then
        write(qq,'(5X,''HELIUM I/2'',1P,E10.3,'' simple='',E10.3
     1  ,'' 2/1'',E10.3,'' simple='',E10.3,
     2  '' 2/3'',E10.3)') heiov2, smiov2 , he2ov1, sm2ov1 , he2ov3
      endif
*
*     populations
      if( he2ov1 .eq.0.0 .or. he2ov3.eq.0.0 ) then
*       gas is completely neutral (although trace He++ possible)
        hei3 = 0.
        heii = 0.
        heiii = 0.
        hei1 = ahe
        hei = ahe
      else if( heiov2 .eq.0. .and. he2ov1 .ne.0. ) then
*       gas is singly ionized, but not doubly
        heiii = 0.
*       ratio of total neutral to ionized helium
        r1ov2 = 1.d0/he2ov3 + 1.d0/he2ov1
        heii = ahe / ( 1.d0 + r1ov2 )
        hei =  ahe / ( 1.d0 + 1.d0/r1ov2 )
        hei1 = hei / ( 1.d0 + he2ov1 /he2ov3 )
        hei3 = hei / ( 1.d0 + he2ov3 /he2ov1 )
      else
*       all three stages of ionization populated
*       ratio of total neutral to ionized helium
        r1ov2 = 1.d0/he2ov3 + 1.d0/he2ov1
        heiii = ahe / ( 1.d0 + (1.d0+r1ov2)/heiov2 )
        heii = ahe / (1.d0 + r1ov2 + heiov2 )
        hei = ahe / ( 1.d0 + (1.d0+heiov2 )/r1ov2 )
        hei1 = hei / ( 1.d0 + he2ov1 /he2ov3 )
        hei3 = hei / ( 1.d0 + he2ov3 /he2ov1 )
      endif
*
*     save into master ionization array
      xIonFracs(2,1) = hei
      xIonFracs(2,2) = heii
      xIonFracs(2,3) = heiii
*
      if( lgTrace )write(qq,'(5X,''HE; 23S:'',1P,E9.2,'' HEo:'',E9.2,
     1'' HE+:'',E9.2,'' HE++:'',E9.2)') hei3,hei,heii,heiii
*
*     July 93 logic added for partially neutral soln, not yet converged
      dtri = abs(hei3-he3old)/max(1e-36,hei3)
      if( hei3.gt.0. .and. dtri.gt.0.02 ) then
        loop3 = loop3 + 1
        if( loop3.lt.9 ) then
          if(lgTrace.and.lgHeBug) write(qq,'(5X,''HELIUM loops '',I3,
     1    '' since trip pop changed.  New, old trip='',1P,2E10.2)')
     2    loop3, hei3, he3old
          he3old = hei3
          goto7
        endif
      endif
*     He II Ly photoionization rate
      call HeDiff
*
*-----------------------------------------------------------------------
*
      ssav(1) = hhe1(1) * he1n(1)
      sum = ssav(1)
      do n=2,7
        ssav(n) = hhe1(n) * he1n(n)
        sum = sum + ssav(n)
      end do
      heating(2,1) = sum * heii
*
      sum = hhe2(1) * he2n(1)
      do n=2,7
        sum = sum + hhe2(n) * he2n(n)
      end do
      heating(2,2) = sum * heiii
*
*     heating(2,3) is helium triplets
      heating(2,3) = he3hsv(1)*he3n(1)* hei3
      workfz = workfz + (heii*(reci+rectri)*1.8+heiii*recii*4.)*eden
      if(ioreco.ne.0) then
        write(ioreco,'(''He '',1p,2e9.2)') reci+rectri,recii
	endif
*
      helax = (hela*hei  +  he2la*heii)
      seche = (gam22*hei1 + gam32*heii)
*
      if( lgTrace.and.lgHeBug ) then
        write(qq,'(5X,''HE; bn(2tripS)='',1P,E9.2,'' bn(HeI)='',E9.2,
     1  '' bn(HeII)='',E9.2,'' and HELIUM returns.'')')
     2  he3bn(1) , he1bn(1) , he2bn(1)
      endif
*
      end
