******************************************************************************
      subroutine HeTran
      implicit none
*derive escape and destruction probabilities for He lines
      include "ncell.par"
      include "limelm.par"
      include "nhetau.par"
      include "nta.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "ipLnArry.par"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "DoppVel.com"
      include "escdst.com"
      include "touton.com"
      include "he.com"
      include "he1as.com"
      include "he2as.com"
      include "he2dmp.com"
      include "he1dmp.com"
      include "he1esc.com"
      include "he2esc.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "he1tau.com"
      include "he2tau.com"
      include "d10830.com"
      include "hetrpEXP.com"
      include "he3tuARR.com"
      include "he1nxt.com"
      include "he2nxt.com"
      include "iphe1l.com"
      include "iphe2l.com"
      include "twoway.com"
      include "he1fin.com"
      include "he2fin.com"
      include "wind.com"
      include "opac.com"
      include "rfield.com"
      include "radius.com"
      include "eovrlpVar.com"
      include "DstWght.com"
*
*     local variables
      integer i,j 
      real esin,eshe1l,he1jbr,esa0k2,damp,eovrlp,eshe2l,
     1 esccom,esout,he2jbr,escsub , tout
*     integer ihi , lo
*
*     evaluate helium destruction probabilities
*     this code was heavily modified by Paul T. O'Brien, UCL, to
*     both inward and outward fractional escape
*     the original code had only one-sided escapes
*
*     this this is 0th zone then use full destruction prob,
*     else use mean of old and new - NB must reset at end
      if( nzone.lt.1 ) DestWght = 1.
*
      if( he1lim(2,1)*0.90-he1nxt(2,1).gt.0. ) then
*       only evaluate if we have not overrun optical depth scale
        he1esc(2,1) = eshe1l( esin )
        he1esc(1,2) = he1esc(2,1) * He1EinA(2,1)
        he1fin(2,1) = fracin
        damp = he1dmp(2) / doppler(2) / 0.75
*       >>chng 96 sep 4, added DestWght weighting
*       >>chng 96 sep 4, following had extra div by two????
        he1dst(2,1) = (1.-DestWght)*he1dst(2,1) + DestWght*He1EinA(2,1)*
     1   eovrlp( heii*he1n(1) ,he1tau(2,1),he1lim(2,1) , damp ,
     2   he1opc(2,1), iphe1l(2,1) ,doppler(2),he1esc(2,1),'  K2' ) 
*     2   he1opc(2,1), iphe1l(2,1) ,doppler(2),he1esc(2,1),'INCO' ) 
*       >>chng 97 sept 13, did not conserve energy, added following
        he1con(2,1) = he1jbr(2,1) * He1EinA(2,1)*esa0k2(he1nxt(2,1))
      else
*       >>chng 97 sept 13, did not conserve energy, added following
        he1con(2,1) = he1jbr(2,1) * He1EinA(2,1)*esa0k2(he1nxt(2,1))
      endif
*
      if( he2lim(2,1)*0.90-he2nxt(2,1).gt.0. ) then
*       only evaluate if we have not overrun optical depth scale
        he2esc(2,1) = eshe2l( esin )
        he2esc(1,2) = he2esc(2,1) * he2as(2,1)
        he2fin(2,1) = fracin
        he2con(2,1) = he2jbr(2,1) * esin *he2as(2,1)
        damp = he2dmp(2) / doppler(2) / 0.75
*       >>chng 96 sep 4, added DestWght weighting
        he2dst(2,1) = (1.-DestWght)*he2dst(2,1) + DestWght*he2as(2,1)*
     1  eovrlp( heiii*he2n(1) ,he2tau(2,1),he2lim(2,1) , damp ,
     2  he2opc(2,1), iphe2l(2,1) , doppler(2) , he2esc(2,1) ,'INCO' ) 
      else
*       >>chng 97 sept 13, did not conserve energy, added following
        damp = eshe2l( esin )
        he2con(2,1) = he2jbr(2,1) * esin *he2as(2,1)
      endif
*
      do i=3,nhe1lvl
        damp = he1dmp(i) / doppler(2) / 1.808/(1. - 1./float(i*i) )
        esin = esccom(he1nxt(i,1),damp )
        tout = he1lim(i,1)*0.90-he1nxt(i,1)
        if( tout.gt.0. ) then
          tout = he1lim(i,1)-he1nxt(i,1)
          esout = esccom(tout,damp)
          he1esc(i,1) = 0.5*( esin + esout )
          he1fin(i,1) = esin / (esin + esout)
*         other index is product of A and escape
          he1esc(1,i) = he1esc(i,1) * He1EinA(i,1)
*         >>chng 96 sep 4, added DestWght weighting
          he1dst(i,1) = (1.-DestWght)*he1dst(i,1)+DestWght*He1EinA(i,1)*
     1    eovrlp( heii*he1n(1) ,he1tau(i,1),he1lim(i,1) , damp ,
     2    he1opc(i,1),iphe1l(i,1) , doppler(2) , he1esc(i,1) ,chDstFun )
        endif
        he1con(i,1) = he1jbr(i,1) * esa0k2(he1nxt(i,1))*He1EinA(i,1)
      end do
*
      do i=3,nhe2lvl
        damp = he2dmp(i) / doppler(2) / 4. / (1. - 1./float(i*i) )
        esin = esccom(he2nxt(i,1),damp )
        tout = he2lim(i,1)*0.90-he2nxt(i,1)
        if( tout.gt.0. ) then
*         only do this when we are not close to boundary
*         but when we do it, use correct tau
          tout = he2lim(i,1)-he2nxt(i,1)
          esout = esccom(tout,damp )
          he2esc(i,1) = 0.5*( esin + esout )
*         >>chng 96 feb 5, no test for 
*         he2esc(i,1) = 0.5* esin
*         he2esc(i,1) = esin
          he2fin(i,1) = esin / (esin + esout)
          he2con(i,1) = he2jbr(i,1)*esa0k2(he2nxt(i,1))*he2as(i,1)
          he2esc(1,i) = he2esc(i,1) * he2as(i,1)
*         >>chng 96 sep 4, added DestWght weighting
          he2dst(i,1) = (1.-DestWght)*he2dst(i,1) + DestWght*he2as(i,1)*
     1    eovrlp( heiii*he2n(1) ,he2tau(i,1),he2lim(i,1) , damp ,
     2    he2opc(i,1),
     2    iphe2l(i,1) , doppler(2) , he2esc(i,1) ,chDstFun ) 
        endif
      end do
*
      if ( lgTauOutOn) then
        do j=2,nhe1lvl-1
          do i=j+1,nhe1lvl
            damp = he1dmp(i) /doppler(2)/1.808/(1./float(j*j)-1./
     1      float(i*i))
            esin = esccom(he1nxt(i,j),damp )
            tout = he1lim(i,j)*0.90-he1nxt(i,j)
            if( tout.gt.0. ) then
              tout = he1lim(i,j)-he1nxt(i,j)
              esout = esccom(tout,damp )
              he1fin(i,j) = esin / (esin + esout)
              he1con(i,j) = he1jbr(i,j) * esin * He1EinA(i,j)
              he1esc(i,j) = 0.5 * (esin + esout)
              he1esc(j,i) = he1esc(i,j) * He1EinA(i,j)
*             destruction of line by background opacity
*             >>chng 96 sep 4, added DestWght weighting
              he1dst(i,j) = (1.-DestWght)*he1dst(i,j) +
     1        DestWght*He1EinA(i,j)*
     1        eovrlp( heii*he1n(j) ,he1tau(i,j),he1lim(i,j) , damp ,
     2        he1opc(i,j),
     2        iphe1l(i,j) , doppler(2) , he1esc(i,j) ,chDstFun ) 
            endif
          end do
        end do
        esin = esccom(t206(ipLnTauIn),1e-3 )
        esout = esccom(t206(ipLnTauTot),1e-3 )
        t206(ipLnEscP) = 0.5 * (esin + esout )
        t206(ipLnInwd) = esin / (esin + esout)
      else
*       outward optical depths not defined
        do j=2,nhe1lvl-1
          do i=j+1,nhe1lvl
            damp = he1dmp(i) /doppler(2)/1.808/(1./float(j*j)-1./
     1      float(i*i))
            esin = esccom(he1nxt(i,j),damp )
            he1fin(i,j) = 1.
            he1con(i,j) = he1jbr(i,j) * esin * He1EinA(i,j)
            he1esc(i,j) = esin
            he1esc(j,i) = he1esc(i,j) * He1EinA(i,j)
*           destruction of line by background opacity
*           >>chng 96 sep 4, added DestWght weighting
            he1dst(i,j) = (1.-DestWght)*he1dst(i,j) +
     1      DestWght*He1EinA(i,j)*
     1      eovrlp( heii*he1n(j) ,he1tau(i,j),he1lim(i,j) , damp ,
     2      he1opc(i,j),
     2      iphe1l(i,j) , doppler(2) , he1esc(i,j) ,chDstFun ) 
          end do
        end do
        t206(ipLnEscP) = esccom( t206(ipLnTauIn) , 1e-3  )
        t206(ipLnInwd) = 1.
      endif
*
*     do loop to get outward fraction if lgTauOutOn defined
      if ( lgTauOutOn) then
*       outward optical depths defined
        do j=2,nhe2lvl-1
          do i=j+1,nhe2lvl
            damp = he2dmp(i) / doppler(2) / 4./(1./float(j*j)-1./
     1      float(i*i))
            esin = esccom(he2nxt(i,j),damp )
            tout = he2lim(i,j)*0.90 - he2nxt(i,j)
            if( tout.gt.0. ) then
              tout = he2lim(i,j) - he2nxt(i,j)
              esout = esccom(tout ,damp )
              he2fin(i,j) = esin/ (esin + esout)
              he2con(i,j) = he2jbr(i,j) * esin * he2as(i,j)
              he2esc(i,j) = 0.5 * (esin + esout)
              he2esc(j,i) = he2esc(i,j) * he2as(i,j)
*             >>chng 96 sep 4, added DestWght weighting
              he2dst(i,j) = (1.-DestWght)*he2dst(i,j) +
     1        DestWght*he2as(i,j)*
     1        eovrlp( heiii*he2n(j) ,he2tau(i,j),he2lim(i,j) , damp ,
     2        he2opc(i,j),
     2        iphe2l(i,j) , doppler(2) , he2esc(i,j) ,chDstFun ) 
            endif
          end do
        end do
      else
*       outward optical depths not defined
        do j=2,nhe2lvl-1
          do i=j+1,nhe2lvl
            damp = he2dmp(i) / doppler(2) / 4./(1./float(j*j)-1./
     1      float(i*i))
            esin = esccom(he2nxt(i,j),damp )
            he2fin(i,j) = 1.
            he2con(i,j) = he2jbr(i,j) * esin * he2as(i,j)
            he2esc(i,j) = esin
            he2esc(j,i) = he2esc(i,j) * he2as(i,j)
*           >>chng 96 sep 4, added DestWght weighting
            he2dst(i,j) = (1.-DestWght)*he2dst(i,j) +
     1      DestWght*he2as(i,j)*
     1      eovrlp( heiii*he2n(j) ,he2tau(i,j),he2lim(i,j) , damp ,
     2      he2opc(i,j),
     2      iphe2l(i,j) , doppler(2) , he2esc(i,j) ,chDstFun ) 
          end do
        end do
      endif
*     >>chng 96 sep 4, added DestWght weighting
*     >>chng 97 aug 24, set init val if zone number small
      if( nzone.le.1) then
        DstPrb10830 = 
     1  eovrlp( p2s , he3tau(ipLnTauIn,1),he3tau(ipLnTauTot,1),
     1  1e-4,8.80e-7,
     1  ipHe3l(1) , doppler(2) , he3tau(ipLnEscP,1) ,chDstFun)
      else
        DstPrb10830 = DstPrb10830 * (1.-DestWght) + DestWght*
     1  eovrlp( p2s , he3tau(ipLnTauIn,1),he3tau(ipLnTauTot,1),
     1  1e-4,8.80e-7,
     1  ipHe3l(1) , doppler(2) , he3tau(ipLnEscP,1) ,chDstFun)
      endif
*
      if( windv.eq.0. ) then
        do i=1,nhetau
*         always use complete redis for helium lines
          he3tau(ipLnEscP,i) = escsub( he3tau(ipLnTauIn,i) ,
     1    he3tau(ipLnTauTot,i) , 1e-4)
          he3tau(ipLnInwd,i) = fracin
        end do
      else
*       this is wind solution
*       ESCCOM is one-sided complete distribution (OK for wind)
        do i=1,nhetau
          he3tau(ipLnEscP,i) = esccom( he3tau(ipLnTauIn,i) , 1e-4  )
          he3tau(ipLnInwd,i) = 0.5
        end do
      endif
*
*     reset weight to old value
      DestWght = DestWghtSave
*
      end
