******************************************************************************
      subroutine highen( seccmp , scmpla )
      implicit none
*do high energy radiation field - gas interaction, Compton scattering, etc
      real seccmp , scmpla
*
      include "ncell.par"
      include "en1ryd.par"
      include "limelm.par"
      include "nopsv.par"
      include "itrdim.par"
      include "pair.com"
      include "he.com"
      include "trace.com"
      include "combug.com"
      include "recoil.com"
      include "heating.com"
      include "h.com"
      include "efrac.com"
      include "mev.com"
      include "radius.com"
      include "turhet.com"
      include "hextra.com"
      include "neutrn.com"
      include "ircoil.com"
      include "shullc.com"
      include "comptn.com"
      include "rfield.com"
      include "occnum.com"
      include "comsig.com"
      include "heat.com"
      include "phycon.com"
      include "hgamsc.com"
      include "ipair.com"
      include "iopcom.com"
      include "opsv.com"
      include "ots.com"
      include "comexc.com"
      include "hmi.com"
      include "crsnut.com"
      include "ZoneCnt.com"
      include "IOqq.com"
      include "DoPhoto.com"
*
*     local variables
      double precision hin
      integer nskip , i
      parameter (nskip=1 )
      save csav , ccsav , hcoil , crtla , crate , hecoil , cldold
      real hcoil,crsphi,energy,hecoil,crate,crtla,cd,sqthot,hcolde,
     1 cldold,clder,crion,sexp,eneut,excnut,secnut,gamfun,den,parion,
     2 pairla,heatin,csav,ccsav , crateh , cratehe
      real crtlah , crtlahe
      data crate/0./
*
*     free statement labels >=5
*
*-----------------------------------------------------------------------
*
*     bound electron scattering of >2.3 kev photons if neutral
      if( lgDoPhoto ) then
*       comoff usually 1, 0 if "NO COMPTON EFFECT" command given
*       lgCompRecoil usually t, f if "NO RECOIL IONIZATION" command given
        if( comoff.gt. .9 .and. lgCompRecoil ) then
          hcoil = 0.
          hgamsc = 0.
*         recoil starts at 194 Ryd = 2.6 keV
          do i=ircoil,nflux,nskip
            crsphi = OpacStack(i-1+iopcom) *
     1      (flux(i)+outcon(i)+outlin(i))
*           direct hydrogen ionization
            hgamsc = hgamsc + crsphi
*           recoil energy in Rydbergs
*           heating modified for suprathermal secondaries below; ANU2=ANU**2
            energy = 2.66e-5 * anu2(i) - 1.
            hcoil = hcoil + crsphi * energy
          end do
*
*         direct hydrogen ionization rate, does not include secondaries
          hgamsc = hgamsc * nskip
*         heating is in rydbergs because efionz, exctef, heatef in ryd
          hcoil = hcoil * nskip
*         secondary ionization rate
          crateh = hcoil * efionz * hi
*         La excitation rate
          crtlah = hcoil * 1.333 * exctef * hi
*         net heating efficiency, now in ergs/sec/cm3
          hcoil = hcoil * en1ryd
*
*         same thing for helium
          hecoil = 0.
          do i=irche,nflux,nskip
            crsphi = OpacStack(i-1+iopcom) *
     1      (flux(i)+outcon(i)+outlin(i))
*           recoil energy in Rydbergs
*           heating modified for suprathermal secondaries below; ANU2=ANU**2
            energy = 2.66e-5 * anu2(i) - 1.8
            hecoil = hecoil + crsphi * energy
          end do
*         first heating in ryd, later convert to ergs
          cratehe = hecoil * efionz * hei
          crate = crateh + cratehe
          crtlahe = hecoil*1.333*exctef*hei
          crtla = crtlah + crtlahe
          hecoil = hecoil * en1ryd * nskip
*
        else
          hcoil = 0.
          hecoil = 0.
          crate = 0.
          crtla = 0.
          hgamsc = 0.
        endif
      endif
*     second term is helium, two because two electrons
      heating(1,19) = hcoil*heatef*hi + hecoil*heatef*hei*2.
*
*-----------------------------------------------------------------------
*
*     heating and ionization by relativistic particles
*     CRYDEN=density (1/CM**3), neutral rate assumes 15ev total
*     energy loss, 13.6 into ionization, 1.4 into heating
*     units erg/sec/cm**3
*     iff not specified, CRTEMP is 2.6E9K
*
      if( cryden.gt.0. ) then
        cd = cryden * (radius/rinner) ** crpowr
        sqthot = sqrt( crtemp )
*       rate hot electrons heat cold ones, Balbus and McKee 1982
*       erg sec^-1 cm^-3
        hcolde = 5.5e-14 / sqthot * cd * eden
*       this is check for initial use of code
        if( nzone.le.0 ) cldold = hi+2.*htwo+hei 
*       density of colliders, this can oscillate
        clder = cldold*0.8 + (hi+2.*htwo+hei) * 0.2
        cldold = clder
*       ionization rate; Balbus and McKee
        crion = 1.22e-4 / sqthot * log(2.72*(crtemp/1e8)**0.097)
     1  * cd * clder
        if( crtemp .gt. 2e9 ) then
*          cosmic ray ionization rate s-1 cm-3; ext rel limit
           crion = crion * 3.
*          usual circumstance; relativistic cosmic rays
           hxtot = 3.7e-20 *clder*cd + hcolde
        else
*          option for thermal cosmic rays
           crion = crion * 10.
           hxtot = hcolde + crion * 0.093 * 2.18e-11
        endif
        if( lgTrace ) write(qq,'(''     HIGHEN: cosmic ray density;'',
     1  1P,E10.2,'' CRion rate;'',E10.2,'' CR heat rate=;'',E10.2,
     2  '' CRtemp;'',E10.2)') cd , crion , hxtot , crtemp
      else
        crion = 0.
        hxtot = 0.
      endif
*
*     add on arbitrary extra heat
      if( turhet.ne.0. ) then
        hxtot = hxtot + turhet*sexp( turrad/real(depth) )
      endif
*
*     option to add on fast neutron heating
      if( lgNeutrnHeatOn ) then
*       eneut = totneu * (4e-26 * hden)
*       CrsSecNeutron is 4E-26 cm^-2, cross sec for stopping rel neutrons
*       and is set in large block data
        eneut = totneu * (CrsSecNeutron * hden)
        if( ElecFrac.lt.0.95 ) then
          secnut = eneut / 2.42e-11 * efionz
          excnut = secnut
          hxtot = hxtot + eneut * heatef
        else
          secnut = 0.
          excnut = 0.
          hxtot = hxtot + eneut
        endif
      else
        secnut = 0.
        excnut = 0.
      endif
*
*     pair production in elec field of nucleus
      posrat = gamfun( ippr ,nflux , ioppr )
      htpair = h
      den = hden + 4.*ahe
*
*     find heating, secondary ionization, Ly-alpha, excitation rates
*     following includes possible supra thermal electrons
*     effective pair heating
      pair = htpair * heatef * den
      parion = htpair / 2.42e-11 * efionz * den
      pairla = htpair / 2.42e-11 *exctef * 1.333 * den
*
      if( lgTrace.and.lgComBug.and.(htpair.ne.0.) ) write(qq,
     1 '(''     HIGHEN: pair production, heat'',1P,E8.2,'' ioniz'',
     2E9.2,'' la excit'',E9.2,'' HTPAIR'',E9.2)')
     1 pair , parion , pairla , htpair
*
*-------------------------------------------------------------------
*     Compton energy exchange
      if( lgDoPhoto  ) then
        cmcool = 0.
        cmheat = 0.
        heatin = 0.
        do i=1,nflux
*
*         Compton cooling
*         CSIGC is Tarter expression times ANU(I)*3.858E-25
*         6.338E-6 is k in inf mass Rydbergs, still needs factor of TE
          comup(i) = dble(flux(i)+outcon(i)+outlin(i)) * csigc(i) *
     1    (eden*4.d0*6.338d-6*1d-15)
          cmcool = cmcool + comup(i)
*
*         Compton heating 
*         CSIGH is Tarter expression times ANU(I)**2 * 3.858E-25
*         CMHEAT is just spontaneous, HEATIN is just induced
          comdn(i) = dble(flux(i)+outcon(i)+outlin(i)) *
     1    csigh(i)*eden*1d-15
*
*         induced Compton heating
          hin = dble(flux(i)+outcon(i)+outlin(i))*
     1    csigh(i)*occnum(i)*eden*1d-15
          comdn(i) = comdn(i) + hin
          heatin = heatin + hin
*         following is total compton heating
          cmheat = cmheat + comdn(i)
        end do
*
*       remember how important induced compton heating is
        if( cmheat.gt.0. ) then
          cinrat = max( real(cinrat), heatin/max(1e-37,real(cmheat)) )
        endif
*
        if( lgTrace.and.lgComBug ) then
          write(qq,'(5x,''HIGHEN: COOL num='',1p,
     1    e8.2,'' HEAT num='',e8.2,'' HCOIL='',e8.2)')
     4    cmcool, cmheat, hcoil
        end if
*
*       comoff usually 1, turns off Compton
        csav = cmheat * comoff
        ccsav = cmcool * comoff
      endif
*
      cmheat = csav
      cmcool = ccsav
*
*-------------------------------------------------------------------------
*
*     following saved for possible printout in PRSTEP
      heating(1,20) = cmheat
      heating(1,21) = hxtot
      heating(1,22) = pair
*
      if( lgTrace.and.lgComBug ) write(qq,'(5X,''HIGHEN sets '',
     1''total heating='',1P,E10.2,'' frac(compt)='',E10.2,
     2'' f(bcompt)='',E10.2,'' f(hxtot)='',E10.2,'' f(pair)'',E10.2)')
     3 htot , cmheat/htot , hcoil/htot , hxtot/htot , pair/htot
*
      seccmp = crate + crion + parion + secnut
      scmpla = crtla + pairla + excnut
*
      end
