******************************************************************************
      subroutine hmole( hmovh1 , h2ovh1 )
      implicit none
*determine populations of hydrogen molecules
      double precision h2ovh1
      real hmovh1
      include "saha.par"
      include "limelm.par"
      include "ndust.par"
      include "nhlvl.par"
      include "itrdim.par"
      include "nopsv.par"
      include "en1ryd.par"
      include "ncell.par"
      include "nhe1lvl.par"
      include "heat.com"
      include "dstfac.com"
      include "shullc.com"
      include "newion.com"
      include "cldnEXP.com"
      include "tedust.com"
      include "opsv.com"
      include "logte.com"
      include "Heavy.com"
      include "h.com"
      include "rfield.com"
      include "ots.com"
      include "widflx.com"
      include "corind.com"
      include "TePowers.com"
      include "hmi.com"
      include "heating.com"
      include "iph2.com"
      include "trmole.com"
      include "trace.com"
      include "nomole.com"
      include "hehp.com"
      include "he.com"
      include "phycon.com"
      include "rh2dis.com"
      include "hmihet.com"
      include "iphmin.com"
      include "iphmop.com"
      include "hmidep.com"
      include "nh.com"
      include "h2max.com"
      include "phlevl.com"
      include "thlo.com"
      include "ghabng.com"
      include "gionrc.com"
      include "h2dish.com"
      include "h2ppnt.com"
      include "ZoneCnt.com"
      include "DoppVel.com"
      include "hcolrt.com"
      include "hahmin.com"
      include "HMolLTE.com"
      include "SummdCon.com"
      include "DoPhoto.com"
      include "h2opac.com"
      include "nhe1.com"
      include "AgeMole.com"
      include "HPhoto.com"
      include "IOqq.com"
*
*     local variables
      real sexp,exph2,exphp,ex3hp,ph3lte,rspon,ratind,g,hmirat,
     1 gh2dis,th2,h2esc,escinc,cionhm,drate,tdlow,fa,rgrain,rh2h2p,
     2 gamtwo,h2phet,hmiht,gamhmi,exphmi,f,corr,gamfun,
     1 hneut,faneut,c3bod,ratach,batach,fhneut,bhneut,eh2hhm,eh2old,
     4 bh2dis,gamhd,bh2h2p,gamheh,renorm,h1fnd,h1good,desh2p,
     5 colind,fac,radasc,eh2hh,h3ph2p,hmrate,h3petc,rate,damper,
     6 radath,h2pion,h2ph3p,hnnew,hatmic,fmol,h32h2,h2pcin,h2phhp
      integer i,nd,j,iho,ih2,ih2p,ih3p,k,nmole,merror,ihmi
      integer ipOffSet , ipConServ
      double precision b2pcin , plte
      parameter (nmole=5)
      double precision c(nmole+1,nmole+1) 
*     CONST is 8\pi * nu(912)**3 / c**2
      real const
      parameter (const=9.940622e26 )
      character*4 chLab(nmole)
      save rspon , ratind , gamhmi , colind , gh2dis , eh2old , eh2hhm,
     1 gamtwo , h2phet , hmiht , rgrain , hneut , th2 , h2esc
*
*     free statement labels >=9
*
      if( lgNoMole .or. te.gt.1e5 ) then
*       thtmol = 0.
        hmovh1 = 0.
        hminus = 0.
        hmihet = 0.
        H2Opacity = 0.
        hmiht = 0.
        hmicol = 0.
        heating(1,16) = 0.
        heating(1,17) = 0.
        heating(1,18) = 0.
        HeatH2Dish = 0.
        hmidep = 1.
        gamhmi = 0.
        htwo   = 0.
        h2plus = 0.
        hehp   = 0.
        rh2dis = 0.
        GrnIonRec = 0.
        HalphaHmin = 0.
        return
      endif
*
*     population of H- in LTE
*     IP is 0.754 eV
*     LTE population of H minus - cm^3
      exphmi = sexp( 8.745e3/te )
      if( exphmi.gt.0. ) then
*       these are ratio n*(H-)/[  n*(ne) n*(Ho)  ]
        phmlte = saha / (te32*exphmi) * (1. / ( 2.*2. ) )
      else
        phmlte = 0.
      endif
*
*     population of H2 in LTE
*     dissociation energy is 4.477eV
      exph2 = sexp( 5.195e4 / te )
      if( exph2.gt.0. ) then
*       extra factor accounts for mass of H instead of e- in saha
*       last factor was put in ver 85.23, missing before
        if( nzone.le.0 ) then
          damper = 0.
        else
          damper = 0.5
        endif
        ph2lte = 
     1  (1.-damper)* saha / (te32*exph2 ) *(1./(2.*2.))*3.634E-5 +
     2  damper * ph2lte
      else
        ph2lte = 0.
      endif
*
*     population of H2+ in LTE, phplte is H_2+/H / H+
*     dissociation energy is 2.647
      exphp = sexp( 3.072e4 / te )
      if( exphp.gt.0. ) then
*       stat weight of H2+ is 4
*       last factor was put in ver 85.23, missing before
        phplte = saha / ( te32*exphp ) *(4./(2.*1.))*3.634e-5
      else
        phplte = 0.
      endif
*
*     population of H3+ in LTE, ph3lte is H_3+/( H2+ H+ )
*     dissociation energy is 2.647
      ex3hp = sexp( 1.882e4 / te )
      if( ex3hp.gt.0. ) then
*       stat weight of H2+ is 4
*       last factor was put in ver 85.23, missing before
        ph3lte = saha / ( te32*ex3hp ) *(4./(2.*1.))*3.634e-5
      else
        ph3lte = 0.
      endif
*
*     first do gamma function for H minus, with spon+induc rec
      if( lgDoPhoto ) then
        rspon = 0.
        ratind = 0.
        gamhmi = 0.
        hmiht = 0.
        colind = 0.
        hmicol = 0.
        ipOffSet = iphmin+iphmop
        do i=iphmin,min( nhe1(1) , nflux )
* 666 error! why is this done in a loop, instead of bnfun??
          f = SummedCon(i) * OpacStack(i+ipOffSet)
          gamhmi = gamhmi + f
          hmiht = hmiht + f * anu(i)
          ratind = ratind + f * ContBoltz(i)
*         induced cooling
          colind = colind + f * ContBoltz(i) * anu(i)
          g = OpacStack(i-iphmin+iphmop) * ContBoltz(i) *
     1    widflx(i) * anu2(i)
          rspon = rspon + g
          hmicol = hmicol + g * anu(i)
        end do
*
*       correct for work function, convert from Ryd to erg
        hmiht = (hmiht-gamhmi*0.055502) * en1ryd
        colind = (colind-ratind*0.055502) * en1ryd
        hmicol = (hmicol-rspon *0.055502) * en1ryd
*       add on high energy ionization, assume hydrogen cross section
*       n.b.; HGAMNC with secondaries
        gamhmi = gamhmi + hgamnc(1)
        hmicol = (hmicol*const) * (phmlte*eden) * hi
        ratind = ratind * phmlte * eden
        colind = colind * phmlte * eden * hi
*
*       radiative association rate, spon and induced
        if( te.ge.1e4 ) then
          rspon = (rspon *const) * (phmlte * eden)
        else
          rspon = hmirat( te ) * eden
        endif
      endif
*
*     photodissociation by Lyman band absorption: esc prob treatment,
*     treatment based on Tielens and Hollenbach 1985 ApJ 291, 722.
      if( lgDoPhoto ) then
        GammaHabing = 0.
*       find total intensity over carbon-ionizing continuum
        do i=ipHeavy(6,1),ipHn(1)
          GammaHabing = GammaHabing +
     1    (flux(i)+outcon(i)+outlin(i))*anu(i)
        end do
*       now convert to Habing ISM units
*       GammaHabing is FUV continuum relative to Habing value
        GammaHabing = GammaHabing * 2.18e-11 / 1.6e-3
*       cross section is eqn A8 of Teilens and Hollenbach 85a
*       branching ratio of 10% in, so like their table 5
        gh2dis = GammaHabing * 3.4e-11
*       escape prob is line shielding, eqn A10
        H2Opacity = 1.2e-14 * (1e5/doppler(1))
        th2 = colh2 * 1.2e-14 * (1e5/doppler(1))
        h2esc = escinc(th2 ,1e-4)
*       H_2 + h nu => 2H
        gh2dis = gh2dis * h2esc
      endif
*
*     collisional ionization of H-, rate from Janev, Langer et al.
      if( te.lt.3074. ) then
        cionhm = 1.46e-32 * (te**6) * sqrte * exphmi
      else if(te.ge.3074. .and. te.lt.30000. ) then
        cionhm = 5.9e-19 * te*te*sqrte*te03*te01*te01
      else
        cionhm = 3e-7
      endif
*
*     H2 formation on grains;
*     rate from Hollenback and McKee Ap.J.Sup 41, 555 eq 3.4 3.8
      if( lgNewIon ) then
        if( lgDustOn ) then
          drate = 0.
          tdlow = 1e37
          do nd=1,ndust
            if( lgDustOn1(nd) .and. tedust(nd).gt.0. ) then
              tdlow = min( tdlow , tedust(nd) )
              drate = dstfactor(nd)
            endif
          end do
          fa = 1. / (1. + 1e4 * sexp( 600./tdlow ) )
          rgrain = 3e-18 * sqrte * fa / (1.+0.04*sqrt(tdlow+te) +
     1     0.002*te + 8e-6*te*te ) * drate
*         rate ions recombine on grain surface - used elsewhere
*         based on Drain and Sutin 1987  ApJ 320, 803 eqn 5.15
*         GRECON is usually 1, option to turn this process off
*         >>chng 97 feb 24, following had sqrt( tdlow ) not sqrte,
*         caught by Jon Slavin
          GrnIonRec = 5.8e-13 / sqrte * drate * hden * grecon
        else
          rgrain = 0.
          GrnIonRec = 0.
        endif
      endif
*
*     collisional dissociation, rate from Dove and Mandy, Ap.J.(Let) 311, L93.
*     corr is correction for approach to high density limit
*     H2 + H => 3H - rate very uncertain
      corr =10.**( max(0., min(6.,(14.44-alogte*3.08)))/(1.+1.6e4/hi))
      rh2dis = 1.55e-8 / sqrte * sexp(65107./te) * corr
*
*     H2  +  H+  =>  H2+  +  H
*>>chng 98 jan 02, from 2.12r4 to 2.123e4
      rh2h2p = 1.8e-12 * sqrte*te10/te01* sexp(2.123e4/te)
*
*     inverse rate
      bh2h2p = 1.8e-12 * sqrte*te10/te01*2./16.
*>>chng 98 jan 02, to stop oscillations deep in PDR
*kill all of following, replace with above
*     if( ph2lte.gt.0. .and. phplte.gt. 0. ) then
*       extra factor of HII appeared before version 85.23, typo!
*       bh2h2p = rh2h2p * ph2lte/phplte 
*     else if( te.gt.300. ) then
*       bh2h2p = rh2h2p * exp(2.123e4/te) *2./16.
*     else
*       bh2h2p = 0.
*     endif
*
*     H2+  +  HNU  =>  H+  + H
      if( lgDoPhoto ) then
        gamtwo = gamfun( ih2pnt(1) , ih2pnt(2) , ih2pof ) 
        h2phet = h
      endif
*
*     molecule formation
*
      do i=1,nmole
        c(i,nmole+1) = 0.
        do j=1,nmole
          c(i,j) = 0.
        end do
      end do
      hneut = hi + hminus + 2.*(htwo+h2plus) + 3.*h3plus
*     these should be totally equivalent??
*     >>chng 96 june 3, hneut floated above hden, ended negative
      hneut = hden - hii
*     protect against roundoff in ionized gas
      if( hneut/hden.lt.1e-3 ) then
        hneut = hi + hminus + 2.*(htwo+h2plus) + 3.*h3plus
      endif
*     
      iho = 1
      chLab(iho) = 'HO  '
      ihmi = 2
      chLab(ihmi) = 'H-  '
      ih2 = 3
      chLab(ih2) = 'H2  '
      ih2p = 4
      chLab(ih2p) = 'H2+ '
      ih3p = 5
      chLab(ih3p) = 'H3+ '
*
*--------------------------------------------------------------------
*
*     H- H minus hminus balance equations
*     (IHMI,IHO) == processes making H- from Ho =+sign
*     radiative attachment: HI + NE => H-;
      c(ihmi,iho) = c(ihmi,iho) + rspon + ratind
      c(iho,iho) = c(iho,iho) - rspon - ratind
*
*     (IHMI,IHMI) = processes destroying H- =-sign
*     photodissociation, H- + H NU => H + NE
      c(ihmi,ihmi) = c(ihmi,ihmi) - gamhmi
      c(iho,ihmi) = c(iho,ihmi) + gamhmi
*
*     mutual neutralization with heavies, rate from Dalgarno and Mcray
*     all charged ions contribute equally
      faneut = 4e-6 / sqrte * max( 0. , eden - hii-heii-2.*heiii )
      c(ihmi,ihmi) = c(ihmi,ihmi) - faneut
*
*     electron collisional ionization of H-
      c(ihmi,ihmi) = c(ihmi,ihmi) - cionhm * eden
      c(iho,ihmi) = c(iho,ihmi) + cionhm*eden
*
*     inverse process; three body rec
      c3bod = cionhm * (phmlte * eden) * eden
      c(ihmi,iho) = c(ihmi,iho) + c3bod
      c(iho,iho) = c(iho,iho) - c3bod
*
*     associative detachment:  H- + H => H2 + E
      ratach = hi * 1.35e-9
      c(ihmi,ihmi) = c(ihmi,ihmi) - ratach
      c(iho,iho) = c(iho,iho) - hminus * 1.35e-9
*
*     (1,IH2) convert H2 into H- = +sign
*     the back reaction, H2 + e => H- + Ho
      if( ph2lte.gt.0. ) then
        batach = ( ratach / hi )  * phmlte / ph2lte * eden
      else
        batach = 0.
      endif
      c(ihmi,ih2) = c(ihmi,ih2) + batach
      c(iho,ih2) = c(iho,ih2) + batach
*
*     mutual neut, mostly into n=3; rates from Janev et al
*     H- + H+ => H + H(n=3)
      fhneut = hii * 7e-8
      c(ihmi,ihmi) = c(ihmi,ihmi) - fhneut
      c(iho,ihmi) = c(iho,ihmi) + fhneut
*     back reaction from excited state H
      if( te.gt.thlo ) then
*       HBN(3) is defined; when <THLO then set to 1
        bhneut = (fhneut * phmlte * eden) * hbn(3)
      else
        bhneut = 0.
      endif
*     this is the back reaction, forming H- from Ho
      c(ihmi,iho) = c(ihmi,iho) + bhneut
      c(iho,iho) = c(iho,iho) - bhneut
*
*     the processes H2(v>=4) + e- => H + H-,
*     from Janev et al, quoted in lenzuni etal
*     density dep is for non-lte, guess from dalgarno and roberge apl 233, 25
*     extra expo factor added for low temps
      if( nzone.le.1 ) then
*       this is initial setup of code, so set rate coef to actual val
        eh2hhm = 2.7e-8 * 10**(-0.7*(alogte-3.615)**2) * eden *
     1  (hden / (1e7+hden) ) * sexp(52000. /te)
        eh2old = eh2hhm
      else
*       this is deeper into the cloud, and there is danger of oscillation
        eh2old = eh2hhm
        eh2hhm = 2.7e-8 * 10**(-0.7*(alogte-3.615)**2) * eden *
     1  (hden / (1e7+hden) ) * sexp(52000. /te)
        fac = 0.5
        eh2hhm = eh2hhm*fac + eh2old*(1.-fac)
      endif
      c(ihmi,ih2) = c(ihmi,ih2) + eh2hhm
      c(iho,ih2) = c(iho,ih2) + eh2hhm
*
*--------------------------------------------------------------------
*
*     molecular hydrogen H2 htwo balance equation
*     (IH2,IHO)==create H2 from Ho =+
*
*     H2 formation on grains;
*     rate coefficient from Hollenback and McKee Ap.J.Sup 41, 555 eq 3.4 3.8
*     really is rate coefficient, needs two HIs
      c(ih2,iho) = c(ih2,iho) + rgrain * hi
      c(iho,iho) = c(iho,iho) - rgrain * hi
*
*     excited atom radiative association,
*     H(n=2) + H(n=1) => H2 + hnu
*     from Latter, W.B., and black, J.H., 1991, Ap.J. 372, 161
      radasc = (hn(2)*hii)*3e-14 
      c(ih2,iho) = c(ih2,iho) + radasc
      c(iho,iho) = c(iho,iho) - radasc
*
*     make H2 from H- =+ sign
*     associative detachment; H- + H => H2: Browne and Dalgarno J PHys B 2, 885
      c(ih2,ihmi) = c(ih2,ihmi) + ratach
*
*     photo-destroy H2
      c(ih2,ih2) = c(ih2,ih2) - gh2dis
      c(iho,ih2) = c(iho,ih2) + gh2dis
*
*     the process H2 + e- => H + H + e
*     from Lenzuni et al. apj sup 76, 759, quoted from Janev et al.
      eh2hh = 1.3e-18*te*te*sexp(52000./te) * eden
      c(ih2,ih2) = c(ih2,ih2) - eh2hh
      c(iho,ih2) = c(iho,ih2) + eh2hh
*
*     the processes H2(v>=4) + e- => H + H-
*     from Lenzuni et al. apj sup 76, 759, quoted from Janev et al.
*     density dep is for non-lte, guess from dalgarno and roberge apl 233, 25
      c(ih2,ih2) = c(ih2,ih2) - eh2hhm
*
*     add on inverse of radiative attachment
      c(ih2,ih2) = c(ih2,ih2) - batach
*
*     collisional dissociation, rate from Dove and Mandy, Ap.J.(Let) 311, L93.
*     H_2 + S => 2H + S
      c(ih2,ih2) = c(ih2,ih2) - rh2dis * hi
      c(iho,ih2) = c(iho,ih2) + rh2dis * hi
*
*     back rate, three body recombination, 2H + S => H_2 + S
      bh2dis = rh2dis * ph2lte * hi * hi
      c(ih2,iho) = c(ih2,iho) + bh2dis
      c(iho,iho) = c(iho,iho) - bh2dis
*
*     H2 + HNU=>  H2+ + E
*     photoionization by hard photons, crossection=3*HI
*     GAMHD = 3. * HGAMNC(1)
      gamhd = hgamnc(1)
      c(ih2,ih2) = c(ih2,ih2) - gamhd
*     assume cosmic rays do the same thing
      c(ih2,ih2) = c(ih2,ih2) - csupra
*
*     H2  +  H+  =>  H2+  +  H
      c(ih2,ih2) = c(ih2,ih2) - rh2h2p * hii
      c(iho,ih2) = c(iho,ih2) + rh2h2p * hii
*
*     H2+ + H => H+ + H2
      c(ih2,ih2p) = c(ih2,ih2p) + bh2h2p * hi
      c(iho,iho) = c(iho,iho) - bh2h2p * h2plus
*
*     H + H3+ => H2 + H2+
      h3ph2p = hmrate( 2.08e-9 , 0. , 1.88e4 ) * hi
      c(ih2,ih3p) = c(ih2,ih3p) + h3ph2p
      c(iho,iho) = c(iho,iho) - hmrate( 2.08e-9 , 0. , 1.88e4 ) * h3plus
*
*     H2 + H3+ => H2 + H2+ + H
      h3petc = hmrate(3.41e-11,0.5,7.16e4 ) * htwo
      c(ih2,ih3p) = c(ih2,ih3p) + h3petc
      c(iho,ih2) = c(iho,ih2) + h3petc
*
*     H2 + H3+ => H2 + H+ + H2
      h32h2 = hmrate( 3.41e-11 , 0.5, 5.04e4 ) * htwo
      c(ih2,ih3p) = c(ih2,ih3p) + 2.*h32h2
*
*     e + H3+ => H2 + H
      c(ih2,ih3p) = c(ih2,ih3p) + hmrate(5.00e-9,-0.5,0.)*eden
      c(iho,ih3p) = c(iho,ih3p) + hmrate(5.00e-9,-0.5,0.)*eden
*
      if( lgTrace.and.lgTrMole .or. lgPunH2 ) then
        if( lgPunH2 ) then
          k = ipPunH2
        else
          k = qq
        endif
        if( c(ih2,ih2).ne.0. ) then
          rate = -c(ih2,ih2)
          write(k,'('' Destroy H2: rate='',1P,E10.2,''DIS;'',0P,
     1    f5.3,'' bat;'',f5.3,'' h2dis;'',f5.3,'' gamhd;'',f5.3,
     2    '' h2h2p;'',f5.3,'' E-h;'',f5.3,'' E-h-;'',f5.2)')
     2    rate,gh2dis/rate,batach/rate,rh2dis*hi/rate,gamhd/rate,
     3    rh2h2p*hii/rate , eh2hh/rate,eh2hhm/rate
*666    write(k,'('' batach, ratach,hi,phmlte,ph2lte,eden'',1p,
*    1 1p,6e10.2)') BATACH,RATACH,HI, PHMLTE , PH2LTE , EDEN
        else
          write(k,'('' Destroy H2: rate=0'')')
        endif
      endif
*
*     remember local and global H2 formation ages
      if(c(ih2,ih2).ne.0) then
*       this is destruction rate, s^-1, equal to formation
        AgeH2MoleForm = -1. / c(ih2,ih2)
*       establish age timescale for molecule formation if this is important
        BigH2MoleForm = max( BigH2MoleForm , AgeH2MoleForm )
      endif
*
*-------------------------------------------------------------------
*
*     h2plus H2+ balance equations
*
*     make H2+ from Ho
*     H+  + H  =>  H2+ + HNU
*     approximation was from Kurucz thesis, not meant for hot gas
      radath = max(0.,2.325*min(5000.,te)-1375.)*1e-20
      c(ih2p,iho) = c(ih2p,iho) + radath*hii
      c(iho,iho) = c(iho,iho) - radath*hii
*
*     make H2+ from H2 =+sign
*     H2 + HNU => H2+ + E
*     also cosmic rays
      c(ih2p,ih2) = c(ih2p,ih2) + gamhd + csupra
*
*     H2 + H+  => H2+  + H
      c(ih2p,ih2) = c(ih2p,ih2) + rh2h2p *hii
*
*     (3,IH2P) == destroy H2+ = -sign
*     H + H2+ => H+ + H2
      c(ih2p,ih2p) = c(ih2p,ih2p) - bh2h2p*hi
      c(iho,iho) = c(iho,iho) - bh2h2p*h2plus
*
*     H2+  +  p  => H + H+ + H+; Janev et al. 3.2.6
      h2pion = 2.4e-27*te**3  * hii
      c(ih2p,ih2p) = c(ih2p,ih2p) - h2pion 
      c(iho,ih2p) = c(iho,ih2p) + h2pion 
*
*     H2+  +  E  => H + H+ + e-; Janev et al.
      h2pcin = 2e-7 * sexp( 30720./te )
      c(ih2p,ih2p) = c(ih2p,ih2p) - h2pcin * eden
      c(iho,ih2p) = c(iho,ih2p) + h2pcin * eden
*
*     back reaction, H + H+ + e => h2+ + e
      b2pcin = h2pcin * phplte
*     this is the hot reaction at high densities
      c(ih2p,iho) = c(ih2p,iho) + b2pcin*eden*hii
      c(iho,iho) = c(iho,iho) - b2pcin*eden*hii
*
*     H2+  +  HNU  =>  H+  + H
      c(ih2p,ih2p) = c(ih2p,ih2p) - gamtwo
*
*     photoionization by hard photons, crossection =2*HI (wild guess)
      c(ih2p,ih2p) = c(ih2p,ih2p) - 2.*hgamnc(1)
*
*     H2 + H2+ => H + H3+
      h2ph3p = 1.40e-9 * htwo*(1.-sexp(9940./te))
      c(ih2p,ih2p) = c(ih2p,ih2p) - h2ph3p
      c(iho,ih2p) = c(iho,ih2p) + h2ph3p
*
*     h + h3+ => h2 + h2+
      c(ih2p,ih3p) = c(ih2p,ih3p) + h3ph2p
*
*     H2 + H3+ => H2 + H2+ + H
      c(ih2p,ih3p) = c(ih2p,ih3p) + h3petc
*
*     destroy H2+ via H2+ + H2 => H + H+ + H2
      h2phhp = 2.41e-12*sqrte*sexp(30720./te)*htwo
      c(ih2p,ih2p) = c(ih2p,ih2p) - h2phhp
      c(iho,ih2p) = c(iho,ih2p) + h2phhp
*
*     save total H2P destruction rate for possible later printout:
*     NB this must come last
      desh2p = -c(ih2p,ih2p)
*
*------------------------------------------------------------------
*
*     H3+ balance equations
*
*     H2 + H2+ => H + H3+
      c(ih3p,ih2p) = c(ih3p,ih2p) + h2ph3p
*
*     H + H3+ => H2 + H2+
      c(ih3p,ih3p) = c(ih3p,ih3p) - h3ph2p
*
*     H2 + H3+ => H2 + H2+ + H
      c(ih3p,ih3p) = c(ih3p,ih3p) - h3petc
*
*     H2 + H3+ => H2 + H+ + H2
      c(ih3p,ih3p) = c(ih3p,ih3p) - h32h2
*
*     e + H3+ => 3H
*     e + H3+ => H2 + H
      c(ih3p,ih3p) = c(ih3p,ih3p) - 2.*hmrate(5.00e-9,-0.5,0.)*eden
*
*     photoionization by hard photons, crossection =2*HI (wild guess)
      c(ih3p,ih3p) = c(ih3p,ih3p) - 2.*hgamnc(1)
*
*------------------------------------------------------------------
*
*     first equation is hydrogen conservation
*     remember that htwo/hden = 0.5 when totally molecular
      if( htwo/hden.gt.0.1 ) then
        ipConServ = ih2
      else
*       little molecular hydrogen, leave out the atomic
        ipConServ = iho
      endif
*     this was not the cause of the problem, go back to old way
*     until I have time to debug this logic
      ipConServ = 1
      c(ipConServ,iho) = 1.
      c(ipConServ,ihmi) = 1.
      c(ipConServ,ih2) = 2.
      c(ipConServ,ih2p) = 2.
      c(ipConServ,ih3p) = 3.
*     the above will add up to the following
      c(ipConServ,nmole+1) = hneut 
*
*------------------------------------------------------------------
      if( lgTrace.and.lgTrMole ) then
        do i=1,nmole
          write(qq,'(7X,''MOLE'',I2,1P,11E10.2)') i,(c(i,j),
     1    j=1,nmole+1)
        end do
      endif
*
*     invert matrix
      call matin1(c,nmole+1,nmole,1,merror)
      if(merror.ne.0 ) then
        write(qq,'('' HMOLE matrix error, stop.'')')
        call ShowMe
        stop
      endif
*
      h1fnd = c(iho,nmole+1)
      hminus = c(ihmi,nmole+1)
      htwo = c(ih2,nmole+1)
      h2plus = c(ih2p,nmole+1)
      h3plus = c(ih3p,nmole+1)
*
*     rate H-alpha is created by H- ct
      HalphaHmin  = fhneut * hminus
*
*     identify creation and destruction processes for H2+
      if( lgTrace.and.lgTrMole ) then
        rate = desh2p
        if( rate.ne.0. ) then
          write(qq,'('' Destroy H2+: rate='',1P,E10.2,'' e-;'',0P,
     1    F5.3,'' phot;'',F5.3,'' hard gam;'',F5.3,'' H2col;'',
     2    F5.3,'' h2phhp;'',F5.3,'' pion;'',F5.3,
     3    '' bh2h2p:'',F5.3)')
     2    rate , h2pcin* eden/rate , gamtwo/rate , 2.*hgamnc(1)/rate ,
     3    h2ph3p/rate , h2phhp/rate , h2pion/rate ,
     1    bh2h2p*hi/rate
*
          rate = rate * h2plus
          if( rate.gt.0. ) then
            write(qq,'('' Create  H2+: rate='',1P,E10.2,'' HII HI;'',0P,
     1      F5.3,'' Col H2;'',F5.3,'' HII H2;'',F5.3,'' HI HI;'',
     2      f5.3)') rate,
     4      radath *hii*hi/rate ,
     5      (gamhd + csupra)*htwo/rate,
     6      rh2h2p *hii*htwo/rate ,
     7      b2pcin*hi*hii*eden/rate
          else
            write(qq,'('' Create  H2+: rate= is zero'')')
          endif
        endif
      endif
*
*     heating due to H2 dissociation
      HeatH2Dish = 1.36e-23 * htwo * h2esc * GammaHabing
      heating(1,18) = HeatH2Dish
*
      hmovh1 = ( (htwo+h2plus)*2. + 3.*h3plus + hminus ) / hi
      if( hmovh1.lt.0. ) then
        write(qq,'('' HMOLE:  I found a negative molecular fraction=''
     1  ,1p,e10.2)') hmovh1
        write(qq,'('' HMOLE:  htwo,h2plus,h3plus,hminus,hi,eden=''
     1  ,1p,9e9.1)') htwo,h2plus,h3plus,hminus ,hi,eden
        write(qq,'('' HMOLE:  h1fnd='',1p,e10.2)') h1fnd
        call ShowMe
        stop
      endif
      h1good = hden / (1.d0 + dble(hmovh1) + h2ovh1 )
      hnnew = h1good * (1.d0 + dble(hmovh1) )
      renorm = hnnew / hneut
      if( lgTrace.and.lgTrMole ) then
        write(qq,'('' raw;'',8(1X,A4,'':'',1P,E10.2))')
     1  (chLab(i),c(i,nmole+1),i=1,nmole)
        write(qq,'('' ren;'',8(1X,A4,'':'',1P,E10.2))')
     1  (chLab(i),c(i,nmole+1)*renorm,i=1,nmole)
        write(qq,'('' RENORM factor was'',1P,E10.2)') renorm
      endif
      h1fnd = h1fnd * renorm
      hminus = hminus * renorm
      htwo = htwo * renorm
      h2plus = h2plus * renorm
      h3plus = h3plus * renorm
*
*     following not used any more
      hatmic = (hi+hii) / ( hi+hii+hminus+2.*(htwo+h2plus)+3*h3plus)
*
      if( lgTrace.and.lgTrMole .or. lgPunH2 ) then
        if( lgPunH2 ) then
          k = ipPunH2
        else
          k = qq
        endif
       rate = rgrain*hi + ratach*hminus + bh2dis*hi + bh2h2p*hi*h2plus +
     1  radasc*hi + h3ph2p*h3plus + h3petc*h3plus
        write(k,'('' Create H2, rate='',1P,E10.2,'' grain;'',0P,
     1  F5.3,'' hmin;'',F5.3,'' bhedis;'',F5.3,'' h2+;'',F5.3,
     2  '' radasc:'',F5.3,'' h3ph2p:'',F5.3,'' h3petc:'',F5.3)') rate ,
     2  rgrain*hi /rate,ratach*hminus /rate,bh2dis /rate,
     3  bh2h2p*hi*h2plus /rate , radasc*hi/rate,h3ph2p*h3plus/rate,
     4  h3petc*h3plus/rate
      endif
*
      if( lgTrace.and.lgTrMole ) then
        rate = rh2h2p*htwo*hii + b2pcin*hii*eden*hi +
     1  h3ph2p * h3plus + h3petc * h3plus
        if( rate.gt.1e-25 ) then
          write(qq,'(''  Create H2+, rate='',1P,E10.2,'' rh2h2p;'',0P,
     1    F5.3,'' b2pcin;'',F5.3,
     1    '' h3ph2p;'',F5.3,'' h3petc+;'',F5.3)') rate ,
     1    rh2h2p*hii*htwo /rate ,  b2pcin*hi*hii*eden/rate , 
     1    h3ph2p*h3plus/rate ,  h3petc*h3plus/rate
        else
          write(qq,'(''  Create H2+, rate=0'')')
        endif
      endif
*
      if( hminus.gt.0. .and. phmlte.gt.0. ) then
        hmidep = hminus / hi / eden / phmlte
      else
        hmidep = 1.
      endif
*     this will be net volume heating rate, photo heat - induc cool
      hmihet = hmiht * hminus - colind 
*     save it
      heating(1,16) = hmihet
      heating(1,17) = h2phet * h2plus
*
*     THTMOL is total heating due to absorption of Balmer continuum
*     thtmol = hmihet + h2phet * h2plus
*     departure coef for H2 defined rel to N(1s)**2
*     (see Littes and Mihalas Solar Phys 93, 23)
      plte = hi * hi * ph2lte
      if( plte.gt.0. ) then
        h2dep = htwo / plte
      else
        h2dep = 1.
      endif
*
*     departure coef of H2+ defined rel to N(1s) N(p)
*     sec den was HI before 85.34
      plte = hi * hii * phplte
      if( plte.gt.0. ) then
        h2pdep = h2plus / plte
      else
        h2pdep = 1.
      endif
*
*     departure coef of H3+ defined rel to N(H2+) N(p)
      plte = hi * hii * phplte
      if( plte.gt.0. ) then
        h3pdep = h3plus / plte
      else
        h3pdep = 1.
      endif
*
      if( lgTrace.and.lgTrMole ) then
        write(qq,'('' HMOLE, Dep Coef, H-:'',1p,e10.2,'' H2:'',e10.2,
     1  '' H2+:'',e10.2)')   hmidep, h2dep, h2pdep
        write(qq,'(5X,''H- creat: Rad atch'',1P,E10.3,
     1  '' Induc'',E10.3,'' bHneut'',E10.2,'' 3bod'',E10.2,'' b=>H2'',
     2  E10.2,'' N(H-);'',E10.2,'' b(H-);'',E10.2)')
     1  rspon, ratind, bhneut , c3bod , batach , hminus , hmidep
*
        write(qq,'(5X,''H- destr: Photo;'',1P,E10.3,'' mut neut'',E10.2
     1  ,'' e- coll ion'',E10.2,'' =>H2'',E10.2,'' x-ray'',E10.2,
     2  '' p+H-'',E10.2)')
     2  gamhmi, faneut ,cionhm,ratach,hgamnc(1),
     3  fhneut
        write(qq,'(5X,''H- heating:'',1P,E10.3,'' Ind cooling'',E10.2,
     1  '' Spon cooling'',E10.2)') hmihet , colind , hmicol
      endif
*
      fmol = ( hminus + 2.*(htwo+h2plus) ) / hden
      BiggestH2 = max( BiggestH2 , fmol )
*
*----------------------------------------------------------------
*
*     He H+ formation
*     rates taken from Flower+Roueff, Black
*     photodissociation through 1.6->2.3 continuum
      gamheh = 0.
      do i=iheh1,iheh2
        gamheh = gamheh + (flux(i)+outcon(i)+outlin(i))
      end do
      gamheh = gamheh * 4e-18
*
*     both He+ + H and He + H+
*     first rate is radiative associatino from 
*     >>refer Zygelman, B., and Dalgarno, A. 1990, ApJ 365, 239
      hehp = (1e-15*hi*heii + 1e-20*hii*hei)
*
*     H2+ + HE => HEH+ + H0
      hehp = hehp + 3e-10*exp(-6717./te)*hei*h2plus
*
*     hard radiation
      gamheh = gamheh + 3.*hgamnc(1)
*
*     HeH+  +  H => H2+  + He
      gamheh = gamheh + 1e-10*hi
*
*     recombination, HeH+  +  e => He + H
      if( gamheh .gt. hehp * 1e-15 ) then
        gamheh = gamheh + eden * 1e-9
      else
        gamheh = -1
      endif
      hehp = hehp / gamheh
*
      end
