******************************************************************************
      subroutine htrans
      implicit none
*evaluate the radiative transition rates for model hydrogen atom
      include "ncell.par"
      include "nhlvl.par"
      include "itrdim.par"
      include "rfield.com"
      include "ZoneCnt.com"
      include "ots.com"
      include "opac.com"
      include "iphl.com"
      include "nh.com"
      include "redis.com"
      include "h.com"
      include "bowoi.com"
      include "hyas.com"
      include "htau.com"
      include "htnext.com"
      include "hbug.com"
      include "trace.com"
      include "touton.com"
      include "otsmin.com"
      include "TePowers.com"
      include "phycon.com"
      include "phlevl.com"
      include "hnet.com"
      include "hrc2sp.com"
      include "logte.com"
      include "strkar.com"
      include "hesc.com"
      include "hcbr.com"
      include "ophf.com"
      include "hstat.com"
      include "rin2ph.com"
      include "telogn.com"
      include "htotrc.com"
      include "tusedcom.com"
      include "hcaseb.com"
      include "caseb.com"
      include "tautot.com"
      include "search.com"
      include "newion.com"
      include "dstfe2.com"
      include "ioreco.com"
      include "HTopOff.com"
      include "IOqq.com"
*
*     local variables
      integer i,j,n , lower , iupper , level , iup
      real a,b,c,hrcf,sum,recf,receff , rec2,coloi,extra
*
*     free statement labels >=13
*
      recf(a,b,c) = a + b * (alogte-c)**2
*
*     evaluate recombination coef for H, hrec(i,2) is modified OTS factor
      if( lgNewIon ) then
        do n=1,nhlvl
*         this is escape probability
          hrec(n,3) = receff( ipHn(n) )
        end do
      endif
*
*     option for case b conditions
      if( lgCaseb ) then
        hrec(1,3) = 1e-10
      endif
*
      do n=1,nhlvl
        hrec(n,3) = max( hrec(n,3) , otsmin )
*       following accounts for absorption of diffuse continuum
*       by .not.hydrogen
        hrec(n,2) = min(1.,hrec(n,3) + (1.-hrec(n,3))*ophf(n) )
      end do
      hrec(nhlvl+1,2) = hrec(2,2) 
      hrec(nhlvl+1,3) = hrec(2,3) 
*
      if( lgTrace.and.lgHBugFull ) then
        write(qq,'(7X,''HTRANS recomb effic'',1P,9E10.3,'' (tau only)''
     1  )') (hrec(i,3),i=1,nhlvl)
*
        write(qq,'(7X,''HTRANS recomb effic'',1P,9E10.3,'' (net)'')')
     1  (hrec(i,2),i=1,nhlvl)
*
        write(qq,'(7X,''HTRANS in optic dep'',1P,9E10.3)')
     1  (tauabs(ipHn(i),1),i=1,nhlvl)
        write(qq,'(7X,''HTRANS out op depth'',1P,9E10.3)')
     1  (tauabs(ipHn(i),2),i=1,nhlvl)
      endif
*
*     evaluate radiative recom coef
*     this sum does not have highest level since that rec coef
*     will be the difference between finite levels and true case b
      do n=1,nhlvl
        hrec(n,1) = hrcf(n)
      end do
*
*     make sum of case b up to band
      sum = 0.
      do n=2,nhlvl
        sum = sum + hrec(n,1)
      end do
*
*     following is expansion for case b
      HRecRad = 
     1 (-9.9765209 + 0.158607055*telogn(1) + 0.30112749*telogn(2) 
     2 - 0.063969007*telogn(3) + 0.0012691546*telogn(4) ) /
     3 (1.+ 0.035055422*telogn(1) - 0.037621619*telogn(2) 
     4 + 0.0076175048*telogn(3) - 0.00023432613*telogn(4) )
*     
      HRecRad = (10.**HRecRad)/te
*     this is rec coef that applies at low densities, is in hcaseb common block
      hrectot = hrec(1,1)*hrec(1,2) + HRecRad
*     highest level is remainder of recombination coefficient
*     will rescale all rec coef up by this factor to get tot case b
*     did not put h=2 in above sum, this is extra needed to top off h atom
      extra = HRecRad - sum
      if( chHTopType .eq.'scal' ) then
*       this is now scale factor to get correct sum, we will add for n=3 to end
*       nHTopOff default is 5, change with set nHTopOff
        sum = 0
        do n=nHTopOff,nhlvl
          sum = sum + hrec(n,1)
        end do
*       scale factor to get right sum
        extra = 1. + extra/sum
*       this is the top-off top off of the h atom
        do n=nHTopOff,nhlvl
          hrec(n,1) = hrec(n,1) * extra
        end do
      else if( chHTopType .eq.' add' ) then
*       spread it out by adding same to all top levels
        extra = extra /( nhlvl-nHTopOff+1 )
        do n=nHTopOff,nhlvl
          hrec(n,1) = hrec(n,1) + extra
        end do
      else
*       this is insanity
        write(qq,'('' htrans has insane chHTopType='',a4)') chHTopType
        call ShowMe
        stop
      endif
*
*     check top not negative
      if( hrec(nhlvl,1).lt.0. ) then
        write(qq,'('' ERROR - H rec to band negative.'')')
        hrec(nhlvl,1) = HRecRad * 0.15
      endif
*
*     do 2s 2p fixup
*
*     independent fits to 2s and 2p recombination
      hrc2s =   10.** (-recf(8.9776,.06256,7.2302)) / te
      hrc2p =   10.** (-recf(9.1508,.12667,4.9748)) / te
*     these fits may not agree to all sig fig with hrcf above -
*     hrcf is better - renormalize these to that
      rec2 = hrc2s + hrc2p
      rec2 = hrec(2,1) / rec2
*     now renormalize the result
      hrc2s = hrc2s * rec2
      hrc2p = hrc2p * rec2
      hrec(2,1) = hrc2p
      hrec(nhlvl+1,1) = hrc2s
*
      if( lgTrace.and.lgHBugFull ) then
        write(qq,'(7X,''HTRANS eval rec cof'',1P,9E10.3)') 
     1  (hrec(i,1),i=1,nhlvl)
      endif
*
*     htotrc is total radiative recombination, must add 3-body too
      htotrc = hrec(2,1)*hrec(2,2) + hrec(1,1)*hrec(1,2)
      do i=3,nhlvl+1
        htotrc = htotrc + hrec(i,1) * hrec(i,2)
      end do
*
      if(ioreco.ne.0) write(ioreco,'(''H  '',1P,E9.2)') HRecRad
      if( lgTrace.and.lgHBug ) then
        write(qq,'(7X,''HTRANS total rec coef'',1P,E10.3,'' case A='',
     1  E10.3,'' caseB='',E10.3)') htotrc , HRecRad+hrec(1,1) , HRecRad
      endif
*
*----------------------------------------------------------------------
*
*     find Stark escape probabilities
      call strk
*
*     find prob of emission, defines ESESC=elec scat escape
      call HydroPesc
*
*     do the 8446 problem
      call p8446( coloi )
      if( lgTrace.and.lgHBugFull )  then
        write(qq,'(7X,''HTRANS calls P8446 who ''
     1  ,''found pmph31='',1p,e10.2)') pmph31
      end if
*
*     find FeII overlap destruction rate
      call fe2ovr
*
*     find the rate of induced two photon
      call twopht
*
      do j=1,nhlvl-1
        do i=j+1,nhlvl
*         hemis(i,j) = hyas(i,j)*min(1.,(hesc(i,j)+pestrk(i,j)+
*     >>chng 96 may 13 cap of 1 prevented maser emission
          hemis(i,j) = hyas(i,j)*(hesc(i,j)+pestrk(i,j)+
     1    esesc(i,j))
          hnet(i,j) = hemis(i,j) + hdest(i,j)
*begin sanity check
*      maser emission tricks this
*         if( hnet(i,j)/hyas(i,j).gt.1.01 ) then
*           write(qq,'('' HTRANS: hnet/A > 1: this is insane.'')')
*           write(qq,'('' i,j, ratio'',2i4,1p,e10.2)')i,j,
*    1      hnet(i,j)/hyas(i,j)
*           call insane
*         endif
*end sanity check
        end do
      end do
*
*     now add in FeII deexcitation via overlap,
*     but only as loss, not photoionization, source
*     dstfe2lya is Ly-alpha deexcit by FeII overlap - conversion into FeII em
      hnet(2,1) = hnet(2,1) + dstfe2lya * hyas(2,1)
      hemis(3,1) = pmph31
      hnet(3,1) = hemis(3,1) + hdest(3,1)
*
*     add ots from lines, continua
      call HydroOTS
*
*     total rates out of level due to induced processes
      do level=1,nhlvl
        hbul(level) = 0.
        do lower=1,level-1
          hbul(level) = hbul(level) + hcont(level,lower)
        end do
*       hstat is correct stat weight, =6 for 2
        do iupper=level+1,nhlvl
          hbul(level) = hbul(level) +
     1    hcont(iupper,level)*hstat(iupper)/hstat(level)
        end do
      end do
*     add on induced two photon 1s -> 2s, ratio stat weight = 1
      hbul(1) = hbul(1) + ri2s1s
*     this is used for both 2s and 2p, in following
      hbul(2) = 0.
      do iupper=3,nhlvl
        hbul(2) = hbul(2) + 
     1  hcont(iupper,2)*hstat(iupper)/(hstat(2)+hstat(nhlvl+1))
      end do
*     2s - add on induced two photon
*     following should be multiplied by g(l)/g(tot) as branching ratio
*     from upper level, and then by g(tot)/g(l) to correct stat weights
*     in equation above, so they cancel out
      hbul(nhlvl+1) = hbul(2) + ri2s1s
*     2p - add on Ly a
      hbul(2) = hbul(2) + hcont(2,1)
*
      if( lgTrace.and.lgHBugFull ) then
        write(qq,'(7X,''HTRANS finds arrays, with optical depths defi''
     1  ,''ned? '',L1,'' induced 2ph='',1P,E12.3)') lgTauOutOn,ri2s1s
        do iup=2,nhlvl
         write(qq,'(1X,''up:'',I2,15I9)') iup,(j,j=1,iup-1)
         write(qq,'(i3,1x,''A-net'',1P,15E9.2)')
     1   iup,(hnet(iup,j)    ,j=1,iup-1)
         write(qq,'(i3,1x,''A*esc'',1P,15E9.2)')
     1   iup,(hemis(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''tauin'',1P,15E9.2)')
     1   iup,(htnext(iup,j)  ,j=1,iup-1)
         write(qq,'(i3,1x,''t tot'',1P,15E9.2)')
     1   iup,(htlim(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''Esc  '',1P,15E9.2)')
     1   iup,(hesc(iup,j)    ,j=1,iup-1)
         write(qq,'(i3,1x,''Dest '',1P,15E9.2)')
     1   iup,(hdest(j,iup)    ,j=1,iup-1)
         write(qq,'(i3,1x,''A*dst'',1P,15E9.2)')
     1   iup,(hdest(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''StrkE'',1P,15E9.2)')
     1   iup,(pestrk(iup,j)  ,j=1,iup-1)
         write(qq,'(i3,1x,''EsctE'',1P,15E9.2)')
     1   iup,(esesc(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''B(ul)'',1P,15E9.2)')
     1   iup,(hcont(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''Tnext'',1P,15E9.2)')
     1   iup,(htnext(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''C(ul)'',1P,15E9.2)')
     1   iup,(hcol(iup,j)*eden,j=1,iup-1)
         if(iup.eq.2)
     1   write(qq,'(4X,''FeIIo'',1P,8E9.2)') dstfe2lya * hyas(2,1)
        end do
*
        write(qq,'(9x,13i9)') (i,i=1,nhlvl+1)
      endif
*
      end
