******************************************************************************
      subroutine humla( taume , beta , esc , dest )
      implicit none
*fit Hummer and Kunasz escape probability for hydrogen atom Lya
      real taume,beta,esc,dest
*
      include "ncell.par"
      include "limelm.par"
      include "nhlvl.par"
      include "escdst.com"
      include "IOqq.com"
      include "iphl.com"
      include "scatop.com"
      include "LaMase.com"
*
*     local variables
      real tau,taulog,betal,taucon,fac,fac1,fac2
      real esc0 , dest0
      include "sqrtpi.par"
      parameter (dest0=1e-8)
*
*     fits to numerical results of Hummer and Kunasz Ap.J. 80
      tau = taume * sqrtpi
*
      if( chEscFun.eq.'SIMP' ) then
*       this set with "escape simple" command, used for debugging
        esc0 = 1. / (1. + taume )
      else
*       this is the real escape probability
        esc0 = 1. / ( (0.6451+tau) * (0.47+1.08/(1.+7.3e-6*tau) ) )
      endif
      esc0 = max(0., esc0)
      esc0 = min(1., esc0)
*
      if( tau.gt.0. ) then
        taulog = log10( min(1e8,tau ) )
      else
*       the line mased
        xLaMase = min(xLaMase,tau)
        dest = 0.
        esc = esc0
      endif
*
      if( beta .gt.0. ) then
        betal = log10( beta )
        taucon = min( 2.,beta * tau )
*
        if( taucon.gt.1e-3 ) then
          fac1 = -1.25 + 0.475 * taulog
          fac2 = -0.485 + 0.1615 * taulog
          fac = -fac1 * taucon + fac2 * taucon**2
          fac = 10.**fac
          fac = min(1. , fac )
        else
          fac = 1.
        endif
*
        esc = esc0 * fac
*       MIN puts cat at 50
        dest = beta / (0.30972 - min( .28972,0.03541667*taulog))
      else
        dest = 0.
        esc = esc0
      endif
      dest = max( 0. , min( dest , 1.-esc ) )
*
*
*     chng>> 99 apr 12, limit destruction prob in case where gas dominated by scattering.
*     in this case scattering is much more likely than absorption on this event */
      dest=(1.-albedo(iphl(2,1)))*dest+albedo(iphl(2,1))*dest0
      end
