******************************************************************************
      subroutine hydrgn( hlax , sechi )
      implicit none
*main routine to call hlevel and determine model hydrogen atom level balance
      include "ncell.par"
      include "ipLnArry.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "limelm.par"
      include "nta.par"
      include "itrdim.par"
      include "HNIonRyd.com"
      include "rfield.com"
      include "ots.com"
      include "ZoneCnt.com"
      include "opac.com"
      include "hcolrt.com"
      include "iphop.com"
      include "htau.com"
      include "iphl.com"
      include "hesc.com"
      include "prad.com"
      include "DoppVel.com"
      include "newion.com"
      include "hionon.com"
      include "search.com"
      include "iondun.com"
      include "nebug.com"
      include "HPhoto.com"
      include "hbug.com"
      include "trace.com"
      include "IonFracs.com"
      include "heating.com"
      include "hlvcol.com"
      include "x12.com"
      include "recgrd.com"
      include "phlevl.com"
      include "workf.com"
      include "shullc.com"
      include "TePowers.com"
      include "ip2gam.com"
      include "h.com"
      include "heat.com"
      include "phycon.com"
      include "resmax.com"
      include "photn2.com"
      include "lhytot.com"
      include "hgamsc.com"
      include "hmihet.com"
      include "nh.com"
      include "hwidth.com"
      include "resion.com"
      include "hmi.com"
      include "TLineEXP.com"
      include "LyaExT.com"
      include "InCvgRsn.com"
      include "hex.com"
      include "dtrans.com"
      include "DoPhoto.com"
      include "erredn.com"
      include "TrConvg.com"
      include "EdenOther.com"
      include "hem.com"
      include "coolng.com"
      include "hstat.com"
*     include "HdeltaT.com"
      include "ipSecIon.com"
      include "BigSec.com"
      include "PhotScale.com"
      include "HPHeat.com"
      include "PhotRate.com"
      include "iphe1l.com"
      include "iphe2l.com"
      include "LevTrace.com"
      include "nhe2.com"
      include "nhe1.com"
      include "pbowen.com"
      include "IOqq.com"
*
*     local variables
      real ResultEden,hiip,diffhii,diffhi,dne,hip,p2,widla,
     1 pratio,gamtot,coltot,hlax,sechi,bnfun,f,ff,edensave,
     2 out2,hginv,ohii,ohi,AssumEden,simhii,hmovh1,HighE,
     3 otsmg2 , SignSave , FracChange , xLowE , csupeff
      save xLowE , HighE
      logical lgNeOscil
      integer luphlim
      parameter (luphlim=8)
      integer i,n,ip,luph
      double precision h2ovh1
      save h2ovh1
      real gh(lmhlvl)
      integer nZoneDone
      logical lg2ndPass
      save nZoneDone
      save lg2ndPass
      save gh
      real aa(6)
      character chLab(7)*6
      logical lgNeCap , lgConverged , lg2BigChg
      real dNeSave , otsnew , EdenInit
      real coef(3),frac(7) , weight , gamk
      data coef/ 2.66e-9 , 5.04e-11, 2.63e-12/
*
*     free statement numbers, >=13, not 999
*
      edensave = eden
      if( lgDoPhoto ) then
*
*       induced recombination; FINDUC is integral of
*       pho rate times exp(-hn/kt) for induc rec
*       CIND is this times hnu-hnu0 to get ind rec cooling
*       PhotScaleOn is 1, set to 0 with 'no photoionization' command
*       >>chng 96 oct 25, energy from 1 ryd to .99946 contained in HLevNIonRyd
*       >>chng 97 aug 14, divided into two branches depending on whether
*       induced is important - lgHInducImp is set in setcon
        if( lgHInducImp ) then
          xLowE = bnfun( ipHn(1) , ipSecIon-1,iphop(1), HLevNIonRyd(1),
     1    finduc(1), cind(1))*PhotScaleOn
          HPhotHeat(1) = h * PhotScaleOn
*         do second piece and pick up effects of suprathermals
          HighE = bnfun(ipSecIon,nflux,iphop(1)+ipSecIon-ipHn(1),
     1    HLevNIonRyd(1),f, ff)* PhotScaleOn
          finduc(1) = finduc(1) + f
          cind(1) = cind(1) + ff
        else
          xLowE = gamk(ipHn(1),ipSecIon-1,iphop(1),1.)
          HPhotHeat(1) = h * PhotScaleOn
          HighE = gamk(ipSecIon,nflux,iphop(1)+ipSecIon-ipHn(1),1.)
          finduc(1) =  0.
          cind(1) =  0.
        endif
*       now get sum of photoionization and heating
        gh(1) = xLowE + HighE
        HPhotHeat(1) = HPhotHeat(1) + h * PhotScaleOn
*       option to print photoionization rates
        if( lgTrace.and.lgHBug ) then
          call PrtGamma(ipHn(1),nflux,iphop(1),qq,xLowE+HighE,
     1    (HighE+xLowE) *0.05)
        endif
*       units for secondaries; inverse seconds.
        sechi = secion
        hlax = secla
*       hgamsc is direct photioniz rate due to very hard x-rays+Compton scat
        hgamnc(1) = gh(1) + hgamsc
        PhotoRate(1,1,1,1) = hgamnc(1)
        PhotoRate(1,1,1,2) = HPhotHeat(1)
*       all other continua
        do i=2,nhlvl
          if( lgHInducImp ) then
            gh(i) = bnfun(ipHn(i),ipHn(1)-1,iphop(i),HLevNIonRyd(i) ,
     1      finduc(i), cind(i)) * PhotScaleOn
          else
            gh(i) = gamk(ipHn(i),ipHn(1)-1,iphop(i),1.) * PhotScaleOn
            finduc(i) = 0.
            cind(i) = 0.
          endif
          hgamnc(i) = gh(i)
          HPhotHeat(i) = h
        end do
*666    write(qq,'(''HPhotHeat'',1p,10e10.2)') te,hgamnc(2),HPhotHeat(2)
*         call PrtGamma(ipHn(2),ipHn(1)-1,iphop(2),qq,hgamnc(2) ,
*    1    hgamnc(2) *0.10)
*       now split up 2s and 2p
*       factor of 1.5 is to get to te in induc problem
        finduc(nhlvl+1) = finduc(2)*1.5
        cind(nhlvl+1) = cind(2)
*       factor of 1.079 ratio of 2s cs to n=2 cs, Allen, AQ p96
        hgamnc(nhlvl+1) = hgamnc(2)*1.5
      endif
*
*     break out ots ionization due to mg ii 2798
      otsmg2 = otslin(int(t2804(ipLnIpCont)))+
     1 otslin(int(t2796(ipLnIpCont)))
      out2 = max(1e-37,gh(2) + eden*(hcol(2,1)+hcolnc(2)) +
     1 (otsmg2+otsfe2)*6.4e-18 + hemis(2,1) )
      resmax = max( resmax , (otsmg2+otsfe2)*6.4e-18 / out2 )
*
      if( lgTrace ) then
*        if( lgNewIon .and.hgamnc(1).gt.0. ) then
*     >>chng 97 july 8, from 0 to 1e-35, crash in pdr due to overflow
         if( lgNewIon .and.hgamnc(1).gt.1e-35 ) then
           hginv = 1. / hgamnc(1)
           chLab(1) = 'INCDNT'
           frac(1) = gh(1) * hginv
           ip = 1
           if( hgamsc*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'HGAMSC'
             frac(ip) = hgamsc*hginv
           endif
           if( otslin(iphe2l(2,1))*2.85e-19*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS304'
             frac(ip) = otslin(iphe2l(2,1))*2.85e-19*hginv
           endif
           if( otslin(iphe1l(2,1))*1.85e-18*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS584'
             frac(ip) = otslin(iphe1l(2,1))*1.85e-18*hginv
           endif
           if( otscon(nhe2(2))*6.30e-18*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS911'
             frac(ip) = otscon(nhe2(2))*6.30e-18*hginv
           endif
           if( otscon(nhe1(1))*1.25e-18*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS504'
             frac(ip) = otscon(nhe1(1))*1.25e-18*hginv
           endif
           if( otscon(nhe2(1))*1.20e-19*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS228'
             frac(ip) = otscon(nhe2(1))*1.20e-19*hginv
           endif
           if( otslin(ip660)*2.40e-18*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS660'
             frac(ip) = otslin(ip660)*2.40e-18*hginv
           endif
           write(qq,'(5X,''HYDRGNgr low, med hi='',1P,3E9.2)')
     1     xLowE , HighE , hgamsc
           write(qq,'(5X,''HYDRGNgr pht='',1P,E9.2,'' frc:'',1X,A6,E9.2,
     1     0P,6(1X,A6,F6.3))') hgamnc(1) , ( chLab(i), frac(i),i=1,ip)
*
           if(hgamnc(2).gt.1.e-20.and.(otsmg2+otsfe2)/hgamnc(2).gt.0.01)
     1       then
             write(qq,'(5X,''HYDRGNn2 rate'',1P,E9.2,'' Prim'',E9.2,
     1       '' Res line:'',E9.2)') hgamnc(2), gh(2)/hgamnc(2) ,
     2       (otsmg2+otsfe2)/hgamnc(2)
           endif
         else if( hgamnc(1).le.0. ) then
           write(qq,'(5X,''HYDRGN finds zero photoioniz rate.'')')
         else
           writE(qq,'(5X,''HYDRGN does not reeval photoioniz rates.'',
     1     '' n=1, 2='',1P,2E10.2)') hgamnc(1) , hgamnc(2)
         endif
      endif
*
*---------------------------------------------------------------------
*
*     drive HLEVEL to find H solution
*
*     set exponential factors for HLEVEL
      call hcolst
*
*     EDNCOR is correct eden, from charge conservation, eval in ESUM
*     dead code - it erev activated, current name of variable is EdenTrue
*     EdenNotH is sum of all electrons from everything else, it is set in esum
*     eother = max(0., edncor - hii )
*
*     this is top of loop for hydrogen ionization-electron density conver
*     evaluate radiative quantities
*     DEC 1 93  84.09
* 666 error! speed up code by changing htrans
*     this was moved into loop so that the destruction rates are
*     constantly reevaluated.  Much of what HTRANS does could be
*     moved back out of this loop.  Rewrite HTRANS so that each block
*     of do loops checks whether its really necessary to be reevaluated
*     Putting htrans in this loop slowed the code down by about 10%
*     the logic to reevaluate hlevel if the neutral fraction changes is now
      luph = 0
      lgNeCap = .true.
      diffhii = EdenError* 2.
      diffhi = EdenError* 2.
*     luphlim set in parameter above, is 8
      lgConverged = .false.
*     this will be flag for electron density having changed by
*     too much - this is bad if secondary ionizations are important
      EdenInit = eden
      lg2BigChg = .false.
      if( nzone.gt.1 .and. nzone.eq.nZoneDone ) then
        lg2ndPass = .true.
      else
        lg2ndPass = .false.
      endif
      nZoneDone = nzone
      dne = -1.
*     dne is set to zero within this loop
      do while( luph.lt.luphlim .and. .not.lgConverged .and.
     1  .not.lg2BigChg .and. dne.ne.0. )
        if( lgTrConvg .and. nLevTrace.eq.0 ) then
          if(luph.eq.0 ) then
            write(qq,'(7x,''enter hlevel loop, search='',l2)')lgSearch
          else if( lgNeCap ) then
            write(qq,'(7x,''hlevel loop'',i3,'' lgNeCap set, '',
     1      ''FracChange='',1p,e10.2)')luph,FracChange
          else if( diffhii.gt.EdenError ) then
            write(qq,'(7x,''hlevel loop'',i3,'' large diffhii='',1p,
     1      e10.2)') luph, diffhii
          else if( diffhi.gt.EdenError ) then
            write(qq,'(7x,''hlevel loop'',i3,'' large diffhi='',1p,e10.2
     1      )') luph, diffhi
          else if( abs(ResultEden-AssumEden)/ResultEden.gt.EdenError)
     1      then
            write(qq,'(7x,''hlevel loop'',i3,'' large change in eden'',
     1      '' to '',1p,e10.2,'' from'',e10.2)') luph, ResultEden,
     2      AssumEden
          else
            write(qq,'(7x,''hlevel loop, insane'')')
          endif
        endif
        ohii = hii
        ohi = hi
        call htrans
        luph = luph + 1
        lhytot = lhytot + 1
*       AssumEden = EdenNotH + hii
        AssumEden = eden
        call hlevel( h2ovh1 , simhii , csupeff )
        call hmole( hmovh1 , h2ovh1 )
        if( lgTrace ) write(qq,'(5X,''HYDRGN, H2OVH1='',1P,
     1  E10.3,'' simple='',E10.3,'' H-ovH1:'',e10.2)')
     1  h2ovh1 , simhii,hmovh1
        hiip = hden * h2ovh1 / (1. + h2ovh1 + hmovh1 )
        hip = hden / (1. + h2ovh1 + hmovh1 )
*       EdenNotH is electrons for everything not hydrogen
*       hiip is proposed proton density from current solution
        ResultEden = EdenNotH + hiip
        if( ResultEden.lt.0. ) then
          write(qq,'('' I found a negative electron density in HYDRGN.''
     1    ,''  Whats up?  ResultEden='',1PE10.2,'' EdenNotH='',E10.2,
     2    '' new HII='',E10.2)') ResultEden , EdenNotH , hiip
          stop
        endif
*       dne is resulting change in proton density
*       dne = hiip - ohii
*       >>chng 97 july 8, some models went totally neutral, do nothing here
        if( hiip.eq.0. ) then
          dne  = 0.
        else
          dne = ResultEden - AssumEden
        end if
*       dne = (hiip - ohii) * 0.5
*       make sure not totally neutral
        if( h2ovh1.gt.0.  ) then
*         this is true error in soln
          diffhii = abs( hiip-ohii ) / ResultEden
          diffhi = abs( hip-ohi ) / ohi
        else
*         this happens if there is no ionizing radiation
          diffhii = 0.
          diffhi = 0.
          ResultEden = AssumEden
        endif
        if( lgSearch ) then
*         this is search for new solution
          if( (lgTrConvg.and. nLevTrace.eq.0).or.(lgTrace.and.lgNeBug))
     1      then
            write(qq,'(7x,''hlevel, chg1 ne from, to, dn'',1p,3e10.3)')
     1      eden, 10.**( 0.5*(log10(AssumEden)+log10(ResultEden) ) )
          endif
          eden = 10.**( 0.5*(log10(AssumEden)+log10(ResultEden) ) )
          lgNeCap = .false.
        else
*         do not let ne change by too much
*         sign of second argument applied to first argument
*         dne = sign( min( abs(dne),0.02*hii) , dne )
*         we want final soln better than EdenError of electron density
*         so must change eden by less than that
*         EdenError default is set to 0.01 in block data
          if( luph.le.1 ) then
*           this is first time through loop, remember sign of change in eden
            SignSave = dne
*           may have been oscillating while previous calls in this zone
            if(.not.lg2ndPass) lgNeOscil = .false.
            FracChange = EdenError / 2.
          else 
            if( SignSave * dne .le.0. ) then
*             change in eden is oscillating
              lgNeOscil = .true.
              FracChange = EdenError / 3.
            else if( luph.gt.4 .and. .not.lgNeOscil ) then
*             allow bigger changes
              FracChange = EdenError * 4.
            else if( .not.lgNeOscil ) then
              FracChange = EdenError * 2.
            endif
          endif
          dNeSave = dne
          dne = sign( min( abs(dne), FracChange*eden ) , dne )
*         only do this loop one time
*         >>chng 97 aug 26, do now change electron density here, eden
*         changes only one time per full loop
          dne = 0.
*         was dne capped?  if so then not converged
          if( dne.ne.dNeSave ) then
            lgNeCap = .true.
          else
            lgNeCap = .false.
          endif
          if( lgTrConvg .or.lgTrace.and.lgNeBug ) then
            write(qq,'(5x,''HYDRGN chg2 EDEN from, to, dn'',1p,3e10.3)')
     1      eden, eden+dne, dne
          endif
          eden = eden + dne
        endif
        if( eden.le.0. ) then
          write(qq,'('' Negative electron density in HYDRGN, zone='',i5
     1    )')nzone
          write(qq,'('' hii='',1p,e10.2,'' eden, dne='',2e10.2)')
     1    hii , eden , dne
          call ShowMe
          stop
        endif
        hii = hiip
        hi = hip
*       test that electron density has not changed by too much
        if( lgBigSec ) then
          if(abs(eden/EdenInit-1.).gt.0.05 ) lg2BigChg = .true.
        endif
*       test for convergence - this is a do while loop which
*       loops until this is true, or exceed max number of iterations
        if(diffhii.gt.EdenError.or.diffhi.gt.EdenError .or. 
     1    abs(ResultEden-AssumEden)/ResultEden.gt.EdenError) then
          lgConverged = .false.
        else
          lgConverged = .true.
        endif
*       actual end of loop
        if( lgTrace ) then
          write(qq,'(5X,''HYDRGN, LUPH='',I2,'' OldE-'',1P,
     1    E11.4,'' OldHII='',E11.4,'' NewHII='',E11.4,'' NewE-'',E11.4,
     2    ''  HI:'',E11.4,'' EdenNotH:'',E11.4)')
     3    luph,AssumEden,ohii,hiip,eden,hip,EdenNotH
          if( lgNeBug ) write(qq,'(5X,''HYDRGN: EDEN to'',1P,
     1    E11.4,'' from'',E11.4,'' Ne resulting='',E11.4,
     2    '' AssumEden='',e11.4,'' cap?'',l2,'' oscl?'',l2,'' fne'',
     3    e8.1)')
     2    eden , eden-dne , ResultEden,AssumEden,lgNeCap,lgNeOscil,
     3    FracChange
        endif
*       do while( luph.lt.luphlim .and. .not.lgConverged .and.
*    1  .not.lg2BigChg )
      end do
*     end of elecron density convergence loop
*
*       if( lgNeCap.or. diffhii.gt.EdenError .or. diffhi.gt.EdenError )
*    1   then
*         dif is ratio of abs val of change in n+ to new electron density
*         so is change in HII relative to the electron density
*         another loop on hlevel, hmole will be needed
*         if( luph.lt.8.and. lgNeCap ) go to999
*   do while( luph.gt.8 .and.(lgNeCap.or.diffhii.gt.EdenError.or.diffhi.gt.EdenError)
*
      if( luph.ge.luphlim .or. lg2BigChg ) then
*       falls through here if it didn't converge, or if change in
*       electron density got too big
*       tells IONTE that IONIZE is not finished
        if( lgTrace ) then
          if( lg2BigChg ) then
            write(qq,'(5X,''>>>>>> HYDRGN did not converge elec den,'',
     1      '' limit hit of'',i4,'' sec ioniz 2 imp'')') luph
          else if(lgNeCap) then
            write(qq,'(5X,''>>>>>> HYDRGN did not converge elec den,'',
     1      '' limit hit of'',i4,'' Change in eden capped.'')') luph
          else
            write(qq,'(5X,''>>>>>> HYDRGN did not converge elec den,'',
     1      '' limit hit of'',i4,'' Change in eden not capped.'')')
     2      luphlim
          endif
        endif
        lgIonDone = .false.
        chInCvgRsn = 'HEden conv'
      endif
*-------------------------------------------------------------
*
*     save into master ionization array
      xIonFracs(1,1) = hi
      xIonFracs(1,2) = hii
*
*     RECGRD is total recombination rate
      recgrd = hrec(1,1)*hrec(1,2)
      do i=2,nhlvl+1
        recgrd = recgrd + hrec(i,1)*hrec(i,2)
      end do
      workfz = recgrd * eden * hii
*
*     put into OTS continuum
      weight = 0.75
*     >>chng 96 may 14 weight to below for c oscil
      weight = 0.25
      do n=1,nhlvl+1
        if( opac(ipHn(n) ).gt.0.) then
          otsnew = ( otscon(ipHn(n))*(1.-weight) +
     1    weight*hrec(n,1)*(1.-hrec(n,3))*eden*hii/ opac(ipHn(n)) ) /2.
          otsnew = otsnew * opac(ipHn(n))
          if( otsnew.lt.0. ) then
            write(qq,'('' hydrgn found negative OTS CON, n='',i4,
     1      '' val='',1p,e10.1)')n , otsnew
            call ShowMe
            stop
          endif
          call AddOTSCon( otsnew , ipHn(n) )
        else
          call AddOTSCon( 0. , ipHn(n) )
        endif
      end do
*
*     OTS fields due to line destruction by background opacity
*     fix Ly-alpha since 2s2p make it special
*     95 oct 20, changed to single precision on right
      call HydroOTS
*
      photex = hn(2) * hgamnc(2)
      do i=3,nhlvl
        photex = photex + hn(i) * hgamnc(i)
      end do
*--------------------------------------------------------------
*
      if( hn(1).gt.0. ) then
        p2 = hn2p / hn(1) / 3.
*       la radiation pressure, check if incomp or compl redis, also always
*       has outward optical depth
        HLineWidth(1) = widla(htau(2,1) , htlim(2,1) , 4.72e-2/sqrte ,
     1  doppler(1))
*       coefficient in following assumes that HLineWidth is half width, not total
        plines(1) = p2 * 5.08e-6 * HLineWidth(1)
*       excitation temperature of Lya
        if( p2.gt.0. ) then
          TexcLya = -1.183E5 / LOG( p2 )
        else
          TexcLya = 0.
        endif
      else
        p2 = 0.
        HLineWidth(1) = 0.
        plines(1) = 0.
        TexcLya = 0.
      endif
*
*     now do prad for excited H states
*     inner optical depths
      aa(1) = htau(3,2)
      aa(2) = htau(4,3)
      aa(3) = htau(5,4)
*     outer optical depths
      aa(4) = htlim(3,2)
      aa(5) = htlim(4,3)
      aa(6) = htlim(5,4)
*
      plines(3) = 0.
      do i=2,4
        if( hn(i).gt.0. ) then
          pratio = hn(i+1)/hn(i)
*         now assume line width just doppler core
          HLineWidth(i) = doppler(1)*2. * (1. - hesc(i+1,i) )
*         HLineWidth(i) = widlin( aa(i-1) ,aa(i+2) ,0. ,doppler(1) )
          plines(3) = plines(3) + coef(i-1) * pratio * HLineWidth(i)
        else
          pratio = 0.
          HLineWidth(i) = 0.
        endif
*       now assume line width just doppler core
        HLineWidth(i) = doppler(1)*2. * (1. - hesc(i+1,i) )
*       HLineWidth(i) = widlin( aa(i-1) ,aa(i+2) ,0. ,doppler(1) )
        plines(3) = plines(3) + coef(i-1) * pratio * HLineWidth(i)
      end do
*
*     higher Lyman lines radiation pressure
*     now assume only doppler core
      if( hn(1).gt.0.) then
        plines(2) = hn(3)/hn(1)/9.*1.01e-5 * doppler(1) * 2. *
     1  (1.-hesc(3,1))+
     2  hn(4)/hn(1)/16.*1.24e-5* doppler(1) * 2.*(1.-hesc(4,1)) +
     3  hn(5)/hn(1)/25.*1.36e-5 * doppler(1) * 2.*(1.-hesc(5,1)) 
      else
        plines(2) = 0.
      endif
*
*---------------------------------------------------------------------
*
      gamtot = hgamnc(1) + csupeff
      coltot = (hcolnc(1) + hcol(2,1)*4.*hlbolt(1,2))
      if( lgHIonON ) then
        photn2 = hgamnc(1) / (gamtot+coltot*eden+x12+photex/
     1  max(1e-37,hn(1)))
      else
        photn2 = 0.
      endif
*
*     evaluate hydrogen heating-cooling due to collisions
      call HydroCool
*
      if( lgTrace ) then
        write(qq,'(''     HYDRGN retrn H,2,NE='',3(1P,E9.2),
     1  '' REC, COL, GAMT= '',3E9.2,'' CSUP='',E8.2,'' Htwo='',E9.2)')
     2  hi,hii,eden,recgrd,coltot,gamtot, csupeff,htwo
        if(lgNeBug ) write(qq,'(5x,''EDEN change HYDRGN from to'',1p,
     1  3e10.3)') edensave , eden , edensave/eden
      endif
*
      end
