****************************************************************************
      subroutine HydroOTS
      implicit none
*evaluate model hydrogen atom ots rates
      include "nhlvl.par"
      include "ncell.par"
      include "itrdim.par"
      include "phlevl.com"
      include "radius.com"
      include "h.com"
      include "ots.com"
      include "iphl.com"
      include "opac.com"
      include "ZoneCnt.com"
      include "IOqq.com"
*
*     make ots fields due to hydrogen lines
*
*     local variables
      real damp , otshere , temp
      integer i,j , nzUsed
      save nzUsed
      data nzUsed/-1/
*
      if( nzone.gt.1 .and. nzone.eq.nzUsed ) return
      nzUsed = nzone
*
*     OTS fields due to line destruction by background opacity
*     fix Ly-alpha since 2s2p make it special
      damp = 0.25
*
      otshere = hn2p*hii*hdest(2,1)
*begin sanity check
      if( otshere.lt.0. ) then
        write(qq,'('' HydroOTS found negative OTS H2l'',2i4,
     1  '' val='',1p,e10.1)')2,1 , otshere
        call ShowMe
        stop
      endif
*end sanity check
      temp = otslin(iphl(2,1))
*     otslin can be zeroed out in AddOpac if opacity too small
      call AddOTSLin( otshere , iphl(2,1) ,damp )
*this code in case of )(#$ oscillations
*      write(qq,'(''hlyaots'',1p,4e10.2)') depth,otshere,opac(iphl(2,1))
*     1 , otslin(iphl(2,1)) 
*
      do j=3,nhlvl
        otshere =  hn(j)*hii*hdest(j,1)
*begin sanity check
        if( otshere.lt.0. ) then
          write(qq,'('' HydroOTS finds an insane negative OTS line'',
     1    '' rate='',1p,e10.2)') otshere
          write(qq,'('' upper level was'',i4,'', level pop, dest rate=''
     1    ,1p,2e10.2)') j,hn(j),hdest(j,1)
          call ShowMe
          stop
        endif
*end sanity check
        call AddOTSLin( otshere , iphl(j,1) ,damp )
      end do
*
      do i=2,nhlvl-1
        do j=i+1,nhlvl
          otshere = hn(j)*hii*hdest(j,i)
          if( otshere.lt.0. ) then
            write(qq,'('' HydroOTS found negative OTS H 2l'',2i4,
     1      '' val='',1p,e10.1)')j,i , otshere
            call ShowMe
            stop
          endif
          call AddOTSLin( otshere , iphl(j,i) ,damp )
        end do
      end do
*
      end
