******************************************************************************
      subroutine HydroPesc
      implicit none
*evaluate escape and destruction probabilities for hydrogen lines
      include "ncell.par"
      include "itrdim.par"
      include "rydlam.par"
      include "limelm.par"
      include "nhlvl.par"
      include "opac.com"
      include "iphl.com"
      include "htau.com"
      include "htnext.com"
      include "hesc.com"
      include "hfrcin.com"
      include "he.com"
      include "h.com"
      include "phlevl.com"
      include "phycon.com"
      include "touton.com"
      include "trace.com"
      include "hyas.com"
      include "hlife.com"
      include "DoppVel.com"
      include "escdst.com"
      include "twoway.com"
      include "HEnrRyd.com"
      include "ZoneCnt.com"
      include "hstat.com"
      include "eovrlpVar.com"
      include "DstWght.com"
      include "IOqq.com"
*
*     local variables
      real branch,esin,dest,escla,damp,pop,eovrlp,
     1 hjbar,esa0k2,esccom,es , esout , tout ,
     2 OldPop(lmhlvl)
      logical lgTsave
      integer ihigh,ilow,i,j,ilo,ihi
      integer nzUsed
      save nzUsed , OldPop
*
*     real tmax
*     real fudge
*     integer iu,il
*     tmax(iu,il) = max( htlim(iu,il)/10., htlim(iu,il)-htnext(iu,il) )
*
*     free statement numbers >= 17
*
*     this this is 0th zone then use full destruction prob,
*     else use mean of old and new - NB must reset at end
      if( nzone.lt.1 ) DestWght = 1.
*
      if(lgTrace) then
        write(qq,'(10X,''HydroPesc called, DestWght='',1p,e10.2)')
     1  DestWght
      end if
*
*     >>chng 96 may 14 do not evaluate more than once
*     >>chng 96 may 16 evaluate every time
*     if( nzone.gt.0 .and. nzUsed.eq.nzone ) then
*       if(lgTrace)write(qq,'(10X,''HydroPesc not eval.'')')
*     endif
      nzUsed = nzone
*
      if( chEscFun.ne.'  K2'.and. chEscFun.ne.'INCO' .and. chEscFun.ne.
     1  'SIMP') then
        write(qq,'('' This is routine HydroPesc'')')
        write(qq,'('' Unknown escape prob func='',A4)')chEscFun
        stop
      endif
*
      lgTsave = lgTauOutOn
      lgTauOutOn = .true.
*
*     save level pops if starting
      if( nzone.le.1 ) then
        do i=1,nhlvl
          OldPop(i) = hn(i) * hii
        end do
      else
        do i=1,nhlvl
          OldPop(i) = OldPop(i)*0.75 + 0.25*hn(i)*hii
        end do
      endif
*     following if all neutral
      if( OldPop(1).le.0. ) OldPop(1) = hi
*
*     hydrogen lines opacity is function of A's
*     above 15 just use actual A's for high density limit
      do ihigh=4,min(15,nhlvl)
        do ilow=2,ihigh-1
          hyas(ihigh,ilow) = hlife(ihigh) * branch(ihigh,ilow)
*         make self-consistent opaciity
          hopac(ihigh,ilow) = hyas(ihigh,ilow) * 2.2448e-26 * 
     1    hstat(ihigh)/hstat(ilow) * (rydlam/HEnerRyd(ihigh,ilow))**3
        end do
      end do
*
*     this is kludge to get departure coef of highest level below unity
*     NB cannot have ilow=1 since in above only 2 and up are set
*     do ilow = 2,nhlvl-1
*       hyas(nhlvl,ilow) = hyas(nhlvl,ilow) * fudge(1)
*     end do
*
*     >>chng factor had been 0.98, changed to 0.9 to stop oscillations
      tout = htlim(2,1)*0.9 - htnext(2,1)
      if( tout.gt.0. ) then
        tout = htlim(2,1) - htnext(2,1)
        hesc(2,1) = escla( esin , dest , OldPop(1) )
        hesc(1,2) = hesc(2,1) * hyas(2,1)
        hdest(1,2) = dest*0.25 + 0.75*hdest(1,2)
*       >>chng 96 may 14 above did not have average
        hdest(2,1) = hyas(2,1) * hdest(1,2)
*       this is fraction of line which is inward escaping
        hfrcin(2,1) = min(1., max(0.,fracin ) )
      endif
*     >>chng 97 sep 13, moved following out of if
      hcont(2,1) = hjbar(2,1) * esa0k2(htnext(2,1)) * hyas(2,1)
*
      lgTauOutOn = lgTsave
*
*     Lyman lines special since always have outer optical depths
*     if( hii.gt.0. ) then
*       popl = hii * hn(1)
*     else
*       popl = hi
*     endif
      do ihigh=3,nhlvl
        damp = hdamp(ihigh) / doppler(1) / (1. - 1./float(ihigh*ihigh) )
        esin = esccom(htnext(ihigh,1),damp) 
        hcont(ihigh,1) = hjbar(ihigh,1) * esa0k2(htnext(ihigh,1)) *
     1  hyas(ihigh,1)
*       >>chng factor had been 0.98, changed to 0.9 to stop oscillations
        tout = htlim(ihigh,1)*0.9 - htnext(ihigh,1)
*       only change things if we have not overrun optical depth scale
        if( tout.gt.0. ) then
*         must use correct optical depth
          tout = htlim(ihigh,1) - htnext(ihigh,1)
          esout = esccom(tout, damp)
          hesc(ihigh,1) = 0.5*( esin + esout )
          hfrcin(ihigh,1) = min(1., max(0., esin*0.5 / hesc(ihigh,1) ))
          hesc(1,ihigh) = hesc(ihigh,1) * hyas(ihigh,1)
*         chDstFun default here is K2
*         >>chng 96 sep 4, changed explicit factors to DestWght option
          hdest(1,ihigh) = hdest(1,ihigh)*(1.-DestWght) + DestWght*
     1    eovrlp( OldPop(1) ,htnext(ihigh,1),htlim(ihigh,1) , damp ,
     2    hopac(ihigh,1), iphl(ihigh,1) , doppler(1) , hesc(ihigh,1) ,
     2    chDstFun)
          hdest(ihigh,1) = hyas(ihigh,1) * hdest(1,ihigh)
        endif
      end do
*
      if( lgTauOutOn ) then
*       outward optical depths defined
        do j=2,nhlvl-1
          do i=j+1,nhlvl
            if( htnext(i,j).lt.-30. ) then
              write(qq,'('' HYDROPESC:  H maser optical depth too '',
     1        ''small1,='',1p,e10.2,2i3)') htnext(i,j),i,j
              call ShowMe
              stop
            endif
            damp = hdamp(i) / doppler(1) / (1./float(j*j)-1./float(i*i))
*           this is used for pumping
            esin = esccom(htnext(i,j),damp) 
            hcont(i,j) = hjbar(i,j) * hyas(i,j) * esin
            tout = htlim(i,j)*0.9 - htnext(i,j)
*           only change things if we have not overrun optical depth scale
*           but also trap maser effects
            if( tout.gt.0. .or. htnext(i,j).lt.0. ) then
              if( chEscFun.eq.'  K2') then
                esin = esa0k2( htnext(i,j) )
*               must use correct optical depth
                tout = htlim(i,j) - htnext(i,j)
                esout = esa0k2( tout )
              else
                esout = esccom(tout,damp) 
              endif
              hesc(i,j) = 0.5*( esin + esout )
*             >>chng 96 sep 5, end had hesc(i,1) not correct i,j <= big bug
              hfrcin(i,j) = min(1., max(0., esin*0.5 / hesc(i,j) ))
              hesc(j,i) = hesc(i,j) * hyas(i,j)
*             destruction by background opacity
*             pop = max(0., hn(j) - hn(i)*float(j*j)/float(i*i) ) * hii
*             >>chng 96 may 16 from above to below
              pop = max(0., OldPop(j) - OldPop(i)*float(j*j)/float(i*i))
*             >>chng 96 sep 4, changed explicit factors to DestWght option
              hdest(j,i) = hdest(j,i)*(1.-DestWght) + DestWght*
     1        eovrlp( pop ,htnext(i,j),htlim(i,j) , damp ,
     2        hopac(i,j), iphl(i,j) , doppler(1) , hesc(i,j) ,chDstFun ) 
              hdest(i,j) = hyas(i,j) * hdest(j,i)
            endif
          end do
        end do
      else
*       not defined
        do j=2,nhlvl-1
          do i=j+1,nhlvl
            if( htnext(i,j).lt.-30. ) then
              write(qq,'('' HYDROPESC:  H maser optical depth too '',
     1        ''small2,='',1p,e10.2,2i3)') htnext(i,j),i,j
              call ShowMe
              stop
            endif
            damp = hdamp(i) / doppler(1) / (1./float(j*j)-1./float(i*i))
            esin = esccom(htnext(i,j),damp) 
            hcont(i,j) = hjbar(i,j) * hyas(i,j) * esin
            if( chEscFun.eq.'  K2') then
              esin = esa0k2( htnext(i,j) )
            else
              esout = esccom(htnext(i,j),damp) 
            endif
            hesc(i,j) = esin
            hfrcin(i,j) = 0.
            hesc(j,i) = hesc(i,j) * hyas(i,j)
*           pop = max(0., hn(j) - hn(i)*float(j*j)/float(i*i) ) * hii
*           >>chng 96 may 16 from above to below
            pop = max(0., OldPop(j) - OldPop(i)*float(j*j)/float(i*i))
*           destruction by background opacity
*           >>chng 96 sep 4, changed explicit factors to DestWght option
            hdest(j,i) = hdest(j,i)*(1.-DestWght) + DestWght*
     1      eovrlp( pop , htnext(i,j),htlim(i,j) , damp ,
     2      hopac(i,j), iphl(i,j) , doppler(1) , hesc(i,j) ,chDstFun )
            hdest(i,j) = hyas(i,j) * hdest(j,i)
          end do
        end do
      endif
*     >>chng 96 may 14 above made average of old and new dest probs
*     >>chng 96apr23 kill high min
*     highest level is a mess, set escape prob to one, actually a blend
*     if this is removed, then oscillations in totally optically thick
*     blr occur, for cases where all lines are optically thick
*     see model badbugs/bug0.in
      hesc(nhlvl,1) = max( hesc(nhlvl,1) , 0.1 )
      hesc(1,nhlvl) = hyas(nhlvl,1) * hesc(nhlvl,1)
      do i=2,nhlvl-1
        hesc(nhlvl,i) = max( hesc(nhlvl,i) , 1.0 )
        hesc(i,nhlvl) = hyas(nhlvl,i) * max( hesc(nhlvl,i) , 1.0 )
      end do
*
*begin sanity check
      do ilo=1,nhlvl-1
        do ihi=ilo+1,nhlvl
          if( hopac(ihi,ilo).le.0. ) then
            write(qq,'('' HydroPesc insane H opacity='',2i3,1p,e10.2)')
     1      ihi,ilo,hopac(ihi,ilo)
          endif
        end do
      end do
*end sanity check
*
*     electron scattering escape
      es = eden * 6.65e-25
      do ilo=1,nhlvl-1
       do ihi=ilo+1,nhlvl
          esesc(ihi,ilo) = min(1. , 5.9 * es / (es+hii*hn(ilo)*
     1    hopac(ihi,ilo)))*
     1    max( 0., 1.-hesc(ihi,ilo) - hdest(ihi,ilo)/hyas(ihi,ilo) )
          esesc(ilo,ihi) = esesc(ihi,ilo) * hyas(ihi,ilo)
        end do
      end do
*
      DestWght = DestWghtSave
*
      end
