******************************************************************************
      logical function lgEndFun()
      implicit none
*after each zone, determine whether model is complete
*
      include "ncell.par"
      include "lotsco.com"
      include "comneg.com"
      include "drneg.com"
      include "badstp.com"
      include "dr2sml.com"
      include "zonset.com"
      include "tautot.com"
      include "nhlvl.par"
      include "htau.com"
      include "dump.com"
      include "efrend.com"
      include "IterCnt.com"
      include "cpres.com"
      include "nlines.par"
      include "sum.com"
      include "mxstpl.par"
      include "trace.com"
      include "cldnEXP.com"
      include "ndust.par"
      include "toiii.com"
      include "timed.com"
      include "MapPar.com"
      include "TePowers.com"
      include "phycon.com"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "stphit.com"
      include "tauend.com"
      include "colend.com"
      include "endedn.com"
      include "prad.com"
      include "radius.com"
      include "drnxt.com"
      include "called.com"
      include "only.com"
      include "pstart.com"
      include "velpos.com"
      include "drminu.com"
      include "lastit.com"
      include "trovrd.com"
      include "reason.com"
      include "StopLine.com"
      include "TrConvg.com"
      include "IOqq.com"
*
*     local variables
      logical lgDone , lgPrinted
      integer i
*     following used to ensure outer radius not exceeded
      real eps
      parameter (eps=1.00001)
*
*     free statement labels >=2
*
      if( lgTrace ) write(qq,'('' lgEndFun called.'')')
*
*     >>chng 97 june 9, now called before first zone with nozne 0
      if( nzone.eq.0 ) then
        lgEndFun = .false.
        return
      endif
*
*     check whether trace is needed for this zone and iteration
      if( nzone.ge.nznbug .and. iter.ge.npsbug .and. lgTrOvrd) then
        nprint = 1
        lgTrace = .true.
      endif
*
*     option to turn printout on after certain zone
      if( lgPrtStart .and. nstart.eq.nzone ) then
        lgTalk = .true.
      endif
*
*     check whether model is done, various criteria used.
      lgDone = .false.
*     this is flag to chekc whether stopping reason was bad
      lgBadStop = .false.
*
*     >>chng 97 july 23, from last iteration only, to any greater than 1
*     >>chng 97 july 23, back again to original
      if( lgRadPresON .and. pbeta.gt.1.0 .and. chCPres.eq.'CPRE' .and.
     1  lgLastIt ) then
*    1  iter.gt.1 ) then
*       const total pres model; if RadPres>PGAS, then unstable, stop
        if( lgTalk ) then
          write(qq,'(/,'' STOP since P(rad)/P(gas)='',F7.3,'' >1.0'')'
     1    ) pbeta
          if( plines(1)/RadPres.gt.0.9 ) then
            write(qq,'('' Caused by Ly-alpha.'')')
          else
            write(qq,'('' Line contributors to radiation pressure '',
     1      ''follows:'')')
            call PrtLinePres
          endif
        endif
        lgDone = .true.
        lgBadStop = .true.
        chReason = 'of radiation pressure'
*
      else if( .not.lgVelPos ) then
*       wind solution with negative velocity
        lgDone = .true.
        chReason = 'wind veloc too small '
*
      else if( lgBusted ) then
*       calculation failed
        lgBadStop = .true.
        lgDone = .true.
        chReason = 'code returned BUSTED '
*
      else if( lgLotsCO ) then
*       all carbon in CO
        lgDone = .true.
        chReason = 'carbon fully moleculr'
*
      else if( lgComNeg ) then
*       heavy element molecule solution with negative population
        lgDone = .true.
        lgBadStop = .true.
        chReason = 'negative mole abundan'
*
      else if( lgdR2Small                      )  then
        lgDone = .true.
        lgBadStop = .true.
        chReason = 'DR small rel to thick'
*
      else if( eden   .lt. StopElecDensity    )  then
        lgDone = .true.
        chReason = 'lowest EDEN reached. '
*
      else if( eden/hden.lt. StopElecFrac  )  then
        lgDone = .true.
        chReason = 'low electron fraction'
*
      else if( lgDrMinUsed                  )  then
*       dr became too small
        lgBadStop = .true.
        lgDone = .true.
        chReason = 'DRAD small- set DRMIN'
*
      else if( depth.ge.router(iter)/eps.or.lgDrNeg  )  then
        lgDone = .true.
        chReason = 'outer radius reached.'
*
      else if(iptnu.ne.ncell.and. 
     1  tauabs(iptnu,1) .ge.tauend/eps )  then
        lgDone = .true.
        chReason = 'optical depth reached'
*
      else if( colden .ge. HColStop/eps    )  then
        lgDone = .true.
        chReason = 'column dens reached. '
*
      else if( chii .ge. colpls/eps        )  then
        lgDone = .true.
        chReason = 'column dens reached. '
*
      else if( chi .ge. colnut/eps         )  then
        lgDone = .true.
        chReason = 'column dens reached. '
*
      else if( te     .gt. T2High          )  then
        lgDone = .true.
        chReason = 'highest Te reached.  '
*
      else if( te     .lt. tend            )  then
        lgDone = .true.
        chReason = 'lowest Te reached.   '
*
      else if( nzone  .ge. nend(iter)     )  then
        lgDone = .true.
        lgZoneTrp = .true.
        chReason = 'NZONE reached.       '
*
      else if( nstpl      .gt.0            )  then
*       line ratio exceeded maximum permitted value
*       do not consider case where norm line has zero intensity
        do i=1,nstpl
          if( sumlin(ipStopLin2(i)) .gt.0. ) then
            if(sumlin(ipStopLin1(i))/sumlin(ipStopLin2(i)).gt.stpint(i))
     1        then
              lgDone = .true.
              write(chReason,'(''line'',i5,'' reached.   '')')
     1        LineStopWl(i)
            endif
          endif
        end do
*
      else if( drNext.le.0. ) then
*       this cant happen
        if(lgTalk) write(qq,'('' drNext='',1P,E10.2,'' STOP'')') drNext
        lgDone = .true.
        lgBadStop = .true.
        chReason = 'internal error - DRAD'
        call ShowMe
      endif
*
      lgPrinted = .false.
      if( lgDone ) then
*       flag to call it quits
        lgEndFun = .true.
        call prstep
        lgPrinted = .true.
      else
*       passed all the tests, keep going
*       time dependent model of this zone?
        if( itime .eq. nzone ) then
          call timer
          stop
        endif
*       check whether this zone should be printed
        if( (nzone/nprint)*nprint.eq.nzone  .or.  nzone.eq.1
     1  .or. lgTrConvg ) then
          call prstep
          lgPrinted = .true.
        endif
*       flag to keep going
        lgEndFun = .false.
      endif
*
*     dump cooling arrays for this zone?
      if( nzdump.eq.nzone .or. nzdump.eq.0 ) call dmpary
*
*     do map of cooling function if desired
      if( MapZone .lt. 0 .or. nzone.eq.MapZone ) then
*       print last zone if not already done
        if( .not.lgPrinted ) call prstep
        call punt(' map')
*       stop after doing map
        lgEndFun = .true.
        chReason = 'MAP command used-stop'
        return
      endif
*
      if( lgEndFun .and. lgOnlyZone ) then
        stop
      endif
*
      end
