******************************************************************************
      integer function LimitSh( ion , nshell , nelem ) 
      implicit none
*sets upper limit to subshell integrations
      integer nelem
      integer ion , nshell
      include "limelm.par"
      include "KshllEnr.com"
      include "NumUpper.com"
      include "ipElement.com"
      include "IOqq.com"
*
*     this routine returns the high energy limit to the energy range
*     for photoionizatin of a given shell
*
      if( nshell.eq.1 ) then
*       this limit is high energy limit to code unless changed with set kshell
        LimitSh = KshellLimit
*
      else if( nshell.eq.2 ) then
*       this is 2s shell, upper limit is 1s
*     >>chng 96 oct 8, up to high energy limit
*       LimitSh = ipElement(nelem,ion , 1,1)-1
        LimitSh = KshellLimit
*
      else if( nshell.eq.3 ) then
*       this is 2p shell, upper limit is 1s
*     >>chng 96 oct 8, up to high energy limit
*       LimitSh = ipElement(nelem,ion , 1,1)-1
        LimitSh = KshellLimit
*
      else if( nshell.eq.4 ) then
*       this is 3s shell, upper limit is 2p
*     >>chng 96 oct 8, up to K-shell edge
*       LimitSh = ipElement(nelem,ion , 3,1)-1
        LimitSh = ipElement(nelem,ion , 1,1)-1
*
      else if( nshell.eq.5 ) then
*       this is 3p shell, upper limit is 2p
*     >>chng 96 oct 8, up to K-shell edge
*       LimitSh = ipElement(nelem,ion , 3,1)-1
        LimitSh = ipElement(nelem,ion , 1,1)-1
*
      else if( nshell.eq.6 ) then
*       this is 3d shell, upper limit is 2p
*     >>chng 96 oct 8, up to K-shell edge
*       LimitSh = ipElement(nelem,ion , 3,1)-1
        LimitSh = ipElement(nelem,ion , 1,1)-1
*
      else if( nshell.eq.7 ) then
*       this is 4s shell, upper limit is 3d
        if( ipElement(nelem,ion , 6,1).lt.3 ) then
*         this is check for empty shell 6, 3d
*         if so then set to 3p instead
          LimitSh = ipElement(nelem,ion , 5,1)-1
        else
          LimitSh = ipElement(nelem,ion , 6,1)-1
        endif
*     >>chng 96 sep 26, set upper limit down to 2s
        LimitSh = ipElement(nelem,ion , 3,1)-1
*
      else
        write(qq,'('' LimitSh cannot handle nshell as large as'',i4)')
     1  nshell
        stop
      endif
*
      end
