******************************************************************************
      subroutine lindst(xInten , lam , chLab , ipnt , chInfo, lgOutToo)
      implicit none
*add local line intensity to line luminosity stack
      real xInten
      logical lgOutToo
      character chLab*4 , chInfo*1
      integer lam , ipnt
*
      include "nlines.par"
      include "en1ryd.par"
      include "ndust.par"
      include "ncell.par"
      include "opac.com"
      include "VolRef.com"
      include "tmn.com"
      include "rfield.com"
      include "reflec.com"
      include "ots.com"
      include "scatop.com"
      include "sumlab.com"
      include "tautot.com"
      include "dRdVeff.com"
      include "smdlab.com"
      include "dsum.com"
      include "sum.com"
      include "linsum.com"
      include "called.com"
      include "dstfac.com"
      include "exptau.com"
      include "IOqq.com"
*
*     local variables
      real e2fn,e2
*
*     albeff(ip) = scatop(ip) / (scatop(ip) + opac(ip) )
*
      nsum = nsum + 1
      if( ipass .ne. 0) then
*       not first pass, sum lines only
        sumlin(nsum) = sumlin(nsum) + xInten * dVeff
        emslin(nsum) = xInten
*       add line to outward beam
        if( lgOutToo ) then
*         >>chng 97 sep 02, add tmn
          outlin(ipnt) = outlin(ipnt) + xInten/(anu(ipnt)*en1ryd) *
     1    OutFac *
     2    tmn(ipnt)
          reflin(ipnt) = reflin(ipnt) + xInten/(anu(ipnt)*en1ryd) *
     1    RefFac
        endif
      else
*       check if number of lines in arrays exceeded
        if( nsum.gt.NLINES) then
          if( lgTalk ) write(qq,'(I5,'' lines is too many for LINADD.''
     1    )') nsum
          write(qq,'('' Increase the value of NLINES everywhere '',
     1    ''in the code.'')')
          stop
        endif
*
        if( chInfo.ne.'c'.and.chInfo.ne.'h'.and.chInfo.ne.'i' .and.
     1  chInfo.ne.'r' ) then
          write(qq,'('' Type label for line'',I5,A4,'' is '',A1,
     1    '' which I do not understand.'')') lam,chLab,chInfo
        endif
        chSumTyp(nsum) = chInfo
*       number of lines ok, set parameters for first pass
        sumlin(nsum) = 0.
        lin(nsum) = lam
        chALab(nsum) = chLab
      endif
*
*     this is dust part
      if( lgDustOn ) then
        ndsum = ndsum + 1
        if( ipass .ne. 0) then
*         not first pass, sum lines only
*         evaluate 2nd exponential integral function
*         >>chng 97 nov 5, some variables not defined above nflux
          if( ipnt.le.nflux ) then
            e2fn = e2( tauabs(ipnt,1) , ExpmTau(ipnt) )
*           DSTOTH was unit vol energy lost onto dust by cooling lines
*           dstoth = dstoth + xInten * (1.-e2fn)
            smdlin(ndsum) = smdlin(ndsum) + xInten * dVeff / 2. *
     1      (1. + albedo(ipnt) ) * e2fn
          endif
        else
*         check if number of lines in arrays exceeded
          if( ndsum.gt.NLINES) then
            write(qq,'(I5,'' lines is too many for LINDST'')') ndsum
            write(qq,'('' Increase the value of NLINES everywhere '',
     1      ''in the code.'')')
            stop
          endif
*         number of lines ok, set parameters for first pass
          smdlin(ndsum) = 0.
          lind(ndsum) = lam
          chSMDLab(ndsum) = chLab
        endif
      endif
*
      end
