******************************************************************************
* note - order of routines in this file is important since hazy iv
* gets a table from here.  do not split this file into pieces.
******************************************************************************
      subroutine LineSet1
      implicit none
*put energetics, H, and He lines into line intensity stack
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "ncell.par"
      include "bltzman.par"
      include "nlines.par"
      include "en1ryd.par"
      include "rydlam.par"
      include "dclgas.com"
      include "heots.com"
      include "nta.par"
      include "limelm.par"
      include "ndust.par"
      include "ipLnArry.par"
      include "FeIIAtom.com"
      include "totlum.com"
      include "dRdVeff.com"
      include "cover.com"
      include "hesc.com"
      include "hyas.com"
      include "linsum.com"
      include "covib.com"
      include "h.com"
      include "phlevl.com"
      include "iphl.com"
      include "heat.com"
      include "heating.com"
      include "heatlmax.com"
      include "hetmet.com"
      include "he1ex.com"
      include "he2ex.com"
      include "he.com"
      include "HTopOff.com"
      include "hfrcin.com"
      include "smbeta.com"
      include "phycon.com"
      include "logte.com"
      include "pair.com"
      include "coolng.com"
      include "hextra.com"
      include "dphoht.com"
      include "dustheat.com"
      include "hmihet.com"
      include "comptn.com"
      include "chrex.com"
      include "ffheat.com"
      include "HLineTot.com"
      include "he2fin.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "he1tau.com"
      include "heinwd.com"
      include "he3c.com"
      include "he3tuEXP.com"
      include "hetrpEXP.com"
      include "dtrans.com"
      include "sphere.com"
      include "cionhe.com"
      include "codish.com"
      include "h2pcng.com"
      include "h2dish.com"
      include "HFBNet.com"
      include "dhla.com"
      include "widflx.com"
      include "diffus.com"
      include "rfield.com"
      include "mev.com"
      include "dstfe2.com"
      include "strkar.com"
      include "hem.com"
      include "hahmin.com"
      include "htau.com"
      include "x12.com"
      include "TePowers.com"
      include "rin2ph.com"
      include "hcaseb.com"
      include "reflec.com"
      include "r1r0sq.com"
      include "ots.com"
      include "PredCont.com"
      include "KatyaDat.com"
      include "trace.com"
      include "sum.com"
      include "ip626.com"
      include "iphe1l.com"
      include "iphe2l.com"
      include "IOqq.com"
*
*     local variables
      real hbf,hbetab,eryd , hbetac , hlalph , dhtot , pump,
     1 e626,e228,e504,e584,e911,spfac,sexp,hebf  , ConRef ,
     2 cb206,f10830,flow , eff , em,rec,pop,col,totl,
     3 cb5016 , halpha , sum, fac , ConIn , ConOt
      integer i , nd , low,iup , ipnt
*
      if( lgTrace ) write(qq,'(''   LineSet1 called'')')
*
*     initialize ExtraInten with a zero
      call PutExtra( 0. )
*
*     option to punch out FeII atom
      if( chFeIIAtom.eq.'Verner'.and..not.lgSimKatya ) then
        call Fe2Lines('add' , 0. )
      endif
*
*     total H-beta from multi-level atom
      eryd = (1./float(2*2)-1./float(4*4))
      hbetac = hii*hn(4)*hemis(4,2)*en1ryd*eryd
*     these lines added to outlin in metdif - following must be false
      call lindst( hbetac , 4861 , 'TOTL' , iphl(4,2) ,'i',.false.)
*
*     total Ly-a from multi-level atom
      hlalph = hii*hn2p *hemis(2,1)*1.634e-11
      call linadd( hlalph , 1216 , 'TOTL','i')
      totlsv = totlsv / dVeff * covgeo
*
*     someday, put in 21 cm, A from Gould, ApJ 423, 522, =2.88426e-15 s-1
*
*     total luminosity in incident continuum
      call linadd( totlsv , 0 , 'Inci' , 'i' )
      totlsv = totlsv * dVeff / covgeo
*
*     ipass is flag to indicate whether to only set up line array
*     (ipass=0) or actually evaluate lines intensities (ipass=1)
      if( ipass.ne.0 ) totlsv = 0.
*
*     total heating, all forms, information since individuals added later
      call linadd( htot , 0 , 'TotH','i')
*
*     hydrogen photoionization heating, ground state only
      call linadd( heating(1,1) , 0 , 'BFH1','h')
*
*     net hydrogen photoionization heating less rec cooling, all excited states
*     normally zero, positive if excited states are net heating
      call linadd( heating(1,2)  , 0 , 'BFHx','h')
      if(htot.gt.0.) then
        if( heating(1,23)/htot .gt.heatlmax ) then
          heatlmax = heating(1,23)/htot
          call GetMaxhLine
        endif
      endif
*
*     heating due to induced lines absorption of continuum
      call linadd( heating(1,23)  , 0 , 'Line','h')
*
*     net cooling due to collisional ionization of Heo
      call linadd( max(0.,he1ex*heii ) , 0 , 'He1i','c')
*
*     this is the heating due to 3-body recombination
      call linadd( max(-he1ex*heii ,0.) , 0 , '3He1','h')
*
*     net cooling due to collisional ionization of He+
      call linadd( max(0.,he2ex*heiii ) , 0 , 'He2i','c')
*
*     this is the heating due to 3-body recombination
      call linadd( max(-he2ex*heiii ,0.) , 0 , '3He2','h')
*
*     total helium photoionization heating, all stages
      call linadd( heating(2,1)+heating(2,2)+heating(2,3),0,'BFHe','h')
*
*     total heavy element photoionization heating, all stages
      call linadd( hetmet , 0 , 'TotM','h')
*
*     net free-free cooling, nearly cancels with cooling in lte
      call linadd(max(0.,HFFNet) , 0 , 'HFFc','c')
*
*     net free-free heating, nearly cancels with cooling in lte
      call linadd(max(0.,-HFFNet) , 0 , 'HFFh','h')
*
*     H brems (free-free) cooling
      call linadd(hbrems , 0 , 'H FF','i')
*
*     total free-free heating
      call linadd( FreeFreeHeat , 0 , 'FF H','i')
*
*     charge exchange cooling
*     call linadd( chrexCool , 0 , 'Hchr' , 'c' )
*
*     Compton heating
      call linadd( real(cmheat) , 0 , 'ComH','h')
*
*     H- heating
      call linadd( max(0.,hmihet) , 0 , 'H- H','h')
*
*     induced H- cooling
      call linadd( max(0.,-hmihet) , 0 , 'H-Hc','c')
*
      dhtot = 0.
      do nd=1,ndust
        dhtot = dhtot + dheat(nd)
      end do
      TotalDustHeat = TotalDustHeat + dhtot * dVeff
      dphmax = max( dhtot/htot , dphmax )
      h2pmax = max( h2pmax , heating(1,17) /htot )
*     gas heating by grain photoionization
      call linadd( dhtot , 0 , 'GrGH' ,'h')
*
*     heating/cooling due to charge transfer
      call linadd( max(0.,heating(1,25) ), 0 , 'CT H' , 'h' )
      call linadd( max(0.,-heating(1,25)), 0 , 'CT C' , 'c' )
*
      dclmax = max( dclmax , DustCoolGas/htot )
*     gas cooling by grain collisions
      call linadd( DustCoolGas , 0 , 'GrGC' ,'c')
*
*     "extra" heat added to this zone, from HEXTRA command
      call linadd( hxtot , 0 , 'extH' ,'h')
*
*     "extra" cooling added to this zone, from CEXTRA command
      call linadd( cextxx , 0 , 'extC' ,'c')
*
*     heating due to pair production
      call linadd( pair , 0 , 'pair', 'h' )
*
*     H beta recombination, assuming case B
      hbetab = (10.**(-20.89-0.10612*(alogte-4.4)**2))/te*hii*eden
      call linadd( hbetab , 4861 , 'Ca B','i')
*
*     case b intensity of Ly-alpha, no two photon
      call linadd(HRecRad*eden*hii*1.64e-11, 1216 , 'Ca B' ,'i')
*
*     H-beta computed from Q(H) and specified covering factor
      smbeta = smbeta / dVeff * covgeo
      call linadd( smbeta , 4861 , 'Q(H)' ,'i')
*
*     Ly-alpha from Q(H), high-dens lim, specified covering factor
      call linadd( smbeta*34.19 , 1216 , 'Q(H)' ,'i')
      smbeta = smbeta * dVeff / covgeo
      if( ipass.ne.0 ) smbeta = 0.
*
*     total Ly-a from multi-level atom
      hlalph = hii*hn2p *hemis(2,1)*1.634e-11
*     these lines added to outlin in metdif - following must be false
      call lindst( hlalph , 1216 , 'TOTL',iphl(2,1),'i',.false.)
*
*     inward part of Lya
      hlalph = hlalph * hfrcin(2,1)
      call linadd( hlalph , 1216 , 'Inwd', 'i')
*
*     do not put in distubed high levels
      do low=1,min(nHTopOff-2,nhlvl-2)
*
*       do not have n=2 since population of hn(2) is 2s+2p
*       highest level is way overpopulated due to top-off of
*       finite atom - do not predict its intensity
        do iup=max(3,low+1),min(nHTopOff-1,nhlvl-1)
          eryd = (1./float(low*low)-1./float(iup*iup))
          halpha = hii*hn(iup)*hemis(iup,low)*en1ryd*eryd
          i = rydlam/eryd
          if( i.gt.99999 ) i = i / 10
*         these lines added to outlin in metdif - following must be false
          call lindst( halpha,i,'TOTL',iphl(iup,low) ,'r',.false.)
          halpha = halpha * hfrcin(iup,low)
          call linadd( halpha,i,'Inwd','i')
        end do
      end do
*
*     total collisional cooling due to all hydrogen lines
      call linadd( max(0.,HLineTotCool) , 912,'Clin' , 'c')
*
*     total collisional heating due to all hydrogen lines
      call linadd( max(0.,-HLineTotCool) , 912,'Hlin' , 'h')
*
*     2-photon two photon emission from multi-level atom
      call linadd( hii*hn2s *8.23      *1.634E-11 ,    0 , '2 NU','r')
*
*     la contribution from suprathermal secondaries from ground
      call linadd(x12*hii*hn(1)*1.634e-11,1216,'LA X','i')
*
*     H-alpha produce by H- mutual neutralization
      call linadd( HalphaHmin *3.032E-12,6563,'H-CT','i')
*
*     "Ly alpha" produced by induced two photon
      call linadd( hn2s*hii*ri2s1s *1.634E-11,1216,'Ind2','i')
*
*     H-beta produced by continuum pumping in optically thin ld limit
      pump = hcont(4,1) * hn(1)*hii * 4.09e-12 * 0.4836 * 16.
      call linadd( pump , 4861 , 'Pump','r')
*
*     CHION is HEX*HII (in COOLR) and is net col ionz-3 body heat
*     collision ionization cooling of hydrogen
      call linadd( max(0.,chion) , 0 , 'CION','c')
*
*     this is the heating due to 3-body recombination
      call linadd( max(-chion,0.) , 0 , '3bHt','h')
*
*     Stark broadening contribution to line
      call linadd( hii*hn2p*pestrk(1,2)*1.634E-11 , 1216 , 'Strk','i')
*
*     Stark broadening contribution to line
      call linadd(hii*hn(3)*pestrk(2,3)*3.025E-12 , 6563  ,'Strk','i')
*
*     Stark broadening contribution to line
      call linadd(hii*hn(4)*pestrk(2,4)*4.084E-12 , 4861 , 'Strk','i')
*
*     Stark broadening contribution to line
      call linadd(hii*hn(4)*pestrk(3,4)*1.059E-12 ,18751 , 'Strk','i')
*
*     Stark broadening contribution to line
      call linadd(hii*hn(5)*pestrk(4,5)*4.900E-13 ,40512 , 'Strk','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd( hii*hn2p*hdest(2,1)*1.634E-11, 1216,'Dest','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd(hii*hn(3)*hdest(3,2)*3.025E-12, 6563,'Dest','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd(hii*hn(5)*hdest(5,4)*4.915E-13,40516,'Dest','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd(hii*hn(4)*hdest(4,2)*4.084E-12, 4861,'Dest','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd(hii*hn(4)*hdest(4,3)*1.059E-12,18751,'Dest','i')
*
*     Ly-alpha destroyed by overlap with FeII
      call linadd(hn2p*hii*hyas(2,1)*dstfe2lya*1.637E-11 ,
     1 1216 , 'Fe 2' , 'i' )
*
*     electron scattering escape contribution to line
      call linadd( hii*hn2p*esesc(1,2)*1.634E-11 , 1216 , 'e sc','i')
*
*     electron scattering escape contribution to line
      call linadd( hii*hn(3)*esesc(2,3)*3.03E-12 , 6563 , 'e sc','i')
*
*     electron scattering escape contribution to line
      call linadd( hii*hn(4)*esesc(2,4)*4.09E-12 , 4861 , 'e sc','i')
*
*     electron scattering escape contribution to line
      call linadd( hii*hn(4)*esesc(3,4)*1.06E-12 ,18751 , 'e sc','i')
*
*     electron scattering escape contribution to line
      call linadd( hii*hn(5)*esesc(4,5)*4.91E-13 ,40512 , 'e sc','i')
*
*     511keV annihilation line
      hbf = (hden+4.*ahe)*posrat*2.*8.20E-7
      call PntForLine( 2.427e-2 , 'e-e+' , ipnt )
      call lindst(hbf,511,             'e-e+',ipnt,'i', .true.)
*     call linadd( (hden+4.*ahe)*posrat*2.*8.20E-7 , 511 ,'e-e+','i')
*
*     free-found transitions
      if( te.lt.1e4 ) then
         hbf = 3.64e-25*sexp(5584./te)
      else if( te.lt. 5e4 ) then
         hbf = 2.15e-25
      else
         hbf = 1.66e-24 / te10 / te10 * te01
      endif
      if(heiii.gt.0. ) then
        if( te.lt.2500. ) then
          hebf = 1.24e-23*sexp(4760./te)
        else if( te.lt.5000. ) then
          hebf = 1.85e-24
        else
          hebf = 2.57e-23 / te10/te10/te10
        endif
      else
        hebf = 0.
      endif
*
*     hbnuf1 = (Hy2nu(iphl(4,2))/widflx(iphl(4,2)))*0.75/2.*hn2s*hii*
*    1 anu(iphl(4,2))*
*    1 en1ryd  + (hii+heii)*eden*hbf + heiii * eden * hebf
*
*     this is diffuse emission computed by code
*     hbnufn = DiffCont( iphl(4,2) )/widflx(iphl(4,2))*en1ryd*
*    1 anu(iphl(4,2))**2
*     diffuse cont-nu.fnu(4862) due to all computed emission processes
*     call linadd( hbnufn, 4862 , 'nFnu' ,'i')
*
*     hbnufn = DiffCont( iphl(2,1) )/widflx(iphl(2,1))*en1ryd*
*    1 anu(iphl(2,1))**2
*     diffuse cont-nu.fnu(1212) due to all computed emission processes
*     call linadd( hbnufn, 1212 , 'nFnu' ,'i')
*
*     predict emitted continuum at series of continuum points
      do i=1,nPredCont
*       reflected toal continuum (dif+incident emitted inward direction)
        ConRef = refcon(ipPredCont(i))/widflx(ipPredCont(i))*
     1  anu2(ipPredCont(i))*en1ryd
*       reflected part of INCIDENT continuum (only incident)
        ConIn = reflux(ipPredCont(i))/widflx(ipPredCont(i))*
     1  anu2(ipPredCont(i))*en1ryd
*       outward continuum
        ConOt = outcon(ipPredCont(i))/widflx(ipPredCont(i))*
     1  anu2(ipPredCont(i))*en1ryd*r1r0sq
*       this is wavelength in Angstroms, energies stored in EnrPredCont
        low = rydlam / EnrPredCont(i)
*       some are hundreds of microns, overflows in printout, cnvrt to microns
        if( low.gt. 100 000 ) low = low / 10 000
        sumlin(nsum+1) = 0.
*       total continuum produced by cloud at selected energy points
        call linadd( (ConRef+ConOt)/dVeff, low , 'nFnu' ,'i')
*       change to get correct emissivity
        emslin(nsum) = DiffCont(ipPredCont(i))/widflx(ipPredCont(i))*
     1  anu2(ipPredCont(i))*en1ryd
        sumlin(nsum+1) = 0.
*       total reflected continuum, total inward emission plus
*       reflected diffuse continuum
        call linadd( ConRef        /dVeff, low , 'InwT' ,'i')
*       change to zero this emissivity
        emslin(nsum) = 0.
        sumlin(nsum+1) = 0.
*       reflected incident continuum (only incident)
        call linadd( ConIn         /dVeff, low , 'InwC' ,'i')
*       change to zero this emissivity
        emslin(nsum) = 0.
*	write(qq,'(i6)') low
      end do
*	stop
*
*     now find incident continuum
      cn4861 = cn4861 / dVeff
*
*     incident continuum nu*f_nu at H-beta, at illuminated face of cloud 
      call linadd( cn4861 , 4860 , 'Inci' ,'i')
      cn1216 = cn1216 / dVeff
*
*     incident continuum nu*f_nu near Ly-alpha, at illuminated face of cloud
      call linadd( cn1216 , 1215 , 'Inci' ,'i')
      cn1216 = cn1216 * dVeff
      cn4861 = cn4861 * dVeff
      if( ipass.ne.0 ) then
        cn4861 = 0.
        cn1216 = 0.
      endif
*
*     >>chng 96 june 13, had been hrec(2,2)
*     integrated Balmer continuum emission
      flow = (hrec(2,1)+hrec(nhlvl+1,1))*hrec(2,3)*eden*hii*5.45e-12
      call linadd( flow , 0,'Ba C','i')
*
*     >>chng 96 june 13, had been hrec(3,2)
*     Paschen continuum emission
      call linadd(hrec(3,1)*hrec(3,3)*eden*hii*3.53e-12 , 0 ,'PA C','i')
*
*     total grain heating by all sources, lines, collisions, incident continuum
      call linadd( dstotl , 0 , 'GraT' ,'i')
*
*     grain heating by incident continuum
      call linadd( dincon , 0 , 'GraI' ,'i')
*
*     grain heating due to destruction of Ly alpha 
      call linadd( DustHeatLya , 1216 , 'GraL' ,'i')
*
*     grain heating due to collisions with gas
      call linadd( dhcol , 0 , 'GraC' ,'i')
*
*     grain heating due to diffuse fields, may also have grain emission
      call linadd( HDustDif , 0 , 'GraD' ,'i')
*
*     part of H brems, in x-ray beyond 0.5KeV
      call linadd((hbrems+bhe)*sexp(5.8e6/te) , 0 , 'FF X','i')
*
*     total Compton cooling
      call linadd( tccool , 0 , 'ComC','c')
*
*     expansion cooling, only non-zero for wind
      call linadd( expans , 0 , 'Expn','c' )
*
*     electron - electron brems
      call linadd( eebrm , 0 , 'eeff','c')
*
*     H recombination cooling
      call linadd( hrecem , 0 , 'H FB','i')
*
*     net free-bound cooling and heating
      call linadd(max(0.,HFreBndNet) , 0 , 'HFBc','c')
      call linadd(max(0.,-HFreBndNet) , 0 , 'HFBh','h')
*
*     cooling due to induced rec of hydrogen
      call linadd( crcind , 0 , 'Hind','c')
*
*     cooling due to induced rec of fully ionized helium
      call linadd( c3ind , 0 , '3He2','c')
*
*     cyclotron cooling
      call linadd( cyntrn , 0 , 'Cycn' ,'c')
*
*     changed from info to cooling june 25 95 to pick this up in primal.in
*     collisionally excited La cooling
      call linadd( max(0., coola),  1216 , 'Cool','i')
*
*     collisionally de-excited La heating
      call linadd( max(0.,-coola),  1216 , 'Heat','i')
*
*     cooling due to n>2 Lyman lines
      call linadd( max(0., restly),  960 , 'Crst','i')
*
*     heating due to n>2 Lyman lines
      call linadd( max(0.,-restly),  960 , 'Hrst','i')
*
*     cooling due to n>3 Balmer lines
      call linadd( max(0., barest), 4861 , 'Crst','i')
*
*     heating due to n>3 Balmer lines
      call linadd( max(0.,-barest), 4861 , 'Hrst','i')
*
*     cooling due to higher Paschen lines
      call linadd( max(0., hrest) ,  0   , 'Crst','i')
*
*     heating due to higher Paschen lines
      call linadd( max(0.,-hrest) ,  0   , 'Hrst','i')
*
*     H2 rotation lines from Lepp and Shull ApJ 270, 578.
      call linadd( h2line , 2 , 'H2 l','c')
*
*     H2 dissociation by H atoms (not e)
      call linadd( h2dis , 0 , 'H2dC','c')
*
*     molecular hydrogen heating
      h2dtot = h2dtot + HeatH2Dish * dVeff
      h2dfrc = max( HeatH2Dish/htot , h2dfrc )
*
*     heating by H2 dissociation by Lyman continuum
      call linadd( HeatH2Dish , 0 , 'H2dH','h')
*
*     neg H ion free-bound emission
      call linadd( hmfb , 0 , 'H-FB' ,'c')
*
*     H+ + H => H2+ + photon continuum cooling
      call linadd( H2PlsCool , 0 , 'H2+ ','c')
*
*     HeH+ formation cooling
      call linadd(max((3.27E-12+te*Boltzmann),0.)*hii*hei*1e-20+
     1(1.76E-11+te*Boltzmann )*hi*heii*1e-16 , 0 , 'HEH+','i')
*
*     carbon monoxide heating
      codtot = codtot + CODissHeat * dVeff
      codfrc = max( CODissHeat/htot , codfrc )
*
*     carbon monoxide co photodissociation
      call linadd( CODissHeat , 0 , 'COdh' , 'h')
*
*     cooling due to coll of vib rot levels
      call linadd( COVibCool , 0 , 'CO C' , 'c' )
*
*     He brems emission
      call linadd(bhe , 0 , 'HeFF','c')
*
*     He recombination cooling
      call linadd(herec , 0 , 'HeFB','c')
*
*     heavy element recombination cooling
      call linadd( heavfb , 0 , 'MeFB' ,'c')
*
*     metal brems emission
      call linadd( heavff , 0 , 'MeFF','c')
*
*     total brems emission
      call linadd((hbrems+bhe+heavff) , 0 , 'ToFF' ,'i')
*
*     He I triplet net collisional ionization cooling
      call linadd( max(0.,He3IonCool) , 0 , 'He3I','c')
*
*     He I triplet net 3-body heating
      call linadd( max(0.,-He3IonCool) , 0 , 'He3b','h')
*
*     He I 584, collisional excitation cooling
      call linadd( max(0.,c584) , 584 , 'HeIC','c')
*
*     He I 584, collisional de-excitation heating
      call linadd( max(0.,-c584) , 584 , 'HeIH','h')
*
*     total 584 emergent from cloud in inner direction
*     now compute emergent Helium emergent flux
      if( lgSphere ) then
        spfac = 0.5
        e911 = 0.
        e584 = 0.
        e626 = 0.
        e228 = 0.
        e504 = 0.
      else
        spfac = 1.
        if( chDffTrns(1:2).eq.'OU' ) then
          eff = 0.5
        else
          eff = 1.
        endif
        e504 = esc504 / 2. * 3.95e-11 * eff
*       this is inward looking tau but no fac of two in original defn
        e584 = esc584 / 2. * 3.41e-11 /2.
*       this looked to illuminated face and does not need extra factor
        e626 = esc626 * 3.18e-11
        e911 = esc911 * 2.18e-11 * eff
        e228 = esc228 * 8.72e-11 * eff
      endif
*
*     He I rec to ground escaping cloud
      call linadd( e504 , 504 , 'He I' ,'i')
*
*     He I Ly alpha escaping cloud
*     call linadd( e584 , 584, 'esc ' ,'i')
*     these lines added to outlin in metdif - following must be false
      call lindst( e584 , 584, 'esc ',iphe1l(2,1),'i', .false.)
*
*     He I 2^3S-ground emission escaping lluminated face of cloud
*     call linadd( e626 , 626 , 'esc ' ,'i')
*     these lines added to outlin in metdif - following must be false
      call lindst( e626 , 626, 'esc ',ipHe23sGrnd,'i', .false.)
*
*     He I 4471,
      if( te.le.1e4 ) then
        em = 2.42e-22/(te/te10) 
      else
        em = 8.79e-22 / te / te03 / te01
      endif
*
*     >>chng 97 jan 4, label was HeI, changed to Ca B for symmetry with others
*     He I 4471 recombination only, fit to Brocklehurst '72
      rec = eden*heii*em 
      call PntForLine( 4471. , 'He 1' , ipnt )
      call lindst(rec,4471,'Ca B',ipnt,'i', .true.)
*     call linadd( eden*heii*em , 4471 , 'Ca B' ,'i')
*
*     He I total 5876, from n-level atom
*     these lines added to outlin in metdif - following must be false
      call lindst(p5876,5876,'TOTL',ipHe3l(2),'i', .false.)
*
*     inward part of 5876
      call linadd( p5876*t5876(ipLnInwd) , 5876 , 'Inwd','i')
*
*     He I 5876 REC, simple fit to Brocklehurst
      call linadd(eden*heii*4.22e-21/(te*te10),5876,'Ca B','r')
*
*     He I 6678 REC, simple fit to Brocklehurst
      rec = eden*heii*1.32e-21/(te*te10*te01)
      call PntForLine( 6678. , 'He 1' , ipnt )
      call lindst(rec,6678,'Ca B',ipnt,'i', .true.)
*
*     10830 from n-level atom
*     these lines added to outlin in metdif - following must be false
      call lindst(p10830,10830,'TOTL',ipHe3l(1),'i', .false.)
*
      f10830 = 1.02e7*t10830(ipLnEscP) /
     1 (1.02e7*t10830(ipLnEscP)+ 2.51e-9*sqrte*eden)
*
*     He I 10830 produced by radiative recombination
      rec = heii * eden * 5.13e-22 /(te70*te10*te01*te01)*f10830
      call linadd( rec,10830 ,'reco' ,'i')
*
*     following expression from Clegg 1987
      pop = heii * 5.79e-6*((te/1e4)**(-1.18)) /
     1 (1. + 3110./eden*((te/1e4)**(-0.51)) )
      col = pop * c2s2p * 1.84e-12*f10830
*
*     collisionally excited 10830 estimated from Clegg 1987 (not model atom)
      call linadd( col,10830 ,'coll' ,'i')
*
*     inward escaping HeI 10830
      call linadd( he10in,10830 ,'Inwd' ,'i')
*
*     He I 3889 from n-level atom
*     these lines added to outlin in metdif - following must be false
      call lindst(p3889,3889,'TOTL',ipHe3l(4),'i', .false.)
*
*     He I 7065 from n-level atom
*     these lines added to outlin in metdif - following must be false
      call lindst(p7065,7065,'TOTL',ipHe3l(3),'i', .false.)
*
*     total collisional He I triplet line cooling, from n-level atom
      call linadd( max(0.,he3clx) , 0 , 'CcHE' ,'c')
*
*     total collisional de-exec He I heating, from n-level atom
      call linadd( max(0.,-he3clx) , 0 , 'ChHE' ,'h')
*
      em = eden * heii
      cb206 = 1.064e-22 / te70/te10/te03/te03 * em
*
*     case B He I 2.06 micron
      call linadd( cb206 , 2 , 'Ca B','i')
*
*     He I 2.06 micron from model atom, all physics in
      totl = heii*he12p*t206(ipLnAul)*t206(ipLnEscP)*9.66e-13
      call PntForLine( 20600. , 'He 1' , ipnt )
      call lindst( totl , 2 , 'TOTL',ipnt,'i', .true.)
*     call linadd( totl , 2 , 'TOTL','i')
*
*     Case B He I 5016
      cb5016 = 5.43e-23 / te70/te10 * em
      call PntForLine( 5016. , 'He 1' , ipnt )
      call lindst( cb5016 , 5016 , 'Ca B',ipnt,'i', .true.)
*     call linadd( cb5016 , 5016 , 'Ca B','i')
*
*     He II Lyman continuum
      call linadd( e228 , 228 , 'HeII' ,'i')
*
*     He II Balmer continuum escaping from cloud
      call linadd( e911 , 911 , 'He2C' ,'i')
*
*     He II 304 predicted by 10-level atom
      sum = heiii*he22p*he2mis(2,1)*6.546e-11*spfac
*     these lines added to outlin in metdif - following must be false
      call lindst(sum,  304,'TOTL',iphe2l(2,1),'i', .false.)
*     call linadd(sum , 304,'TOTL','i')
*
*     He II 1640 predicted by 10-level atom
*     these lines added to outlin in metdif - following must be false
      sum = heiii*he2n(3)*he2mis(3,2)*1.214e-11
      call lindst( sum,  1640,'TOTL',iphe2l(3,2),'i', .false.)
*     call linadd( sum , 1640,'TOTL','i')
*
*     inward part of HeII 1640
      call linadd(sum*he2fin(3,2) , 1640,'Inwd','i')
*
      sum = heiii*he2n(4)*he2mis(4,2)*1.637e-11
*     He II 1216 predicted by 10-level atom, only valid at high densities
*     these lines added to outlin in metdif - following must be false
      call lindst( sum, 1217,'TOTL',iphe2l(4,2),'i', .false.)
*     call linadd(sum , 1217,'TOTL','i')
*
*     He II 1216 inward fraction
      call linadd(sum*he2fin(4,2) , 1217,'Inwd','i')
*
*     He II 1085 predicted by 10-level atom, only valid at high densities
      sum = heiii*he2n(5)*he2mis(5,2)*1.84e-11
*     these lines added to outlin in metdif - following must be false
      call lindst( sum,  1085,'TOTL',iphe2l(5,2),'i', .false.)
*     call linadd( sum,  1085,'TOTL','i')
*
*     He II 1085 inward fraction
      call linadd( sum*he2fin(5,2) , 1085,'Inwd','i')
*
*     He II 4686 predicted by 10-level atom, only valid at high densities
      sum = heiii*he2n(4)*he2mis(4,3)*4.247e-12
*     these lines added to outlin in metdif - following must be false
      call lindst( sum, 4686,'TOTL',iphe2l(4,3),'i', .false.)
*     call linadd( sum, 4686,'TOTL','i')
*
*     inward beamed part of 4686
      call linadd( sum * he2fin(4,3) , 4686,'Inwd','i')
*
*     He II 3205 predicted by 10-level atom, only valid at high densities
      sum = heiii*he2n(5)*he2mis(5,3)*6.21e-12
*     these lines added to outlin in metdif - following must be false
      call lindst( sum, 3205,'TOTL',iphe2l(5,3),'i', .false.)
*     call linadd( sum, 3205,'TOTL','i')
*
*     HeII 3205 inward fraction
      call linadd( sum * he2fin(5,3) , 3205,'Inwd','i')
*
      fac = eden * heiii
      em = fac *2.03e-20/(te70*te10*te03)
*     He II 1640, case B at low densities
      call linadd(  em , 1640 , 'Ca B' ,'i')
*
*     He II 4686, case B
      em = fac *2.52e-20/(te**1.05881) 
      call linadd(  em , 4686 , 'Ca B' ,'i')
*
      if( lgTrace ) write(qq,'(''   LineSet1 returns'')')
*
      end
