******************************************************************************
      subroutine LineSet3
      implicit none
*place lines of elements sodium through argon into lines storage stack
      include "limelm.par"
      include "nhlvl.par"
      include "nta.par"
      include "ipLnArry.par"
      include "raten3.com"
      include "DiffHeav.com"
      include "coolna.com"
      include "coolmg.com"
      include "coolal.com"
      include "coolsi.com"
      include "cools.com"
      include "coolcl.com"
      include "coolar.com"
      include "coolng.com"
      include "pmp2s.com"
      include "supprs.com"
      include "phycon.com"
      include "TePowers.com"
      include "popoi.com"
      include "s3727.com"
      include "iphl.com"
      include "embesq.com"
      include "h.com"
      include "he.com"
      include "edsqte.com"
      include "TLineEXP.com"
      include "IonFracs.com"
      include "trace.com"
      include "sii.com"
      include "IOqq.com"
*
*     local variables
      integer nelem , ipnt
      real alla,sla,clla,phla,drec,sila,sexp,xnala,arla,rec, fac,xmgla,
     1 t4 ,sum
*
      if( lgTrace ) write(qq,'(''   LineSet3 called'')')
*
      t4 = te / 1e4
*
*     sodium
*     sum of Na D lines
      call PutLine( t5895 )
*
*     [NaIII] 7.319 micron
      call PutLine( fsNa373 )
*
*     [NaIV] 9.048 micron
      call PutLine( fsNa490 )
*
*     [NaIV] 21.29 micron
      call PutLine( fsNa421 )
*
*     [NaV] 1365, sum of 1365.1+1365.8; cs only guess
      call PntForLine(     1365., 'Na 5' , ipnt )
      call lindst( c1365 , 1365 , 'Na 5',ipnt,'c',.true.)
*     call linadd( c1365 , 1365 , 'Na 5','c')
*
*     [NaV] 2067, sum of 2066.9+2068.4; cs only guess
      call PntForLine(     2067., 'Na 5' , ipnt )
      call lindst( c2067 , 2067 , 'Na 5',ipnt,'c',.true.)
*     call linadd( c2067 , 2067 , 'Na 5','c')
*
*     [NaV] 4017, sum of 4010.9+4016.7+4022.7; cs only guess
      call PntForLine(     4017., 'Na 5' , ipnt )
      call lindst( c4017 , 4017 , 'Na 5',ipnt,'c',.true.)
*     call linadd( c4017 , 4017 , 'Na 5','c')
*
*     [Na VI] 2568.9
      call PntForLine(     2569., 'Na 6' , ipnt )
      call lindst( c2569 , 2569 , 'Na 6',ipnt,'c',.true.)
*     call linadd( c2569 , 2569 , 'Na 6','c')
*
*     [Na VI] 1356.6
      call PntForLine(     1357., 'Na 6' , ipnt )
      call lindst( c1357 , 1357 , 'Na 6',ipnt,'c',.true.)
*     call linadd( c1357 , 1357 , 'Na 6','c')
*
*     [Na VI] 2971.9
      call PntForLine(                  2972., 'Na 6' , ipnt )
      call lindst( c2972/(1.+1./3.02) , 2972 , 'Na 6',ipnt,'c',.true.)
*     call linadd( c2972/(1.+1./3.02) , 2972 , 'Na 6','c')
*
*     [Na VI] 2872.7
      call PntForLine(               2872., 'Na 6' , ipnt )
      call lindst( c2972/(1.+3.02) , 2872 , 'Na 6',ipnt,'c',.true.)
*     call linadd( c2972/(1.+3.02) , 2872 , 'Na 6','c')
*
*     [NaVI] 14.32 micron
      call PutLine( xNa6143 )
*
*     [NaVI] 8.62 micron
      call PutLine( xNa6862 )
*
*     [NaVII] 4.675 micron
      call PutLine( xNa0746 )
*
*     Na Ly-alpha recombination from fully stripped ion, 10A
      nelem = 11
*     these lines added to outlin in metdif - following must be false
      xnala = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.98e-9 
      call PntForLine( 10. , 'NaLr' , ipnt )
      call lindst( xnala, 10 , 'NaLr',ipnt,'i',.false.)
*     call linadd( xnala, 10 , 'NaLr','i')
*
*     Magnesium I 4571, O I data for coll strength and trans prob
      call PutLine( t4561 )
*
*     Mg I 2853
      call PutLine( MgI2853 )
*
*     Mg I 2026
      call PutLine( MgI2026 )
*
*     Mg II 2798 
      call linadd( t2796(ipLnInten)+t2804(ipLnInten),2798,'TOTL','i')
      sum = t2796(ipLnInten)*t2796(ipLnInwd) +
     1 t2804(ipLnInten)*t2804(ipLnInwd)
*
*     inward part of Mg II 2798
      call linadd( sum,2798,'Inwd','i')
      call PutLine( t2796 )
      call PutLine( t2804 )
*
*     Mg IV 4.5 micron
      call PutLine( tMg4 )
*
*     Mg V  13.5 micron emission
      call PutLine( tMg14 )
*
*     Mg V 5.6 micron emission
      call PutLine( tMg6 )
*
*     [Mg 5] 2571, 2893
      call PutLine( xMg52855 )
*
*     [Mg 5] 2417.5A, 3-2 in model atom
      call PutLine( xMg52417 )
*
*     [Mg 5] 1324.58A, 3-1 in model atom
      call PutLine( xMg51325 )
*
*     MG VI
      call PntForLine(    1806., 'Mg 6' , ipnt )
      call lindst( c1806, 1806 , 'Mg 6',ipnt,'c',.true.)
*     call linadd( c1806, 1806 , 'Mg 6','c')
*
*     [Mg 7] 2510, 2629, 2-1 transitions, together
      call PutLine( xMg72569 )
*
*     [Mg 7] 3-2 transition, 2261.5
      call PutLine( xMg72261 )
*
*     [Mg 7] 3-1 transition, 1189.82A
      call PutLine( xMg71190 )
*
*     Mg 7 IR line 5.50 microns
      call PutLine( fsMg755 )
*
*     Mg 7 IR line 9.03 microns
      call PutLine( fsMg790 )
*
*     [Mg 8] 3.03 micron
      call PutLine( xMg08303 )
*
*     Mg 9 704.5
      call PutLine( t705 )
*
*     Mg 10 614.9 bothof doublet, li seq 2s 2p
      call linadd( tMg610(ipLnInten)+tMg625(ipLnInten),615,'TOTL','i')
      call PutLine( tMg610 )
      call PutLine( tMg625 )
*
*     Mg 10 58 li seq 2s 3p
      call PutLine( t58 )
*
*     recombination from fully stripped ion
      nelem = 12
*     these lines added to outlin in metdif - following must be false
      xmgla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*2.80E-9 
      call PntForLine(    7., 'MgLr' , ipnt )
      call lindst( xmgla, 7 , 'MgLr',ipnt,'i',.true.)
*     call linadd( xmgla, 7 , 'MgLr','i')
*
*     Aluminum
*     Al I 3957
      call PutLine( AlI3957 )
*
*     Al I 3090
      call PutLine( AlI3090 )
*
*     Al II 1671
*     taken out of level one for parallel speed up
*     call PutLine( Al1671 )
*
*     total emission in Al II] 2669.7, 2660 doublet
      call linadd( em2669+t2670(ipLnInten) , 2665 , 'totl','i')
      call PutLine( t2670 )
*
*     emission in Al II] 2669 alone
      call linadd( em2669 , 2660 , 'Al 2','i')
*
*     Al III
      call linadd( t1855(ipLnInten)+t1863(ipLnInten),1860,'TOTL','i')
      sum = t1855(ipLnInten)*t1855(ipLnInwd) +
     1 t1863(ipLnInten)*t1863(ipLnInwd)
*
*     inward part of AlIII line
      call linadd( sum,1860,'Inwd','i')
      call PutLine( t1855 )
      call PutLine( t1863 )
*
*     [Al V] 2.905 mic
      call PutLine( Al529 )
*
*     [Al VI] 3.66 mic
      call PutLine( Al6366 )
*
*     [Al VI] 9.12 mic
      call PutLine( Al6912 )
*
*     [Al VI] 2428.4
      call PntForLine(                  2428., 'Al 6' , ipnt )
      call lindst( c2428/(1.+1./3.73) , 2428 , 'Al 6',ipnt,'c',.true.)
*     call linadd( c2428/(1.+1./3.73) , 2428 , 'Al 6','c')
*
*     [Al VI] 2601.0
      call PntForLine(               2601., 'Al 6' , ipnt )
      call lindst( c2428/(1.+3.73) , 2601 , 'Al 6',ipnt,'c',.true.)
*     call linadd( c2428/(1.+3.73) , 2601 , 'Al 6','c')
*
*     [Al VI] 1169.86
      call PntForLine(     1170., 'Al 6' , ipnt )
      call lindst( c1170 , 1170 , 'Al 6',ipnt,'c',.true.)
*     call linadd( c1170 , 1170 , 'Al 6','c')
*
*     [Al VI] 2124.95
      call PntForLine(     2125., 'Al 6' , ipnt )
      call lindst( c2125 , 2125 , 'Al 6',ipnt,'c',.true.)
*     call linadd( c2125 , 2125 , 'Al 6','c')
*
*     [Al VIII] 5.75 mic
      call PutLine( Al8575 )
*
*     [Al VIII] 3.70 mic
      call PutLine( Al8370 )
*
*     [Al IX] 2.04 micron, no collision strength, A NIST
      call PutLine( Al09204 )
*
*     Al X
      call PutLine( t639 )
*
*     Al 11, Li seq 2s2p
      call linadd( tAl550(ipLnInten)+tAl568(ipLnInten),556,'TOTL','i')
      call PutLine( tAl550 )
      call PutLine( tAl568 )
*
*     Al 11, Li seq 2s3p
      call PutLine( tAl48 )
*
*     recombination from fully stripped ion
      nelem = 13
*     these lines added to outlin in metdif - following must be false
      alla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*3.25E-9 
      call PntForLine(    6., 'AlLr' , ipnt )
      call lindst( alla , 6 , 'AlLr',ipnt,'i',.false.)
*     call linadd( alla , 6 , 'AlLr','i')
*
*     silicon
*     Si I 2518
      call PutLine( Sii2518 )
*
*     Si I 2215
      call PutLine( Sii2215 )
*
*     Silicon II 35 micron
      call PutLine( tSi35 )
*
*     SI II] 2336,
      call PutLine( t2335 )
*
*     SI II 1808, permitted resonance line, collisionally excited
      call PutLine( t1808 )
*
*     SI II 1527, permitted resonance line, collisionally excited
      call PutLine( t1527 )
*
*     SI II 1305, permitted resonance line, collisionally excited
      call PutLine( t1305 )
*
*     SI II 1260, permitted resonance line, collisionally excited
      call PutLine( t1260 )
*
*     SI II 1260, rough guess of dielec contribution
      drec = xIonFracs(14,3)*eden*7.6e-7 /te32*1.57E-11*supprs(3,2)
      fac = t1260(ipLnAovTOT)
      call PntForLine( 1260. , 'Si 2' , ipnt )
      call lindst( drec*fac , 1260 , 'diel',ipnt,'i',.true.)
*     call linadd( drec*fac , 1260 , 'diel','i')
*
*     dielectronic recombination SiII 1909
      call PntForLine(                1909., 'Si 2' , ipnt )
      call lindst( drec*1260./1909. , 1909 , 'diel',ipnt,'i',.true.)
*     call linadd( drec*1260./1909. , 1909 , 'diel','i')
      rec = 
     1  1e-12*(0.1152/t4-0.3082+4.4734*t4+0.0207*t4*t4)/t4**1.5*
     2  sexp(0.2981/t4)
*     >>chng 96 july 8, added dielectronic recombination contribution to 789
      rec = rec*xIonFracs(14,4)*eden*t1207(ipLnAovTOT)*1.65e-11 *
     1 supprs(3,2)
      call PutExtra( max(0.,rec) )
*
*     SI III 1207, collisional excitation and dielectronic recombination
      call PutLine( t1207 )
*
*     Si III 1207, dielectronic recombination only
      call linadd(max(0.,rec),1207,'rec ','i')
*
*     Si III] 1892+1883, total intensity of both lines
      call linadd( em1895+t1895(ipLnInten) ,1888 , 'TOTL','i')
      call PutLine(t1895 )
*
*     Si III] 1883 by itself
      call PntForLine(      1883., 'Si 3' , ipnt )
      call lindst( em1895 , 1883 , 'Si 3',ipnt,'i',.true.)
*     call linadd( em1895 , 1883 , 'Si 3','i')
*
      fac = t1895(ipLnAovTOT)
*
*     photoproduction by inner shell removal
      call linadd( p1895*1.05e-11*fac , 1895 , 'PHOT','i')
*
*     Si IV 1397, collisionally excited
      call linadd( t1403(ipLnInten)+t1394(ipLnInten),1397,'TOTL','i')
*
      sum = t1403(ipLnInten)*t1403(ipLnInwd) +
     1 t1394(ipLnInten)*t1394(ipLnInwd)
*     inward part of SiIV 1397
      call linadd( sum,1397,'Inwd','i')
      call PutLine( t1403 )
      call PutLine( t1394 )
*
*     SI VI 1.9641 micron
      call PutLine( Si619 )
*
*     SI VII, 2148, O III like, collisionally excited
      call PntForLine(     2148., 'Si 7' , ipnt )
      call lindst( c2148 , 2148 , 'Si 7',ipnt,'c',.true.)
*     call linadd( c2148 , 2148 , 'Si 7','c')
*
*     Si VII 2.48, 6.49 micron, collisionally excited
      call PutLine( tSi25 )
*
*     Si VII 2.48, 6.49 micron, collisionally excited
      call PutLine( tSi65 )
*
*     SI VIII 1446, OIII like, collisionally excited
      call PntForLine(     1446., 'Si 8' , ipnt )
      call lindst( c1446 , 1446 , 'Si 8',ipnt,'c',.true.)
*     call linadd( c1446 , 1446 , 'Si 8','c')
*
*     SI IX 1985, 2150, collisionally excited
      call PntForLine(     1985., 'Si 9' , ipnt )
      call lindst( c1985 , 1985 , 'Si 9',ipnt,'c',.true.)
*     call linadd( c1985 , 1985 , 'Si 9','c')
*
*     collisionally excited
      call PntForLine(    949., 'Si 9' , ipnt )
      call lindst( c949 , 949 , 'Si 9',ipnt,'c',.true.)
*     call linadd( c949 , 949 , 'Si 9','c')
*
*     collisionally excited
      call PntForLine(     1815., 'Si 9' , ipnt )
      call lindst( c1815 , 1815 , 'Si 9',ipnt,'c',.true.)
*     call linadd( c1815 , 1815 , 'Si 9','c')
*
*     SI 9, 3.86, 2.84 3P fine structure lines
      call PutLine( tSi4 )
*
*     SI 9, 3.86, 2.84 3P fine structure lines
      call PutLine( tSi3 )
*
*     both components of 5S-3P doublet
      call PntForLine(    691., 'Si 9' , ipnt )
      call lindst( c691 , 691 , 'Si 9',ipnt,'c',.true.)
*     call linadd( c691 , 691 , 'Si 9','c')
*
*     SI 10 606A, actually group of 4 intercombination lines.
      call PntForLine(    606., 'Si10' , ipnt )
      call lindst( c606 , 606 , 'Si10',ipnt,'c',.true.)
*     call linadd( c606 , 606 , 'Si10','c')
*
*     [Si 10] 1.43 micron, collisionally excited
      call PutLine( Si10143 )
*
*     SI XI 582.9, collisionally excited
      call PntForLine(    583., 'Si11' , ipnt )
      call lindst( c583 , 583 , 'Si11',ipnt,'c',.true.)
*     call linadd( c583 , 583 , 'Si11','c')
*
      call linadd( tSi499(ipLnInten)+tSi521(ipLnInten),506,'TOTL','i')
*
*     SI XII 506 li seq 2s 2p
      call PutLine( tSi499 )
      call PutLine( tSi521 )
*
*     SI XII 40.9A, li seq 2s 3p
      call PutLine( tSi41 )
*
*     recombination from fully stripped ion
      nelem = 14
*     these lines added to outlin in metdif - following must be false
      sila = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*3.23E-9 
      call PntForLine(    6., 'SiLr' , ipnt )
      call lindst( sila , 6 , 'SiLr',ipnt,'i',.false.)
*     call linadd( sila , 6 , 'SiLr','i')
*
*     phosphorus
*     [P II] 60.64 micron
      call PutLine( P0260 )
*
*     [P II] 32.87 micron
      call PutLine( P0233 )
*
*     [P III] 17.885 micron
      call PutLine( P0318 )
*
*     P VII 1.3745 micron
      call PutLine( P713 )
*
*     P VIII 4.85 mic
      call PutLine( P848 )
*
*     P VIII 1.735 microns
      call PutLine( P817 )
*
*     P X 2.708 mic
      call PutLine( P1027 )
*
*     P X 1.868 microns
      call PutLine( P1018 )
*
*     recombination from fully stripped ion
      nelem = 15
*     these lines added to outlin in metdif - following must be false
      phla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.05E-9 
      call PntForLine(    19., 'P15r' , ipnt )
      call lindst( phla , 19 , 'P15r',ipnt,'i',.false.)
*     call linadd( phla , 19 , 'P15r','i')
*
*     sulphur
*     guestimate of Sulphur I triplet excited state recombination rate.
*     this is to check whether photoexcit of S II is ever important
      call linadd( 1.75e-22*eden*xIonFracs(16,2)/sqrte/te10/te03 ,
     1 1807 , 'S 1R','i')
*
*     S II 6731 + 6716 together
      call linadd( c6731 ,6720,'S  2','c')
*
*     S II 4070 +4078 together
      call linadd( S4070+S4078 , 4074 , 'S  2','c')
*
*     S II N=3 lines, all four lines together
      call PntForLine( 10330. , 'S  2' , ipnt )
      call lindst( c10330 , 10330 , 'S  2',ipnt,'c',.true.)
*
*     now output the real thing
*     individual line from five level atom
      call PntForLine(     6731., 'S II' , ipnt )
      call lindst( S6733 , 6731 , 'S II',ipnt,'i',.true.)
*     call linadd( S6733 , 6731 , 'S II','i')
*
*     individual line from five level atom
      call PntForLine(     6716., 'S II' , ipnt )
      call lindst( S6718 , 6716 , 'S II',ipnt,'i',.true.)
*     call linadd( S6718 , 6716 , 'S II','i')
*
*     individual line from five level atom
      call PntForLine(     4070., 'S II' , ipnt )
      call lindst( S4070 , 4070 , 'S II',ipnt,'i',.true.)
*     call linadd( S4070 , 4070 , 'S II','i')
*
*     individual line from five level atom
      call PntForLine(     4078., 'S II' , ipnt )
      call lindst( S4078 , 4078 , 'S II',ipnt,'i',.true.)
*     call linadd( S4078 , 4078 , 'S II','i')
*
*     individual line from five level atom
      call linadd(S10323,10323,'S II','i')
*
*     individual line from five level atom
      call linadd(S10289,10289,'S II','i')
*
*     individual line from five level atom
      call linadd(S10373,10373,'S II','i')
*
*     individual line from five level atom
      call linadd(S10339,10339,'S II','i')
*
*     resonance line near NV, collisionally excited
      call PutLine( t1256 )
*
*     S III fine structure 18.7
      call PutLine( tS19 )
*
*     S III fine structure 34
      call PutLine( tS34 )
*
*     S III] 1713.12, 1728.94
      call PutLine( tS1720 )
*
*     [S III] 9532 alone
      call PntForLine(                  9532., 'S  3' , ipnt )
      call lindst( c9532/(1.+1./2.48) , 9532 , 'S  3',ipnt,'c',.true.)
*
*     [S III] 9069 alone
      call PntForLine(               9069., 'S  3' , ipnt )
      call lindst( c9532/(1.+2.48) , 9069 , 'S  3',ipnt,'c',.true.)
*
*     [S III] 6312, transauroral temperature sensitive
      call PntForLine(     6312., 'S  3' , ipnt )
      call lindst( c6312 , 6312 , 'S  3',ipnt,'c',.true.)
*     call linadd( c6312 , 6312 , 'S  3','c')
*
*     [S III] 3722, same upper level as 6312
      call PntForLine(          3722., 'S  3' , ipnt )
      call lindst( c6312*0.59 , 3722 , 'S  3',ipnt,'c',.true.)
*     call linadd( c6312*0.59 , 3722 , 'S  3','c')
*
*     WL, other data, from Ho + Henry Ap.J. 1984
      call PutLine( t1194 )
*
*     S IV 10.5 micron, collisionally excited (label is 105)
      call PutLine( tS11 )
*
*     S IV 1406, collisionally excited
      call PutLine( t1406 )
*
*     S V 1198] both lines together
      call linadd( em1198+t1198(ipLnInten) , 1198 , 'TOTL','i')
*
*     S V 1198] the stronger transition
      call PutLine( t1198)
*
*     Be seq, weaker of the two transitions
      call linadd( em1198 , 1188 , 'S  5','i')
*
*     S V 786.5, collisionally excited
      call PutLine( t786 )
*
*     S VI 933+944, collisionally excited
*     total S VI 933+944
      call linadd( t944(ipLnInten)+t933(ipLnInten),933,'TOTL','i')
      call PutLine( t944 )
      call PutLine( t933 )
*
*     S VIII 9913
      call PutLine( fsS810 )
*
*     S IX 1.25 microns
      call PutLine( fsS912 )
*
*     S IX  3.78 microns
      call PutLine( fsS938 )
*
*     S XI 1.91 microns
      call PutLine( fsS1119 )
*
*     S XI 1.40 microns
      call PutLine( fsS1114 )
*
*     S IX 1715, 1987, collisionally excited
      call PntForLine(     1715., 'S  9' , ipnt )
      call lindst( c1715 , 1715 , 'S  9',ipnt,'c',.true.)
*     call linadd( c1715 , 1715 , 'S  9','c')
*
*     S XII 7611.2
      call PutLine( fsS1207 )
*
*     S X 1213, 1197, collisionally excited
      call PntForLine(    1213., 'S 10' , ipnt )
      call lindst( c1213, 1213 , 'S 10',ipnt,'c',.true.)
*     call linadd( c1213, 1213 , 'S 10','c')
*
*     S XI 1615, 1826, collisionally excited
      call PntForLine(     1826., 'S 11' , ipnt )
      call lindst( c1826 , 1826 , 'S 11',ipnt,'c',.true.)
*     call linadd( c1826 , 1826 , 'S 11','c')
*
*     group of four intercombination lines
      call PntForLine(    520., 'S 12' , ipnt )
      call lindst( c520 , 520 , 'S 12',ipnt,'c',.true.)
*     call linadd( c520 , 520 , 'S 12','c')
*
*     S XIII 488.4, 1909 like, collisionally excited
      call PntForLine(    488., 'S 13' , ipnt )
      call lindst( c488 , 488 , 'S 13',ipnt,'c',.true.)
*     call linadd( c488 , 488 , 'S 13','c')
*
*     S 14 506 li seq 2s2p
      call linadd( tSu418(ipLnInten)+tSu446(ipLnInten),427,'TOTL','i')
      call PutLine( tSu418 )
      call PutLine( tSu446 )
*
*     S 14 30 li seq 2s3p
      call PutLine( tSu30 )
*
*     S 16 4.7A Ly a recombination from fully stripped ion
      nelem = 16
*     these lines added to outlin in metdif - following must be false
      sla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*4.21E-9
      call PntForLine(   5., 'S LR' , ipnt )
      call lindst( sla , 5 , 'S LR',ipnt,'i',.false.)
      call linadd( sla , 5 , 'S LR','i')
*
*     chlorine lines
*     [Cl II] 33.281 micron
      call PutLine( fsCl233 )
*
*     [Cl II] 14.3678 micron
      call PutLine( fsCl214 )
*
*     Chlorine II 8581, 9127 doublet
      call PntForLine(           8579., 'Cl 2' , ipnt )
      call lindst( c8579*0.791 , 8579 , 'Cl 2',ipnt,'c',.true.)
*     call linadd( c8579*0.791 , 8579 , 'Cl 2','c')
*
*     Chlorine II 8581, 9127 doublet
      call PntForLine(           9127., 'Cl 2' , ipnt )
      call lindst( c8579*0.209 , 9127 , 'Cl 2',ipnt,'c',.true.)
      call linadd( c8579*0.209 , 9127 , 'Cl 2','c')
*
*     Chlorine II 6164 auroral line
      call PntForLine(     6164., 'Cl 2' , ipnt )
      call lindst( c6164 , 6164 , 'Cl 2',ipnt,'c',.true.)
*     call linadd( c6164 , 6164 , 'Cl 2','c')
*
*     Chlorine II 3679 auroral line
      call PntForLine(     3676., 'Cl 2' , ipnt )
      call lindst( c3679 , 3676 , 'Cl 2',ipnt,'c',.true.)
*     call linadd( c3679 , 3679 , 'Cl 2','c')
*
*     Cl III 5519, 5539 doublet, both together
      call linadd( c5525 , 5525 , 'TOTL','c')
*
*     Cl III 3354, 3344 doublet, both together
      call linadd( c3350 , 3350 , 'TOTL','c')
*
*     Cl III 8504, 8436, 8552, 8483 multiplet, all together
      call linadd( c8494 , 8494 , 'TOTL','c')
*
*     Cl III 5538 
      call PntForLine(      5538., 'Cl 3' , ipnt )
      call lindst( Cl5539 , 5538 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl5539 , 5538 , 'Cl 3','i')
*
*     Cl III 5518 
      call PntForLine(      5518., 'Cl 3' , ipnt )
      call lindst( Cl5519 , 5518 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl5519 , 5518 , 'Cl 3','i')
*
*     Cl III 3354 
      call PntForLine(      3354., 'Cl 3' , ipnt )
      call lindst( Cl3354 , 3354 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl3354 , 3354 , 'Cl 3','i')
*
*     Cl III 3344 
      call PntForLine(      3344., 'Cl 3' , ipnt )
      call lindst( Cl3344 , 3344 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl3344 , 3344 , 'Cl 3','i')
*
*     Cl III 8504 
      call PntForLine(      8504., 'Cl 3' , ipnt )
      call lindst( Cl8504 , 8504 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl8504 , 8504 , 'Cl 3','i')
*
*     Cl III 8436 
      call PntForLine(      8436., 'Cl 3' , ipnt )
      call lindst( Cl8436 , 8436 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl8436 , 8436 , 'Cl 3','i')
*
*     Cl III 8552 
      call PntForLine(      8552., 'Cl 3' , ipnt )
      call lindst( Cl8552 , 8552 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl8552 , 8552 , 'Cl 3','i')
*
*     Cl III 8483 
      call PntForLine(      8483., 'Cl 3' , ipnt )
      call lindst( Cl8483 , 8483 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl8483 , 8483 , 'Cl 3','i')
*
*     [Cl IV] fine structure line 20.354 microns
      call PutLine(Cl04203)
*
*     [Cl IV] fine structure line 11.741 microns
      call PutLine(Cl04117)
*
*     ClIV 8047
      call PntForLine(           8047., 'Cl 4' , ipnt )
      call lindst( c8047*0.667 , 8047 , 'Cl 4',ipnt,'c',.true.)
*     call linadd( c8047*0.667 , 8047 , 'Cl 4','c')
*
*     ClIV 7532
      call PntForLine(           7532., 'Cl 4' , ipnt )
      call lindst( c8047*0.333 , 7532 , 'Cl 4',ipnt,'c',.true.)
*     call linadd( c8047*0.333 , 7532 , 'Cl 4','c')
*
*     ClIV 3119
      call PntForLine(     3119., 'Cl 4' , ipnt )
      call lindst( c3119 , 3119 , 'Cl 4',ipnt,'c',.true.)
*     call linadd( c3119 , 3119 , 'Cl 4','c')
*
*     ClIV 5324
      call PntForLine(     5324., 'Cl 4' , ipnt )
      call lindst( c5324 , 5324 , 'Cl 4',ipnt,'c',.true.)
      call linadd( c5324 , 5324 , 'Cl 4','c')
*
*     Cl IX 7334A
      call PutLine( Cl973 )
*
*     Cl X 3.05 microns
      call PutLine( Cl1030 )
*
*     Cl X 9223A
      call PutLine( Cl1092 )
*
      nelem = 17
*     these lines added to outlin in metdif - following must be false
      clla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*5.33E-9 
*     Cl 17 ly a recombination 3.7A from fully stripped ion
      call PntForLine(    4., 'ClRr' , ipnt )
      call lindst( clla , 4 , 'ClRr',ipnt,'i',.false.)
*     call linadd( clla , 4 , 'ClRr','i')
*
*     Argon II 7 micron
      call PutLine( tAr7 )
*
*     Argon III 7135
      call PntForLine(                   7135., 'Ar 3' , ipnt )
      call lindst( c7136/(1.+1./4.144) , 7135 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c7136/(1.+1./4.144) , 7135 , 'Ar 3','c')
*
*     Argon III 7751
      call PntForLine(                7751., 'Ar 3' , ipnt )
      call lindst( c7136/(1.+4.144) , 7751 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c7136/(1.+4.144) , 7751 , 'Ar 3','c')
*
*     Argon III 5192
      call PntForLine(     5192., 'Ar 3' , ipnt )
      call lindst( c5192 , 5192 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c5192 , 5192 , 'Ar 3','c')
*
*     Argon III 3109
      call PntForLine(            3109., 'Ar 3' , ipnt )
      call lindst( c3109*0.9894 , 3109 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c3109*0.9894 , 3109 , 'Ar 3','c')
*
*     Argon III 3005
      call PntForLine(                 3005., 'Ar 3' , ipnt )
      call lindst( c3109*(1.-0.9894) , 3005 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c3109*(1.-0.9894) , 3005 , 'Ar 3','c')
*
*     Argon III 21.8, 9 micron lines
      call PutLine( tAr22 )
*
*     Argon III 21.8, 9 micron lines
      call PutLine( tAr9 )
*
*     Argon IV 4711 + 4740 together, 4740=90%
      call linadd( Ar4740+Ar4711, 4725 , 'TOTL','i')
*
*     [AvIV] 2868, 2854 together
      call linadd( Ar2868+Ar2854 , 2860 , 'TOTL','i')
*
*     [AvIV] auroral lines, 7237, 7331, 7171, 7263
      call linadd( Ar7237+Ar7331+Ar7171+Ar7263,7250,'TOTL','i')
*
*     [Ar IV] 4740
      call PntForLine(      4740., 'Ar 4' , ipnt )
      call lindst( Ar4740 , 4740 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar4740 , 4740 , 'Ar 4','c')
*
*     [Ar IV] 4711
      call PntForLine(      4711., 'Ar 4' , ipnt )
      call lindst( Ar4711 , 4711 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar4711 , 4711 , 'Ar 4','c')
*
*     [Ar IV] 2868
      call PntForLine(      2868., 'Ar 4' , ipnt )
      call lindst( Ar2868 , 2868 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar2868 , 2868 , 'Ar 4','c')
*
*     [Ar IV] 2854
      call PntForLine(      2854., 'Ar 4' , ipnt )
      call lindst( Ar2854 , 2854 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar2854 , 2854 , 'Ar 4','c')
*
*     [Ar IV] 7263
      call PntForLine(      7263., 'Ar 4' , ipnt )
      call lindst( Ar7263 , 7263 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar7263 , 7263 , 'Ar 4','c')
*
*     [Ar IV] 7171
      call PntForLine(      7171., 'Ar 4' , ipnt )
      call lindst( Ar7171 , 7171 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar7171 , 7171 , 'Ar 4','c')
*
*     [Ar IV] 7331
      call PntForLine(      7331., 'Ar 4' , ipnt )
      call lindst( Ar7331 , 7331 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar7331 , 7331 , 'Ar 4','c')
*
*     [Ar IV] 7237
      call PntForLine(      7237., 'Ar 4' , ipnt )
      call lindst( Ar7237 , 7237 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar7237 , 7237 , 'Ar 4','c')
*
*     Argon V, 3P lines, 7005, collisionally excited
      call PntForLine(                  7005., 'Ar 5' , ipnt )
      call lindst( c7007/(1.+1./2.143) ,7005 , 'Ar 5',ipnt,'c',.true.)
*     call linadd( c7007/(1.+1./2.143), 7005 , 'Ar 5','c')
*
*     Argon V, 3P lines, 6435, collisionally excited
      call PntForLine(                6435., 'Ar 5' , ipnt )
      call lindst( c7007/(1.+2.143) , 6435 , 'Ar 5',ipnt,'c',.true.)
      call linadd( c7007/(1.+2.143) , 6435 , 'Ar 5','c')
*
*     Argon V fine structure lines, 13.09, 7.903 micron line
      call PutLine( tAr13 )
*
*     Argon V fine structure lines, 13.09, 7.903 micron line
      call PutLine( tAr8 )
*
*     [Ar VI] 4.53 micron
      call PutLine( Ar06453 )
*
*     Ar X 5533.4A
      call PutLine( Ar1055 )
*
*     Ar XI 2.60 microns
      call PutLine( Ar1126 )
*
*     Ar XI 6917A
      call PutLine( Ar1178 )
*
*     Ar XIV 4413, predicted lambda, not observed(??)
      call PntForLine(      4413., 'Ar14' , ipnt )
      call lindst( fs4413 , 4413 , 'Ar14',ipnt,'c',.true.)
*     call linadd( fs4413 , 4413 , 'Ar14','c')
*
*     collisionally excited
      call PntForLine(    409., 'Ar15' , ipnt )
      call lindst( c409 , 409 , 'Ar15',ipnt,'c',.true.)
*     call linadd( c409 , 409 , 'Ar15','c')
*
*     collisionally excited Ar16 354, Li seq 2s-2p
      call PutLine( t354 )
*
*     collisionally excited Ar16 389, Li seq 2s-2p
      call PutLine( t389 )
*
*     collisionally excited Ar16 365, Li seq 2s-3p
      call PutLine( t25 )
*
*     Ar 18 ly a recombination 3.7A from fully stripped ion
      nelem = 18
*     these lines added to outlin in metdif - following must be false
      arla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*5.33e-9 
      call PntForLine( 3.75 , 'ArRr' , ipnt )
      call lindst( arla , 4 , 'ArRr',ipnt,'i',.false.)
*     call linadd( arla , 4 , 'ArRr','i')
*
      if( lgTrace ) write(qq,'(''   LineSet3 returns'')')
*
      end
