******************************************************************************
      subroutine LineSet4
      implicit none
*place lines of elements sodium through argon into lines storage stack
      include "limelm.par"
      include "nhlvl.par"
      include "LimPredFe2.par"
      include "ncell.par"
      include "nta.par"
      include "ipLnArry.par"
      include "raten3.com"
      include "dcala.com"
      include "caline.com"
      include "pumpfe.com"
      include "DiffHeav.com"
      include "coolca.com"
      include "coolvan.com"
      include "coolfe.com"
      include "coolsc.com"
      include "coolti.com"
      include "coolcr.com"
      include "resion.com"
      include "fekems.com"
      include "rfield.com"
      include "coolng.com"
      include "supprs.com"
      include "phycon.com"
      include "TePowers.com"
      include "iphl.com"
      include "embesq.com"
      include "h.com"
      include "he.com"
      include "edsqte.com"
      include "TLineEXP.com"
      include "IonFracs.com"
      include "fe4cool.com"
      include "fe2cool.com"
      include "trace.com"
      include "PredFe2.com"
      include "IOqq.com"
*
*     local variables
      real r14,cola,fela,znla,c14,scla, c10,colfac, escinc,
     1 tila,potla, xmnla,cala,cula,chla,xnila,vala,eff , SumBandFe2
      integer nelem , i , ipnt
*
      if( lgTrace ) write(qq,'(''   LineSet4 called'')')
*
*     potassium
*     K I 7745
      call PutLine( KI7745 )
*
*     [K III] 4.62 microns
      call PutLine( xK03462 )
*
*     [KIV] 5.983 min 
      call PutLine( xK04598 )
*
*     [KIV] 15.39 mic
      call PutLine( xK04154 )
*
*     [KVI] 8.823 mic
      call PutLine( xK06882 )
*
*     [KVI]  5.575 mic
      call PutLine( xK06557 )
*
*     [K VII] 3.189 microns
      call PutLine( xK07319 )
*
*     K 11 4249.99A
      call PutLine( xK11425 )
*
*     K 19 ly a recombination 3.7A from fully stripped ion
      nelem = 10
*     these lines added to outlin in metdif - following must be false
      potla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*5.33E-9 
      call PntForLine(  3.55 , 'K19r' , ipnt )
      call lindst( potla , 4 , 'K19r',ipnt,'i',.false.)
*     call linadd( potla , 4 , 'K19r','i')
*
*     calcium
*     Ca I 4228
      call PutLine( CaI4228 )
*
*     coll excit calcium k+h
      call linadd( Cakh  , 3933 , 'Ca 2','c')
*
*     infrared triplet
      call linadd( Cair  , 8579 , 'Ca 2','c')
*
*     forbidden lines, 7291+7324 together
      call linadd( c7306 , 7306 , 'Ca 2','c')
*
*     fraction H Ly-alpha destruction of excited levels
      call linadd( dCakh  , 3933 , 'Phot','i')
*
*     fraction H Ly-alpha destruction of excited levels
      call linadd( dCaf12 , 7306 , 'Phot','i')
*
*     individual lines from five level atom
      call PntForLine(   3934., 'Ca2K' , ipnt )
      call lindst( Cak , 3934 , 'Ca2K',ipnt,'i',.true.)
*     call linadd( Cak , 3934 , 'Ca2K','i')
*
*     individual lines from five level atom
      call PntForLine(   3969., 'Ca2H' , ipnt )
      call lindst( Cah , 3969 , 'Ca2H',ipnt,'i',.true.)
*     call linadd( Cah , 3969 , 'Ca2H','i')
*
*     individual lines from five level atom
      call PntForLine(   8498., 'Ca2X' , ipnt )
      call lindst( Cax , 8498 , 'Ca2X',ipnt,'i',.true.)
*     call linadd( Cax , 8498 , 'Ca2X','i')
*
*     individual lines from five level atom
      call PntForLine(   8542., 'Ca2Y' , ipnt )
      call lindst( Cay , 8542 , 'Ca2Y',ipnt,'i',.true.)
*     call linadd( Cay , 8542 , 'Ca2Y','i')
*
*     individual lines from five level atom
      call PntForLine(   8662., 'Ca2Z' , ipnt )
      call lindst( Caz , 8662 , 'Ca2Z',ipnt,'i',.true.)
*     call linadd( Caz , 8662 , 'Ca2Z','i')
*
*     individual lines from five level atom
      call PntForLine(    7291., 'CaF1' , ipnt )
      call lindst( Caf1 , 7291 , 'CaF1',ipnt,'i',.true.)
*     call linadd( Caf1 , 7291 , 'CaF1','i')
*
*     individual lines from five level atom
      call PntForLine(    7324., 'CaF2' , ipnt )
      call lindst( Caf2 , 7324 , 'CaF2',ipnt,'i',.true.)
*     call linadd( Caf2 , 7324 , 'CaF2','i')
*
*     reccombination contribution to CaII emission
      eff = eden * xIonFracs(20,3) * 5.4e-21 / (te/te10/te10)
      call linadd( eff , 3933 , 'Rec ','i')
*
*     Ca IV 3.2 micron
      call PutLine( tCa3 )
*
*     Ca V 4.16, 11.47 micron
      call PutLine( tCa4 )
*
*     Ca V 4.16, 11.47 micron
      call PutLine( tCa12 )
*
*     Ca V optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      6087., 'Ca 5' , ipnt )
      call lindst( Ca6087 , 6087 , 'Ca 5',ipnt,'c',.true.)
*     call linadd( Ca6087 , 6087 , 'Ca 5','c')
*
*     Ca V optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(     5311., 'Ca 5' , ipnt )
      call lindst( c5311 , 5311 , 'Ca 5',ipnt,'c',.true.)
*     call linadd( c5311 , 5311 , 'Ca 5','c')
*
*     Ca V optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(     2414., 'Ca 5' , ipnt )
      call lindst( c2414 , 2414 , 'Ca 5',ipnt,'c',.true.)
*     call linadd( c2414 , 2414 , 'Ca 5','c')
*
*     Ca V optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(     3997., 'Ca 5' , ipnt )
      call lindst( c3997 , 3997 , 'Ca 5',ipnt,'c',.true.)
*     call linadd( c3997 , 3997 , 'Ca 5','c')
*
*     [Ca VII] 4.09 microns
      call PutLine( Ca0741 )
*
*     [Ca VII] 6.15 microns
      call PutLine( Ca0761 )
*
*     Ca VII optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      5620., 'Ca 7' , ipnt )
      call lindst( Ca5620 , 5620 , 'Ca 7',ipnt,'c',.true.)
*     call linadd( Ca5620 , 5620 , 'Ca 7','c')
*
*     Ca VII optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      4941., 'Ca 7' , ipnt )
      call lindst( Ca4941 , 4941 , 'Ca 7',ipnt,'c',.true.)
*     call linadd( Ca4941 , 4941 , 'Ca 7','c')
*
*     Ca VII optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      2112., 'Ca 7' , ipnt )
      call lindst( Ca2112 , 2112 , 'Ca 7',ipnt,'c',.true.)
*     call linadd( Ca2112 , 2112 , 'Ca 7','c')
*
*     Ca VII optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      3688., 'Ca 7' , ipnt )
      call lindst( Ca3688 , 3688 , 'Ca 7',ipnt,'c',.true.)
*     call linadd( Ca3688 , 3688 , 'Ca 7','c')
*
*     [Ca VIII]  2.32 microns, A Saraph and Strey
      call PutLine( Ca08232 )
*
*     [Ca 12] 3328.78A
      call PutLine( Ca12333 )
*
*     Ca 18 Li seq 2s2p, 302, 345 separate
      call PutLine( tCa302 )
*
*     Ca 18 Li seq 2s2p, 302, 345 separate
      call PutLine( tCa345 )
*
*     Ca 18 Li seq 2s3p, 
      call PutLine( tCa19 )
*
*     Calcium Ly a recombination from fully stripped ion
      nelem = 20
*     these lines added to outlin in metdif - following must be false
      cala = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9 
      call PntForLine( 3.02 , 'CaLr' , ipnt )
      call lindst( cala , 3 , 'CaLr',ipnt,'i',.false.)
*     call linadd( cala , 3 , 'CaLr','i')
*
*     scandium Ly a recombination from fully stripped ion
      nelem = 21
*     these lines added to outlin in metdif - following must be false
      scla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9 
      call PntForLine( 2.98 , 'ScLr' , ipnt )
      call lindst( scla , 3 , 'ScLr',ipnt,'i',.false.)
*     call linadd( scla , 3 , 'ScLr','i')
*
*     Sc II 2.08 (1-3)
      call PntForLine(   22.08e4 , 'Sc 2' , ipnt )
      call lindst( Sc22p08m , 21 , 'Sc 2',ipnt,'c',.true.)
*     call linadd( Sc22p08m , 21 , 'Sc 2' , 'c' )
*
*     Sc II 4.1 mic (1-2)
      call PntForLine(   24.1e4 , 'Sc 2' , ipnt )
      call lindst( Sc24p1m , 41 , 'Sc 2',ipnt,'c',.true.)
*     call linadd( Sc24p1m , 41 , 'Sc 2' , 'c' )
*
*     Sc II 4.22 (2-3)
      call PntForLine(   24.2e4 , 'Sc 2' , ipnt )
      call lindst( Sc24p2m , 42 , 'Sc 2',ipnt,'c',.true.)
*     call linadd( Sc24p2m , 42 , 'Sc 2' , 'c' )
*
*     Sc III 3936
      call PntForLine(       3933., 'Sc 3' , ipnt )
      call lindst( Sc33936 , 3933 , 'Sc 3',ipnt,'c',.true.)
*     call linadd( Sc33936 , 3933 , 'Sc 3' , 'c' )
*
*     [Sc V] 1.46 microns
      call PutLine( Sc05231 )
*
*     Sc VI 5054 (1-2)
      call PntForLine(       5054., 'Sc 6' , ipnt )
      call lindst( Sc45058 , 5054 , 'Sc 6',ipnt,'c',.true.)
*     call linadd( Sc45058 , 5054 , 'Sc 6' , 'c' )
*
*     Sc VI 3595 (2-3)
      call PntForLine(       3592., 'Sc 6' , ipnt )
      call lindst( Sc43595 , 3592 , 'Sc 6',ipnt,'c',.true.)
*     call linadd( Sc43595 , 3592 , 'Sc 6' , 'c' )
*
*     Sc VI 2100 (1-3)
      call PntForLine(       2100., 'Sc 6' , ipnt )
      call lindst( Sc42100 , 2100 , 'Sc 6',ipnt,'c',.true.)
*     call linadd( Sc42100 , 2100 , 'Sc 6' , 'c' )
*
*     [Sc 13] 2637.97A
      call PutLine( Sc13264 )
*
*     titanium Ly a recombination from fully stripped ion
      nelem = 22
*     these lines added to outlin in metdif - following must be false
      tila = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9 
      call PntForLine( 2.95 , 'TiLr' , ipnt )
      call lindst( tila , 3 , 'TiLr',ipnt,'i',.false.)
*     call linadd( tila , 3 , 'TiLr','i')
*
*     Ti III 1.21 micron, (actually multiplet) 2-1 transition from model atom
      call PntForLine(  1.21e4 , 'Ti 3' , ipnt )
      call lindst( Ti3l21 , 12 , 'Ti 3',ipnt,'c',.true.)
*     call linadd( Ti3l21 , 12 , 'Ti 3','c')
*
*     Ti III 9594, 3-1 transition, (actually multiplet) from model atom
      call PntForLine(      9594., 'Ti 3' , ipnt )
      call lindst( Ti3l31 , 9594 , 'Ti 3',ipnt,'c',.true.)
*     call linadd( Ti3l31 , 9594 , 'Ti 3','c')
*
*     Ti III 4.57 micron, 3-2 transition, (actually multiplet) from model atom
      call PntForLine( 4.57e4  , 'Ti 3' , ipnt )
      call lindst( Ti3l32 , 45 , 'Ti 3',ipnt,'c',.true.)
*     call linadd( Ti3l32 , 45 , 'Ti 3','c')
*
*     [Ti VI] 1.72 microns
      call PutLine( Ti06172 )
*
*     [Ti XIV] 2117.79
      call PutLine( Ti14212 )
*
*     vanadium Ly a recombination from fully stripped ion
      nelem = 23
*     these lines added to outlin in metdif - following must be false
      vala = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9 
      call PntForLine( 2.92 , 'V Lr' , ipnt )
      call lindst( vala , 3 , 'V Lr',ipnt,'i',.false.)
*     call linadd( vala , 3 , 'V Lr','i')
*
*     V III 8823
      call PntForLine(      8823., 'V  3' , ipnt )
      call lindst( V38830 , 8823 , 'V  3',ipnt,'c',.true.)
*     call linadd( V38830 , 8823 , 'V  3' , 'c' )
*
*     V III 8507
      call PntForLine(      8507., 'V  3' , ipnt )
      call lindst( V38507 , 8507 , 'V  3',ipnt,'c',.true.)
      call linadd( V38507 , 8507 , 'V  3' , 'c' )
*
*     V IV 7741 1-3
      call PntForLine(      7735., 'V  4' , ipnt )
      call lindst( V47741 , 7735 , 'V  4',ipnt,'c',.true.)
*     call linadd( V47741 , 7735 , 'V  4' , 'c' )
*
*     V IV 9496 2-1
      call PntForLine(      9489., 'V  4' , ipnt )
      call lindst( V49496 , 9489 , 'V  4',ipnt,'c',.true.)
*     call linadd( V49496 , 9489 , 'V  4' , 'c' )
*
*     V IV 4.19 mic 3-2
      call PntForLine( 4.19e4  , 'V  4' , ipnt )
      call lindst( V44p2m , 42 , 'V  4',ipnt,'c',.true.)
*     call linadd( V44p2m , 42 , 'V  4' , 'c' )
*
*     [V VII] 1.304 microns
      call PutLine( Va07130 )
*
*     [V 15] 1721.38
      call PutLine( Va15172 )
*
*     Chromium Ly a recombination from fully stripped ion
      nelem = 24
*     these lines added to outlin in metdif - following must be false
      chla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9 
      call PntForLine( 2.89 , 'CrLr' , ipnt )
      call lindst( chla , 3 , 'CrLr',ipnt,'i',.false.)
*     call linadd( chla , 3 , 'CrLr','i')
*
*     [CrIII] multiplet blend at 5828A
      call PntForLine(      5828., 'Cr 3' , ipnt )
      call lindst( Cr3l21 , 5828 , 'Cr 3',ipnt,'c',.true.)
*     call linadd( Cr3l21 , 5828 , 'Cr 3','c')
*
*     [CrIV] 2 - 1 multiplet blend at 7272
      call PntForLine(      7267., 'Cr 4' , ipnt )
      call lindst( Cr4l21 , 7267 , 'Cr 4',ipnt,'c',.true.)
*     call linadd( Cr4l21 , 7267 , 'Cr 4','c')
*
*     [CrIV] 3 - 1 multiplet blend at 6806
      call PntForLine(      6801., 'Cr 4' , ipnt )
      call lindst( Cr4l31 , 6801 , 'Cr 4',ipnt,'c',.true.)
*     call linadd( Cr4l31 , 6801 , 'Cr 4','c')
*
*     [CrV] 2 - 1 multiplet blend at 7985
      call PntForLine(      7979., 'Cr 5' , ipnt )
      call lindst( Cr5l21 , 7979 , 'Cr 5',ipnt,'c',.true.)
*     call linadd( Cr5l21 , 7979 , 'Cr 5','c')
*
*     [CrV] 3 - 1 multiplet blend at 6582
      call PntForLine(      6577., 'Cr 5' , ipnt )
      call lindst( Cr5l31 , 6577 , 'Cr 5',ipnt,'c',.true.)
*     call linadd( Cr5l31 , 6577 , 'Cr 5','c')
*
*     [CrV] 3 - 2 multiplet blend at 3.75 microns
      call PntForLine( 3.75e4  , 'Cr 5' , ipnt )
      call lindst( Cr5l32 , 37 , 'Cr 5',ipnt,'c',.true.)
*     call linadd( Cr5l32 , 37 , 'Cr 5','c')
*
*     [Cr VIII] 1.01 microns
      call PutLine( Cr08101 )
*
*     [Cr 16] 1410.60
      call PutLine( Cr16141 )
*
*     Manganese Ly a recombination from fully stripped ion
      nelem = 25
*     these lines added to outlin in metdif - following must be false
      xmnla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9 
      call PntForLine( 2.84  , 'MnLr' , ipnt )
      call lindst( xmnla , 3 , 'MnLr',ipnt,'i',.false.)
*     call linadd( xmnla , 3 , 'MnLr','i')
*
*     [Mn IX] 7968.5 A
      call PutLine( xMn0979 )
*
*     [Mn 17] 1169.59
      call PutLine( xMn1712 )
*
*     bob rubin's uv line
*     f2 = xIonFracs(26,4)*sexp(50 764./te)*0.45*cdsqte/6.*7.01e-12
*     call linadd( f2 , 2837 , 'BobR' , 'i')
*     f2 = xIonFracs(26,4)*sexp(55 989./te)*0.384*cdsqte/6.*7.74e-12
*     call linadd( f2 , 2568 , 'BobR' , 'i')
*
*     iron
*     Fe 1 3884
      call PutLine( FeI3884 )
*
*     Fe 1 3729
      call PutLine( FeI3729 )
*
*     Fe 1 3457
      call PutLine( FeI3457 )
*
*     Fe 1 3021
      call PutLine( FeI3021 )
*
*     Fe 1 2966
      call PutLine( FeI2966 )
*
*     Fe 2 the 3-2 transition of Netzer's atom
      call linadd( rmt48 , 6200 , 'Fe 2','i')
*
*     Fe 2 forbidden 2-1 transition from Netzer's atom
      call linadd( for7 , 4300 , 'Fe 2','i')
*
*     Fe 2 UV3, 3-1 transition from Netzer's atom
      call linadd( emuv3 , 2400 , 'Fe 2','i')
*
*     total of all UV+optical Fe 2 cooling
      call linadd( max(0.,Fecool), 0 , 'Fe2c','c')
      call linadd( max(0.,-Fecool), 0 , 'Fe2h','h')
*
*     1 to 6 transition of Fred's Fe 2 atom
      call linadd( cFe16 , 1100 , 'Fe 2','i')
*
*     2 to 6 transition of Fred's Fe 2 atom
      call linadd( cFe26 , 1500 , 'Fe 2','i')
*
*     3 to 4 transition of Fred's Fe 2 atom
      call linadd( cFe34 , 11500 , 'Fe 2','i')
*
*     3 to 5 transition of Fred's Fe 2 atom
      call linadd( cFe35 , 2500 , 'Fe 2','i')
*
*     4 to 6 transition of Fred's Fe 2 atom
      call linadd( cFe46 , 2300 , 'Fe 2','i')
*
*     5 to 6 transition of Fred's Fe 2 atom
      call linadd( cFe56 , 8900 , 'Fe 2','i')
*
*     results of 16 level Fe 2 atom, not all are printed
*     all cooling due to 16 level atom
      call linadd( Fe2L16Tot , 0 , 'Fe 2', 'c' )
*
*     Fe 2 1.664 microns 8-13
      call PntForLine(    16640. ,  'Fe 2' , ipnt )
      call lindst( fe21308 , 166 ,  'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21308 , 166 ,  'Fe 2' , 'i' )
*
*     Fe 2 1.599 microns 7-12
      call PntForLine(    15990. , 'Fe 2' , ipnt )
      call lindst( fe21207 , 160 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21207 , 160 , 'Fe 2' , 'i' )
*
*     Fe 2 1.534 microns 6-11
      call PntForLine(    15340. , 'Fe 2' , ipnt )
      call lindst( fe21106 , 153 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21106 , 153 , 'Fe 2' , 'i' )
*
*     Fe 2 1.644 microns 6-10
      call PntForLine(    16440. , 'Fe 2' , ipnt )
      call lindst( fe21006 , 164 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21006 , 164 , 'Fe 2' , 'i' )
*
*     Fe 2 1.279 microns 12-4
      call PntForLine(     12790. , 'Fe 2' , ipnt )
      call lindst( fe21204 , 128 ,  'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21204 , 128 ,  'Fe 2' , 'i' )
*
*     Fe 2 1.295 microns 11-3
      call PntForLine(     12950. , 'Fe 2' , ipnt )
      call lindst( fe21103 , 130 ,  'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21103 , 130 ,  'Fe 2' , 'i' )
*
*     Fe 2 1.328 microns 11-4
      call PntForLine(    13280. , 'Fe 2' , ipnt )
      call lindst( fe21104 , 133 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21104 , 133 , 'Fe 2' , 'i' )
*
*     Fe 2 1.257 microns 10-1
      call PntForLine(    12570. , 'Fe 2' , ipnt )
      call lindst( fe21001 , 126 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21001 , 126 , 'Fe 2' , 'i' )
*
*     Fe 2 1.321 microns 10-2
      call PntForLine(    13210. , 'Fe 2' , ipnt )
      call lindst( fe21002 , 132 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21002 , 132 , 'Fe 2' , 'i' )
*
*     Fe 2 25.988 microns 2-1
      call PntForLine(   259880. , 'Fe 2' , ipnt )
      call lindst( fe20201 , 259 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20201 , 259 , 'Fe 2' , 'i' )
*
*     Fe 2 35.348 microns 3-2
      call PntForLine(   353480. , 'Fe 2' , ipnt )
      call lindst( fe20302 , 353 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20302 , 353 , 'Fe 2' , 'i' )
*
*     Fe 2 17.936 microns 7-6, label is 178 to be unique
      call PntForLine(   179360. , 'Fe 2' , ipnt )
      call lindst( fe20706 , 178 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20706 , 178 , 'Fe 2' , 'i' )
*
*     Fe 2 24.518 microns 8-7
      call PntForLine(   245180. , 'Fe 2' , ipnt )
      call lindst( fe20807 , 245 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20807 , 245 , 'Fe 2' , 'i' )
*
*     Fe 2 35.776 microns 9-8
      call PntForLine(   357760. , 'Fe 2' , ipnt )
      call lindst( fe20908 , 358 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20908 , 358 , 'Fe 2' , 'i' )
*
*     Fe 2 1.810 microns 10-7
      call PntForLine(    18100. , 'Fe 2' , ipnt )
      call lindst( fe21007 , 181 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21007 , 181 , 'Fe 2' , 'i' )
*
*     Fe 2 1.677 microns 11-7
      call PntForLine(    16770. , 'Fe 2' , ipnt )
      call lindst( fe21107 , 168 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21107 , 168 , 'Fe 2' , 'i' )
*
*     Fe 2 1.800 microns 11-8
      call PntForLine(    18000. , 'Fe 2' , ipnt )
      call lindst( fe21108 , 180 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21108 , 180 , 'Fe 2' , 'i' )
*
*     Fe 2 1.712 microns 12-8
      call PntForLine(    17120. , 'Fe 2' , ipnt )
      call lindst( fe21208 , 171 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21208 , 171 , 'Fe 2' , 'i' )
*
*     Fe 2 1.798 microns 12-9
      call PntForLine(    17980. , 'Fe 2' , ipnt )
      call lindst( fe21209 , 179 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21209 , 179 , 'Fe 2' , 'i' )
*
*     Fe 2 22.902 microns 11-10
      call PntForLine(   229020. , 'Fe 2' , ipnt )
      call lindst( fe21110 , 229 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21110 , 229 , 'Fe 2' , 'i' )
*
*     Fe 2 34.660 microns 12-11
      call PntForLine(   346600. , 'Fe 2' , ipnt )
      call lindst( fe21211 , 347 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21211 , 347 , 'Fe 2' , 'i' )
*
*     >>chng 97 mar 14, added following 4 lines after consultation with Verner
*     these are typically within 5-9% of their large model atom
*     Fe 2 8619A 14-06
      call PntForLine(       8619., 'Fe 2' , ipnt )
      call lindst( fe21406 , 8619 , 'Fe 2',ipnt,'i',.true.)
*     call linadd( fe21406 , 8619 , 'Fe 2' , 'i' )
*
*     Fe 2 8894A 15-07
      call PntForLine(       8894., 'Fe 2' , ipnt )
      call lindst( fe21507 , 8894 , 'Fe 2',ipnt,'i',.true.)
*     call linadd( fe21507 , 8894 , 'Fe 2' , 'i' )
*
*     Fe 2 9229A 15-08
      call PntForLine(       9229., 'Fe 2' , ipnt )
      call lindst( fe21508 , 9229 , 'Fe 2',ipnt,'i',.true.)
*     call linadd( fe21508 , 9229 , 'Fe 2' , 'i' )
*
*     Fe 2 9270A 16-09
      call PntForLine(       9270., 'Fe 2' , ipnt )
      call lindst( fe21609 , 9270 , 'Fe 2',ipnt,'i',.true.)
*     call linadd( fe21609 , 9270 , 'Fe 2' , 'i' )
*
*     some banks from Katya Verner's model Fe II atom
*     when not linked in, just zeros, numbers set in block data scalar
      do i=1,LimPredFe2
        eff = SumBandFe2( iPredFe2(2,i) , iPredFe2(3,i))
*       emission from lage FeII atom, integrated over band
        call linadd( eff , iPredFe2(1,i) , 'Fe2b' , 'i' )
      end do
*
*     anomalous Fe 2 transition at 1787, RMT 191
      call PutLine( t191 )
*
*     sum of 3p and 3g states together
      call linadd( c5270 , 0 , 'Fe 3','c')
*
*     Fe 3 5270, predictions from garstang et al 78
      call PntForLine(            5270., 'Fe 3' , ipnt )
      call lindst( c5270*0.2090 , 5270 , 'Fe 3',ipnt,'c',.true.)
*     call linadd( c5270*0.2090 , 5270 , 'Fe 3','c')
*
*     Fe 3 5270, predictions from garstang et al 78
      call PntForLine(            4658., 'Fe 3' , ipnt )
      call lindst( c5270*0.3667 , 4658 , 'Fe 3',ipnt,'c',.true.)
*     call linadd( c5270*0.3667 , 4658 , 'Fe 3','c')
*
*     Fe 3 1122 entire multiplet
      call PutLine( t1122 )
*
*     total cooling due to 12-level Fe 4 atom
      call linadd( Fe4CoolTot , 0 , 'Fe 4','c')
*
*     Fe 4 3096.A, 4-1 and 5-1 transitions together
      call PntForLine(       3096., 'Fe 4' , ipnt )
      call lindst( fe40401 , 3096 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe40401 , 3096 , 'Fe 4','i')
*
*     Fe 4 2835.7A, 6-1 transition, 4P5/2 - 6S5/2
      call PntForLine(       2836., 'Fe 4' , ipnt )
      call lindst( fe42836 , 2836 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe42836 , 2836 , 'Fe 4','i')
*
*     Fe 4 2829.4A, 7-1 transition, 4P3/2 - 6S5/2
      call PntForLine(       2829., 'Fe 4' , ipnt )
      call lindst( fe42829 , 2829 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe42829 , 2829 , 'Fe 4','i')
*
*     Fe 4 2567.6+ 2567.4. 11-1 and 12-1 transitions
      call PntForLine(       2567., 'Fe 4' , ipnt )
      call lindst( fe42567 , 2567 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe42567 , 2567 , 'Fe 4','i')
*
*     Fe 4 2.774 microns 12-7 transition
      call PntForLine(    2.774e4, 'Fe 4' , ipnt )
      call lindst( fe41207 , 277 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41207 , 277 , 'Fe 4','i')
*
*     Fe 4 2.714 microns 12-6 transition
      call PntForLine(  2.714e4  , 'Fe 4' , ipnt )
      call lindst( fe41206 , 271 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41206 , 271 , 'Fe 4','i')
*
*     Fe 4 2.716 microns 11-6 transition
      call PntForLine(  2.716e4  , 'Fe 4' , ipnt )
      call lindst( fe41106 , 272 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41106 , 272 , 'Fe 4','i')
*
*     Fe 4 2.806 microns 10-7 transition
      call PntForLine(  2.806e4  , 'Fe 4' , ipnt )
      call lindst( fe41007 , 281 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41007 , 281 , 'Fe 4','i')
*
*     Fe 4 2.865 microns 10-8 transition
      call PntForLine(  2.865e4  , 'Fe 4' , ipnt )
      call lindst( fe41008 , 287 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41008 , 287 , 'Fe 4','i')
*
*     Fe 4 2.836 microns 9-6 transition
      call PntForLine(  2.836e4  , 'Fe 4' , ipnt )
      call lindst( fe40906 , 284 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe40906 , 284 , 'Fe 4','i')
*
*     Fe 5  3892+3839
      call PntForLine(     3892., 'Fe 5' , ipnt )
      call lindst( c3892 , 3892 , 'Fe 5',ipnt,'c',.true.)
*     call linadd( c3892 , 3892 , 'Fe 5','c')
*
*     all of 2G lines together first
      call linadd( c5177 , 0 , 'Fe 6','c')
*
*     Fe 6 5177, approximate correct
      call PntForLine(           5177., 'Fe 6' , ipnt )
      call lindst( c5177*0.354 , 5177 , 'Fe 6',ipnt,'c',.true.)
*     call linadd( c5177*0.354 , 5177 , 'Fe 6','c')
*
*     [Fe 7] 9.51 micron
      call PutLine( Fe0795 )
*
*     [Fe 7] 7.81 micron
      call PutLine( Fe0778 )
*
*     [Fe 7] 6087
      call PntForLine(     6087., 'Fe 7' , ipnt )
      call lindst( c6087 , 6087 , 'Fe 7',ipnt,'c',.true.)
*     call linadd( c6087 , 6087 , 'Fe 7','c')
*
*     [Fe 7] 5722
      call PntForLine(      5722., 'Fe 7' , ipnt )
      call lindst( Fe5722 , 5722 , 'Fe 7',ipnt,'c',.true.)
*     call linadd( Fe5722 , 5722 , 'Fe 7','c')
*
*     Be-seq lines
      call PutLine( t245 )
*
*     Fe 9 242 j=1 slower decay
      call PntForLine(    242., 'Fe 7' , ipnt )
      call lindst( c242 , 242 , 'Fe 7',ipnt,'c',.true.)
*     call linadd( c242 , 242 , 'Fe 9','c')
*
*     the E1 transition that can pump [Fe X]
      call PutLine( t352 )
*
*     optically thin Fe X pumping
      colfac = 8.629e-6/sqrte*eden
      eff = 69.4 / (69.4 + 0.27*colfac)
*
*     coll exc of 352 which decays to escit state of 6374
*     assumes 17/56 (ratio of A's) go to excit state
      c10 = t352(ipLnNPhots)*eff*.01676  * t352(ipLnEnrErg) *
     1 352/6374.
*
*     Fe 10 and Fe 14 from Mason 75
*     total (coll, pumped)
*     call linadd( C6374+C10 , 6374 , 'Fe10','i')
      call PutExtra( c10 )
*
*     [Fe 10] 6375, collisions with pumping too
      call PutLine( Fe106375 )
*
*     collisional contribution
*     call linadd( C6374 , 6374 , 'Coll','c')
*     collisions of E1 line, plus pumped by continuum fluorescense
*     call linadd( C10 , 6374 , ' 352','c')
*     Fe XI 7892, 6.08 micron
      call PutLine( tFe07 )
*
* 666 error! put this line back in!
*     EFF = 43.6 / (43.6 + 0.27*COLFAC)
*     R11 = FE(11)*FLUX(IPFE10)*3.122E-12*EFF *
*    1 ( PFE11A*ESCINC(T353(1),1E-4)/(1.+17.0/5.3*T353(3) )  +
*    2 PFE11B*ESCINC(T353(1)/3.,1E-4)/(1.+11.0/12.3*T353(3) ) )
*     contribution to Fe11 from continuum fluorescense
*     call linadd( R11    , 7892 , 'Pump','i')
*
*     [Fe 11] 6.08 microns
      call PutLine( tFe61 )
*
*     Fe 11 2649 collisional excitation
      call PntForLine(     2649., 'Fe11' , ipnt )
      call lindst( c2649 , 2649 , 'Fe11',ipnt,'c',.true.)
*     call linadd( c2649 , 2649 , 'Fe11','c')
*
*     Fe 11 1467 collisional excitation
      call PntForLine(     1467., 'Fe11' , ipnt )
      call lindst( c1467 , 1467 , 'Fe11',ipnt,'c',.true.)
*     call linadd( c1467 , 1467 , 'Fe11','c')
*
*     Fe 12, 1242, 1349 together, collisional excitation
      call PntForLine(     1242., 'Fe12' , ipnt )
      call lindst( c1242 , 1242 , 'Fe12',ipnt,'c',.true.)
*     call linadd( c1242 , 1242 , 'Fe12','c')
*
*     Fe 12, 2170, 2406 together, collisional excitation
      call PntForLine(     2170., 'Fe12' , ipnt )
      call lindst( c2170 , 2170 , 'Fe12',ipnt,'c',.true.)
*     call linadd( c2170 , 2170 , 'Fe12','c')
*
*     Fe12 2904, 2567, 3567, 3073 together, collisional excitation
      call PntForLine(     2568., 'Fe12' , ipnt )
      call lindst( c2568 , 2568 , 'Fe12',ipnt,'c',.true.)
*     call linadd( c2568 , 2568 , 'Fe12','c')
*
*     [Fe 13] 1.07 microns
      call PutLine( Fe1310 )
*
*     [Fe 13] 1.08 microns
      call PutLine( Fe1311 )
*
*     Fe 14 optically thin in line 344
      eff = 60.3 / (60.3 + 0.23 * colfac/4. )
      r14 = xIonFracs(26,14)*pfe14*flux(ipfe10)*3.75e-12*eff /
     1 (1.+24./.63*t347(3) ) * escinc(t347(1),1e-4)
      call PntForLine(         5303., 'Fe14' , ipnt )
      call lindst( c5303+r14 , 5303 , 'Fe14',ipnt,'i',.true.)
*     call linadd( c5303+r14 , 5303 , 'Fe14','i')
*
*     contribution from collisional excitation
      call linadd( c5303 , 5303 , 'Coll','c')
*
*     continuum fluorescense
      call linadd( r14 , 5303 , 'Pump','r')
*
*     collisional excitation of E1 line
* 666 error! put this in
      c14 = 0.
      call linadd( c14 , 5303 , ' 347','c')
*
*     Fe 18 974.86A
      call PutLine( Fe18975 )
*
*     Fe 19 from loulergue et al '85
      call PntForLine(    592., 'Fe19' , ipnt )
      call lindst( c592 , 592 , 'Fe19',ipnt,'c',.true.)
*     call linadd( c592 , 592 , 'Fe19','c')
*
*     Fe 19 from loulergue et al '85
      call PntForLine(     7082., 'Fe19' , ipnt )
      call lindst( c7082 , 7082 , 'Fe19',ipnt,'c',.true.)
*     call linadd( c7082 , 7082 , 'Fe19','c')
*
*     Fe 19 from loulergue et al '85
      call PntForLine(     1118., 'Fe19' , ipnt )
      call lindst( c1118 , 1118 , 'Fe19',ipnt,'c',.true.)
*     call linadd( c1118 , 1118 , 'Fe19','c')
*
*     Fe 19 from loulergue et al '85
      call PntForLine(     1328., 'Fe19' , ipnt )
      call lindst( c1328 , 1328 , 'Fe19',ipnt,'c',.true.)
*     call linadd( c1328 , 1328 , 'Fe19','c')
*
*     next two 3p ground state lines, collisional excitation
      call PutLine( tFe13 )
*
*     collisional excitation
      call PutLine( tFe23 )
*
*     Fe 22 845.6A
      call PntForLine(     846., 'Fe22' , ipnt )
      call lindst( fs846 , 846 , 'Fe22',ipnt,'c',.true.)
*     call linadd( fs846 , 846 , 'Fe22','c')
*
*     Fe 23 1909-like 262.6
      call PntForLine(    263., 'Fe23' , ipnt )
      call lindst( c263 , 263 , 'Fe23',ipnt,'c',.true.)
*     call linadd( c263 , 263 , 'Fe23','c')
*
*     Fe 24 only 192 of 255, 192 Li seq doublet, collisional excitation
      call PutLine( t192 )
*
*     Fe 24 255 of 255, 192 Li seq doublet, collisional excitation
      call PutLine( t255 )
*
*     Fe 24 Li seq 2s3p collisional excitation
      call PutLine( t11 )
*
*     recombination Ka
      nelem = 26
*     these lines added to outlin in metdif - following must be false
      fela = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
*
*     total intensity of K-alpha line
      call linadd( fekcld*1.03e-8+(fekhot+fela)*1.11E-8, 2 , 'FeKa','i')
*
*     recombination from fully stripped ion
      call linadd( fela*1.11E-8 , 2 , 'FeLr','i')
*
*     total hot iron Ka; Auger "hot" iron, plus recom
      call linadd( (fekhot+fela)*1.11E-8 , 2 , 'TotH','i')
*
*     Auger production of "cold" iron, less than or 17 times ionized
      call linadd( fekcld*1.03e-8 , 2 , 'AugC','i')
*
*     cobalt
*     Ly-alpha recombination from fully stripped ion
      nelem = 27
*     these lines added to outlin in metdif - following must be false
      cola = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( cola*1.30E-8 , 1 , 'CoLr','i')
*
*     [Co XI] 5168. A
      call PutLine( Co11527 )
*
*     nickel
*     Ni Ly-alpha recombination from fully stripped ion, 1.5A
      nelem = 28
*     these lines added to outlin in metdif - following must be false
      xnila = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( xnila*1.30e-8 , 1 , 'NiLr','i')
*
*     [Ni XII] 4230.8 A
      call PutLine( xNi1242 )
*
*     copper
*     Cu Ly-alpha recombination from fully stripped ion, 1.5A
      nelem = 29
*     these lines added to outlin in metdif - following must be false
      cula = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.30E-8
      call PntForLine( 1.3  , 'CuLr' , ipnt )
      call lindst( cula , 1 , 'CuLr',ipnt,'i',.false.)
*     call linadd( cula , 1 , 'CuLr','i')
*
*     zinc
*     Zn Ly-alpha recombination from fully stripped ion, 1.5A
      nelem = 30
*     these lines added to outlin in metdif - following must be false
      znla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.30E-8
      call PntForLine( 1.3  , 'ZnLr' , ipnt )
      call lindst( znla , 1 , 'ZnLr',ipnt,'i',.false.)
*     call linadd( znla , 1 , 'ZnLr','i')
*
      if( lgTrace ) write(qq,'(''   LineSet4 returns'')')
*
      end
