      subroutine lithi
      implicit none
*compute ionization balance for lithium
      include "limelm.par"
      include "elmton.com"
      include "timed.com"
      include "trace.com"
      include "TePowers.com"
      include "h.com"
      include "phycon.com"
      include "IonFracs.com"
      include "TrHeav.com"
      include "IOqq.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=4)
      parameter (nelem=3)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) 
*
*     lithium nelem=3
*     data are for carbon
*
*     real CollidRate(nelem,2)
*     fluorescent fields, first dim is stage of ionization, sec is shell
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.44e-10,4.20e-11,1.92e-11/
      data (cion(i,2),i=1,ndim-1)
     2 /1.31e5,2.83e5,5.56e5/
*     DATA GRDEFF/0.10,0.10,0.10/
*     GRDEFF is fraction of recombinations to ground state, used for
*     outward diffuse fields
*
*     rec from +3, +4 from Arnaud et al Ast Ap Sup 60 425. (1985)
*     rec from fully ionized uses Seaton '79 in ionrat
      data rec , pl/
     1 1.47e-10 , 8.74e-10 ,
     2  -0.624  , -0.645   /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/1.44e-10 , -0.621/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.54E-3 , 6.15E-3 ,  0./
      data (dicoef(i,2),i=1,ndim-1)
     1/4.42E-2 , 5.88E-2 ,  0./
      data (dite(i,1),i=1,ndim-1)
     2/1.57E+5 , 1.41E+5 , 0./
      data (dite(i,2),i=1,ndim-1)
     2 /3.74E5 , 1.41E5 ,  0./
      data ditcrt
     3/1.2E+4 , 1.2E+4 , 1E20/
*
      data aa/  .0108  ,1.8267 ,0./
     1  ,  bb/-0.1075  ,4.1012 ,0./
     1,    cc/  .2810  ,4.8443 ,0./
     2,    dd/-0.0193  ,.2261  ,0./
     3,    ff/ 0.001   ,0.5960 ,0./
*
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
*     zero out ionization balance arrays
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
* 
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
