***************************************************************
      subroutine MakeStatRT( t )
      implicit none
*do line radiative transfer for static geometry
      include "nta.par"
      real t(nta)
*
      include "ipLnArry.par"
      include "limelm.par"
      include "ncell.par"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "wind.com"
      include "twoway.com"
      include "occnum.com"
      include "DoppVel.com"
      include "fluors.com"
      include "DstWght.com"
      include "taumin.com"
      include "IOqq.com"
*
*     local variables
      real velocity , damp , eovrlp , escgrd,escsub,esccom,escinc
      integer nelem
*
*     this is the routine that computes much of the radiative transfer
*     physics for lines for static case.  Lines diveded into two types,
*     high quality (ipLnCS1=0) and lower quality g-bar lines
*
*begin sanity check
      if( t(ipLnColovTOT).gt.1.00001 .or. t(ipLnColovTOT).lt.0. ) then
        write(qq,'('' MakeStatRT insane ipLnColovTOT='',1p,e10.2)')
     1  t(ipLnColovTOT)
      endif
      if( t(ipLnTauIn).lt.-30. ) then
        write(qq,'('' MakeStatRT called with large negative optical'',
     1  '' depth.'')')
        call DumpLine( t )
      endif
*end sanity check
*
*     this checks if we have overrun the optical depth scale
*     possible for line to mase, reason for sec test
*     >>chng 97 jan 8, on iterations where the first iteration had NO species,
*but it does exist on later iterations, added test for existence of ion
      if( t(ipLnTauTot)*0.9-t(ipLnTauIn) .lt. 0. .and.
     1  t(ipLnTauIn).gt.0. .and. t(ipLnTauTot).ne.taumin ) then
*       do not do anything if we have overrun the scale
        return
      endif
      nelem = t( ipLnNelem )
*     negative element number says ignore it
      if( nelem.lt.0. ) return
      velocity = doppler(nelem)
      damp = t(ipLnDampRel) / velocity
      t(ipLnDamp) = damp
*
*     this this is 0th zone then use full destruction prob,
*     else use mean of old and new - NB must reset at end
      if( nzone.lt.1 ) DestWght = 1.
*
*     static solution - which redistribution function?
      if( t(ipLnRedis).gt.0. ) then
*       incomplete redistribution
*       escape probability
*     >>chng 97 june 27, add pointer to continuum 
        t(ipLnEscP) = escgrd( t(ipLnTauIn) , t(ipLnTauTot) , damp ,
     1  int( t(ipLnIpCont) ) )
*       inward escaping fraction
        t(ipLnInwd) = fracin
*       destruction probability
        if( t(ipLnCS1).eq.0. ) then
*         higher quality lines
*     >>chng 96 sep 4 to DestWght weighting
          t(ipLnDesP) =  t(ipLnDesP) * (1.-DestWght) + DestWght*
     1    eovrlp( t(ipLnPopOpc) , t(ipLnTauIn) ,
     1    t(ipLnTauTot) , damp , t(ipLnOpac) , INT(t(ipLnIpCont)) ,
     1    velocity, t(ipLnEscP) , 'INCO')
*         continuum pumping rate, A gu/gl abs prob occnum
*         the "no induced" command causes conpmp to set 0
          if( lgFluor ) then
            wayin = escinc( t(ipLnTauCon),damp )
            t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1      wayin * occnum(int(t(ipLnIpCont)))
          else
            t(ipLnPump) = 0.
          endif
*    1    conpmp(t(1)) * occnum(int(t(ipLnIpCont)))
        else
          t(ipLnDesP) = 0.
*         wayin was computed by escape prob routine, is inner esc
          if( lgFluor ) then
            wayin = escinc( t(ipLnTauCon),damp )
            t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1      wayin * occnum(int(t(ipLnIpCont)))
          else
            t(ipLnPump) = 0.
          endif
        endif
      else
*       complete redistribution - t(ipLnRedis) is negative
* 666 error! put in something like escfs for maser effects
        t(ipLnEscP) = escsub( t(ipLnTauIn) , t(ipLnTauTot) , damp )
*       inward escaping fraction
        t(ipLnInwd) = fracin
        if( t(ipLnCS1).eq.0. ) then
*         destruction probability
*     >>chng 96 sep 4 to DestWght weighting
          t(ipLnDesP) =  t(ipLnDesP) * (1.-DestWght) + DestWght*
     1    eovrlp( t(ipLnPopOpc) , t(ipLnTauIn) ,
     1    t(ipLnTauTot) , damp , t(ipLnOpac) , INT(t(ipLnIpCont)) ,
     1    velocity, t(ipLnEscP) , '  K2')
*         continuum pumping rate
*         the "no fluor" command causes conpmp to set 0
          if( lgFluor ) then
            wayin = esccom( t(ipLnTauCon),damp )
            t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1      wayin * occnum(int(t(ipLnIpCont)))
          else
            t(ipLnPump) = 0.
          endif
*    1    conpmp(t(1))* occnum(int(t(ipLnIpCont)))
        else
          t(ipLnDesP) = 0.
*         wayin was computed by escape prob reoutine, is inner esc
          if( lgFluor ) then
            wayin = esccom( t(ipLnTauCon),damp)
            t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1      wayin * occnum(int(t(ipLnIpCont)))
          else
            t(ipLnPump) = 0.
          endif
        endif
      endif
*
*     reset weighting
      DestWght = DestWghtSave 
*
      end
