******************************************************************************
      subroutine mgcol
      implicit none
*compute magnesium cooling
      include "ndfst.par"
      include "limLevelN.par"
      include "limelm.par"
      include "ncell.par"
      include "ipLnArry.par"
      include "nta.par"
      include "dcool.com"
      include "coolmg.com"
      include "PopLevls.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "opac.com"
      include "resion.com"
      include "mgexc.com"
      include "ots.com"
      include "logte.com"
      include "TauDmmy.com"
      include "IonFracs.com"
*
*     local variables
      real csoi,popexc,cs, cs2s2p,cs2s3p,csdum
*
*     Mg I 2853 
*     fit to Dima's  integration of
*     >>refer Leep, D., & Gallagher, A. 1976, Phys Rev A, 13, 148
      cs = 5.21e-4 * te/te10
      call PutCS( cs , MgI2853 )
      call level2( MgI2853 )
*
*     Mg I 2026, 
      call MakeCS( MgI2026 )
      call level2( MgI2026 )
*
*     Mg 1 4571, data from Mendoza
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs set to O I
      csoi = 2.68e-5*te*(1.+1.67e-6*te-2.95e-10*te*te)
      csoi = max( 0.1 , csoi)
      call PutCS( csoi/9. , t4561 )
      call level2( t4561 )
*
*     Mg II 2798
*     cs from 
*     >>refer Sigut, A., & Pradhan, A.K., 1994, J Phys B sub
*     refer not publ as of '97, cs agrees fairly well with Harrington et al.
*     previous reference (~'82)
      cs2s2p = 4.50 * te10
      call PutCS( cs2s2p , t2796 )
      call PutCS( cs2s2p*0.5 , t2804 )
      call PutCS(  1.0 , TauDummy )
      call level3( t2804,TauDummy, t2796)
*     call PutCS( cs , t2800 )
*     call level2( t2800 )
*
*     following used in MAGNES for photo destruction rate
      if( PopLevels(0) .gt.0. ) then
        popmg2 = (PopLevels(2)+PopLevels(1))/PopLevels(0)
      else
        popmg2 = 0.
      endif
*
*     MG IV 4.487 MIC 
*     cs 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.356 , min(0.425, 0.180*te05*te02 ) )
      call PutCS( cs ,  tMg4 )
      call level2( tMg4 )
*
*     MG V 5.61, 13.54 micron, 
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
*     >>chng 96 july 16 had been constant 0.3
      cs = min( 0.311, 0.11*te10 )
      call PutCS( cs , tMg14 )
      cs = min( 1.06 , 0.339 * te10 )
      call PutCS( cs , tMg6 )
*     >>chng 96 july 16 had been constant 0.3
      cs = min( 0.297, 0.0745*te10*te02 )
      call PutCS( cs , TauDummy )
      call level3(tMg6,tMg14,TauDummy)
*
*     [Mg V] 2751+2893- Ne III-like, cs 
*     >>refer Mendoza, C., & Zeippen, C.J. 1987, MNRAS, 224, 7p
*     >>chng 96 aug 5 to three level atom
*     c2751 = popexc(1.33,9.,5.,2.4,5.14e4,xmg(5))*7.11e-12
*     dCooldT = dCooldT + c2751*5.14e4*tsq1
*     call coladd( 'Mg 5' , 2751 , C2751 )
*
*     following is 2-1 transition, both 2928 and 2783, 
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      call PutCS( 1.187 , xMg52855 )
      cs = max( 0.182 , min( 0.278,0.0171*te20*te05/te005/te003) )
*     3-2 transition, 2417.5
      call PutCS( cs , xMg52417 )
*     3-1 transition, 1324.58
      call PutCS( 0.153 , xMg51325 )
      call level3(  xMg52855,xMg52417,xMg51325)
*
*     Mg VI, 1806- OII like, data 
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1806 = popexc( 0.6,4.,10.,0.1,7.974e4,xIonFracs(12,6))*1.11E-11
      call coladd( 'Mg 6' , 1806 , c1806 )
*
*     [Mg VII] IR lines at 5.517 and 9.03 microns, 
*     carbon-like, 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      if( alogte.lt.4.4 ) then
        cs =  0.027 * te30/te03*te003*te001
      else
        cs =  0.44
      endif
      call PutCS( cs ,fsMg790 )
      if( alogte.lt.4.6 ) then
        cs =  min( 1.456, 0.0577*te30*te02/te001/te001 )
        csdum = 8.275e-3 * sqrte/te10/te001
      else
        cs =  3.257/(te05*te02*te003*te003 )
        csdum =  1.456/(te10*te01*te005 )
      endif
      call PutCS( cs ,fsMg755 )
      call PutCS( csdum , TauDummy )
*     level3(  t10,t21,t20)
      call level3(fsMg790,fsMg755,TauDummy)
*
*     [mg vii] 2510, 2629
*     c2596 = popexc( 1.7,9.,5.,10.,5.76e4,xIonFracs(12,7))*7.96e-12
*     dCooldT = dCooldT + c2596 * 5.76e4*tsq1
*     call coladd( 'Mg 7' , 2596 , C2596 )
*
*     >>chng 96 aug 5, converted to 3 level atom
      cs = min( 0.22, 0.3622/(te05*te02*te003) )
      call PutCS( cs , xMg71190 )
*     2-1 transitions, 2509.2A+2629.1A together
      cs = min( 1.067 , 0.247*te10*te03*te005 )
      call PutCS( cs , xMg72569 )
*     3-2 transition, 2261.5A
      cs = max( 0.3735 , min( 0.542 , 3.863/(te20*te03*te01/te003) ) )
      call PutCS( cs , xMg72261 )
      call level3( xMg72569 , xMg72261 , xMg71190 )
*     level3(  t10,t21,t20)
*
*     Mg VIII 3.03 micron, data from 
*     >>refer Chandra, S. 1982, SoPh, 75, 133
*     cs from 
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
      call PutCS( 1.0 , xMg08303 )
      call level2( xMg08303 )
*     fs303 = popexc(0.26,2.,4.,0.324,4752.,xmg(8))*6.58E-13
*     call coladd( 'Mg 8' , 303 , FS303 )
*
*     Mg IX 704.5, 1909-like, A from
*     >>refer Muhlethaler, H.P., & Nussbaumer, H. 1976, A&A 48, 109
*     beseq line, cs data from 
*     >>refer Keenan, F.P. Berrington, K.A., Burke, P.G., Dufton, P.L.,
*     >>refer Kingston, A.E. 1986, PhyS 34, 216
*     A's 
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
* 666 error! use beseq here
      cs = 0.98288 - 0.23766*alogte + 0.014334*alogte**2
      cs = max( 0.01, cs )
      call PutCS( cs , t705 )
      call level2( t705 )
*
*     Mg X 610
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 12 , tMg610, t58, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , tMg610 )
      call PutCS( cs2s2p*0.5 , tMg625 )
      call PutCS(  1.0 , TauDummy )
      call level3( tMg625,TauDummy, tMg610)
*
*     Mg X 58A
      call PutCS( cs2s3p , t58 )
      call level2( t58 )
*
      end
