******************************************************************************
      subroutine molcol( chLabel )
      implicit none
*generate and print molecular column densities
      character chLabel*4
*
      include "nhevml.par"
      include "limelm.par"
      include "hvmolARR.com"
      include "hvcolARR.com"
      include "dRdVeff.com"
      include "phycon.com"
      include "DoppVel.com"
      include "IOqq.com"
*
*     local variables
      integer i
      real xMosheH2O , Xm4
      save xMosheH2O
*
      if( chLabel.eq.'ZERO' ) then
*        zero out the column densities
         do i=1,nhevml
           hevcol(i) = 0.
         end do
         xMosheH2O = 0.
*
      else if( chLabel.eq.'ADD ' ) then
*        add together column densities
         do i=1,nhevml
           hevcol(i) = hevcol(i) + hevmol(i) * dReff
         end do
*
*        parameters for Moshe's maser theory
         Xm4 = hevmol(9)*1e4/hden
         xMosheH2O = xMosheH2O +  Xm4 * ( (hden*1e-9)**2 ) *
     1   (dReff/1e13) * (doppler(9)/1e5)
*
      else if( chLabel.eq.'PRIN' ) then
*        print the column densities
         write(qq,'(''                  CH:'',1P,E9.3,2X,'' CH+:'',E9.3,
     1   ''  OH:'',E9.3,'' OH+:    '',E9.3,2X,''O2:   '',E9.3,''  C2:'',
     2   E9.3,4X,''   CO:'',E9.3)') (hevcol(i),i=1,7)
*
         write(qq,'(''                 CO+:'',1P,E9.3,2X,'' H2O:'',E9.3,
     1   ''H2O+:'',E9.3,'' O2+:    '',E9.3,'' C2+:   '',E9.3,'' H3+:'',
     2   E9.3,4X,'' H3O+:'',E9.3)') (hevcol(i),i=8,14)
*
         write(qq,'(''                CH2+:'',1P,E9.3,2X,'' CH2:'',E9.3,
     1   '' CH3:'',E9.3,''MoH2O    '',e9.3)') (hevcol(i),i=15,17),
     2   xMosheH2O
      else
         write(qq,'('' MOLCOL does not understand the label '',A4)') 
     1   chLabel
         stop
      endif
*
      end
