******************************************************************************
      subroutine nockon
      implicit none
*computes suprathermal excitation and ionization efficiencies
      include "itrdim.par"
      include "secoff.com"
      include "efrac.com"
      include "shullc.com"
      include "phycon.com"
      include "totnuc.com"
      include "ZoneCnt.com"
*
*     local variables
      real xe 
      integer nzsave
      real OldEfionz , OldHeatef , OldExctef
      save OldEfionz , OldHeatef , OldExctef
      save nzsave
      data nzsave/-2/
*
      nzsave = nzone
*     ElecFrac is electron fraction
      ElecFrac = eden / totnuc
      csuEfrac = ElecFrac
*
*     XE = EDEN/(total neutrals, roughly H)
*     analytic fits to Shull and Van Steenberg (1985; Ap.J. 298, 268).
*     lgSecOFF turns off secondary ionizations, sets heating effic to 100%
*
*     heating efficiency
*     following is electron fraction, could be >1 because of He
      xe = ElecFrac
*     only do this if continuum goes to high energies
      if( nzone.lt. 1 ) then
        OldHeatef = 1.
        OldEfionz = 0.
        OldExctef = 0.
      endif
*
      if( lgSecOFF .or. xe.gt.0.95 ) then
        heatef = 1.
        efionz = 0.
        exctef = 0.
      else
*
*       at very low ionization - as per Xu and McCray 1991, Ap.J. 375, 190.
*       everything goes to asymptote that is not present in Shull and
*       Van Steenberg - do this by not letting xe fall below 1e-4
        xe = max( xe , 1e-4)
        heatef = 0.9971 * ( 1.-(1.-xe**0.2663)**1.3163 )
        heatef = (heatef + OldHeatef)/2.
        OldHeatef = heatef
*
*       secondary ionization
        efionz = 0.3908 * (1.-xe**0.4092)**1.7592
        OldEfionz = efionz
*
*       secondary excitation of L-alpha, actually all Lyman lines
        exctef = 0.4766 * (1.-xe**0.2735)**1.5221
        exctef = (exctef + OldExctef) / 2.
        OldExctef = exctef
      endif
*
      end
