******************************************************************************
      subroutine nsset
      implicit none
*generate low and high boundaries for ionization distribution of each element
      include "ncell.par"
      include "limelm.par"
      include "he.com"
      include "trace.com"
      include "phycon.com"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "phlevl.com"
      include "h.com"
      include "u.com"
      include "rfield.com"
      include "strkar.com"
      include "he1str.com"
      include "he2str.com"
      include "IonRange.com"
      include "IOqq.com"
*
*     local variables
      integer i,j
*
      if( lgTrace ) write(qq,'('' NSSET called.'')')
*     free statement numbers >=3
*
*     define array of quantum numbers needed for Puetter Stark broadening
      do i=1,nhlvl-1
        do j=i+1,nhlvl
          strkar(j,i) = float(i*j) ** 1.2
          pestrk(j,i) = 0.
        end do
      end do
*
      do i=1,nhe1lvl-1
        do j=i+1,nhe1lvl
          peshe1(j,i) = 0.
        end do
      end do
*
      do i=1,nhe2lvl-1
        do j=i+1,nhe2lvl
          peshe2(j,i) = 0.
        end do
      end do
*
*     fix number of stages of ionization
      do i=1,limelm
        IonLow(i) = 1
        IonHigh(i) = i + 1
      end do
*
*     bring highest stage of ionization within the freq array
      call histag( 6)
      call histag( 7)
      call histag( 8)
      call histag( 9 )
      call histag( 10)
      call histag( 11)
      call histag( 12)
      call histag( 13)
      call histag( 14)
      call histag( 15 )
      call histag( 16)
      call histag( 17)
      call histag( 18)
      call histag( 19 )
      call histag( 20)
      call histag( 21 )
      call histag( 22 )
      call histag( 23 )
      call histag( 24 )
      call histag( 25 )
      call histag( 26)
      call histag( 27)
      call histag( 28)
      call histag( 29)
      call histag( 30)
*
*     if very highly ionized then raise lower ionization stages
      if( uh .ge. 1. ) then
        do i=11,20
          IonLow(i) = max( 1 , IonHigh(i) -7)
        end do
        do i=21,limelm
          IonLow(i) = max( 1 , IonHigh(i) -15)
        end do
      endif
*
      end
