******************************************************************************
      subroutine obsred( chCard )
      implicit none
*parse observed line intensites for optimization routines
      character*80  chCard
*     read observed line fluxes & errors
      include "nobslm.par"
      include "obsint.com"
      include "obslin.com"
      include "troptm.com"
      include "trace.com"
      include "IOqq.com"
*
*     local variables
      logical lgEOF , lgEOL
      integer i , j
      real fread
      character*80  chCap , chVlt*1
      real deferr
      parameter (deferr=0.05)
*
      nlobs = 0
*
      call readar( chCard , lgEOF )
      if( lgEOF ) then
        write(qq,'('' Hit EOF while reading line list; use END to'',
     1  '' end list.'')')
        stop
      endif
      chCap = chCard
      call caps( chCap )
*
      do while( .not.lgEOF )
        nlobs = nlobs + 1
        if( nlobs.gt.nobslm ) then
          write(qq,'('' Too many lines have been entered; the limit is''
     1    ,I4,''.  Increase variable NOBSLM.'')') nobslm
          stop
        endif
*
*       order on line is label (col 1-4), wavelength, flux, error
        chAmLab(nlobs) = chCard(1:4)
        i = 5
        linam(nlobs) = fread( chCard , i , 76 , lgEOL )
        amint(nlobs) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'(1X,A80)') chCard
          write(qq,'('' The wavelength and relative intensity MUST'',
     1    '' be entered on this line.  Sorry.'')')
          stop
        endif
        amierr(nlobs) = fread( chCard , i , 76 , lgEOL )
*
        if( amint(nlobs).le.0. ) then
          write(qq,'('' An observed intensity of'',1P,E10.2,
     1    '' is not allowed.  Sorry.'')') amint(nlobs)
          stop
        endif
*
        if(amierr(nlobs).le.0.0 ) then
*         this is the relative error allowed
          amierr(nlobs) = deferr
        endif
*
*       check if number is a limit
        chVlt = ' '
        do j=1,80
          if(chCard(j:j).eq.'<') then
*           limit value assumed
            chVlt='<'
          endif
        end do
*
        if(chVlt.eq.'<') then
*         value is an upper limit only, use negative error to flag
          amierr(nlobs) = -amierr(nlobs)
        endif
*
*       get next line
        call readar( chCard , lgEOF )
        if( lgEOF ) then
          write(qq,'('' Hit EOF while reading line list; use END to'',
     1    '' end list.'')')
          stop
        endif
        chCap = chCard
        call caps( chCap )
        if( chCap(1:3).eq.'END' ) lgEOF = .true.
      end do
*
      if(lgTrace.and.lgTrOptm ) then
        write(qq,'(I4,'' lines were entered, they were;'')') nlobs
        do i=1,nlobs
          write(qq,'(1x,a4,i5,1p,2e10.2)') chAmLab(i),linam(i),
     1    amint(i),amierr(i)
        end do
      endif
*
      end
