*****************************************
      subroutine oilevl( abund , coloi )
      implicit none
*get OI level population with Ly-beta pumping
      real abund , coloi
*
      include "ipLnArry.par"
      include "nta.par"
      include "ncell.par"
      include "corind.com"
      include "phycon.com"
      include "edsqte.com"
      include "called.com"
      include "ipoi.com"
      include "trace.com"
      include "tr8446.com"
      include "bowoi.com"
      include "popoi.com"
      include "heat.com"
      include "negoi.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "IOqq.com"
*
*     local variables
      integer i, ner
      real c12,c14,c15,c23,c64,c65,c53,c43,c62,simple,cs,
     1 c26,c32,c51,c41,c21,a65,a64,a53,a62,a32,a51,a41,a21,
     2 e56,e45,e23,e12,e34,a43,c56,c46,c34,c35,c16,c61,c13,c31,
     3 c36 , c63 , c42, c24, c52, c25 , c45 , c54
      double precision zz(7,7) 
      logical lgNegPop
      real deptoi(6)
      real g(6)
      data g/9.,3.,9.,3.,15.,9/
*
*     free statement numbers >=3
*
*     compute emission from six level OI atom
*
*     boltzmann factors for ContBoltz since collisions not dominant in UV tran
*     ipoiex is array lof dEnergy for each level, set in DoPoint
      e12 = ContBoltz( ipoiex(1) )
      e23 = ContBoltz( ipoiex(2) )
      e34 = ContBoltz( ipoiex(3) )
      e45 = ContBoltz( ipoiex(4) )
      e56 = ContBoltz( ipoiex(5) )
*
*     total rad rates here include dest by background continuum
      a21 = t1304(ipLnAul)*(t1304(ipLnDesP)+t1304(ipLnEscP))
*
*     check on Martin's line
      a21 = a21 + 1800.
      a41 = t1039(ipLnAul)*(t1039(ipLnDesP)+t1039(ipLnEscP))
      a51 = tO1025(ipLnAul)*(tO1025(ipLnDesP)+tO1025(ipLnEscP))
      a51 = pmpo51
      a32 = t8446(ipLnAul)*(t8446(ipLnDesP)+t8446(ipLnEscP))
      a62 = t4368(ipLnAul)*(t4368(ipLnDesP)+t4368(ipLnEscP))
      a43 = tOI13(ipLnAul)*(tOI13(ipLnDesP)+tOI13(ipLnEscP))
      a53 = tOI11(ipLnAul)*(tOI11(ipLnDesP)+tOI11(ipLnEscP))
      a64 = tOI29(ipLnAul)*(tOI29(ipLnDesP)+tOI29(ipLnEscP))
      a65 = tOI46(ipLnAul)*(tOI46(ipLnDesP) +tOI46(ipLnEscP))
*
*     even at density of 10^17 excited states not in lte due
*     to fast transitions down - just need to kill a21 to get to unity at 10^17
*
*     the 2-1 transition is 1302, cs Wang and McConkey '92 Jphys B 25, 5461
      cs = 2.151e-5 * te/te03
      call PutCS( cs , t1304 )
*     the 5-1 transition is 1027, cs Wang and McConkey '92 Jphys B 25, 5461
      cs = 9.25e-7 * te*te10/te01/te01
      call PutCS( cs , tO1025 )
      c21 = cdsqte * t1304(ipLnCS)  / g(2)
      c51 = cdsqte * tO1025(ipLnCS) / g(5)
*     all following are g-bar approx, g-bar = 0.2
      c31 = cdsqte * 1.0  / g(3)
      call PutCS( 0.27 , t1039 )
      c41 = cdsqte * t1039(ipLnCS) / g(4)
      c61 = cdsqte * 1.   / g(6)
      c12 = c21 * g(2)/g(1) * e12
      c13 = c31 * g(3)/g(1) * e12*e23
      c14 = c41 * g(4)/g(1) * e12*e23*e34
      c15 = c51 * g(5)/g(1) * e12*e23*e34*e45
      c16 = c61 * g(6)/g(1) * e12*e23*e34*e45*e56
*
      c32 = cdsqte*85. / g(3)
      c42 = cdsqte*85. / g(4)
      c52 = cdsqte*85. / g(5)
      c62 = cdsqte*85. / g(6)
      c23 = c32 * g(3)/g(2) * e23
      c24 = c42 * g(4)/g(2) * e23*e34
      c25 = c52 * g(5)/g(2) * e23*e34*e45
      c26 = c62 * g(6)/g(2) * e23*e34*e45*e56
*
      c43 = cdsqte * 70.  / g(4)
      c53 = cdsqte * 312. / g(5)
      c63 = cdsqte * 1.   / g(6)
      c34 = c43 * g(4)/g(3) * e34
      c35 = c53 * g(5)/g(3) * e34*e45
      c36 = c63 * g(6)/g(3) * e34*e45*e56
*
      c54 = cdsqte *  50. / g(5)
      c64 = cdsqte * 415. / g(6)
      c45 = c54 *g(5)/g(4) * e45
      c46 = c64 *g(6)/g(4) * e45*e56
*
      c65 = cdsqte * 400. / g(6)
      c56 = c65 * g(6)/g(5) * e56
*
* 666 error! this must include all stimulated emission, pump by cont, etc
*
*     this is check for whether matrix inversion likely to fail
      simple = (c16 + pmpo15) / (c61+c62+c64+a65+a64+a62)
      if( simple .lt.1e-19 ) then
        popoi(1) = abund
        do i=2,6
          popoi(i) = 0.
        end do
        coloi = 0.
        return
      endif
*
*---------------------------------------------------------
*
      do i=1,6
        zz(1,i) = 1.0
        zz(i,7) = 0.
      end do
*     first equation is sum of populations
      zz(1,7) = abund
*
*     level one ground term
*     zz(1,1) = c12+c14+c15+pmpo15+c16+c13
*     zz(1,2) = -a21 - c21
*     zz(1,3) = -c31
*     zz(1,4) = -c41 - a41
*     zz(1,5) = -c51 - a51
*     zz(1,6) = -c61
*
*     level two, 3s 3So
      zz(2,1) = -c12
      zz(2,2) = c21 +c23 +c24 +c25 +c26 +a21
      zz(2,3) = -c32 - a32
      zz(2,4) = -c42
      zz(2,5) = -c52
      zz(2,6) = -c62 -a62
*
*     level three
      zz(3,1) = -c13
      zz(3,2) = -c23
      zz(3,3) = c31 +c32 +c34 +c35 +c36 +a32
      zz(3,4) = -c43 - a43
      zz(3,5) = -c53 - a53
      zz(3,6) = -c63
*
*     level four
      zz(4,1) = -c14
      zz(4,2) = -c24
      zz(4,3) = -c34
      zz(4,4) = c41 +c42 +c43 +c45 +c46 +a41 +a43
      zz(4,5) = -c54
      zz(4,6) = -c64  -a64
*
*     level five
      zz(5,1) = -c15 - pmpo15
      zz(5,2) = -c25
      zz(5,3) = -c35
      zz(5,4) = -c45
      zz(5,5) = c51 +c52 +c53 +c54 +c56 +a51 +a53
      zz(5,6) = -c65 - a65
*
*     level six
      zz(6,1) = -c16
      zz(6,2) = -c26
      zz(6,3) = -c36
      zz(6,4) = -c46
      zz(6,5) = -c56
      zz(6,6) = c61+c62+c63+c64+c65+a65+a64+a62
*
      call matin1(zz,7,6,1,ner)
      if( ner.ne.0 ) then
        if( lgTalk ) write(qq,'('' oi matrix error'')')
        stop
      endif
*
      lgNegPop = .false.
      do i=1,6
        popoi(i) = zz(i,7)
        if( popoi(i).lt.0. ) lgNegPop = .true.
      end do
*
*     following used to confirm that all dep coef are unity at
*     density of 1e17, t=10,000, and all A's set to zero
      if( lgTrace.and.lgTr8446 ) then
        deptoi(1) = 1.
        deptoi(2) = popoi(2)/popoi(1)/(g(2)/g(1)*e12)
        deptoi(3) = popoi(3)/popoi(1)/(g(3)/g(1)*e12*e23)
        deptoi(4) = popoi(4)/popoi(1)/(g(4)/g(1)*e12*e23*e34)
        deptoi(5) = popoi(5)/popoi(1)/(g(5)/g(1)*e12*e23*e34*e45)
        deptoi(6) = popoi(6)/popoi(1)/(g(6)/g(1)*e12*e23*e34*e45*e56)
        write(qq,'('' oilevl finds levl pop'',1p,10e11.3)') popoi
        write(qq,'('' oilevl finds dep coef'',1p,10e11.3)') deptoi
      endif
*
*     this happens due to numerical instability in matrix inversion routine
      if( lgNegPop ) then
         negoi = negoi + 1
         write(qq,'('' OILEVL finds negative population'',1P,6E10.2)')
     1   popoi
         write(qq,'('' simple 5 ='',1P,E10.2)') simple
*
         popoi(6) = 0.
         popoi(5) = abund*(c15+pmpo15)/(a51+a53+c51+c53) 
         popoi(4) = 0.
         popoi(3) = popoi(5)*(a53+c53)/(a32+c32)
         popoi(2) = (popoi(3)*(a32+c32)+abund*c12) /(a21+c21)
         popoi(1) = abund
*        write(QQ,'('' OILEVL resets this to simple pop'',1P,6E10.2)')
*    1   popoi
      endif
*
*     this is total cooling due to model atom, can be neg (heating)
      coloi =
     1 (popoi(1)*c12-popoi(2)*c21) * 1.53e-11 +
     1 (popoi(1)*c14-popoi(4)*c41) * 1.92e-11 +
     2 (popoi(1)*c15-popoi(5)*c51) * 1.94e-11 +
     3 (popoi(2)*c23-popoi(3)*c32) * 2.36e-12 +
     4 (popoi(2)*c26-popoi(6)*c62) * 4.55e-12 +
     5 (popoi(3)*c35-popoi(5)*c53) * 1.76e-12 +
     6 (popoi(3)*c34-popoi(4)*c43) * 1.52e-12 +
     7 (popoi(4)*c46-popoi(6)*c64) * 6.86e-13 +
     8 (popoi(5)*c56-popoi(6)*c65) * 4.32e-13
*
      end
