******************************************************************************
      subroutine opacrm( low , ihi , cross , ncross,  ipop ,chLabl)
      implicit none
*generate photoionization cross sections from Reilman and Manson points
      integer ncross , low , ihi , ipop
      character*4 chLabl
      real cross(ncross)
*
      include "nopsv.par"
      include "opsv.com"
      include "ncell.par"
      include "rfield.com"
      include "IOqq.com"
      include "noptot.com"
*
*     local variables
      integer nop , ncr , i , j , ics
      real slope
      parameter(nop=100)
      real en(nop) , cs(nop)
*
*     this is the opacity entering routine designed for
*     the Reilman and Manson tables.  It works with incident
*     photon energy (entered in eV) and cross sections in megabarns
*
      ipop = noptot + 1
*
      ncr = ncross / 2
      if( ncr.gt.nop ) then
         write(qq,'('' Too many opacities were entered into'',
     1   '' OPACRM.  Increase the value of NOP.'')')
         write(qq,'('' chLabl was '',A4)') chLabl
         stop
      endif
*
*     the array CROSS has ordered pairs of elements.
*     the first is the energy in eV (not Ryd)
*     and the second is the cross section in megabarns
      do i=1,ncr
        en(i) = cross( (i-1)*2+1 ) / 13.6
        cs(i) = cross( i*2 ) * 1e-18
      end do
*
      if( en(1).gt.anu(low) ) then
         write(qq,'('' OPACRM: The entered opacity energy bandwidth''
     1   ,'' is not large enough (low fail).'')')
         write(qq,'('' The desired energy (Ryd) was'',1P,E12.5,
     1   ''eV and the lowest entered in the array was'',E12.5,'' eV'')')
     2   anu(low)*13.606 , en(1)*13.606
         write(qq,'('' chLabl was '',A4)') chLabl
         write(qq,'('' The original energy (eV) and cross section (mb)''
     1   ,'' arrays follow:'')')
         write(qq,'(1X,1P,2E11.4)') (cross(i),i=1,ncross)
         stop
      endif
*
      slope = ( cs(2)-cs(1) ) / ( en(2)-en(1) )
      ics = 1
*
*     now fill in the opacities using linear interpolation
      do i=low,ihi
        if( anu(i).gt.en(ics) .and. anu(i).le.en(ics+1)) then
          OpacStack(i-low+ipop) = cs(ics) + slope*(anu(i)-en(ics))
        else
          ics = ics + 1
          if(ics+1.gt.ncr ) then
            write(qq,'('' OPACRM: The entered opacity energy ''
     1      ,''bandwidth is not large enough (high fail).'')')
            write(qq,'('' The entered energy was '',1P,E10.2,
     1      ''eV and the highest in the array was '',E10.2,''eV'')')
     2      anu(i)*13.6 , en(ncr)*13.6
            write(qq,'('' chLabl was '',A4)') chLabl
            write(qq,'('' The lowest energy enterd in the array was''
     1      ,1P,E10.2,'' eV'')') en(1)*13.65
            write(qq,'('' The highest energy ever needed would be'',
     1      1P,E10.2,''eV'')') anu(ihi)*13.6
            write(qq,'('' The lowest energy needed was'',
     1      1P,E10.2,''eV'')') anu(low)*13.6
            stop
          endif
          slope = ( cs(ics+1)-cs(ics) ) / ( en(ics+1)-en(ics) )
          if( anu(i).gt.en(ics) .and. anu(i).le.en(ics+1)) then
            OpacStack(i-low+ipop) = cs(ics) + slope*(anu(i)-en(ics))
          else
            write(qq,'('' Internal logical error in OPACRM.'')')
            write(qq,'('' The desired energy ('',1P,E9.2,
     1      ''eV), I='',I5,'', is not within the next energy bound'',
     2      2e10.2)') anu(i)*13.6 , i , en(ics) , en(ics+1)
            write(qq,'('' The previous energy (eV) was'',1P,E9.2)')
     3      anu(i-1)*13.6
            write(qq,'('' Here comes the energy array.  ICS='',
     1      I4)') ics
            write(qq,'(1P,10E10.2)') (en(j),j=1,ncr)
            write(qq,'('' chLabl was '',A4)') chLabl
            stop
          endif
        endif
      end do
*
      noptot = noptot + ihi - low + 1
      if( noptot.gt.NOPSV ) then
         write(qq,'('' OPACPL too many opacity points.'')')
         write(qq,'('' Increase parameter variable NOPSV'',
     1   '' everywhere it occurs in the code.'')')
         write(qq,'('' The current value is'',I6,''.'')') NOPSV
         stop
      endif
*
      end
