******************************************************************************
      subroutine oxygen
      implicit none
*derive ionization balance for oxygen
      include "te1ryd.par"
      include "limelm.par"
      include "ncell.par"
      include "itrdim.par"
      include "nhe2lvl.par"
      include "heating.com"
      include "elmton.com"
      include "hvmolEXP.com"
      include "iopo.com"
      include "trace.com"
      include "he.com"
      include "augro3.com"
      include "o3exc.com"
      include "pmp2s.com"
      include "chrex.com"
      include "shullc.com"
      include "s3727.com"
      include "i3727.com"
      include "timed.com"
*     include "decoff.com"
      include "TePowers.com"
      include "rfield.com"
      include "h.com"
      include "chargt.com"
      include "nhe2.com"
      include "PhotRate.com"
      include "phycon.com"
      include "coatom.com"
      include "DoPhoto.com"
      include "IonFracs.com"
      include "ZoneCnt.com"
      include "CharExc.com"
      include "IonRange.com"
      include "IOqq.com"
*
*     local variables
      real aeff,popexc,gamfun
      integer i,iup
      integer ndim , nelem
      parameter (ndim=9)
      parameter (nelem=8)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2), save,
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) 
*     oxygen nelem=8
*
*     real CollidRate(nelem,2)
*
*     DATA yYIELD/6*0./
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.09E-10,3.96E-11,1.67E-11,7.60E-12,3.33E-12,1.15E-12,
     1 7.90E-14,2.89E-14/
      data (cion(i,2),i=1,ndim-1)
     1 / 1.58E5,4.07E5,6.37E5,8.98E5,1.32E6,1.60E6,8.57E6,1.01E7/
*     DATA GRDEFF/ 0.10,0.10,0.10,0.10,0.03,0.042,0.11,0.30/
*
*     highest three from Arnaud et al '85
      data rec,pl
     1/1.60E-10 , 7.67E-10 , 2.35E-09 , 4.59E-09 , 1.73E-08 , 3.04E-8
     1, 1.56E-7 ,
     2  -0.678  , -0.646   , -0.666   , -0.670   , -0.759   , -0.774 ,
     3 -0.834 /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.11e-3, 5.07e-3, 1.48e-2, 1.84e-2, 4.13e-3, 1.06e-1,
     2 6.23e-2, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.0925, .181, .305, .1, .162, .34, .304, 0./
      data (dite(i,1),i=1,ndim-1)
     3/1.75e5  , 1.98e5  , 2.41e5  , 2.12e5  , 1.25e5  , 6.25e6  ,
     4 7.01E6  , 0.  /
      data (dite(i,2),i=1,ndim-1)
     1 /1.45e5, 3.35e5, 2.83e5, 2.83e5, 2.27e5, 1.12e6, 1.47e6, 0./
      data ditcrt
     5/2.7E4  , 2.2E4  , 2.4E4  , 2.5E4  , 1.6E4  , 1.0E6  ,
     6 1.5E6  , 1E20  /
*
      data aa/0.,-0.0036,0.,0.0061,-2.8425,0.,0.,0./
     1 ,   bb/0.0238,0.7519,21.8790,0.2269,0.2283,0.,0.,0./
     2 ,   cc/0.0659,1.5252,16.2730,32.1419,40.4072,0.,0.,0./
     3 ,   dd/0.0349,-0.0838,-0.7020,1.9939,-3.4956,0.,0.,0./
     4 ,   ff/0.5334,0.2769,1.1899,-0.0646,1.7558,0.,0.,0./
*
*     oxygen, atomic number 8
      if( .not.lgElmtOn(8) ) then
        poiii2Max = 0.
        poiii3Max = 0.
        r4363Max = 0.
        r5007Max = 0.
        poiii2 = 0.
        p1666 = 0.
        oatmic = 0.
        AugerO3 = 0.
        p1401 = 0.
        s3727 = 0.
        s7325 = 0.
        heating(8,10) = 0.
        poimax = 0.
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     O-H charge exchange
*     if( loxy.eq.1 ) then
*       rate is Field and Steigman, scaled down by 25% to acknowledge
*       new O+ rate from Chambaud et al J Phys B 13, 4205
*       fit is from Arnaud+Rothenflug 1985 AA(SUP) 60, 425
*       c1 = 0.91e-9 * exp(-227.6/te) * (1. - 0.93*sexp(1e-3*te) )
*       CTHeavy(1,1) = CTHeavy(1,1) + HII * C1
*       >>chng 96 Oct 1, all H ct moved to bidiag
*       CTHeavy(1,1) = CTHeavy(1,1) + HII * HCharExcIon(1,8)
*       c2 = 1.0e-9 * (1. - 0.66*sexp(9.8e-4*te) )
*       CTHeavy(1,2) = CTHeavy(1,2) + hi * c2
*       CTHeavy(1,2) = CTHeavy(1,2) + hi * HCharExcRec(1,8)
*       c1 is ionization of oxygen, rec of hydrogen
*       write(71,'(1p,i4,13e10.3)') nzone,c1,c2,c1/c2,
*    1  HCharExcIon(1,8),HCharExcRec(1,8)
*     endif
*
*     O+2 => O+ Butler Heil and Dalgarno 1980
*     CTHeavy(2,2) = CTHeavy(2,2) + 2.8E-11*TE10*TE10*TE10*TE03*TE03*HI
*     T = MIN( SQRTE,200. ) * HI
*     O+3 => O+2 Bulter Heil and Dalgarno 1980
*     CTHeavy(3,2) = CTHeavy(3,2) + 8.6E-11 * T + HEI*1E-9
      CTHeavy(3,2) = CTHeavy(3,2) + hei*1E-9
*     write(6,*) 'o3', 8.6e-11*t ,HCharExcRec(3,8)*hi
*     O+4 => O+3 Butler and Dalgarno 1980B
*     CTHeavy(4,2) = CTHeavy(4,2) + 2.6E-12 * t + HEI*6E-10
      CTHeavy(4,2) = CTHeavy(4,2) + hei*6E-10
*
*     photoexcitation of O III 1666 and O IV 1401
* 666 error! this will be zero in current form of phfit
*     set 2s**2 rate to rate for O V
      p1666 = PhotoRate(8,4,2,1)
*
      p1401 = PhotoRate(8,3,2,1)
*
*     photoionization from O++ 1D
*
*     estimate gamma function by assuming no frequency dependence
*     betwen 1D and O++3P edge
      if( lgDoPhoto ) then
        d5007r = gamfun( ipo3exc(1),ipo3exc(2) , ipo3exc(3) )
        d4363 = gamfun( ipo3exc3(1),ipo3exc3(2) , ipo3exc3(3) )
        d6300 = gamfun( ipo1exc(1),ipo1exc(2) , ipo1exc(3) )
*       A21 = 0.0263
        aeff = 0.0263 + d5007r
*       1. as last arg makes this the relative population
        poiii2 = popexc(2.5,9.,5.,aeff,2.88e4,1.)/aeff
*       photoionization from excited states
        if( nzone.gt.0 ) then
          PhotoRate(8,1,3,1) = PhotoRate(8,1,3,1)*(1.-poiexc) +
     1    d6300*poiexc
          PhotoRate(8,3,3,1) = PhotoRate(8,3,3,1)*(1.-poiii2-poiii3) +
     1    d5007r*poiii2 + d4363*poiii3
          if( PhotoRate(8,3,3,1).gt.1e-30 .and. IonLow(nelem).le.3) then
            if((d5007r*poiii2+d4363*poiii3)/PhotoRate(8,3,3,1).gt.
     1        (r4363Max+r5007Max)) then
              poiii2Max = d5007r*poiii2/PhotoRate(8,3,3,1)
              poiii3Max = d4363*poiii3/PhotoRate(8,3,3,1)
            endif
            r4363Max = max( r4363Max , d4363 )
            r5007Max = max( r5007Max , d5007r )
          endif
          if( IonLow(nelem).le.1 .and.
     1      (PhotoRate(8,1,3,1)+HCharExcIon(1,8)*hii).gt.1e-30 ) then
            poimax = max( poimax , d6300*poiexc/(PhotoRate(8,1,3,1) +
     1      HCharExcIon(1,8)*hii ) )
          endif
        else
          poiii2Max = 0.
          poiii3Max = 0.
          r4363Max = 0.
          r5007Max = 0.
          poimax = 0.
        endif
      endif
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     save photodistruction rate for 3727 creation
      if( IonLow(nelem).eq.1 .and. i2d.lt.nflux ) then
        s3727 = gamfun( i2d , i2p , iopo2d )
        iup = min( nhe2(1) , nflux )
        s7325 = gamfun( i2d , iup , iopo2d )
        s7325 = s7325 - s3727
        s3727 = (s3727 + s7325)
*       ratio of cross sections
        s7325 = s7325 * 0.66
      else
        s3727 = 0.
        s7325 = 0.
      endif
*
      AugerO3 = PhotoRate(8,1,1,1)
*
      oatmic = xIonFracs(8,0) * max(1e-7,(1.-co/xIonFracs(8,0))) 
      save = xIonFracs(8,0)
      xIonFracs(8,0) = oatmic
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
      xIonFracs(8,0) = save 
*
*     charge exchange onto hydrogen
      CTHionAgnt(3) = xIonFracs(8,2) * HCharExcRec(1,8)
*     write(72,'(i4,1p,10e10.2)')nzone,xIonFracs(8,2),HCharExcRec(1,8),
*    1 CTHionAgnt(3), xIonFracs(8,1) , HCharExcIon(1,8) ,
*    1  xIonFracs(8,1) * HCharExcIon(1,8)
      CTHion(1) = CTHion(1) + CTHionAgnt(3)
      CTHrec(1) = CTHrec(1) + xIonFracs(8,1) * HCharExcIon(1,8)
      chrener = chrener - (hi*xIonFracs(8,2)*HCharExcRec(1,8) -
     1 hii*xIonFracs(8,1)*HCharExcIon(1,8))*230./te1ryd
*
*     1666 ratio corrected for phot crs at 50ev
      p1666 = p1666 * xIonFracs(8,2) * 0.3
      p1401 = p1401 * xIonFracs(8,3) * 0.43
      s3727 = s3727 * xIonFracs(8,1)
      s7325 = s7325 * xIonFracs(8,1)
      AugerO3 = AugerO3 * xIonFracs(8,1)
*
      if( lgTrace ) then
        write(qq,'(5X,''OXYGEN returns; frac='',1P,9E10.3)')
     1  (xIonFracs(8,i)/xIonFracs(8,0),i=1,9)
      endif
*
      end
