******************************************************************************
      subroutine PhotoIonize( nelem )
      implicit none
*fill array PhotoRate with photoionization rates for heavy elements
      real gamk
      integer nelem
      include "limelm.par"
      include "heat.com"
      include "shullc.com"
      include "hv2ion.com"
      include "PhotRate.com"
      include "PhotScale.com"
      include "yield.com"
      include "DoPhoto.com"
      include "nsShells.com"
      include "ipElement.com"
      include "IonRange.com"
      include "IOqq.com"
*
*     local variables
      integer i , j , k , ns , iplow , iphi , ipop
*
*     nelem is element number, 6=carbon, 26=iron
* 
*     IonLow(nelem) and IonHigh(nelem) are bounds for evaluation
*
*     option to not evaluate rates if not first iteration
      if( .not.lgDoPhoto ) return
*
*begin sanity check
      if( IonLow(nelem).le.0 .or. IonLow(nelem).gt.nelem .or.
     1  IonHigh(nelem).gt.nelem+1) then
        write(qq,'('' PhotoIonize called with insane low, high:nelem='',
     1  i4,'' low, high='',2i10)') nelem, IonLow(nelem) , IonHigh(nelem)
        call ShowMe
        stop
      endif
*end sanity check
*
*     zero out the zrray
      do i=1,nelem
        hv2ion(nelem,i) = 0.
        hv2la(nelem,i) = 0.
        do j=1,7
          do k=1,2
            PhotoRate(nelem,i,j,k) = 0.
          end do
        end do
      end do
*
      do i=IonLow(nelem),IonHigh(nelem)-1
*       do ns=1,nsElem(i)
*     >>chng 96 oct 1, get rid of nsElem, use master array instead
        do ns=1,nsShells(nelem,i)
          iplow = ipElement(nelem,i,ns,1)
          iphi = ipElement(nelem,i,ns,2)
          ipop = ipElement(nelem,i,ns,3)
*         compute the photoionization rate,PhotScaleOn is 1, set 0
*         with "no photoionization" command
          PhotoRate(nelem,i,ns,1)  = gamk( iplow , iphi , ipop ,
     1    vyield(nelem,i,ns,1) ) * PhotScaleOn
*         this is the heating rate
*         in all these save rates BEFORE multiplication by secondary
*         efficiencies, since they will themselves change later
          PhotoRate(nelem,i,ns,2)  = h
          hv2ion(nelem,i) = hv2ion(nelem,i) + secion
          hv2la(nelem,i) = hv2la(nelem,i) + secla
        end do
      end do
*
*     real rate
*     if(nelem.eq.6) then
*       call broken
*       ns = nsElem(1)
*       i = 1
*       iplow = ipElement(nelem,i,ns,1)
*       iphi = ipElement(nelem,i,ns,2)
*       ipop = ipElement(nelem,i,ns,3)
*       rate =  PhotoRate(nelem,i,ns,1)
*       if(rate.gt.0. )
*    1  call PrtGamma(iplow ,iphi,ipop,20,rate,rate*0.05)
*     endif
*
      end
