******************************************************************************
      subroutine pltcon( np , chCall )
      implicit none
*generate plot of continuum array
      integer np
      character chCall*5 
*
      include "ncell.par"
      include "rfield.com"
      include "diffus.com"
      include "reflec.com"
      include "flxsav.com"
      include "ots.com"
      include "condif.com"
      include "ndplot.par"
      include "ploton.com"
      include "pltrce.com"
      include "trace.com"
      include "widflx.com"
      include "r1r0sq.com"
      include "cover.com"
      include "sphere.com"
      include "ptype.com"
      include "SumOutInc.com"
      include "opac.com"
      include "IOqq.com"
      character chXtitle*22
      character chSym*1 , chSymPlt1*1 , chSymPlt2*2
      real y(ncell) , y2(ncell)
      save xmin , xmax , ymin , ymax
      save y , y2
      real xmax , contin , ymin , ymin2 , ymax , xmin
      integer i
*
      if( chCall .eq. 'FIRST' ) return
*
      xmin = anulog(1)
      xmin = max( pltxmn(np) , xmin )
      xmax = anulog(nflux)
      xmax = min( xmax , pltxmx(np) )
*
      if(lgPltTrace(np))write(qq,'('' XMIN, XMAX='',1P,2E12.4,
     1'' NFLUX='',3I4)')xmin,xmax,nflux
*
      if( chPType(np).eq.'REFL' .and. lgSphere ) then
        write(qq,'('' Reflected continuum not computed when SPHERE '',
     1  ''set.'')')
        return
      endif
*
*     these will be the default symbols for first and second plot
      chSymPlt1 = '.'
      chSymPlt2 = 'o'
      ymin = 1e37
      ymin2 = 1e37
      ymax = -1e37
      do i=1,nflux
         if( anulog(i).gt.xmin .and. anulog(i).lt.xmax ) then
            if( chPType(np).eq.'CONT' ) then
               y(i) = log10( max( FluxSave(i)/widflx(i)*anu2(i),
     1         1e-37) )
               contin = flux(i) + (ContDiff(i) + outcon(i)) * covgeo
*              >>chng 98 sep 23 outlin div by anu as per pvh bug
               y2(i) =max((contin/widflx(i)+outlin(i)/anu(i)*covgeo)*
     1         anu2(i)* r1r0sq, 1e-37)
               y2(i) = log10( y2(i) )
            else if( chPType(np).eq.'CPHT' ) then
*              plot continuum as photons
               y(i) = log10( max( FluxSave(i)/widflx(i), 1e-37) )
               contin = flux(i) + (ContDiff(i)+outcon(i))*
     1         covgeo/widflx(i)
*              >>chng 98 sep 23 outlin div by anu as per pvh bug
               y2(i) = max( (contin+outlin(i)/anu(i)*covgeo)*r1r0sq,
     1         1e-37)
               y2(i) = log10( y2(i) )
            else if( chPType(np).eq.'REFL' ) then
*              plot "reflected" continuum from last zone only
               y(i) = log10( max( (refcon(i)/widflx(i)+reflin(i))*
     1         anu2(i),1e-37))
               y2(i) = y(i)
            else if( chPType(np).eq.'EMIT' ) then
*              plot "emitted" continuum from both sides of cloud
*              >>chng 98 sep 23 outlin div by anu as per pvh bug
*               y(i) = log10( max(
*     1         ((refcon(i)+ContDiff(i)+outcon(i))/widflx(i) +outlin(i)
*     1         + reflin(i) )* anu2(i), 1e-37))
               y(i) = log10( max(
     1         ((refcon(i)+ContDiff(i)+outcon(i))/widflx(i)+(outlin(i)
     1         + reflin(i))/anu(i) )* anu2(i), 1e-37))
               y2(i) = y(i)
            else if( chPType(np).eq.'OUTW' ) then
*              plot outward and attenuated incident continuum
               chSymPlt1 = 'i'
               y(i) = log10(max(flux(i)*opac(i),1e-37))
               chSymPlt2 = 'o'
               y2(i) = log10(max((outlin(i)+outcon(i)-SavOutCon(i))*
     1         opac(i), 1e-37))
            else if( chPType(np).eq.'DIFF' ) then
*              plot "diffuse" continuum from last zone only
               y(i) = log10( max( DiffCont(i)*anu2(i)/widflx(i) ,1e-37))
               y2(i) = y(i)
            else if( chPType(np).eq.'CRAW' ) then
               y(i) = log10( max( FluxSave(i) ,1e-37))
               y2(i) = max( (flux(i)+ContDiff(i)+otscon(i)+otslin(i)+
     1         outlin(i)+outcon(i))* r1r0sq , 1e-37 )
               y2(i) = log10( y2(i) )
            endif
            if(y(i).gt.-36.9 ) ymin = min( ymin , y(i) )
            if(y2(i).gt.-36.9 ) ymin2 = min( ymin2 , y2(i) )
            ymax = max( ymax , y(i) , y2(i) )
         endif
      end do
*
      if(lgTrace) write(qq,'('' PLOT called for the first time,'',
     1 '' YMAX, MIN='',1P,2E10.2)') ymax , ymin
*
*     lower min by at most 5 dex below peak
      ymin2 = max( ymax - 5. , -35. , ymin2 )
*     make sure there is room at the bottom
      ymin = min( ymin2 , ymin , ymax - 1. )
*     emitted continuum is thermal, so goes to zero
      if( chPType(np) .eq.'EMIT' ) ymin = max( ymin , ymax-4. )
*
      if(lgPltTrace(np))write(qq,'('' YMAX, MIN='',1P,2E14.4,'' Npnts=''
     1 ,I4)') ymax,ymin , nflux
      chXtitle = 'Log(nu fnu) vs log(nu)'
*
      chSym = chSymPlt1
      call pltr( anulog , y , nflux , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 1 , lgPltTrace(np) )
      chSym = chSymPlt2
      call pltr( anulog , y2, nflux , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 3 , lgPltTrace(np) )
*
      end
