******************************************************************************
      subroutine pltopc( np , chCall )
      implicit none
*generate plot of local gas opacity
      character*5 chCall
      integer np
*
      include "ncell.par"
      include "opac.com"
      include "scatop.com"
      include "sctsav.com"
      include "opacsv.com"
      include "ndplot.par"
      include "ptype.com"
      include "ploton.com"
      include "pltrce.com"
      include "rfield.com"
      include "phycon.com"
      include "trace.com"
      include "IOqq.com"
*
*     local variables
      integer i
*     integer i,max,min
      real xmin,xmax,ymin,ymax,arg1,arg2
      character chSym*1
      real y(ncell) , y2(ncell)
      character chXtitle*22
      save xmin , xmax , ymin , ymax
      save y , y2
*
      if( chCall.eq.'FIRST' ) return
      xmin = anulog(1)
      xmin = max( pltxmn(np) , xmin )
      xmax = anulog(nflux)
      xmax = min( xmax , pltxmx(np) )
*
      if(lgPltTrace(np))write(qq,'('' XMIN, XMAX='',1P,2E12.4,
     1'' NFLUX='',3I4)')xmin,xmax,nflux
*
      ymin = 1e37
      ymax = -1e37
*
      do i=1,nflux
        if( chPType(np).eq.'OPAA' ) then
*          absorption opacity
           arg1 = opacsv(i)
           arg2 = opac(i)
        else if( chPType(np).eq.'OPAS' ) then
*          scattering opacity
           arg1 = sctsav(i)
           arg2 = scatop(i)
        else if( chPType(np).eq.'OPAT' ) then
*          total opacity
           arg1 = opacsv(i) + sctsav(i)
           arg2 = opac(i) + scatop(i)
        endif
        y(i) =  log10( max( arg1/hden , 1e-35 ) )
        y2(i) = log10( max( arg2/hden , 1e-35 ) )
        if( anulog(i).gt.xmin .and. anulog(i).lt.xmax ) then
           ymin = min( ymin , y(i) , y2(i) )
           ymax = max( ymax , y(i) , y2(i) )
        endif
      end do
*
      if(lgTrace) write(qq,'('' PLOT called for the first time,'',
     1 '' YMAX, MIN='',1P,2E10.2)') ymax , ymin
*
*     lower min by factor of 10 to show absorption in next plot
      ymin = max( ymin - 1. , -35.)
      ymax = ymax + 1.
      if(lgPltTrace(np))write(qq,'('' YMAX, MIN='',1P,2E14.4,'' Npnts=''
     1 ,I4)') ymax,ymin , nflux
*
      chXtitle = 'Log(opacity) vs log(n)'
      chSym = '.'
      call pltr( anulog , y , nflux , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 1 , lgPltTrace(np) )
*
      chSym = 'o'
      call pltr( anulog , y2, nflux , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 3 , lgPltTrace(np) )
*
      end
