******************************************************************************
      subroutine pmprng( chCard )
      implicit none
*parse range from plot command
      character chCard*80
*
      include "ndplot.par"
      include "IOqq.com"
      include "ploton.com"
* 
*     local variables
      logical lgEOL
      real a , fread
      integer i
      logical lgLogOn , lgMatch
*
      i = 4
*     pltxmn is min for x axis of plot
      pltxmn(nplot) = fread( chCard , i , 76 , lgEOL )
*
      if( .not.lgMatch('RANG' , chCard ) ) then
*       no lines were enterd, so use default temperature limits
        pltxmn(nplot) = 1.
        pltxmx(nplot) = 9.
        lgLogOn = .true.
      else if( lgEOL ) then
*       no lines were enterd, so use default temperature limits
        pltxmn(nplot) = 1.
        pltxmx(nplot) = 9.
        lgLogOn = .true.
      else
*       number entered, now interprete it
        if( pltxmn(nplot).le.10. ) then
          lgLogOn = .true.
        else
          lgLogOn = .false.
        endif
*       linear option for temperature
        if( lgMatch( 'LINE' , chCard ) ) lgLogOn = .false.
*       lower temp was entered, now how about upper temp
        pltxmx(nplot) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          if( lgLogOn ) then
            pltxmx(nplot) = 9.
          else
            pltxmx(nplot) = 1e9
          endif
        else
*          second number was entered, check for sanity
           if( pltxmx(nplot).le.pltxmn(nplot) )  then
             write(qq,'('' The second (maximum) temperature for the'',
     1       '' map is'',1P,E10.2,'', but this is less than the'',
     2       '' first (minimum) temperature,'',E10.2)') pltxmx(nplot),
     3       pltxmn(nplot)
             write(qq,'('' HELP!  I am confused!!'')')
             stop
           endif
        endif
      endif
*
*     now force to be log
      if( .not.lgLogOn ) then
        if( pltxmx(nplot).le.0..or.pltxmn(nplot).le.0. ) then
          write(qq,'('' Limits for temperature are negative.'',
     1    ''  This is impossible.   Sorry.'')') 
          stop
        endif
        pltxmx(nplot) = log10( pltxmx(nplot) )
        pltxmn(nplot) = log10( pltxmn(nplot) )
      endif
*
*     check that min is less than max
      if( pltxmn(nplot).eq.pltxmx(nplot) ) then
        write(qq,'('' Upper and lower plot boundaries are equal.'')')
        stop
      else if( pltxmn(nplot).gt.pltxmx(nplot) ) then
        a = pltxmx(nplot)
        pltxmx(nplot) = pltxmn(nplot)
        pltxmn(nplot) = a
      endif
*
      end
