****************************************************************
      subroutine PointFe2
      implicit none
*set pointers to FeII lines in Katya's FeII atom
      include "nta.par"
      include "pi4.par"
      include "ipLnArry.par"
      include "ncell.par"
      include "nFe2LevN.par"
      include "t1cm.par"
      include "e1cm.par"
      include "WavNRyd.par"
      include "Fe2LevN.com"
      include "LineLabl.com"
      include "IOqq.com"
*
*     local variables
      integer ip , ipoint , low , ihi
      real abscf
*
*     routine called when cloudy sets itself up - one time for all runs
*     sets pointers for Fe2 lines
*
*begin sanity check
*     this does not work with array bounds checking turned on, when nFe2LevN
*     is 1 (not linked in) but would not happen anyway
*     check that first datum is non-zero, 0 sign that block data not
*     properly linked in
*     if( Fe2LevN(ipLnEnrWN,2,1).le.0. ) then
*       write(qq,'('' The vector Fe2LevN has zero data where positive'',
*    1  '' data was expected.'')')
*       write(qq,'('' Was block data FeIIData linked in?'')')
*       call insane
*       stop
*     endif
*end sanity check
*
      do low=1,nFe2LevN-1
        do ihi=low+1,nFe2LevN
          Fe2LevN(ipLnRyd,ihi,low) = Fe2LevN(ipLnEnrWN,ihi,low) *
     1    WavNRyd
          ip = ipoint( Fe2LevN(ipLnRyd,ihi,low) )
          Fe2LevN(ipLnIpCont,ihi,low) =  ip
*         do not over write other pointers with feii since feii is everywhere
          if(chLineLabel(ip).eq.'    ') chLineLabel(ip) = 'FeII'
          Fe2LevN(ipLnDampRel,ihi,low) = Fe2LevN(ipLnAul,ihi,low) * 
     1    Fe2LevN(ipLnWlAng,ihi,low)*1e-8 / pi4
*         derive the abs coef, call to function is gf, wl (A), g_low
          Fe2LevN(ipLnOpac,ihi,low) = abscf( Fe2LevN(ipLnGF,ihi,low) ,
     1    Fe2LevN(ipLnEnrWN,ihi,low) , Fe2LevN(ipLnGl,ihi,low) )
*         excitation energy of transition in degrees kelvin
          Fe2LevN(ipLnBolt,ihi,low) = t1cm * Fe2LevN(ipLnEnrWN,ihi,low)
*         energy of photon in ergs
          Fe2LevN(ipLnEnrErg,ihi,low) = e1cm*Fe2LevN(ipLnEnrWN,ihi,low)
        end do
      end do
*
      end
