******************************************************************************
      subroutine potasi
      implicit none
*compute ionization equilibrium for Potassium
      include "limelm.par"
      include "elmton.com"
      include "TePowers.com"
      include "timed.com"
      include "phycon.com"
      include "h.com"
      include "dcala.com"
      include "PhotRate.com"
      include "RecomRate.com"
      include "IOqq.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=20)
      parameter (nelem=19)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(20)
*
*     potassium nelem=19
*     rec data from calcium
*
*     real CollidRate(nelem,2)
*     DATA GRDEFF/20*0.2/
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /2.09E-10,9.00E-11,5.35E-11,2.58E-11,1.31E-11,5.91E-12,
     1 2.86E-12,6.96E-13,9.56E-13,3.20E-13,3.86E-13,2.54E-13,1.90E-13,
     2 1.42E-13,9.25E-14,5.48E-14,3.74E-14,1.65E-14,1.68E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /7.09E4,1.38E5,5.94E5,7.81E5,9.79E5,1.27E6,1.49E6,1.66E6,
     2 2.18E6,2.45E6,6.87E6,7.61E6,8.43E6,9.48E6,1.04E7,1.13E7,
     3 1.26E7,1.34E7,5.95E7/
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data rec,pl
     1/ 4.5E-10 , 1.07E-9 , 2.50E-9 , 9.33E-9 , 2.45E-8 , 3.43E-8
     2, 4.57E-8 , 6.53E-8 , 6.64E-8 , 2.57E-7 , 1.62E-7 , 2.05E-7
     3, 2.50E-7 , 1.70E-7 , 4.12E-7 , 4.27E-7 , 9.57E-7 , 1.29E-6
     4
     1, -0.900  , -0.800  , -0.700  , -0.780  , -0.840  , -0.820
     2, -0.820  , -0.810  , -0.780  , -0.900  , -0.820  , -0.810
     3, -0.800  , -0.730  , -0.800  , -0.780  , -0.850  , -0.850
     4/
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.06e-10 , -0.683 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/3.28E-4, .0584, .122, .132, .133, .126, .139, .0955, .0402,
     2 .0419, .0257, .0445, .0548, .0713, .0903, .110, .0205, .549,
     3 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/.0907, .110, .0174, .132, .114, .162, .0878, .263, .0627, .0616,
     2 2.77, 2.23, 2.00, 1.82, .424, .243, .185, .292, 0./
      data (dite(i,1),i=1,ndim-1)
     1/3.46E+4, 3.84E+5, 4.08E+5, 3.82E+5, 3.53E+5, 3.19E+5, 3.22E+5,
     2 2.47E+5, 2.29E+5, 3.73E+6, 9.26E+5, 7.96E+5, 6.90E+5, 6.70E+5,
     3 4.72E+5, 5.67E+5, 4.21E+5, 3.65E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/1.64E+4, 2.45E+5, 4.27E+5, 6.92E+5, 8.78E+5, 7.43E+5, 6.99E+5,
     2 4.43E+5, 2.81E+5, 5.84E+6, 4.89E+6, 4.62E+6, 4.52E+6, 3.32E+6,
     3 1.37E+6, 4.41E+6, 2.27E+6, 7.25E+6, 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 1E20 /
*
      data aa/19*0./,bb/19*0./,cc/19*0./,dd/19*0./,
     1 ff/0.,0.1,17*0./
*
*     potassium, atomic number 19
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*666  call PrtGamma(ipPotassium(2,5,1) ,ipPotassium(2,5,2) ,
*    1 ipPotassium(2,5,3),
*    1 qq,  photorate(nelem,2,5,1) ,photorate(nelem,2,5,1)*0.05 )
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     correct low temp rad rec coef
      if( te.lt.1e3 ) then
        RecombinRate(nelem,2) = RecombinRate(nelem,2) + 
     1  ( 5.49e-10*(te**(-0.647)) - rec(2)*(te**pl(2)) ) * eden
      endif
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
