******************************************************************************
      subroutine PotCol
      implicit none
*compute potassium cooling
      include "ipLnArry.par"
      include "nta.par"
      include "limelm.par"
      include "dcool.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "logte.com"
      include "IonFracs.com"
      include "TauDmmy.com"
*
*     local variables
      real cs
*
*     potasium lines
*     KI 7745
      cs = 7.231e-4 * te*te03*te02
      call PutCS( cs, KI7745 )
      call level2( KI7745 )
*
*     [K III] 4.62 microns
*     Y(ik) from 
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 2.2, xK03462 )
      call level2( xK03462 )
*
*     [KIV] 5.983, 15.39 mic, cs from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      call PutCS( 4.3  , xK04598 )
      call PutCS( 1.13 , xK04154 )
      call PutCS( 1.3  , TauDummy )
*     level3(  t10,t21,t20)
      call level3(  xK04598 ,xK04154,TauDummy )
*
*     [KVI] 8.823, 5.575 mic, cs from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      cs = min( 1.505,0.274*te10*te05/te001/te001 )
      call PutCS( cs  , xK06882 )
      cs = max( 4.0 , min(4.632 , 1.909*te10/te003) )
      call PutCS( cs , xK06557 )
      call PutCS( 1.2  , TauDummy )
      call level3(  xK06882 ,xK06557,TauDummy )
*
*     [K VII] 3.189 microns cs from 
*     >>refer Saraph, H.E., & Storey, P.J. A&AS, 115, 151
      call PutCS( 4.5 , xK07319 )
      call level2( xK07319 )
*
*     K 11 4249.99A, cs from 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.111, min( 0.172 , 0.0109*te20*te02/te001/te001 ) )
      call PutCS( 0.115, xK11425 )
      call level2( xK11425 )
*
      end
