******************************************************************************
      subroutine prstep
      implicit none
*print out individual zone results
      include "ndust.par"
      include "en1ryd.par"
      include "ncell.par"
      include "limelm.par"
      include "itrdim.par"
      include "nhe3lvl.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "bltzman.par"
      include "nqgrid.par"
      include "tautot.com"
      include "dustheat.com"
      include "nh.com"
      include "htau.com"
      include "pair.com"
      include "prad.com"
      include "pwind.com"
      include "wind.com"
      include "pbn.com"
      include "trace.com"
      include "dstdft.com"
      include "dstfac.com"
      include "dcneg.com"
      include "called.com"
      include "pheat.com"
      include "heating.com"
      include "hextra.com"
*     include "hbn.com"
      include "he1bn.com"
      include "he2bn.com"
      include "he3n.com"
      include "he3bn.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "photn2.com"
      include "tedust.com"
      include "dstlab.com"
      include "evryd.par"
      include "GrainPot.com"
      include "cldnEXP.com"
      include "filfac.com"
      include "hmi.com"
      include "TePowers.com"
      include "rfield.com"
      include "condif.com"
      include "ots.com"
      include "nlines.par"
      include "sum.com"
      include "recgrd.com"
      include "ntry.com"
      include "heat.com"
      include "comptn.com"
      include "hehp.com"
      include "h.com"
      include "he.com"
      include "radius.com"
      include "ZoneCnt.com"
      include "phycon.com"
      include "hmidep.com"
      include "r1r0sq.com"
      include "hvmolEXP.com"
      include "drsign.com"
      include "elmton.com"
      include "LyaExT.com"
      include "TrConvg.com"
      include "fluct.com"
      include "IonFracs.com"
      include "qheat.com"
      include "qheat2.com"
      include "FeIIAtom.com"
      include "AbunTablLG.com"
      include "IonRange.com"
      include "IOqq.com"
*
*     local variables
      integer i,nd,ishift,nq
      real rmidle,dmidle,fac,hatmic,coninc,cdif,
     1 qt1(ndust) , qp1(ndust)
*     >>chng 96 nov 30, qt1 qp1 as per K Volk changes for quantum heating
      character chLet*1 , chField8*8 , chQHMark*1
      real a(64)
*
*     free statement labesl >=11
*
      if( lgdCNeg ) then
        chLet = 'u'
      else
        chLet = ' '
      endif
*
*     middle of zone for printing
      rmidle = radius - drad * 0.5 * dRadSign
      dmidle = depth - drad * 0.5
*
*     option to print single line when quiet but tracing convergence
*     with "trace convergence" command
      if( lgTalk .or. lgTrConvg ) then
        if(nzone.le.999 ) then
          write(chField8,'(''####'',i3)') nzone
        else
          write(chField8,'(''###'',i4)') nzone
        endif
        write(qq,'(1X,a8,A1,''Te:'',1P,E9.3,'' Hden:'',E9.3,
     1  '' Ne:'',E9.3,'' R:'',E9.3,'' R-R0:'',E9.3,'' dR:'',E9.3,
     2  '' NTR:'',I3,'' Htot:'',E9.3,'' T912:'',E10.3,''###'')')
     3  chField8,chLet,te,hden,eden,rmidle,dmidle,drad,ntry,htot,
     1  tauabs(ipHn(1),1)
        if( lgTrConvg ) write(qq,'('' H:'',1p,2e10.2,'' He:'',3e10.2)')
     3  hi/(hi+hii) , hii / (hi+hii) , hei/ahe , heii/ahe , heiii/ahe
      endif
*
*     now return if not talking
      if( .not.lgTalk .or. lgTrConvg ) return
*
*     lgDenFluc set to true in zero, only false when variable abundances
*     lgAbTaON set true when element table used
      if( .not.lgDenFluc .or. lgAbTaON ) then
        write(qq,'('' Abun:'',1p,15e8.1)')(xIonFracs(i,0),i=1,limelm)
      endif
*
*-------------------------------------------------
*     print wind parameters if windy model
      fac = windv * hden * r1r0sq
      if( windv.ne.0. ) then
         if( AccelTot.eq.0. ) then
            fac = 1.
         else
            fac = AccelTot
         endif
         write(qq,'('' WIND; V:'',1P,E9.3,''km/s G:'',
     1   E10.3,'' Accel:'',E10.3,'' Fr(cont):'',0P,F6.3,'' Fr(line):'',
     2   F6.3,'' Fr(dP):'',F6.3)')
     3   windv/1e5 , -agrav , AccelTot , AccelCont /fac ,AccelLine /fac,
     4   AccelPres /fac
      endif
*
*     print line with radiation pressure if significant
      if( windv.ne.0. .or. pbeta.gt..05 ) then
        call PrtLinePres
      endif
*
*----------------------------------------------------
      hatmic = (hi+hii) / ( hi+hii+hminus+2.*(htwo+h2plus)+3*h3plus)
      write(qq,'('' Hydrogen '',2X,2(1P,E10.3),'' H+o/Hden:'',E10.3,
     1 E10.3,'' H-'',5X,''H2'',E10.3,E10.3,'' H2+  HeH+'',
     2 E10.3,'' H col den'',E10.3)')
     3 hi/(hi+hii) , hii / (hi+hii) ,
     3 hatmic , hminus / hden , htwo / hden , h2plus / hden ,
     4 hehp / hden , colden
*
*     print departure coef if desired
      if( lgPrtBN ) then
         a(1) = hbn(1)
         a(2) = 1.
         a(3) = (hi+hii) / hden
         a(4) = hmidep
         a(5) = h2dep
         a(6) = h2pdep
         a(7) = h3pdep
         a(8) = hehdep
         write(qq,'('' Hydrogen '',2X,2(1P,E10.3),'' H+0/Hden:'',E10.3,
     1   E10.3,'' H-'',5X,''H2'',E10.3,7X,''H2+'',E10.3,5X,''H3+'',
     2   E10.3,''HeH+'',E8.2)') (a(i),i=1,8)
      endif
*
      if(lgPrintHeating) write(qq,'(12X,1P,E10.3,10X,E10.3,10X,E10.3)')
     2 heating(1,1)/htot , heating(1,16)/htot , heating(1,17)/htot
*
*     temperature correspoding to radiation fields
      coninc = 0.
      cdif = 0.
      do i=1,nflux
         coninc = coninc + flux(i) * (anu(i)*en1ryd)
         cdif = cdif + (ContDiff(i)+outlin(i)+outcon(i))*(anu(i)*en1ryd)
      end do
      coninc = ( coninc / 2.997925e10 / 7.56464e-15 )**0.25
      cdif = ( cdif / 2.997925e10 / 7.56464e-15 )**0.25
*
*     print stright level pop per ionized hydrogen
      write(qq,'('' H 2SP 3-6'',2X,6(1P,E10.3),
     1'' Texc(La):'',E10.3,'' T(contn):'',E10.3,'' T(diffs):'',E10.3)') 
     2 hn2s,hn2p,(hn(i),i=3,6),TexcLya, coninc,cdif
*
*     option to print dep coef
      if( lgPrtBN ) then
        write(qq,'('' H 2SP 3-12'',1x,1p,12e10.3)')
     1  hbn(nhlvl+1),(hbn(i),i=2,min(nhlvl,12))
        if( nhlvl.gt.12 ) write(qq,'('' rest:    '',2x,1p,13e10.3)')
     1  (hbn(i),i=13,nhlvl)
      endif
*
      if( lgPrintHeating ) write(qq,'(12X,1P,E10.3,10X,E10.3
     1,'' Bound Com'',E10.3,''    Extra:'',E10.3,''    Pairs:'',E10.3,
     2''   H-lines'',E10.3)')
     2 heating(1,2)/htot ,0. ,heating(1,19)/htot,
     3 heating(1,21)/htot,heating(1,22)/htot
*
*     Helium
      if( lgElmtOn(2) ) then
        a(1) = hei / ahe
        a(2) = heii / ahe
        a(3) = heiii / ahe
        a(4) = hei3 / ahe
*
        write(qq,'('' Helium   '',2X,3(1P,E10.3),'' He I 2S3 '',E10.3,
     1  '' Comp H, C'',2E10.3,'' Fill Fact'',E10.3,'' Gam 1/tot'',E10.3)
     2  ')(a(i),i=1,4),cmheat,cmcool*te,FillFac, photn2
*
*       option to print departure coef
        if( lgPrtBN ) then
          a(1) = he1bn(1)
          a(2) = he2bn(1)
          a(3) = 1.
          a(4) = he3bn(1)
*
          write(qq,'('' Helium   '',2X,3(1P,E10.3),'' He I 2S3 '',E10.3,
     1    '' Comp H, C'',2E10.3,'' Fill Fact'',E10.3,'' Gam 1/tot'',
     2    e10.3)') (a(i),i=1,4),cmheat,cmcool*te,FillFac, photn2
        endif
*
*       print heating from He (and others) if desired
*       entry "lines" is induced line heating
*       1,12 ffheat:  2,3 he triplets, 1,20 compton
        if( lgPrintHeating ) write(qq,'(12X,2(1P,E10.3),''    Lines:'',
     1   2e10.2,''  Compton:'',E10.3,'' FF Heatig'',E10.3)')
     2  heating(2,1)/htot ,heating(2,2)/htot , heating(1,23)/htot,
     3  heating(2,3)/htot , heating(1,20)/htot , heating(1,12)/htot 
*
        fac = heii / ahe
        write(qq,'('' He singlet '',6(1P,E10.3),'' He triplt'',5E10.3)')
     1  (he1n(i)*fac,i=1,6), (he3n(i)*fac,i=1,nhe3lvl)
*       option to print departure coef
        if( lgPrtBN ) then
           write(qq,'('' He singlet '',10(1P,E10.3))') (he1bn(i),
     1     i=1,nhe1lvl+1)
           write(qq,'('' He triplet '',6(1P,E10.3))') he3bn
        endif
        fac = heiii / ahe
        write(qq,'('' HeII'',7X,9(1P,E10.3),'' RadPres/GAS:'',E10.3)')
     1  (he2n(i)*fac,i=1,9) , pbeta
*       option to print departure coef
        if( lgPrtBN ) then
           write(qq,'('' HeII 1-9,2s'',10(1P,E10.3),'' RadPres/GAS:'',
     1     e10.3)') he2bn , pbeta
        endif
      endif
*
      if( lgDustOn ) then
*        Change things so the dust species that are quantum heated are marked with an
*        asterisk just after the name (K Volk)
         do nd=1,ndust
            if( lgDustOn1(nd) ) then
              if (lgQHeat(nd)) then
                chQHMark ='*'
              else
                chQHMark =' '
              end if
*             (K Volk) added QHMARK here and in the write statement
              write(qq,'(1P,A10,a1,''  Dust temp'',E10.3,'' Pot(Volt)''
     1        ,e10.3,'' Nelectron'',E10.3,'' drft cm/s'',E10.3,
     2        ''  Heating:'',E10.3,'' Frac(tot)'',E10.3)')
     1        chDstLab(nd),chQHMark,tedust(nd),dstpot(nd)*evryd,
     2        dstq(nd),DustDftVel(nd) ,dheat(nd),dheat(nd)/htot
            endif
         end do
*        (K Volk) added QHEAT punch out of temperature values
*
         if (iqp.gt.0) then
             if (nqout1.eq.0) then
*
                 do nd=1,ndust
                 if (lgQHeat(nd).and.lgDustOn1(nd)) then
                     nqout1=nqout1+1
                     nqp1(nqout1)=nd
                 end if
                 end do
*
               if (nqout1.eq.0) then
                 write(iqp,'(''**** no grains were quantum heated.'')')
                 nqout1=-1
               end if
             end if
*
             if (nqout1.gt.0) then
                write(iqp,'(''Dust Temperature Distribution: zone '',
     1          i4,'' --- dust types:'',10i3)')
     2          nzone,(nqp1(nd),nd=1,nqout1)
                write(iqp,'(''Weighted mean temperatures: '',0p10f8.2)')
     1          (tedust(nqp1(nd)),nd=1,nqout1)
                write(iqp,'(''Equilibrium temperatures: '',0p10f8.2)')
     1          (tequil1(nqp1(nd)),nd=1,nqout1)
*
                do nq=1,nqhg1
                  do nd=1,nqout1
                    qp1(nd)=qhprob(nqp1(nd),nq)
                    qt1(nd)=qtemp(nqp1(nd),nq)
                  end do
                  write(iqp,'(10(0pf8.2,1pe10.3))')
     1            (qt1(nd),qp1(nd),nd=1,nqout1)
                end do
             end if
         end if
c End of changes here (K Volk)
      endif
*
*     gas pressure, pressure due to incident radiation field, rad accel
      write(qq,'(1P,'' Pressure'',3X,'' NgasTgas:'',E10.3,'' P(total):''
     1,E10.3,'' P( gas ):'',E10.3,'' P(Radtn):'',E10.3,'' Rad accel'',
     1 E10.3,'' Force Mul'',E10.3)')
     3 GasPres/Boltzmann , RadPres+GasPres , GasPres , RadPres ,
     4 AccelTot , fmul
*
*     heavy element molecules
      if( co.gt.0. ) then
         write(qq,'(1P,'' Molecules   CH/Ctot :'',E10.3,'' CH+/Ctot:'',
     1   E10.3,'' CO/Ctot :'',E10.3,'' CO+/Ctot:'',E10.3,'' H2O/Otot:'',
     1   E10.3,'' OH/Ototl:'',E10.3)')
     1   ch/xIonFracs(6,0),chp/xIonFracs(6,0),co/xIonFracs(6,0),
     2   cop/xIonFracs(6,0),h2o/xIonFracs(8,0),
     1   oh/xIonFracs(8,0)
      endif
*
*     Li, be, b
      if( lgElmtOn(3).or.  lgElmtOn(4) ) then
        write(qq,'('' Lithium'',4X,4(1P,E10.3),'' Beryllium'',5E10.3)')
     2  (xIonFracs(3,i)/max(1e-35,xIonFracs(3,0)),i=1,4) ,
     3  (xIonFracs(4,i)/max(1e-35,xIonFracs(4,0)),i=1,5)
        if(lgPrintHeating) write(qq,'(12X,3(1P,E10.3),20x,5(1P,E10.3))') 
     1  (heating(3,i)/htot,i=1,3) , (heating(4,i)/htot,i=1,4)
      endif
      if( lgElmtOn(5)) then
        write(qq,'('' Boron  '',4X,6(1P,E10.3))')
     2  (xIonFracs(5,i)/max(1e-35,xIonFracs(5,0)),i=1,6)
        if(lgPrintHeating) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(5,i)/htot,i=1,5)
      endif
*
*     Carbon
      if( lgElmtOn(6) ) then
        write(qq,'('' Carbon'',5X,7(1P,E10.3),'' H2O+/Otot'',E10.3,
     1  '' OH+/Ototl'',E10.3)')
     2  (xIonFracs(6,i)/max(1e-35,xIonFracs(6,0)),i=1,7) ,
     3  h2op/max(1e-35,xIonFracs(8,0)) ,
     3  ohp/max(1e-35,xIonFracs(8,0))
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(6,i)/htot,i=1,6)
      endif
*
*     Nitrogen
      if( lgElmtOn(7) ) then
        write(qq,'('' Nitrogen'',3X,8(1P,E10.3),'' O2/Ototl:'',E10.3,
     1  '' O2+/Otot:'',E10.3)')
     1   (xIonFracs(7,i)/max(1e-35,xIonFracs(7,0)),i=1,8),
     2   otwo/max(1e-35,xIonFracs(8,0)) ,
     2   o2p/max(1e-35,xIonFracs(8,0))
        if( lgPrintHeating) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(7,i)/htot,i=1,7)
      endif
*
*     Oxygen
      if( lgElmtOn(8) ) then
        write(qq,'('' Oxygen'',5X,9(1P,E10.3),'' Hex(tot):'',E10.3,
     1  '' A:'',0P,F7.3)') (xIonFracs(8,i)/max(1e-35,xIonFracs(8,0)),
     2   i=1,9),
     2  hxtot, log10(max(recgrd,1e-30))
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(8,i)/htot,i=1,8)
      endif
*
*     fluorine
      if( lgElmtOn(9) ) then
        write(qq,'('' Fluorine'',3X,10(1P,E10.3))')
     1  (xIonFracs(9,i)/max(1e-35,xIonFracs(9,0)),i=1,10)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(9,i)/htot,i=1,9)
      endif
*
*     Neon
      if( lgElmtOn(10) ) then
        write(qq,'('' Neon'',7X,11(1P,E10.3))')
     1  (xIonFracs(10,i)/xIonFracs(10,0),i=1,11)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(10,i)/htot,i=1,10)
      endif
*
*     Sodium
      if( lgElmtOn(11)) then
        write(qq,'('' Sodium'',5X,12(1P,E10.3))')
     1  (xIonFracs(11,i)/xIonFracs(11,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(11,i)/htot,i=1,11)
      endif
*
*     Magnesium
      if( lgElmtOn(12)) then
        ishift = max( 0 , IonHigh(12)-12 )
        write(qq,'('' Magnesium'',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(12,i+ishift)/xIonFracs(12,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(12,i+ishift)/htot,i=1,12)
      endif
*
*     Aluminium
      if( lgElmtOn(13)) then
        ishift = max( 0 , IonHigh(13)-12 )
        write(qq,'('' Aluminium'',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(13,i+ishift)/xIonFracs(13,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(13,i+ishift)/htot,i=1,12)
      endif
*
*     Silicon
      if( lgElmtOn(14)) then
        ishift = max( 0 , IonHigh(14)-12 )
        write(qq,'('' Silicon  '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(14,i+ishift)/xIonFracs(14,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(14,i+ishift)/htot,i=1,12)
      endif
*
*     Phosphorus
      if( lgElmtOn(15)) theN
        ishift = max( 0 , IonHigh(15)-12 )
        write(qq,'('' Phosphors'',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(15,i+ishift)/xIonFracs(15,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(15,i+ishift)/htot,i=1,12)
      ENDIF
*
*     Sulphur
      if( lgElmtOn(16)) then
        ishift = max( 0 , IonHigh(16)-12 )
        write(qq,'('' Sulphur  '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(16,i+ishift)/xIonFracs(16,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(16,i+ishift)/htot,i=1,12)
      endif
*
*     Chlorine
      if( lgElmtOn(17)) then
        ishift = max( 0 , IonHigh(17)-12 )
        write(qq,'('' Chlorine '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(17,i+ishift)/xIonFracs(17,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(17,i+ishift)/htot,i=1,12)
      endif
*
*     Argon
      if( lgElmtOn(18)) then
        ishift = max( 0 , IonHigh(18)-12 )
        write(qq,'('' Argon    '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(18,i+ishift)/xIonFracs(18,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(18,i+ishift)/htot,i=1,12)
      endif
*
*     Potassium
      if( lgElmtOn(19)) then
        ishift = max( 0 , IonHigh(19)-12 )
        write(qq,'('' Potassium'',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(19,i+ishift)/xIonFracs(19,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(19,i+ishift)/htot,i=1,12)
      endif
*
*     Calcium
      if( lgElmtOn(20)) then
        ishift = max( 0 , IonHigh(20)-12 )
        write(qq,'('' Calcium  '',I2,12(1P,E10.3))') 
     1  ishift, (xIonFracs(20,i+ishift)/xIonFracs(20,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(20,i+ishift)/htot,i=1,12)
      endif
*
*     Scandiuim
      if( lgElmtOn(21)) then
        ishift = max( 0 , IonHigh(21)-12 )
        write(qq,'('' Scandium '',I2,12(1P,E10.3))') 
     1  ishift, (xIonFracs(21,i+ishift)/xIonFracs(21,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(21,i+ishift)/htot,i=1,12)
      endif
*
*     Titanium
      if( lgElmtOn(22)) then
        ishift = max( 0 , IonHigh(22)-12 )
        write(qq,'('' Titanium '',I2,12(1P,E10.3))') 
     1  ishift, (xIonFracs(22,i+ishift)/xIonFracs(22,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(22,i+ishift)/htot,i=1,12)
      endif
*
*     Vanadium
      if( lgElmtOn(23)) then
        ishift = max( 0 , IonHigh(23)-12 )
        write(qq,'('' Vanadium '',I2,12(1P,E10.3))') 
     1  ishift, (xIonFracs(23,i+ishift)/xIonFracs(23,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(23,i+ishift)/htot,i=1,12)
      endif
*
*     Chromium
      if( lgElmtOn(24)) then
        ishift = max( 0 , IonHigh(24)-12 )
        write(qq,'('' Chromium '',I2,12(1P,E10.3))') 
     1  ishift, (xIonFracs(24,i+ishift)/xIonFracs(24,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(24,i+ishift)/htot,i=1,12)
      endif
*
*     Manganese
      if( lgElmtOn(25)) then
        ishift = max( 0 , IonHigh(25)-12 )
        write(qq,'('' Manganes '',I2,12(1P,E10.3))') 
     1  ishift, (xIonFracs(25,i+ishift)/xIonFracs(25,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(25,i+ishift)/htot,i=1,12)
      endif
*
*     Iron
      if( lgElmtOn(26)) then
        ishift = max( 0 , IonHigh(26)-12 )
        do while( ishift.gt.0 .and. xIonFracs(26,12+ishift)/
     1    xIonFracs(26,0).lt.1e-12 ) 
          ishift = ishift - 1
        end do
        write(qq,'('' Iron'',5X,I2,12(1P,E10.3))') 
     1  ishift,(xIonFracs(26,i+ishift)/xIonFracs(26,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(26,i+ishift)/htot,i=1,12)
      endif
*
*     Cobalt
      if( lgElmtOn(27)) then
        ishift = max( 0 , IonHigh(27)-12 )
        do while( ishift.gt.0 .and. xIonFracs(27,12+ishift)/
     1    xIonFracs(27,0).lt.1e-12 ) 
          ishift = ishift - 1
        end do
        write(qq,'('' Cobalt'',3X,I2,12(1P,E10.3))') 
     1  ishift,(xIonFracs(27,i+ishift)/xIonFracs(27,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(27,i+ishift)/htot,i=1,12)
      endif
*
*     nickel
      if( lgElmtOn(28)) then
        ishift = max( 0 , IonHigh(28)-12 )
        do while( ishift.gt.0 .and. xIonFracs(28,12+ishift)/
     1    xIonFracs(28,0).lt.1e-12 )
          ishift = ishift - 1
        end do
        write(qq,'('' Nickel'',3X,I2,12(1P,E10.3))') 
     1  ishift,(xIonFracs(28,i+ishift)/xIonFracs(28,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1 (heating(28,i+ishift)/htot,i=1,12)
      endif
*
*     Copper
      if( lgElmtOn(29)) then
        ishift = max( 0 , IonHigh(29)-12 )
        write(qq,'('' Copper   '',I2,12(1P,E10.3))') 
     1  ishift, (xIonFracs(29,i+ishift)/xIonFracs(29,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(29,i+ishift)/htot,i=1,12)
      endif
*
*     Zinc
      if( lgElmtOn(30)) then
        ishift = max( 0 , IonHigh(30)-12 )
        write(qq,'('' Zinc     '',I2,12(1P,E10.3))') 
     1  ishift, (xIonFracs(30,i+ishift)/xIonFracs(30,0),i=1,12)
        if( lgPrintHeating ) Write(qq,'(12X,12(1P,E10.3))') 
     1  (heating(30,i)/htot,i=1+ishift,min(30,12+ishift))
      endif
*
      if( chFeIIAtom.eq.'Verner' ) then
        call PrtFeII
      endif
      end
