******************************************************************************
      subroutine PunCool( io )
      implicit none
*punch coolants
      integer io
*
      include "ncolnt.par"
      include "itrdim.par"
      include "collab.com"
      include "coolnt.com"
      include "tcool.com"
      include "heat.com"
      include "tfail.com"
      include "ZoneCnt.com"
      include "WkHtCl.com"
*
*     local variables
      integer iplim , i , j , is , imax , ip
      real cset , xmax
      parameter (iplim=7)
      character*4 chLSav(iplim) , chL2(iplim)
      real csav(iplim) , csav2(iplim) , sgnsav(iplim) , sgn2(iplim)
      integer isav(iplim) , isav2(iplim)
*
*     cset will be weakest cooling to consider
*     WeakHeatCool set with 'set weakheatcool' command
*     default is 0.05
      cset = ctot * WeakHeatCool
*
*     first find all strong lines, both + and - sign
      ip = 1
      do i=1,ncltot
        if( (cooling(i).gt.cset .or.heatnt(i).gt.cset)
     1    .and.ip.le.iplim ) then
          chLSav(ip) = chClntLab(i)
          isav(ip) = collam(i)
          csav(ip) = max( cooling(i) , heatnt(i) ) / ctot
*         save sign to remember if heating or cooling line
          if( heatnt(i).eq.0. ) then
            sgnsav(ip) = +1.
          else
            sgnsav(ip) = -1.
          endif
          ip = ip + 1
        endif
      end do
      ip = ip - 1
*
*     order strongest to weakest
      do i=1,ip
        xmax = 0.
        do j=1,ip
          if(csav(j).gt.xmax ) then
            xmax = csav(j)
            imax = j
          endif
        end do
        chL2(i) = chLSav(imax)
        isav2(i) = isav(imax)
        csav2(i) = csav(imax)
        sgn2(i) = sgnsav(imax)
        csav(imax) = -1.
      end do
*
*     warn is te failure occurred
      if(lgTeFail) then
        write(io,'('' >>>>  A temperature failure occured.'')')
      end if
*
*     convert very long wavelengths to micros
      do i=1,ip
        if( isav2(i).gt.1e5 ) isav2(i) = isav2(i)/1e4
      end do
*
*     keep sign of coolant, for strong negative cooling
      write(io,'(i4,1p,2e9.2,7(1x,a4,i6,0p,f6.3))') nzone,
     1 htot,ctot,(chL2(is),isav2(is), sign(csav2(is),sgn2(is)),is=1,ip)
*
      end
