****************************************************************************
      subroutine PunHeat( io )
      implicit none
*punch contributors to local heating, with punch heat command
      integer io
*
      include "itrdim.par"
      include "nta.par"
      include "ipLnArry.par"
      include "nwindline.par"
      include "ncolnt.par"
      include "limelm.par"
      include "coolnt.com"
      include "heat.com"
      include "tcool.com"
      include "ZoneCnt.com"
      include "heating.com"
      include "tfail.com"
      include "TLineARR.com"
      include "WindData.com"
      include "collab.com"
      include "ElmntSym.com"
      include "IonStage.com"
      include "WkHtCl.com"
      include "IOqq.com"
*
*     local variables
      integer iplim
      parameter ( iplim=9)
      real TauIn , Pump , EscP , CS
      character chLineLbl*10 , chLbl*10 , chLabel(iplim)*4
      integer i , j, k,ipsave(iplim),jpsave(iplim) , ipnt,
     1 level , ipStrong
      real save(iplim) , Strong , ColHeat
      logical lgHeatLine
*
      ipnt = 0
      do i=1,limelm
        do j=1,limelm
*         WeakHeatCool set with 'set weakheatcool' command
*         default is 0.05
          if( heating(i,j)/htot.gt.WeakHeatCool ) then
            ipnt = min( iplim , ipnt + 1 )
            ipsave(ipnt) = i
            jpsave(ipnt) = j
            save(ipnt) = heating(i,j) / htot
          endif
        end do
      end do
*
*     now check for possible line heating not counted in 1,23
*     there should not be any significant heating source heree
*     since they would not be counted in deriv correctly
      do i=1,ncltot
        if( heatnt(i)/htot.gt.WeakHeatCool) then
*         ipnt = min( iplim , ipnt + 1 )
*         ipsave(ipnt) = -1
*         jpsave(ipnt) = i
*         save(ipnt) = heatnt(i) / htot
          j = collam(i)
*         force to save wavelength convention as printout
          if( j.gt. 100 000 ) j = j / 10 000
          write(io,'('' Negative coolant was '',a4,i6,1p,e10.2)')
     1    chClntLab(i),j, heatnt(i)/htot
        endif
      end do
*
      if(lgTeFail) then
        write(io,'('' >>>>  A temperature failure occured.'')')
      end if
*
      do k=1,ipnt
*       generate labels that make sense in printout
        i = ipsave(k)
        j = jpsave(k)
        if( i.ge.j ) then
*         this is case of photoionization of atom or ion
          chLabel(k)(1:2) = chElementSym(i)
          chLabel(k)(3:4) = chIonStage(j)
        else if(i.eq.1 .and. j.eq.2 ) then
*         photoionization from all excited states of H
          chLabel(k) = 'Hn=2'
        else if(i.eq.1 .and. j.eq.4 ) then
*         collisional ionization of H from ground
          chLabel(k) = 'Hion'
        else if(i.eq.1 .and. j.eq.10 ) then
*         CO dissociation
          chLabel(k) = 'COds'
        else if(i.eq.1 .and. j.eq.12 ) then
*         free free heating
          chLabel(k) = 'H FF'
        else if(i.eq.1 .and. j.eq.13 ) then
*         heating line, that was supposed to cool
          chLabel(k) = 'Clin'
        else if(i.eq.1 .and. j.eq.14 ) then
*         grain photoionization
          chLabel(k) = 'dust'
        else if(i.eq.1 .and. j.eq.16 ) then
*         H- heating
          chLabel(k) = 'H-  '
        else if(i.eq.1 .and. j.eq.18 ) then
*         H2 dissociation
          chLabel(k) = 'H2ds'
        else if(i.eq.1 .and. j.eq.19 ) then
*         Compton recoil of bound electrons
          chLabel(k) = 'CBnd'
        else if(i.eq.1 .and. j.eq.20 ) then
*         Compton heating
          chLabel(k) = 'Comp'
        else if(i.eq.1 .and. j.eq.23 ) then
*         line heating
          chLabel(k) = 'line'
        else if(i.eq.1 .and. j.eq.24 ) then
*         hydrogen line heating
          chLabel(k) = 'Hlin'
        else if(i.eq.2 .and. j.eq.4 ) then
*         helium triplet line heating
          chLabel(k) = 'He3l'
        else
          write(chLabel(k),'(2i2)') i,j
        endif
      end do
      write(io,'(i4,1p,2e9.2,0p,9(1x,a4,f6.3))')
     1nzone,htot,ctot,(chLabel(i),save(i),i=1,ipnt)
*
*     a negative pointer in the heating array is probably a problem,
*     indicating that some line has become a heat source
*
      lgHeatLine = .false.
*     check if any lines were major heat sources
      do i=1,ipnt
*       heating(1,23) is line heating - identify line if important
        if( ipsave(i).eq.1 .and. jpsave(i).eq.23 ) lgHeatLine = .true.
      end do
*
      if( lgHeatLine ) then
*       a line was a major heat source - identify it
        call FndLineHt( level, ipStrong , Strong )
        if( Strong/htot.gt.0.005 ) then
          if( level.eq.1 ) then
            chLbl =  chLineLbl(TauLines(1,ipStrong))
            TauIn = TauLines(ipLnTauIn,ipStrong)
            Pump = TauLines(ipLnPump,ipStrong)
            EscP = TauLines(ipLnEscP,ipStrong)
            CS = TauLines(ipLnCS,ipStrong)
*           ratio of line to total heating
            ColHeat = TauLines(ipLnHeat,ipStrong)/htot
          else if( level.eq.2 ) then
            chLbl =  chLineLbl(WindLine(1,ipStrong))
            TauIn = WindLine(ipLnTauIn,ipStrong)
            Pump = WindLine(ipLnPump,ipStrong)
            EscP = WindLine(ipLnEscP,ipStrong)
            CS = WindLine(ipLnCS,ipStrong)
            ColHeat = WindLine(ipLnHeat,ipStrong)/htot
          else
            write(qq,'('' PunHeat insane level'',i4)')level
            stop
          endif
          write(io,'(1X,'' LHeat lv'',i2,1x,a10,'' TIn'',1p,e10.2,
     1    '' Pmp'',e9.1,'' EscP'',e9.1,'' CS'',e9.1,'' Hlin/tot'',
     1    e10.2)')
     1    level , chLbl, TauIn , Pump , EscP , CS,ColHeat
        endif
      endif
*
      end
