******************************************************************************
      subroutine PunOpac( lunit , np )
      implicit none
*punch total opacity in any element, punch opacity command
*     lunit is io unit number, np is pointer within stack of punches
      integer lunit , np
      include "ncell.par"
      include "limpun.par"
      include "nopsv.par"
      include "limelm.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "optype.com"
      include "rfield.com"
      include "NumUpper.com"
      include "KshllEnr.com"
      include "scatop.com"
      include "opac.com"
      include "phycon.com"
      include "he.com"
      include "pca2ex.com"
      include "nhe1.com"
      include "nhe2.com"
      include "iophe1.com"
      include "iophe2.com"
      include "opsv.com"
      include "iphop.com"
      include "nh.com"
      include "LineLabl.com"
      include "nitexc.com"
      include "nsShells.com"
      include "pnunit.com"
      include "ipElement.com"
      include "Heavy.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      integer i , j , ilow , nelem,ion,ipS
      double precision ener , ener3
*
*     free statement labels  => 31
*
*     total opacity
      if( chOpcTyp.eq.'TOTL' ) then
        write(lunit,'(1p,5e12.4,1x,a4)') (anu(j),
     1  (opac(j)+scatop(j)),opac(j),scatop(j),
     2  scatop(j)/max(1e-37,scatop(j)+opac(j)),chContLabel(j),j=1,nflux)
*
*     subshell photo cross sections
      else if( chOpcTyp.eq.'SHEL' ) then
        nelem = punarg(np,1)
        ion = punarg(np,2)
        ipS = punarg(np,3)
        do i=ipElement(nelem,ion,ipS,1),ipElement(nelem,ion,ipS,2)
          write(lunit,'(1p,2e11.3)') anu(i),
     1    OpacStack( i-ipElement(nelem,ion,ipS,1)+
     2    ipElement(nelem,ion,ipS,3))
        end do
*
*     figure for hazy
      else if( chOpcTyp.eq.'FIGU' ) then
        do i=ipHn(1),nhe1(1)-1
          ener = anu(i)* 0.01356
          ener3 = 1e24 * ener**3
          write(lunit,'(1p,5e12.4)') anu(i),ener,
     1    OpacStack(i-ipHn(1)+iphop(1))*ener3,
     1    0.,opac(i)/hden*ener3
        end do
        do i=nhe1(1),nupper
          ener = anu(i)* 0.01356
          ener3 = 1d24 * ener**3
          write(lunit,'(1p,5e12.4)') anu(i),ener,
     1    OpacStack(i-ipHn(1)+iphop(1))*ener3,
     2    OpacStack(i-nhe1(1)+iophe1(1))*ahe/hden*ener3,
     3    opac(i)/hden*ener3
        end do
*
*     hydrogen
      else if( chOpcTyp.EQ.'HYDR' ) then
        call opacz
        call opinb( iphop(1), ipHn(1) , nupper , 1. , 0. )
        ilow = ipHeavy(1,1)
        write(10+1,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1  j=ilow,nupper)
        stop
*
*     helium
      else if( chOpcTyp.EQ.'HELI' ) then
        call opacz
        call opinb( iophe1(1) , nhe1(1) , nflux , 1. , 0.)
        ilow = ipHeavy(2,1)
        write(10+1,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1  j=ilow,nupper)
        call opacz
        call opinb( iophe2(1), nhe2(1) , nupper   , 1. , 0. )
        ilow = ipHeavy(2,2)
        write(10+2,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1  j=ilow,nupper)
        stop
*
*     lithium
      else if( chOpcTyp.eq.'LITH' ) then
        do i=1,3
          do j=1,3
            xIonFracs(3,j) = 0.
          end do
          xIonFracs(3,i) = 1.
          call opacz
          call PutOpacity( 3)
          ilow = ipHeavy(3,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
         end do
        stop
*
*     beryllium
      else if( chOpcTyp.eq.'BERY' ) then
        do i=1,4
          do j=1,4
            xIonFracs(4,j) = 0.
          end do
          xIonFracs(4,i) = 1.
          call opacz
          call PutOpacity( 4)
          ilow = ipHeavy(4,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
         end do
        stop
*
*     boron
      else if( chOpcTyp.eq.'BORO' ) then
        do i=1,5
          do j=1,5
            xIonFracs(5,j) = 0.
          end do
          xIonFracs(5,i) = 1.
          call opacz
          call PutOpacity( 5)
          ilow = ipHeavy(5,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
         end do
        stop
*
*     carbon
      else if( chOpcTyp.eq.'CARB' ) then
        do i=1,6
          do j=1,6
            xIonFracs(6,j) = 0.
          end do
          xIonFracs(6,i) = 1.
          call opacz
          call PutOpacity( 6)
          ilow = ipHeavy(6,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     nitrogen
      else if( chOpcTyp.eq.'NITR' ) then
        p2nit = 0.
        do i=1,7
          do j=1,7
            xIonFracs(7,j) = 0.
          end do
          xIonFracs(7,i) = 1.
          call opacz
          call PutOpacity( 7)
          ilow = ipHeavy(7,i)
          write(10+i,'(1P,2E10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     oxygen
      ELSE IF( chOpcTyp.EQ.'OXYG' ) THEN
        do i=1,8
          do j=1,8
            xIonFracs(8,j) = 0.
          end do
          xIonFracs(8,i) = 1.
          call opacz
          call PutOpacity( 8)
          ilow = ipHeavy(8,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        STOP
*
*     fluorine
      ELSE IF( chOpcTyp.EQ.'FLUO' ) THEN
        do i=1,9
          do j=1,9
            xIonFracs(9,j) = 0.
          end do
          xIonFracs(9,i) = 1.
          call opacz
          call PutOpacity( 9)
          ilow = ipHeavy(9,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
         end do
        STOP
*
*     neon
      ELSE IF( chOpcTyp.EQ.'NEON' ) THEN
        do i=1,10
          do j=1,10
            xIonFracs(10,j) = 0.
          end do
          xIonFracs(10,i) = 1.
          call opacz
          call PutOpacity( 10)
          ilow = ipHeavy(10,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     sodium
      else if( chOpcTyp.EQ.'SODI' ) theN
        do i=1,11
          do j=1,11
            xIonFracs(11,j) = 0.
          end do
          xIonFracs(11,i) = 1.
          call opacz
          call PutOpacity( 11)
          ilow = ipHeavy(11,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     magnesium
      else if( chOpcTyp.eq.'MAGN' ) then
        do i=1,12
          do j=1,12
            xIonFracs(12,j) = 0.
          end do
          xIonFracs(12,i) = 1.
          call opacz
          call PutOpacity( 12)
          ilow = ipHeavy(12,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     aluminium
      ELSE IF( chOpcTyp.EQ.'ALUM' ) THEN
        do i=1,13
          do j=1,12
            xIonFracs(13,j) = 0.
          end do
          xIonFracs(13,i) = 1.
          call opacz
          call PutOpacity( 13)
          ilow = ipHeavy(13,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        STOP
*
*     silicon
      ELSE IF( chOpcTyp.EQ.'SILI' ) THEN
        do i=1,14
          do j=1,14
            xIonFracs(14,j) = 0.
          end do
          xIonFracs(14,i) = 1.
          call opacz
          call PutOpacity( 14)
          ilow = ipHeavy(14,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     phosphorus
      ELSE IF( chOpcTyp.EQ.'PHOS' ) THEN
        do i=1,15
          do j=1,15
            xIonFracs(15,j) = 0.
          end do
          xIonFracs(15,i) = 1.
          call opacz
          call PutOpacity( 15)
          ilow = ipHeavy(15,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     sulfur
      ELSE IF( chOpcTyp.EQ.'SULF' ) THEN
        do i=1,16
          do j=1,16
            xIonFracs(16,j) = 0.
          end do
          xIonFracs(16,i) = 1.
          call opacz
          call PutOpacity( 16)
          ilow = ipHeavy(16,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     chlorine
      ELSE IF( chOpcTyp.EQ.'CHLO' ) THEN
        do i=1,17
          do j=1,17
            xIonFracs(17,j) = 0.
          end do
          xIonFracs(17,i) = 1.
          call opacz
          call PutOpacity( 17)
          ilow = ipHeavy(17,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     argon
      ELSE IF( chOpcTyp.EQ.'ARGO' ) THEN
        do i=1,18
          do j=1,18
            xIonFracs(18,j) = 0.
          end do
          xIonFracs(18,i) = 1.
          call opacz
          call PutOpacity( 18)
          ilow = ipHeavy(18,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        STOP
*
*     potassium
      ELSE IF( chOpcTyp.EQ.'POTA' ) THEN
        do i=1,19
          do j=1,19
            xIonFracs(19,j) = 0.
          end do
          xIonFracs(19,i) = 1.
          call opacz
          call PutOpacity( 19)
          ilow = ipHeavy(19,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     calcium
      ELSE IF( chOpcTyp.EQ.'CALC' ) THEN
        pca2ex = 0.
        do i=1,20
          do j=1,20
            xIonFracs(20,j) = 0.
          end do
          xIonFracs(20,i) = 1.
          call opacz
          call PutOpacity( 20)
          ilow = ipHeavy(20,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        STOP
*
*     scandium
      else if( chOpcTyp.eq.'SCAN' ) theN
        do i=1,21
          do j=1,21
            xIonFracs(21,j) = 0.
          end do
          xIonFracs(21,i) = 1.
          call opacz
          call PutOpacity( 21)
          ilow = ipHeavy(21,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     titanium
      else if( chOpcTyp.EQ.'TITA' ) THEN
        do i=1,22
          do j=1,22
            xIonFracs(22,j) = 0.
          end do
          xIonFracs(22,i) = 1.
          call opacz
          call PutOpacity( 22)
          ilow = ipHeavy(22,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     vanadium
      ELSE IF( chOpcTyp.EQ.'VANA' ) THEN
        do i=1,23
          do j=1,23
            xIonFracs(23,j) = 0.
          end do
          xIonFracs(23,i) = 1.
          call opacz
          call PutOpacity( 23)
          ilow = ipHeavy(23,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     chromium
      ELSE IF( chOpcTyp.EQ.'CHRO' ) THEN
        do i=1,24
          do j=1,24
            xIonFracs(24,j) = 0.
          end do
          xIonFracs(24,i) = 1.
          call opacz
          call PutOpacity( 24)
          ilow = ipHeavy(24,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     manganese
      ELSE IF( chOpcTyp.EQ.'MANG' ) THEN
        do i=1,25
          do j=1,25
            xIonFracs(25,j) = 0.
          end do
          xIonFracs(25,i) = 1.
          call opacz
          call PutOpacity( 25)
          ilow = ipHeavy(25,i)
          WRITE(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     iron
      else if( chOpcTyp.eq.'IRON' ) then
        do i=1,26
          do j=1,26
            xIonFracs(26,j) = 0.
          end do
          xIonFracs(26,i) = 1.
          call opacz
          call PutOpacity( 26)
          ilow = ipHeavy(26,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     cobalt
      else if( chOpcTyp.eq.'COBA' ) then
        do i=1,27
          do j=1,27
            xIonFracs(27,j) = 0.
          end do
          xIonFracs(27,i) = 1.
          call opacz
          call PutOpacity( 27)
          ilow = ipHeavy(27,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     nickel
      else if( chOpcTyp.eq.'NICK' ) then
        do i=1,28
          do j=1,28
            xIonFracs(28,j) = 0.
          end do
          xIonFracs(28,i) = 1.
          call opacz
          call PutOpacity( 28)
          ilow = ipHeavy(28,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     copper
      else if( chOpcTyp.eq.'COPP' ) then
        do i=1,29
          do j=1,29
            xIonFracs(29,j) = 0.
          end do
          xIonFracs(29,i) = 1.
          call opacz
          call PutOpacity( 29)
          ilow = ipHeavy(29,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     zinc
      else if( chOpcTyp.eq.'ZINC' ) then
        do i=1,30
          do j=1,30
            xIonFracs(30,j) = 0.
          end do
          xIonFracs(30,i) = 1.
          call opacz
          call PutOpacity( 30)
          ilow = ipHeavy(30,i)
          write(10+i,'(1P,2E10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
      else
        write(qq,'('' UNIDENTIFIED OPACITY KEY='',A4)') chOpcTyp
        stop
      endif
*
      end
