******************************************************************************
      subroutine PutLine( tarray )
      implicit none
*enter local line intensity into the intensity stack for eventual printout
      include "nta.par"
      real tarray(nta)
*
      include "limelm.par"
      include "nlines.par"
      include "ipLnArry.par"
      include "linsum.com"
      include "ExtrIntn.com"
      include "sum.com"
*
*     local variables
      character chLabel*4 , chIonLbl*4
      real xIntensity
      integer iWavLen
*
*     routine to use line array data to generate input
*     for emission line array
*
*     subroutine linadd(xIntensity , lam , chLab , chInfo)
*     real f
*     integer lam
*     character chLab*4 , chInfo*1
*
*     if ipass=0 then we must generate label info since first pass
*     gt.0 then only need line intensity data
      if( ipass.eq.0 ) then
*       these variables not used by linadd if ipass ne 0
        chLabel = chIonLbl( tarray )
        iWavLen = tarray( ipLnWlAng )
*       NB - following must be kept parallel with logic in setline and pldata
        if(iWavLen.gt.1 000 000 ) then
          iWavLen = iWavLen / 10000
        else if(iWavLen.gt.10 000 ) then
          iWavLen = iWavLen / 1000
        else if( iWavLen.lt.10 ) then
          iWavLen = tarray( ipLnWlAng ) * 10.
        endif
*       line energy in rydbergs
        xLineEnergy(nsum+1) = tarray(ipLnRyd)
      else
        chLabel = '    '
        iWavLen = 0
      endif
*
*     total line intensity or luminosity
      xIntensity = tarray( ipLnInten ) + ExtraInten
*     ExtraInten is option that allows extra intensity (i.e., recomb)
*     to be added to this line  with Call PutExtra( exta )
*     in main lines this extra
*     contribution must be identified explicitly
      ExtraInten = 0.
      call linadd(xIntensity , iWavLen , chLabel(1:4) , 'i')
*
*     inward part of line - do not move this away from previous lines
*     since xIntensity is used here
      xIntensity = tarray( ipLnInwd )* xIntensity
      call linadd(xIntensity , iWavLen , 'Inwd' , 'i')
*
*     cooling part of line
      xIntensity = tarray( ipLnCool )
      call linadd(xIntensity , iWavLen , 'Coll' , 'c')
*
*     fluorescent excited part of line
      xIntensity = tarray( ipLnPopOpc ) * tarray( ipLnPump ) *
     1  tarray( ipLnAovTOT ) * tarray( ipLnEnrErg )
      call linadd(xIntensity , iWavLen , 'Pump' , 'i')
*
*     heating part of line
      xIntensity = tarray( ipLnHeat )
      call linadd(xIntensity , iWavLen , 'Heat' , 'h')
*
      end
