******************************************************************************
      subroutine radi( chCard , ar1 )
      implicit none
*parse the radius command
      character chCard*80
      real ar1
*
      real parscl
      parameter (parscl=18.489396)
      include "itrdim.par"
      include "limext.par"
      include "limpar.par"
      include "radius.com"
      include "varon.com"
      include "ninput.com"
      include "nvary.com"
      include "vformt.com"
      include "vparm.com"
      include "nvfpnt.com"
      include "IOqq.com"
*
*     local variables
      logical lgEOL , lgMatch , lgRLog , lgR2set
      real convl , fread , a
      integer i
*
*     log of inner and outer radii, default second=infinity,
*     if R2<R1 then R2=R1+R2
*     there is an optional keyword, "PARSEC" on the line, to use PC as units
      if( lgMatch( 'PARS' , chCard ) ) then
        convl = parscl
      else
        convl = 0.
      endif
*     if linear appears on line, then radius is linear, otherwise, log
      if( lgMatch( 'LINE' , chCard ) ) then
        lgRLog = .false.
      else
        lgRLog = .true.
      endif
*
      i = 5
      ar1 = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' There should have been a number on this line.'',
     1  ''  Sorry.'')')
        stop
      endif
*
*     option for linear or log radius
      if( lgRLog ) then
        ar1 = ar1 + convl
      else
        ar1 = log10( ar1) + convl
      endif
      radius = 10. ** ar1
*
*     check for second number, which indicates thickness of model
      a = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
*       not set
        lgR2set = .false.
      else
*       outer radius is set,
        lgR2set = .true.
*       log or linear option is still in place
        if( lgRLog ) then
          a = a + convl
        else
          a = log10( a) + convl
        endif
        a = 10. ** a
*       check whether it was thickness or outer radius
        if( a .gt. radius ) then
          router(1) = a - radius
        else
          router(1) = a
        endif
        do i=2,itrdim
          router(i) = router(1)
        end do
      endif
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
*       pointer to where to write
        nvfpnt(nparm) = nRead
        vincr(nparm) = 0.5
*
        if( lgR2set ) then
          chVarFmt(nparm) =
     1    '(''RADIUS='',F9.5,'' depth or outer R'',F9.5)'
          nvarxt(nparm) = 2
*         second number is thickness or outer radius
          vparm(nparm,2) = log10( router(1) )
        else
          chVarFmt(nparm) ='(''RADIUS='',F9.5)'
          nvarxt(nparm) = 1
        endif
*
*       log of radius is first number
        vparm(nparm,1) = log10( radius )
      endif
*
      end
