******************************************************************************
      subroutine rdelem( chCard )
      implicit none
*parse options on element command
      character chCard*80
*
      include "limext.par"
      include "limpar.par"
      include "limelm.par"
      include "limTabD.par"
      include "AbunTablLG.com"
      include "AbunTablFac.com"
      include "trace.com"
      include "abnslr.com"
      include "solar.com"
      include "elmton.com"
      include "scalem.com"
      include "nvary.com"
      include "vformt.com"
      include "vparm.com"
      include "nvfpnt.com"
      include "varon.com"
      include "ninput.com"
      include "ipSolar.com"
      include "ElNames.com"
      include "IOqq.com"
*
*     local variables
      logical lgEnd , lgMatch , lgHIT
      character chCap*80
      logical lgEOL
      integer i , j , k , iel
      real param , fread
*
*     say that abundances have been changed
      lgAbnSolar = .false.
*
*     read in list of elements for abundances command
      if( lgMatch('READ' ,chCard ) ) then
        npSolar = 0
        do i=2,limelm
          call readar( chCard , lgEnd )
          if( lgEnd ) then
            write(qq,'('' Hit EOF while reading element list; use '',
     1      ''END to end list.'')')
            stop
          endif
          chCap = chCard
          call caps( chCap )
          if( chCap(1:3).eq.'END' ) then
*           write(6,*) (ipSolar(j),j=1,npSolar)
            return
          endif
*     >>chng 97 jun 2, removed statement label
*         do j=2,limelm
          j = 1
          lgHIT = .false.
          do while( j.lt.limelm .and. .not.lgHIT )
            j = j + 1
            if(chCap(1:4).eq.chElNames(j) ) then
              npSolar = npSolar + 1
              ipSolar(npSolar) = j
              lgHIT = .true.
            endif
          end do
          if( .not.lgHIT ) then
            write(qq,'(a80)') chCard
            write(qq,'('' Sorry, but I did not recognize element '',
     1      ''name on this line.'')')
            write(qq,'('' Here is the list of names I recognize.'')')
            write(qq,'(10(1x,a4))') (chElNames(k),k=2,limelm)
            stop
* 10       continue
          endif
        end do
*       fell through, make sure one more line, the end line
        call readar( chCard , lgEnd )
        chCap = chCard
        call caps( chCap )
        if( chCap(1:3).eq.'END' ) then
          return
        else
          write(qq,'('' Too many elements were entered.'')')
          write(qq,'('' I only know about'',i3,'' elements.'')')limelm
          write(qq,'('' Sorry.'')')
          stop
        endif
      endif
*
*     find which element
*     >>chng 97 jun 2, remove statement label
*      do i=1,limelm
      lgHIT = .false.
      i = 0
      do while( .not.lgHIT .and.i.lt.limelm )
        i = i + 1
        if( lgMatch(chElNames(i),chCard ) ) then
*         IEL is atomic number of element, is used below
          iel = i
          lgHIT = .true.
        endif
      end do
      if( .not.lgHIT ) then
        write(qq,'('' ELEM did not find an element on the following '',
     1  ''line:'')')
        write(qq,'(a80)') chCard
        stop
      endif
*
* 2    continue
*
*     IEL is the atomic number of the element
*
      i = 4
      param = fread( chCard , i , 76 , lgEOL )
*
      if( lgMatch('SCAL' ,chCard ) ) then
*       enter abundance as scale factor, relative to what is in now
        if( lgEOL ) then
          write(qq,'('' There must be a number on this line.'')')
          write(qq,'('' Sorry.'')')
          stop
        else
          if( lgMatch(' LOG' ,chCard ) .or. param.le.0. ) then
*           option for log of scale factor
            param = 10.** param
          endif
          scalem(iel) = param
        endif
      else if( lgMatch('ABUN' ,chCard ) ) then
*       log of actual abundance
        if( lgEOL ) then
          write(qq,'('' There must be a number on this line.'')')
          write(qq,'('' Sorry.'')')
          stop
        else
          solar(iel) = 10. ** param
          if( solar(iel).gt.1. ) then
            write(qq,'('' Please check this abundance.  It seems high '',
     1      ''to me.'')')
          endif
        endif
      else if( lgMatch(' OFF' ,chCard ) ) then
*       option to turn off this element, set abundance to zero
        lgElmtOn(iel) = .false.
        if( iel.eq.1 ) then
          write(qq,'('' It is not possible to turn hydrogen off.'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
      else if( lgMatch('TABL' ,chCard ) ) then
*     >>chng 97 jun 2, add table option
*       when called, read in densities from input stream
        lgAbunTabl(iel) = .true.
*       general flag saying this option turned on
        lgAbTaON = .true.
        if( lgMatch('DEPT' , chCard ) ) then
          lgAbTaDepth(iel) = .true.
        else
          lgAbTaDepth(iel) = .false.
        endif
*
*       make sure not trying to change hydrogen
        if( iel.eq.1 ) then
          write(qq,'('' cannot change abundance of hydrogen.'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
*
        call readar( chCard , lgEnd )
        i = 1
        AbTabRad(iel,1) = fread( chCard , i , 76 , lgEOL )
        AbTabFac(iel,1) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' no pairs entered - cant interpolate'')')
          stop
        endif
        nAbunTabl = 2
        lgEnd = .false.
        do while( .not.lgEnd .and.nAbunTabl.lt.limTabD)
          call readar( chCard , lgEnd )
          if(.not.lgEnd ) then
            call cap4(chCard(1:4) , chCap )
            if( chCap(1:3).eq.'END') lgEnd = .true.
          endif
          if( .not.lgEnd ) then
            i = 1
            AbTabRad(iel,nAbunTabl) = fread( chCard , i , 76 , lgEOL )
            AbTabFac(iel,nAbunTabl) = fread( chCard , i , 76 , lgEOL )
            nAbunTabl = nAbunTabl + 1
          endif
        end do
        nAbunTabl = nAbunTabl - 1
*       do i=1,nAbunTabl
*         write(6,*)i,AbTabRad(iel,i),AbTabFac(iel,i)
*       end do
        do i=2,nAbunTabl
*         the radius values are assumed to be strictly increasing
          if (AbTabRad(iel,i).le.AbTabRad(iel,i-1)) then
            write(qq,'('' abun radii must be in increasing '',
     1      ''order'')')
            stop
          endif
        end do
      else
        write(qq,'('' There must be a keyword on this line.'')')
        write(qq,'('' The keys I know about are TABLE, SCALE ''
     1  ''and ABUNDANCE.'')')
         write(qq,'('' Sorry.'')')
         stop
      endif
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
        nvarxt(nparm) = 1
*       pointer to where to write
        nvfpnt(nparm) = nRead
        if( lgMatch('SCAL' ,chCard ) ) then
*         vary scale factor
          write(chVarFmt(nparm),'(''(''''ELEMENT '',A4,'' SCALE'''',F9.5,
     1'''' LOG'''')'')') chElNames(iel)
*         param is linear scale factor
          vparm(nparm,1) = log10( param )
          vincr(nparm) = 0.2
        else if( lgMatch('ABUN' ,chCard ) ) then
*         vary absolute abundance
          write(chVarFmt(nparm),'(''(''''ELEMENT '',A4,'' ABUND'''',F9.5,
     1'''' LOG'''')'')') chElNames(iel)
*         param is log of abundance by number relative to hydrogen
          vparm(nparm,1) = param
          vincr(nparm) = 0.2
        endif
      endif
*
      end
