******************************************************************************
      subroutine SetCon(lgOK )
      implicit none
*derive intensity of incident continuum
      logical lgOK
      include "ncell.par"
      include "pi4.par"
      include "hnu3c2.par"
      include "fr1ryd.par"
      include "en1ryd.par"
      include "te1ryd.par"
      include "planck.par"
      include "limspc.par"
      include "SpeedLgt.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nhe3lvl.par"
      include "limelm.par"
      include "bounds.com"
      include "IonFracs.com"
      include "egray.com"
      include "prhd.com"
*     include "gampow.com"
      include "TrueEden.com"
      include "edxtra.com"
      include "smbeta.com"
      include "sv4861.com"
      include "conbug.com"
      include "nebug.com"
      include "secoff.com"
      include "recoil.com"
      include "trace.com"
      include "flxsav.com"
      include "save.com"
      include "comsig.com"
      include "corind.com"
      include "tmn.com"
      include "exptau.com"
      include "e2tau.com"
      include "i3727.com"
      include "telogn.com"
      include "ircoil.com"
      include "u.com"
      include "Heavy.com"
      include "qs.com"
      include "rfield.com"
      include "anusave.com"
      include "reflec.com"
      include "widflx.com"
      include "occnum.com"
      include "nxray.com"
      include "he.com"
      include "he12on.com"
      include "phycon.com"
      include "combug.com"
      include "called.com"
      include "occ1hi.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "HPhoto.com"
      include "habing.com"
      include "tenden.com"
      include "terode.com"
      include "flxfnt.com"
      include "totlum.com"
      include "neutrn.com"
      include "nh.com"
      include "PltTrace.com"
      include "NumUpper.com"
      include "occmax.com"
      include "h.com"
      include "con0.com"
      include "nhe1.com"
      include "nhe2.com"
      include "plasnu.com"
      include "hionon.com"
      include "bit32.com"
      include "HionRad.com"
      include "shullc.com"
      include "cspset.com"
      include "EdenOther.com"
      include "elmton.com"
      include "he3n.com"
      include "o3exc.com"
      include "forcte.com"
      include "IOqq.com"
*
*     local variables
      integer i,j,n,ipoint,ip
      real hokcgs,fsum,factor,ffun,alf,bet,ex1ryd,fntest,p1,p,
     1 p2,pheii,p4,p5,p6,qgn,pgn,p7,tcomp,tcompr,phe,p3,ecrit,
     2 uhei,r2ov1,r3ov2,occ1 , rec , xIoniz , smeets,EdenHeav
*     HOKCGS is h/k in cgs units
      parameter (hokcgs=4.8016e-11)
*
*     free statement labels, anything >=41 except 90, 99
*
      real wanu(4) , aweigh(4) , fweigh(4)
      double precision wfun(4) , amean , amean2 , amean3 , peak
*
      data  aweigh(1)/-0.4305682/ , aweigh(2)/-0.1699905/ , 
     1      aweigh(3)/+0.1699905/ , aweigh(4)/+0.4305682/ ,
     2      fweigh(1)/+0.1739274/ , fweigh(2)/+0.3260726/ ,  
     3      fweigh(3)/+0.3260726/ , fweigh(4)/+0.1739274/
*
*     set continuum
      if( lgTrace ) write(qq,'('' SetCon called.'')')
*
*     define factors to convert FLUX array into photon occupation array OCCNUM
*     by multiplication
      factor = en1ryd / pi4 / fr1ryd / hnu3c2
*
*-------------------------------------------------------------
      do i=1,nupper
*       this was original anu array with no continuum averaging
        anu(i) = AnuOrg(i)
        ContBoltz(i) = 0.
        tmn(i) = 1.
        ExpmTau(i) = 1.
        e2TauAbs(i) = 1.
        fsum = 0.
        amean = 0.
        amean2 = 0.
        amean3 = 0.
        do j=1,4
          wanu(j) = anu(i) + widflx(i)*aweigh(j)
          wfun(j) = fweigh(j) * ffun( wanu(j) )
          fsum = fsum + wfun(j)
          amean = amean + wanu(j) * wfun(j)
          amean2 = amean2 + wanu(j) * wanu(j) * wfun(j)
          amean3 = amean3 + wanu(j) * wanu(j) * wanu(j) * wfun(j)
        end do
        flux(i) = fsum * widflx(i)
        if( flux(i).gt.0. ) then
          anu(i) = amean2 / amean
          anu2(i) = amean3 / amean
*         fix conversion factor for occupation number
        else
          anu2(i) = anu(i) * anu(i)
        endif
        anu3(i) = anu2(i) * anu(i)
*
        refcon(i) = 0.
        convoc(i) = factor / widflx(i) / anu2(i)
*
*       following are Compton exchange factors from Tarter
        alf = 1./ ( 1. + anu(i)* ( 1.1792e-4 + 7.084e-10*anu(i) ) )
        bet = (1. - alf * anu(i)*(1.1792e-4+2.*7.084e-10*anu(i))/4.)
        csigh(i) = alf * anu2(i) * 3.858e-25
        csigc(i) = alf * bet * anu(i) * 3.858e-25
      end do
      if( lgTrace.and.lgComBug ) then
        write(qq,'(/,/,'' Compton heating, cooling coefficients '')')
        write(qq,'(4(i6,1p,3e9.2))')
     1  (i,anu(i),csigh(i),csigc(i),i=1,nupper,2)
      endif
*     option to check frequencies in real time, drive pointers command
      if( lgPtrace ) call ptrcer
      do i=1,nupper
*       define array of log10( nu(ryd))
        anulog(i) = log10( anu(i) )
      end do
*
*     extinguish continuum if set on
      call extin( ex1ryd )
*
*     now find peak of continuum
      ipeak = 1
      peak = 0.
      do i=ipHn(1),nupper
        if( flux(i)*anu(i)/widflx(i) .gt. peak ) then
*         IPEAK is pointer to largest f_nu,
*         and is passed to other parts of code
          ipeak = i
          peak = flux(i) * anu(i)/widflx(i)
        endif
      end do
*
*     check whether this will work on a 32 bit IEEE cpu
      peak = flux(ipeak) * anu(ipeak)
      if( peak.gt.1e38 .and. lgBit32 ) then
        write(qq,'('' SetCon: this appears to be a 32-bit cpu.'')')
        write(qq,'('' The continuum is too intense to compute'',
     1  '' with this cpu.  Use a long-word cpu or a fainter '',
     2  ''continuum. (This is the f_nu test)'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
*     say what type of cpu this is, if desired
      if( lgTrace ) then
        write(qq,'('' SetCon: The peak of the H-ion continuum is at'',
     1  1p,e10.3)')anu(ipeak)
        if( lgBit32 ) then
          write(qq,'('' SetCon: this is a 32-bit cpu.'')')
        else
          write(qq,'('' SetCon: this is a long-word cpu.'')')
        endif
      endif
*
*     find highest energy to consider in continuum flux array
*     peak is the peak product nu*flux
      peak = flux(ipeak)/widflx(ipeak)*anu2(ipeak)
*
      if( peak.gt.1e38 .and. lgBit32 ) then
        write(qq,'('' SetCon: this appears to be a 32-bit cpu.'')')
        write(qq,'('' The continuum is too intense to compute'',
     1  '' with this cpu.  Use a long-word cpu or a fainter '',
     2  ''continuum. (This is the nu*f_nu test)'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
*     FluxFaint set in block data; normally 1e-10
      fntest = peak * FluxFaint 
*
      if( fntest.gt.0. ) then
*       this test for pdr conditions where NO H-ionizing radiation
        i = nupper
        do while(i.gt.ipeak .and. flux(i)*anu2(i)/widflx(i).lt.fntest)
          i = i - 1
        end do
      else
        i = ipHn(1)
      endif
*
*     this line of code dates from 1979 and IOA Cambridge.  removed july 19 95
*     nflux = max( ineon(1)+4 , i )
*
*     last number may have been zero
      do while( flux(nflux).le.0. .and. nflux.gt.1 )
        nflux = nflux - 1
      end do
*
      if( nflux.eq.1 ) then
        write(qq,'('' This incident continuum appears to have no '',
     1  ''radiation.'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
*     check that continuum defined everywhere
      lgCon0 = .false.
      ip = 0
      do i=1,nflux
        if( flux(i).le.0. ) then
          if( lgTalk.and..not.lgCon0 ) then
            write(qq,'('' Continuum has zero intensity starting at'',
     1      1p,e11.4,'' Ryd.'')') anu(i)
            lgCon0 = .true.
          endif
          ip = ip + 1
        endif
      end do
      if( lgCon0.and.lgTalk ) write(qq,'(i6,'' cells in the incident'',
     1'' continuum have zero intensity.  Problems???'')
     2')ip
*
*     turn off secondary ionizations if soft continuum source
      if( anu(nflux) .lt. 7.4 ) lgSecOFF = .true.
*
*     check whether any hydrogen ionizing radiation
      if( nflux.lt.ipHn(1) ) then
        lgHIonON = .false.
      else
        lgHIonON = .true.
      endif
*
*     dont call HE1, HE2, or HE3 routines if no ionizing radiation
      if( lgElmtOn(2) ) then
        if( nflux.lt.nhe2(1) ) then
          lgHe2ON = .false.
        else
          lgHe2ON = .true.
        endif
        lgHe1ON = .true.
      else
        lgHe1ON = .false.
        lgHe2ON = .false.
      endif
*
*     if( nflux.lt.nxray ) then
*        decoff = 0.
*        disdec = 0.
*     else
*        turn off heavy element ionization trimming when X-rays on
*        decoff = 1.
*        disdec = 1.
*     endif
*
*     turn off recoil ionization if high energy < 190R
      if( anu(nflux).le.190 ) lgCompRecoil = .false.
*
*     sum photons and energy, save mean
      call sumcon( 1      , ipHn(2)-1,  qrad ,pradio , p1 )
      call sumcon( ipHn(2), ipHn(1)-1,  qbal ,  pbal , p1 )
      call sumcon( ipHn(1), nhe1(1)-1,     q ,     p , p2 )
      call sumcon( nhe1(1), nhe2(1)-1,   qhe ,   phe , p3 )
      call sumcon( nhe2(1), nxray-1  , qheii , pheii , p4 )
      call sumcon( nxray  , ipEnerGammaRay-1  ,    qx ,  xpow , p5 )
      call sumcon( ipEnerGammaRay  , nflux    ,  qgam ,GammaLumin , p6 )
*
*     find to estimate photoerosion timescale
      n = ipoint( 7.35e5 )
      call sumcon( n , nflux , qgn , pgn , p7)
      TimeErode = qgn
*
*     find Compton temp
      tcompr = (p1+p2+p3+p4+p5+p6) /
     1 (pradio+pbal+p+phe+pheii+xpow+GammaLumin)
      tcomp = tcompr / ( 4.*6.272e-6 )
      if( lgTrace ) then
         write(qq,'('' mean photon energy='',1P,E10.3,
     1   ''R ='',E10.3,''K'','' low, high nu='',2E12.4)')
     2   tcompr , tcomp ,
     2   anu(1)-widflx(1)/2. , anu(nflux)+widflx(nflux)/2.
      endif
*
*     this is total power in ionizing radiation
      powion = p + phe + pheii + xpow + GammaLumin
*     this is the total photon luminosity
      totlum = pradio + powion + pbal
      totlsv = totlum 
*
*     total H-ionizing photon number, followed by total photon number
      qhtot = q + qhe + qheii + qx + qgam
      qtot = qhtot + qbal + qrad
      if( powion.le.0. .and. lgTalk ) then
        lgHionRad = .true.
        write(qq,'('' >>>>There is no hydrogen-ionizing radiation.<<<<''
     1  )')
        write(qq,'('' >>>>Was this intended?<<<<'')')
        write(qq,'(''  '')')
*     >>chng 97 mar 18, add following sanity check - stop if no Paschen ionizing
*radiaion since even metals will be totally neutral
        call sumcon( ipHn(3) , ipHn(2)-1 ,  factor ,  alf , p1 )
        if( factor.le.0. ) then
          write(qq,'('' >>>>There is no sodium-ionizing radiation.<<<<''
     1   )')
          write(qq,'('' >>>>This code is not approriate for these'',
     1    '' conditions.<<<<'')')
*         punch out before we crash
          lgOK = .false.
          return
        endif
      else
        lgHionRad = .false.
      endif
*
*     option to add energy deposition due to fast neutrons, as frc of tot lum
*     efficiency default is unity
      if( lgNeutrnHeatOn ) then
        totneu = effneu * totlum * 10.**frcneu
      else
        totneu = 0.
      endif
*
*     temp correspond to energy density, printed in STARTR
      TEnerDen = ( totlum / SpeedLight / 7.56464e-15 )**0.25
*
*     simple estimate of Hbeta flux if all phot go to H
      smbeta = qhtot * 4.75e-13
*     incident continuum nu*f_nu at Hbeta and Ly-alpha
      cn4861 = ffun(0.1875 ) * planck * fr1ryd * 0.1875 * 0.1875
      cn1216 = ffun(0.75 ) * planck * fr1ryd * 0.75 * 0.75
      sv4861 = cn4861
      sv1216 = cn1216
*
*     flux density nu*Fnu = erg / s / cm2
*     EX1RYD is optional extinction factor at 1 ryd
      fx1ryd = ffun(1.000) * planck * ex1ryd * fr1ryd
*
*     check for plasma frequency - then zero out incident continuum
*     for energies below this
*     this is critical electron density, shielding of incident continuum
*     if electron density is greater than this
      ecrit = (anu(1)/2.729e-12)**2
      if( hden*1.2.gt.ecrit ) then
        lgPlasNu = .true.
        plsfrq = 2.729e-12 * sqrt( hden*1.2 )
        ipPlasma = ipoint( plsfrq )
*       save max pointer too
        ipPlasmax = ipPlasma
        do i=1,ipPlasma
*         count as reflected continuum
          refcon(i) = flux(i)
          flux(i) = 0.
        end do
      else
        lgPlasNu = .false.
        ipPlasma = 0
        plsfrq = 0.
      endif
      if( ipPlasma.gt.1 .and. lgTalk) then
        write(qq,'(''  !The plasma frequency is'',1P,E10.2,
     1  '' Ryd.  The incident continuum is set to 0 below this.'')')
     2  plsfrq
      endif
*
      occmax = 0.
      tbrmax = 0.
      do i=1,nupper
*       set up occupation number array
        occnum(i) = flux(i) * convoc(i)
        if( occnum(i).gt.occmax ) then
          occmax = occnum(i)
          occmnu = anu(i)
        endif
*       following product is continuum brightness temperature
        if( occnum(i)*te1ryd*anu(i) .gt. tbrmax) then
          tbrmax = occnum(i)*te1ryd*anu(i)
          tbrmnu = anu(i)
        endif
*       save continuum for next iteration
        FluxSave(i) = flux(i)
      end do
*
*     if continuum brightness temp is large, where does it fall below
*     1e4k???
      if( tbrmax.gt.1e4 ) then
        i = ipoint( tbrmnu )
        do while( i.lt.nupper.and. (occnum(i)*te1ryd*anu(i).gt.1e4) )
          i = i + 1
        end do
        tbr4nu = anu(i)
      else
        tbr4nu = 0.
      endif
*
*     if continuum occ num is large, where does it fall below 1?
      if( occmax .gt.1. ) then
        i = ipoint(occmnu)
        do while( i.lt.nupper.and.( occnum(i) .GT. 1. )) 
          i = i + 1
        end do
        occ1nu = anu(i)
      else
        occ1nu = 0.
      endif
*
*     remember if incident radiation field is less than 10*Habing ISM
      if( totlum.lt.1.8e-2 ) lgHabing = .true.
*
*     fix ionization parameter (per hydrogen) at inner edge
      uh = qhtot/ hden / SpeedLight
      uheii = (qheii+qx) / hden / SpeedLight
      uhei = (qhe+qheii+qx) / hden / SpeedLight
*
*     guess first temperature and neutral h density
      if( ForceTemp.gt.0. ) then
        te = ForceTemp
      else
        if( uh.gt.0. ) then
          te = max(8000. , 20000. + log10(uh) * 5000. )
        else
          te = 1000.
        endif
      endif
*     following needed for tfidle
      eden = hden
      hi = 0.
      call tfidle
      call velset
*
*     estimate secondary ionizaiton rate - probably 0, but possible extra
*     SetCsupra set with "set csupra"
      csupra = SetCsupra 
*
*     first estimate level of hydrogen ionization
      rec = 
     1(-9.9765209 + 0.158607055*telogn(1) + 0.30112749*telogn(2)
     2- 0.063969007*telogn(3) + 0.0012691546*telogn(4) ) /
     3(1.+ 0.035055422*telogn(1) - 0.037621619*telogn(2) 
     4+ 0.0076175048*telogn(3) - 0.00023432613*telogn(4) )
      rec = (10.**rec)/te * eden
      xIoniz = qhtot*2e-18 + smeets(1)*eden
      r2ov1 = xIoniz / rec
      hi = hden / (1. + r2ov1 )
      hii = hden - hi
      if( hii.gt.1e-30 ) then
        hn(1) = hi / hii
      else
        hn(1) = 0.
      endif
*
*     save into master ionization array
      xIonFracs(1,1) = hi
      xIonFracs(1,2) = hii
*
*     now save estimates of whether induced recombination is going
*     to be important -this is a code pacesetter since bnfun is slower
*     than gamk
      lgHInducImp = .false.
      do i=1,nhlvl
        if(occnum(ipHn(i)).gt.0.01) lgHInducImp = .true.
      end do
*
*     next estimate level of helium singly ionized
*     call colfit( 2,2,0,te,xIoniz )
*     >>chng 97 mar 19, to new data set
      call cfit( 2,2,te,xIoniz )
      xIoniz = xIoniz * eden + qhe * 1e-18 
      r2ov1 = xIoniz / rec
*
*     now estimate level of helium doubly ionized
*     call colfit( 2,1,0,te,xIoniz )
*     >>chng 97 mar 19, to new data set
      call cfit( 2,1,te,xIoniz )
      xIoniz = xIoniz * eden + qheii * 1e-18 
*     rough charge dependence
      rec = rec * 4.
      r3ov2 = xIoniz / rec
*
*     now set level of helium ionization
      if( r2ov1 .gt.0. ) then
        heii = ahe / (1./r2ov1 + 1. + r3ov2 )
        hei = heii / r2ov1
      else
*       no He ionizing radiation
        heii = 0.
        hei = ahe
      endif
      hei1 = hei
      heiii = heii * r3ov2
*     save into master ionization array
      xIonFracs(2,1) = hei
      xIonFracs(2,2) = heii
      xIonFracs(2,3) = heiii
*
*     estimate electrons from heavies, assuming each at least
*     1 times ionized
      EdenHeav = 0.
      do i=3,limelm
        EdenHeav = EdenHeav + xIonFracs(i,0)
      end do
*
*     estimate of electron density
      eden = hii + heii + 2.*heiii + EdenHeav + EdenExtra
*     carbon is nearly always at least once ionized
      EdenMet = xIonFracs(6,0)
      EdenNotH = eden - hii
      if( eden.lt.0. ) then
        write(qq,'('' Negative electron density results in SetCon.'')')
        write(qq,'(1p,10e10.2)') eden,hii,heii,heiii,xIonFracs(6,0),
     1  EdenExtra
        call ShowMe
        stop
      endif
      EdenTrue = eden
      if( lgTrace.and.lgNeBug ) write(qq,'(5X,''EDEN set to'',1P,E12.4,
     1'' by SetCon.'')') eden
*
*     he triplets only one that needs eden
      hei3 = heii * 5.79e-2/te * (1.+3110*(te/1e4)**(-0.51)/eden)
*
*     for later line opacities we need ratioal estimates 
      if( heiii.gt.0. ) then
*       if heiii is 0 then leave at values set in block data
        he2n(1) = heii/heiii
      endif
      if( heii.gt.0. ) then
*       if heii is 0 then leave at values set in block data
        he1n(1) = hei/heii
        he3n(1) = hei3/heii
      endif
*
      occ1 = fx1ryd/hnu3c2/pi4 / fr1ryd
*     what is occupation number at 1 Ryd?
      if( occ1.gt.1. ) then
        lgOcc1Hi = .true.
      else
        lgOcc1Hi = .false.
      endif
*
*     variables needed for possible second iteration, used in RESET
      hsv = hden
*
      if( lgTrace.and.lgConBug ) then
*        print some useful stuff
         write(qq,'('' H2,1='',2I5,'' NX='',I5,'' IRC='',
     1   I5)') ipHn(2) ,ipHn(1),nxray,ircoil
         write(qq,'('' HE3, 1='',2I5,'' HE2='',I5)')nhei3,nhe1(1),
     1   nhe2(1)
         write(qq,'('' CARBON'',11I5)') (ipHeavy(6,i),i=1,6)
         write(qq,'('' OXY'',9I5,'' IOX3='',I5,'' I2D,P='',2I5)')
     1   (ipHeavy(8,i),i=1,8),ipo3exc(1),i2d,i2p
         write(qq,'(//50X,''PHOTONS PER CELL (NOT RYD)'')')
         write(qq,'(//40X,''nu, flux, wid, occ '')')
         write(qq,'(3(1X,I4,1P,4E9.2))') (i,anu(i),flux(i),widflx(i),
     1   occnum(i),i=1,nflux)
      endif
*
      if( lgTrace )then
        write(qq,'(1X,''SetCon returns, nflux='',i5,'' anu(nflux)='',
     1  1p,e11.4,'' eden='',e10.2)') nflux , anu(nflux),eden
      endif
*
      lgOK = .true.
*
      end
