******************************************************************************
      subroutine stopr( chCard )
      implicit none
*parse the stop command
      character chCard*80
*
      include "parsec.par"
      include "itrdim.par"
      include "limext.par"
      include "limpar.par"
      include "mxstpl.par"
      include "bounds.com"
      include "radius.com"
      include "called.com"
      include "ZoneCnt.com"
      include "tauend.com"
      include "colend.com"
      include "endedn.com"
      include "StopLine.com"
      include "telow.com"
      include "stphit.com"
      include "varon.com"
      include "zonset.com"
      include "ninput.com"
      include "nvary.com"
      include "vformt.com"
      include "vparm.com"
      include "nvfpnt.com"
      include "efrend.com"
      include "bit32.com"
      include "EndDflt.com"
      include "IOqq.com"
*
*     local variables
      logical lgEOL , lgMatch
      integer i , j , mxzone
      real a , fread ,tread,effcol
*
      i = 5
      a = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' There MUST be a number on a STOP line.  Sorry.'')
     1  ')
        stop
      endif
*
      if( lgMatch( 'TEMP',chCard) ) then
*       lowest electron temperature allowed before stopping
*       assumed to be the log of the temperature if <10
*       optional keyword LINEAR forces linear
        if( a.le.10. .and. .not.lgMatch('LINE',chCard) ) then
          tread = 10.**a
        else
          tread = a
        endif
        if( tread.lt.3. ) then
          write(qq,'('' Temperatures below 3K not allowed. Reset '',
     1    ''to 3K.  Sorry.'')')
          tread = 3.
        endif
        if( lgMatch( 'EXCE',chCard) ) then
*         option for this to be highest allowed temperature,
*         stop temperate exceeds
          T2High = tread
        else
          tend = tread
          telow = min( telow , tend )
        endif
*
      else if( lgMatch( 'THIC',chCard) ) then
        if( lgMatch( 'LINE' , chCard ) ) then
          router(1) = a
        else
          if( a.gt.37. .and.lgBit32) then
            write(qq,'('' thickness too large for a 32 bit cpu?'')')
            stop
          endif
          router(1) = 10.** a
        endif
        if( lgMatch( 'PARS',chCard) ) then
          router(1) = router(1) * parsec
        endif
        do j=2,itrdim
          a = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) then
            router(j) = router(j-1)
          else
            if( lgMatch( 'LINE' , chCard ) ) then
              router(j) = a
            else
              if( a.gt.37. .and.lgBit32) then
                write(qq,'('' thickness too large for a 32 bit cpu?'')')
                stop
              endif
              router(j) = 10.** a
            endif
            if( lgMatch( 'PARS',chCard) ) then
              router(j) = router(j) * parsec
            endif
          endif
        end do
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          nvarxt(nparm) = 1
          chVarFmt(nparm) ='(''STOP THICKNESS'',F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
*         log of temp will be pointer
          vparm(nparm,1) = log10( router(1) )
          vincr(nparm) = 0.5
        endif
*
      else if( lgMatch( 'OPTI',chCard) ) then
        if( a.gt.37. .and.lgBit32) then
          write(qq,'('' optical depth too big for a 32 bit cpu?'')')
          stop
        endif
        tauend = 10.** a
        taunu = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          if( lgMatch( 'LYMA',chCard) ) then
*           largest Lyman limit optical depth
            taunu = 1.
          else if( lgMatch( 'BALM',chCard) ) then
*           stop at this balmer continuum optical depth
            taunu = 0.25
          else
            write(qq,'('' There must be a second number, the energy''
     1      ,'' in Ryd.  Sorry.'')')
            stop
          endif
        else
          if( taunu.lt.0. ) then
            taunu = 10.** taunu
          endif
          if( taunu.lt.emm .or. taunu.gt.egamry ) then
            write(qq,'('' The energy must be in the range '',1P,
     1      E9.2,'' to '',E9.2,''.  It was '',E9.2,''. Sorry.'')')
     2      emm , egamry , taunu
            stop
          endif
        endif
*
      else if( lgMatch( 'ZONE',chCard) ) then
*       stop after computing this zone
        nend(1) = a
        lgZoneSet = .true.
        mxzone = nend(1)
        lgEndDflt = .false.
        do j=2,itrdim
          nend(j) = fread( chCard , i , 76 , lgEOL )
          mxzone = max( mxzone , nend(j) )
          if( lgEOL ) nend(j) = nend(j-1)
        end do
*
      else if( lgMatch('EFRA' , chCard ) ) then
*       stop at this electron fraction, relative to hydrogen
        if( a.le.0. ) then
          StopElecFrac = 10.**a
        else
          StopElecFrac = a
        endif
*
      else if( lgMatch( 'COLU',chCard) ) then
*        stop at this column density; first is effective
         if( lgMatch( 'EFFE' , chCard ) ) then
*          actually stop at certain optical depth at 1keV
           effcol = 10. ** a
           tauend = effcol * 2.14e-22
           taunu = 73.5
*          vary option
           if( lgVarOn ) then
             nparm = nparm + 1
             nvarxt(nparm) = 1
             chVarFmt(nparm) ='(''STOP EFFECTIVE COLUMN DENSITY'',F9.5)'
*            pointer to where to write
             nvfpnt(nparm) = nRead
*            log of temp will be pointer
             vparm(nparm,1) = log10( effcol )
             vincr(nparm) = 0.5
           endif
*
         else if( lgMatch( 'IONI' , chCard ) ) then
*          this is ionized column
           if( a.gt.37. .and.lgBit32) then
             write(qq,'('' column too big for a 32 bit cpu?'')')
             stop
           endif
           colpls = 10.**a
*          vary option
           if( lgVarOn ) then
             nparm = nparm + 1
             nvarxt(nparm) = 1
             chVarFmt(nparm) = '(''STOP IONIZED COLUMN DENSITY'',F9.5)'
*            pointer to where to write
             nvfpnt(nparm) = nRead
*            log of temp will be pointer
             vparm(nparm,1) = log10( colpls )
             vincr(nparm) = 0.5
           endif
         else if( lgMatch( 'NEUT' , chCard ) ) then
*          this will be neutral column
           colnut = 10. ** a
*          vary option
           if( lgVarOn ) then
             nparm = nparm + 1
             nvarxt(nparm) = 1
             chVarFmt(nparm) = '(''STOP NEUTRAL COLUMN DENSITY'',F9.5)'
*            pointer to where to write
             nvfpnt(nparm) = nRead
*            log of temp will be pointer
             vparm(nparm,1) = log10( colnut )
             vincr(nparm) = 0.5
           endif
         else
*          both HII and HI
           if( a.gt.37. .and.lgBit32) then
             write(qq,'('' column too big for a 32 bit cpu?'')')
             stop
           endif
           HColStop = 10.**a
*          vary option
           if( lgVarOn ) then
             nparm = nparm + 1
             nvarxt(nparm) = 1
             chVarFmt(nparm) = '(''STOP COLUMN DENSITY'',F9.5)'
*            pointer to where to write
             nvfpnt(nparm) = nRead
*            log of temp will be pointer
             vparm(nparm,1) = log10( HColStop )
             vincr(nparm) = 0.5
           endif
         endif
*
      else if( lgMatch( 'EDEN',chCard) ) then
*       stop if electron density falls below this value
*       LINEAR option
        if( lgMatch( 'LINE',chCard) ) then
          StopElecDensity = a
        else
          StopElecDensity = 10. ** a
        endif
*
      else if( lgMatch( 'LINE',chCard) ) then
*       first line wavelength, then intensity relative to Hbeta for stop
*       if third number is entered, it is wl of line in denominator
        nstpl = min( nstpl+1 , MXSTPL )
        ipStopLin1(nstpl) = a
*       save line wavelength
        LineStopWl(nstpl) = a
        stpint(nstpl) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' There MUST be a relative intensity'',
     1    ''  entered.  Sorry.'')')
          stop
        endif
        ipStopLin2(nstpl) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          ipStopLin2(nstpl) = 1
        else
          if(ipStopLin2(nstpl).le.100 .or. ipStopLin2(nstpl).gt.10000 )
     1      then
            write(qq,'('' is the 3rd value correct?'')')
            stop
          endif
        endif
*
      else
        write(qq,'('' keyword error for STOP line.'')')
        stop
      endif
*
      end
