******************************************************************************
      subroutine tauff
      implicit none
*compute optical depth where cloud is thin to free-free and plasma freq
      include "ncell.par"
      include "tautot.com"
      include "plasnu.com"
      include "rfield.com"
      include "widflx.com"
      include "phycon.com"
      include "tff.com"
*
*     routine sets variable ntff, pointer to lowest cont cell that is thin
*
      real fac
*
*     find frequency where continuum thin to free-free
      do while( ntff.lt.nflux .and. tauabs(ntff,1).ge.1. )
        ntff = ntff + 1
      end do
*
*     TFF will be frequency where goes thin to brems
*     >>chng 96 May 7, had been 2, change as per Kevin Volk bug report
      if(ntff.gt.2 .and.tauabs(ntff,1).gt.0.001 ) then
*       for case where plasma frequency important, tau can be zero
        fac = (1.-tauabs(ntff-1,1))/( tauabs(ntff,1)-tauabs(ntff-1,1))
        fac = max( fac , 0. )
        tff = anu(ntff-1) + widflx(ntff-1)*fac
      else
        tff = 0.
      endif
*
*     now evaluate the plasma frequency
      plsfrq = 2.729e-12 * sqrt( eden*1.2 )
      if( plsfrq.gt.anu(1) ) lgPlasNu = .true.
*
*     >>chng 96 july 15, did not include plasma freq before
*     function returns larger of these two frequencies
      tff = max( plsfrq , tff )
*
*     now increment ntff still further, until above plasma frequency
      do while( ntff.lt.nflux .and. anu(ntff).le.tff )
        ntff = ntff + 1
      end do
*
*     save max plasma frequency for case where density changes
      if(tff.eq.plsfrq) ipPlasmax = max( ipPlasma,ntff)
*
      end
