******************************************************************************
      subroutine tefail
      implicit none
*handle temperature failure
      include "dCmHdT.com"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "called.com"
      include "phycon.com"
      include "heat.com"
      include "tcool.com"
      include "dtemp.com"
      include "limfal.com"
      include "failz.com"
      include "nfail.com"
      include "MapPar.com"
      include "iondun.com"
      include "PrnErr.com"
      include "InCvgRsn.com"
      include "IOqq.com"
*
*     local variables
*
      nfail = nfail + 1
      if( lgTalk ) then
        write(qq,'('' NO TE ION CONVERG'',I3,'' Z='',I4,
     1  '' TE='',1P,E10.4,'' ERROR='',E9.2,'' HTOT='',E9.2,'' CTOT='',
     2  E9.2,'' DERR='',E9.2,'' DTe='',E9.2,'' lgIonDone:'',1L1)')
     3  nfail , nzone, te,(htot-ctot)/htot, htot, ctot, dCoolmHeatdT,
     4  dTemper,
     4  lgIonDone
        if(lgTOscl.and.lgCmHOsc) then
          write(qq,'('' Temperature and d(Cool-Heat)/dT were both '',
     1    ''oscillating.'')')
        else if(lgTOscl) then
          write(qq,'('' Temperature was oscillating.'')')
        else if(lgCmHOsc) then
          write(qq,'('' d(Cool-Heat)/dT was oscillating.'')')
        endif
*       not really a temperature failure, but something else
        if( .not.lgIonDone ) then
          write(qq,'('' Solution not converged due to '',a10)')
     1    chInCvgRsn
        endif
      endif
*     option to print to screen
      if( lgPrnErr ) then
        write(ioPrnErr,'('' NO TE ION CONVERG'',I3,'' Z='',I4,
     1  '' TE='',1P,E10.4,'' ERROR='',E9.2,'' HTOT='',E9.2,'' CTOT='',
     2  E9.2,'' DERR='',E9.2,'' DTe='',E9.2,'' lgIonDone:'',1L1)')
     3  nfail , nzone, te,(htot-ctot)/htot, htot, ctot, dCoolmHeatdT, 
     4  dTemper,lgIonDone
        if(lgCmHOsc)write(qq,'('' d(Cool-Heat)/dT was oscillating.'')')
      endif
*
*     remember which zone this is
      ifailz( min( nfail,10 ) ) = nzone
*     remember the relative error
*     convert to single precision for following max, abs (vax failed here)
      failmx = max( failmx , abs(real((htot-ctot)/htot)) )
      if( nfail .lt. limfal ) return
*
*     punt
      if( lgTalk ) then
        write(qq,'('' Stop after'',I3,'' temperature failures.'')')
     1  limfal
        write(qq,'('' This limit can be reset with the'',
     1  '' FAILURES command.'')')
*
*       adjust range of punting map
        RangeMap(1) = te / 100.
        RangeMap(2) = min( te * 100. , 9e9 ) 
        if(.not. lgNoMap) then
*         need to make printout out now, before disturbing soln with map
          call prstep
          call punt('punt')
        endif
      endif
*
*     return out from here and let lgEndFun catch lgBusted set,
*     and generate normal output there
      lgBusted = .true.
      if(lgTalk)write(qq,'('' tefail sets lgBusted since nfail>=limfal'',
     1 2i5)') nfail , limfal
*
      end
