******************************************************************************
      subroutine tfidle
      implicit none
*update some temperature dependent variables
      include "itrdim.par"
      include "teinv.com"
      include "dcool.com"
      include "TePowers.com"
      include "edsqte.com"
      include "sqrne.com"
      include "logte.com"
      include "phycon.com"
      include "telogn.com"
      include "h.com"
      include "ZoneCnt.com"
      include "IterCnt.com"
      include "IOqq.com"
*
*     local variables
      real ttused , edused
      integer i
      save ttused,edused
      data ttused,edused/2*0./
*
*begin sanity check
      if( te.le.0. ) then
        write(qq,'('' TFIDLE has been called with a negative'',
     1  '' temperature,'',1p,e10.3)') te
        write(qq,'('' This is zone'',i5,'' iteration'',i5)')
     1  nzone,iter
        call ShowMe
        stop
      endif
*end sanity check
*
      if( te.ne.ttused ) then
        ttused = te
        sqrte = sqrt(te)
        halfte = 0.5 / te
        tsq1 = 1. / (te**2)
        te32 = te * sqrte
        te70 = te ** 0.70
        te30 = te ** 0.30
        te20 = te ** 0.20
        te10 = te ** 0.10
        te05 = te ** 0.05
        te03 = te ** 0.03
        te02 = te ** 0.02
        te01 = te ** 0.01
        te005 = te** 0.005
        te003 = te** 0.003
        te001 = te** 0.001
        teinv = 1. / te
        alogte = log10( te )
        alogete = log( te )
        telogn(1) = alogte
        do i=2,7
          telogn(i) = telogn(i-1) * telogn(1)
        end do
      endif
*
*     check that eden now negative
      if( eden.le.0. ) then
        write(qq,'('' I found a zero or negative electron density,'',
     1  1p,e10.2)') eden
        stop
      endif
*
*     term with hi added June 4, 93, to account for warm pdr
      edensqte = (eden+hi/1e4) / sqrte
      cdsqte = edensqte * 8.629e-6
*
      if( eden.ne.edused ) then
        edused = eden
        SqrtEden = sqrt( eden ) 
      endif
*
      end
