******************************************************************************
      subroutine tfirst( lgOK )
      implicit none
*drive search for initial temperature, for illuminated face
      logical lgOK
      include "nhlvl.par"
      include "limelm.par"
      include "trace.com"
      include "MapPar.com"
      include "TePowers.com"
      include "telow.com"
      include "nodec.com"
      include "iondun.com"
      include "search.com"
      include "colneg.com"
      include "called.com"
      include "thigh.com"
      include "forcte.com"
      include "tcool.com"
      include "IterCnt.com"
      include "phycon.com"
      include "PresInit.com"
      include "heat.com"
      include "htau.com"
      include "htnext.com"
      include "DoPhoto.com"
      include "newion.com"
      include "InCvgRsn.com"
      include "TrConvg.com"
      include "hvmolEXP.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      real xmultp , trig,told,cold,hold,tnew,cnew,hnew,dt,
     1 TotalPressure,dc,factor,sign,tmin,tmax,t1,t2 ,tinc , fac2
      integer ionlup,loop,isear,j,i , looplimit , nThLoop
*     XMULTP is scale factor to multiply temperature
      parameter (xmultp=3.0)
      double precision derrdt
      real tsave
      save tsave
*
*     free statement labels =>9
*
*     turnon photo rate evaluation
      lgDoPhoto = .true.
*
      if( lgTrConvg ) then
        write(qq,'(''  '')')
        write(qq,'('' TFIRST entered '')')
      endif
*
*     if MapZone LT 0, just map first zone and punch out
      if( MapZone .le. 0 ) then
        if( lgTrace .or.lgTrConvg)
     1  write(qq,'('' TFIRST called.  just map'')')
        call punt(' map')
        lgOK = .false.
        return
      endif
*
*     force an initial temperature, also constant temperature
      if( ForceTemp .ne. 0. ) then
*       force te to certain value
        if(lgTrace) then
          write(qq,'('' TFIRST called, forcing TE to'',1P,E10.2)')
     1    ForceTemp
        end if
        te = ForceTemp
        PressureInit = TotalPressure()
*       say this is search for first solution, let Ne change a lot
        lgSearch = .true.
*
        ionlup = 0
        lgIonDone = .false.
*     >>chng 96 oct 11, loop at least 3x to make sure ionization converged
        do while( ionlup.le.3 .or.(.not.lgIonDone.and.ionlup.le.7) )
*         lgIonDone can be set false by several tests in ionize
          lgIonDone = .true.
          lgNewIon = .true.
          lgDoPhoto = .true.
          call ionize
*         only used to keep forcing new optical depths below
          ionlup = ionlup + 1
          call coolr( ctot , dc )
*         force reevaluation of H trans rates
          htnext(3,2) = htnext(3,2) * 0.9999
        end do
        if( ionlup.gt.1) then
*         repair damage done above
          htnext(3,2) = htnext(3,2) / ( 0.9999**ionlup )
        endif
        lgSearch = .false.
        lgOK = .true.
        return
      endif
*
*     check if this is second or higher iteration
      if( iter .ne. 1) then
*       this is second or higher iteration on multi-iteration model
        if(lgTrace.or.lgTrConvg) write(qq,'('' TFIRST called, ITER='',
     1  I2,'' resetting Te to '',1P,E10.2)') iter , tsave
        lgSearch = .false.
        te = tsave
        PressureInit = TotalPressure()
        do i=1,2
          lgNewIon = .true.
          lgDoPhoto = .true.
          call ConvIoniz
          call coolr( ctot , dc )
*         coolr evaluates level pops, needed for following
          call MakeRT
          tsave = te
        end do
*       now get final temperature
        call ionte( nThLoop ,0 )
        lgOK = .true.
        return
      endif
*
*     do first te from scratch
      lgSearch = .true.
      if( lgTrace ) write(qq,'('' TFIRST called, new temperature.'')')
*
*     approach equilibrium from either high or low TE
      if( lgTeHigh ) then
*       approach from high TE
        te = 1e6
        lgNoDec = .false.
        factor = 1. / xmultp
      else
*       approach from low TE
        lgNoDec = .true.
        te = 4000.
        factor = xmultp
      endif
*
*     find first temperature
      lgColNeg = .false.
      PressureInit = TotalPressure()
*
      htot = 1.
      ctot = 1.
*     call cooling, heating, opacity, loop to convergence
*     this is very first call to it, by default is at 4000K
      if( lgTrConvg ) then
        write(qq,'('' TFIRST calling cholup1 with te='',1p,e10.3)')te
      endif
      call cholup( dc , loop )
      if( lgTrace )then
        write(qq,'('' TFIRST first temp after'',I3,'' trys'')')
     1  loop
      end if
*     >>chng 97 feb 18, define following three
      told = te
      cold = ctot
      hold = htot
*
      if( lgTrace ) write(qq,'('' RETURN TO TFIRST 1, HTOT:'',1P,E10.3,
     1''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e11.4,25(''<''))')
     2 htot , ctot , te,eden
*
*     sign is cooling minus heating, in most cases negative means T too low
      sign = abs(ctot-htot) / (ctot-htot)
*
*     if low te approach then check if already past soln (cooling > heating)
      if( .not.lgTeHigh .and. sign.ge.0. ) then
        if( lgTrConvg ) then
          write(qq,'('' TFIRST entering T<tfirst loop, te htot ctot='',
     1    1p,3e10.3,'' sign='',e9.1)')te,htot,ctot,sign
        endif
*       check range 10 - 4000K, TELOW usually 2.8K, set with SET LOWEST command
*     >>chng 96 may 30, logic had gone straight to 3K, which blew up dense clouds
*       now go down more gently
*     >>chng 97 mar 3, variable factor, smaller when close to 3K
        fac2 = 0.8
        do while( te*fac2 .gt.telow .and. sign.ge.0. )
*     >>chng 96 June 14, to below, so that we can get soln near 3K
*       do while( te.gt.telow .and. sign.ge.0. )
*     >>chng 97 feb 18, define following three
          told = te
          cold = ctot
          hold = htot
*     >>chng 97 mar 3, make fac2 small when close to lower bound
          if( te.lt.5. ) then
            fac2 = 0.97
          else if( te.lt.20. ) then
            fac2 = 0.9
          else
            fac2 = 0.8
          endif
*         now change to new temp
          te = te * fac2
*         te = telow
          PressureInit = TotalPressure()
*         call cooling, heating, opacity, loop to convergence
          if(lgTrConvg) write(qq,'(/'' calling cholup2, te='',1p,e9.2)')
     1    te
          call cholup( dc , loop )
          tnew = te
          cnew = ctot
          hnew = htot
          if( lgTrConvg ) then
            write(qq,'('' cholup2 returns, te='',1p,e9.2,'' htot'',e9.2,
     1      '' ctot'',e9.2)') te, htot , ctot
          endif
          if( lgTrace .or. lgTrConvg) then
            write(qq,'('' RETURN TO TFIRST 2  HTOT:'',1P,E10.3,
     1      ''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e11.4,25(''<'')
     2      )') htot , ctot , te,eden
          endif
          sign = abs( ctot-htot ) / (ctot-htot)
        end do
        if( ctot.gt.htot ) then
*         even at lowest temp, too much cooling; no solution possible
          write(qq,'('' Equilibrium temperture below T='',1P,E8.2,
     1    ''.  If this is OK, then reset with LOWEST command.'',
     2    ''  This is TFIRST.  TELOW was'',e9.2)') te,telow
          lgOK = .false.
          return
        endif
*     >>chng 97 mar 3, from *0.9 to / fac2
        te = te / fac2
        factor = 1./(0.5*(1.+fac2))
        sign = abs( cold-hold ) / (cold-hold)
        if( lgTrConvg ) then
          write(qq,'('' <4000K loop returns, te='',1p,e9.2,'' sign'',
     1    e9.2,'' factor'',e9.2)') te , sign , factor
        endif
      endif
*
      tmin = 1e9
      tmax = 0.
*     coming up to here te is either 4,000 (usually) or 10^6
      t1 = telow / 1.001
*     >>chng 96 dc 28, added div by factor to prevent checking on temp > 1e10
      t2 = tehigh * 1.001 / factor
      if( lgTrConvg ) then
        write(qq,'('' TFIRST entering second loop te='',1p,e9.2,
     1  '' sign'',e9.2,'' factor'',e9.2,'' t1, t2='',2e10.2)') te,
     2  sign ,factor, t1,t2
      endif
      do while ( (ctot-htot)*sign.gt.0. .and. te.gt.t1 .and. te.lt.t2 )
*     >>chng 97 feb 18, define following three
        told = te
        cold = ctot
        hold = htot
        te = te * factor
        PressureInit = TotalPressure()
        tmin = min( tmin , te )
        tmax = max( tmax , te )
        lgIonDone = .false.
        chInCvgRsn = 'TFIRST srh'
        isear = 1
        do while( isear.le.6 .and. .not.lgIonDone )
*         call cooling, heating, opacity, loop to convergence
          lgIonDone = .true.
          if(lgTrConvg)write(qq,'(/'' calling cholup3, te='',1p,e9.2)')
     1    te
          call cholup( dc , loop )
          if( lgTrConvg ) then
            write(qq,'('' cholup3 returns, te='',1p,e9.2,'' htot'',e9.2,
     1      '' ctot'',e9.2)') te, htot , ctot
          endif
          if( lgTrace ) then
            write(qq,'('' RETURN TO TFIRST 3  HTOT:'',1P,E10.3,
     1      ''  ctot:'',e10.3,''  Te:'',e11.4,'' eden'',e11.4,25(''<'')
     2      )') htot , ctot , te,eden
          endif
          isear = isear + 1
        end do
        tnew = te
        cnew = ctot
        hnew = htot
      end do
*
*     fall through loop, te too high or low
      if ( te.le.t1 .or. te.ge.t2 ) then
        if( te.le.t1 ) then
          write(qq,'('' TFIRST finds TE below TE = '',1P,E10.3,
     1    ''K, HTOT='',E12.4,'' CTOT='',E12.4)')
     2    t1 , htot , ctot
        else if( te.ge.t2 ) then
          write(qq,'('' TFIRST finds TE above TE = '',1P,E10.3,
     1    ''K, HTOT='',E12.4,'' last CTOT='',E12.4)')
     2    t2 , htot , ctot
        else
          write(qq,'('' TFIRST finds insanity '')')
          call ShowMe
        endif
        lgOK = .false.
        return
      endif
*
*     now search inside (also either side of) TE range where sign changed
*     first turn on ionization stage trimming
      lgNoDec = .false.
      lgColNeg = .true.
*
      trig = te
*     change sense of temp search so that we can "weave" into soln
      tinc = 1./factor ** 0.2
*
      do j=1,2
        if( (ctot-htot.gt.1e-30).and.ctot.gt.0. ) then
          sign = abs( ctot-htot ) / (ctot-htot)
          if(lgTrConvg)write(qq,'(//'' >>>entering second loop, te '',
     1    ''reset to'',1p,e9.2)') te
          PressureInit = TotalPressure()
*         call cooling, heating, opacity, loop to convergence
          isear = 1
          lgIonDone = .false.
          if( lgTrace ) then
            write(qq,'('' RETURN TO TFIRST 4  HTOT:'',1P,E10.3,
     1      ''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e11.4,25(''<'')
     2      )') htot , ctot , te,eden
          endif
          i = 0
*         looplimit = 8
*         >>chng 97 july 29, to recover fumbled initial ionizatino
          looplimit = 12
          told = te
          cold = ctot
          hold = htot
*         this loop is not necessariy executed (ctot and htot very close)
          do while( i.lt.looplimit .and. (ctot-htot)*sign.gt.0. )
            i = i + 1
            told = te
            cold = ctot
            hold = htot
            te = te * tinc
            PressureInit = TotalPressure()
            lgNewIon = .true.
            lgDoPhoto = .true.
            call cholup( dc , loop )
            if( lgTrConvg ) then
              write(qq,'('' cholup returns, te='',1p,e9.2,'' htot'',e9.2
     1        ,'' ctot'',e9.2)') te, htot , ctot
            endif
            tnew = te
            cnew = ctot
            hnew = htot
            if( lgTrace ) write(qq,'('' RETURN TO TFIRST 4  HTOT:'',1P,
     1      E10.3,''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e11.4,
     2      25(''<''))') htot,ctot,te,eden
          end do
          if( i.ge.looplimit .and. (ctot-htot)*sign.gt.0. .and.
     1      abs(ctot/htot-1.).gt.0.05 ) then
*     >>chng 96 dec 17, way out for dense, cold, molecular gas
            if( te.lt.1e3 .and. co/xIonFracs(6,0).gt.0.5 ) then
              write(qq,'('' cold molecular trap, te='',1p,e10.2,
     1        '' F(CO)='',e10.2)') te,co/xIonFracs(6,0)
              write(qq,'('' Conditions in this cloud are not '',
     1        ''appropriate for this code.'')')
              lgOK = .false.
              return
            else
              write(qq,'('' Insanity occurred in tfirst, i=0'')')
              call ShowMe
              stop
            endif
          endif
*         weave back in again
          tinc = 1./tinc ** 0.2
        endif
      end do
      if( lgTrConvg ) write(qq,'('' search set false'')')
      lgSearch = .false.
*
*     now must be close enough to call regular ionization-cooling
*     first do linear interpolation to guess temperature
      if( tnew.ne.told .and.tnew.gt.0..and.told.gt.0. ) then
        derrdt = dble((cnew-hnew)-(cold-hold)) / dble(tnew-told)
        dt = -dble(cold-hold) / derrdt
        te = told + dt
        te = max( te , min(told,tnew) )
        te = min( te , max(told,tnew) )
        PressureInit = TotalPressure()
      endif
      if( lgTrace ) then
        write(qq,'('' TFIRST calls IONTE after interpolating''
     1  ,'' a temperature of'',1p,e10.3,'' Told='',e10.2,'' Tnew='',
     2  e10.2,'' dC-Hold'',e10.2,'' dC-Hnew'',e10.2)') te , told,tnew,
     1 (cold-hold),(cnew-hnew)
      end if
      if(lgTrConvg)write(qq,'(//'' >>>calling ionte with interpolated'',
     1'' te='',1p,e10.3)') te
      call ionte( nThLoop , 0 )
      tsave = te
      if( lgTrace ) then
        write(qq,'('' TFIRST return, TE:'',1P,E10.2,18(''=''))')
     1  te
      endif
*
      lgOK = .true.
*
      end
