******************************************************************************
      subroutine TiCol
      implicit none
*compute titanium cooling
      include "limelm.par"
      include "nta.par"
      include "dcool.com"
      include "TePowers.com"
      include "phycon.com"
      include "IonFracs.com"
      include "coolti.com"
      include "TLineEXP.com"
*
*     local variables
      real a21, a31 , a32 , pop3, p3, p2
*
*     Ti Titanium cooling
*
*     these are 3 lines estimated by Jim Kingdon
*     a's are bad, collision strengths just one
      a21 = 0.015
      a31 = 0.032
      a32 = 0.002
*
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( 21.,5.,9., 21. , 5.0, 9.0, a21 ,a31,a32,
     1  11844., 3148.4, p2, xIonFracs(22,3),0.)
*     multiplet at roughly 9594
      Ti3l31 = p3 * a31 * 2.07E-12
*     multiplet at roughly 4.57 microns
      Ti3l32 = p3 * a32 * 4.35e-13
*     multiplet at roughly 1.21 microns
      Ti3l21 = p2 * a21 * 1.64E-12
      call coladd( 'Ti 3' , 9594 , Ti3l31  )
      call coladd( 'Ti 3' ,    4 , Ti3l32  )
      call coladd( 'Ti 3' ,    1 , Ti3l21  )
*
*     [Ti VI] 1.7150 mic
*     Y(ik) from 
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 3.48 , Ti06172 )
      call level2( Ti06172 )
*
*     [Ti XIV] 2117.79, cs from 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.23 , Ti14212 )
      call level2( Ti14212 )
*
      end
