******************************************************************************
      subroutine update
      implicit none
*update optical depth scale
      include "nta.par"
      include "nhetau.par"
      include "itrdim.par"
      include "ncell.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nfst.par"
      include "ndfst.par"
      include "ipLnArry.par"
      include "nwindline.par"
      include "limelm.par"
      include "tautot.com"
      include "deptau.com"
      include "caseb.com"
      include "double.com"
      include "xry.com"
      include "he3tuARR.com"
      include "NumUpper.com"
      include "IterCnt.com"
      include "he1nxt.com"
      include "he2nxt.com"
      include "taumin.com"
      include "htau.com"
      include "htnext.com"
      include "he1tau.com"
      include "he2tau.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "trace.com"
      include "hbug.com"
      include "touton.com"
      include "static.com"
      include "sphere.com"
      include "otsmin.com"
      include "pmpcah.com"
      include "nhe1.com"
      include "nhe2.com"
      include "autoit.com"
      include "taucon.com"
      include "TLineARR.com"
      include "ColDnSav.com"
      include "cldnEXP.com"
      include "TAddLya.com"
      include "FeIIAtom.com"
      include "WindData.com"
      include "solars.com"
      include "he12on.com"
      include "PunConv.com"
      include "NoConverge.com"
      include "ZoneCnt.com"
      include "phycon.com"
      include "efrac.com"
      include "phlevl.com"
      include "KatyaDat.com"
      include "IOqq.com"
*
*     local variables
      integer i,j 
      real totwid,f1,f2,fhe1,fhe2,receff,f , TauOff , OldDTau,
     1 AverFac , OldHe1DTau , OldEfrac
      save OldDTau , OldHe1DTau , OldEfrac
      logical lgConverged , lgTauOscil ,lgTauHeOscil , lgEverOscil
      save lgTauOscil ,lgTauHeOscil , lgEverOscil
*
*     save column density
      ColDenSav(iter) = colden
*
      if( lgTrace ) then
        write(qq,'(1X,''UPDATE estimating new optical depths'')')
        if( lgHBug .and.lgHBugFull) then
          write(qq,'(1X,''New Hydrogen outward optical depths:'')')
          write(qq,'(I3,1P,7E9.2)') (i,(htau(i,j),j=1,7),i=1,nhlvl)
        endif
      endif
*
*     pumping of CaH
      conca = max( sqrt(max(1.,log(max(1e-37,tpcah(1))))),
     1 (6.1e-5*tpcah(1))**0.5 )
      conhe = max( sqrt(max(1.,log(max(1e-37,htau(6,2))))) , 
     1 (1.7e-6*max(1e-37,htau(6,2))) ** 0.5 )
      totwid = 10.*conhe + 1.6*conca
*     if( totwid.gt.121. ) write(qq,'('' overlap'')')
      tpcah(2) = tpcah(1)
      tpcah(1) = taumin
*
*     this is an option to keep iterating until it converges
*     iterate to convergence option
*     autocv is percentage difference in optical depths allowed,
*     =0.20 in block data
      lgConverged = .true.
      chNotConverged = 'Converged!'
*     write(qq,'('' entering auto iter loop'')')
      if( iter.gt.1 .and. lgAutoIt ) then
*       check both H-alpha and Ly-alpha - only if balmer lines thick
        if( htau(3,2).gt. 0.5 ) then
          if( abs( htlim(2,1)/(htau(2,1)*DoubleTau)-1.).gt.autocv) then
*           not converged to within AUTOCV, normally 15 percent
            lgConverged = .false.
            chNotConverged = 'H Lya     '
            if(lgPunConv)write(ipPunConv,'('' H Lya'')')
          endif
          if( abs(htlim(3,2)/(htau(3,2)*DoubleTau)-1.).gt.autocv) then
*           not converged to within AUTOCV, normally 15 percent
            lgConverged = .false.
            chNotConverged = 'H Lya     '
            if(lgPunConv)write(ipPunConv,'('' H B a'')')
          endif
        endif
        if( lgHe1ON.and.(he1tau(2,1)-TAddHeI).gt.0.5 ) then
          if( abs(he1tau(2,1)*DoubleTau/he1lim(2,1)-1.).gt.autocv) then
            lgConverged = .false.
            chNotConverged = 'He1 Lya   '
            if(lgPunConv)write(ipPunConv,'('' He1 Lya'')')
          endif
        endif
        if( lgHe2ON.and.(he2tau(2,1)-TAddHeII) .gt.0.5 ) then
          if( abs(he2tau(2,1)*DoubleTau/he2lim(2,1)-1.).gt.autocv) then
            lgConverged = .false.
            chNotConverged = 'He2 Lya   '
            if(lgPunConv)write(ipPunConv,'('' He2 Lya'')')
          else if( he2tau(3,2).gt.0.5.and. 
     1      abs(he2tau(3,2)*DoubleTau/he2lim(3,2)-1.).gt.autocv*2.) then
            lgConverged = .false.
            chNotConverged = 'He2 3-2   '
            if(lgPunConv)write(ipPunConv,'('' He2 3-2'')')
          else if( he2tau(4,3).gt.0.5.and. 
     1      abs(he2tau(4,3)*DoubleTau/he2lim(4,3)-1.).gt.autocv*2.) then
            lgConverged = .false.
            chNotConverged = 'He2 4-3   '
            if(lgPunConv)write(ipPunConv,'('' He2 4-3'')')
          endif
        endif
        if(lgPunConv.and.lgConverged)write(ipPunConv,'('' converged'')')
*       lower limit to number of iterations if converged
        if(lgConverged) itermx = min( itermx , iter )
*
*     >>chng 96 dec 20, moved following to within if on lgAutoIt
*       this is test for stopping on first zone
        if( te.lt.tend .and. nzone.eq.1 ) then
          lgConverged = .true.
          chNotConverged = '          '
          itermx = min( itermx , iter )
        endif
      endif
*
*     must take average of old and new optical depths - were old in place?
*
      if( iter.le.1 ) then
*       this is first pass
        f1 = 1.
        lgTauOscil = .false.
        lgTauHeOscil = .false.
        lgEverOscil = .false.
      else
*     >>chng 96 june 6, kill logic for oscillations, do not use optical depths
*this was too conservative.  instead check whether i-front breaking out
*by looking at electron fractions
        if( (OldEfrac-0.98)*(ElecFrac-0.98) .lt.0. ) then
          f1 = 0.2
          lgTauOscil = .true.
        else
*         no oscillations, save to speed up convergence
          f1 = 0.75
          lgTauOscil = .false.
        endif
*       this will affect convergence speed - use 75% of new result,
*       25 old damping
*       dec 15 95 changed to 0.75 as per Kirk's tests on convergence
*       of Lya in blr
*       convergence for lines appears below in sep statement
*       first find out whether H or He lyman lines are oscillating
*       if( OldDTau*(htlim(2,1)-htau(2,1)*DoubleTau).lt.0. ) then
*         lgTauOscil = .true.
*         lgEverOscil = .true.
*       else
*         lgTauOscil = .false.
*         lgEverOscil = .true.
*       endif
*       if( OldHe1DTau*(he1lim(2,1)-he1tau(2,1)*DoubleTau).lt.0. ) then
*         lgTauHeOscil = .true.
*       else
*         lgTauHeOscil = .false.
*       endif
*       now find how much old and new to take
*       if( lgTauHeOscil.or.lgTauOscil ) then
*     >>chng 96 jan 10 was .5, change to .25 as per kirk's oscillating runs
*         f1 = 0.2
*       else if( lgEverOscil ) then
*         f1 = 0.3
*       else 
*         f1 = 0.5
*       endif
*       write(qq,'('' were lyman lines oscillating??'',2l2)')
*    1  lgTauOscil,lgTauHeOscil
      endif
*     will use this to check on electron density oscillations
      OldEfrac = ElecFrac
      OldDTau = htlim(2,1) - htau(2,1)*DoubleTau
      OldHe1DTau = he1lim(2,1) - he1tau(2,1)*DoubleTau
      AverFac = f1
      f2 = 1. - f1
*
*     static is false unless sphere static set
      if( lgStatic ) then
        do i=2,nhlvl
          if( iter.eq.1 ) then
*           for initial iteration "zero" of ly a optical
*           scale may have been set to one in routine tauout
            TauOff = TAddHLya * hopac(i,1)/hopac(2,1)
          else
            TauOff = 0.
          endif
*         delta below is actual optical depth from illuminated face
*         NB - this code is only for static lines!
*         htlim(i,1) = (htau(i,1)-TauOff)*f1*DoubleTau + htlim(i,1)*f2
          htlim(i,1) = 10.**(
     1    log10(max(taumin,(htau(i,1)-TauOff)*DoubleTau))*f1 + 
     1    log10(max(taumin,htlim(i,1)) )*f2 )
          if(htlim(i,1).le.0. ) then
*           this probably due to underflow above
            htlim(i,1) = TauOff / 1e6
          endif
          htnext(i,1) = htlim(i,1) / 2.
          htau(i,1) = htlim(i,1) / 2.
        end do
        do i=2,nhe1lvl
*         DoubleTau is usually 1, set to 2 with the DoubleTau option to
*         simulate two-sided photoionization
          if( iter.eq.1 ) then
            TauOff = TAddHeI * he1opc(i,1)/he1opc(2,1)
          else
            TauOff = 0.
          endif
*         he1lim(i,1) = (he1tau(i,1)-TauOff)*f1*DoubleTau + he1lim(i,1)*f2
          he1lim(i,1) = 10.**(
     1    log10(max(taumin,(he1tau(i,1)-TauOff)*DoubleTau))*f1 + 
     1    log10(max(taumin,he1lim(i,1)) )*f2 )
          if(he1lim(i,1).le.0. ) then
*           this probably due to underflow above
            he1lim(i,1) = TauOff / 1e6
          endif
          he1nxt(i,1) = he1lim(i,1) / 2.
          he1tau(i,1) = he1lim(i,1) / 2.
        end do
        do i=2,nhe2lvl
          if( iter.eq.1 ) then
            TauOff = TAddHeII * he2opc(i,1)/he2opc(2,1)
          else
            TauOff = 0.
          endif
*         he2lim(i,1) = (he2tau(i,1)-TauOff)*f1*DoubleTau + he2lim(i,1)*f2
          he2lim(i,1) = 10.**(
     1    log10(max(taumin,(he2tau(i,1)-TauOff)*DoubleTau))*f1 + 
     1    log10(max(taumin,he2lim(i,1)) )*f2 )
          if(he2lim(i,1).le.0. ) then
*           this probably due to underflow above
            he2lim(i,1) = TauOff / 1e6
          endif
          he2nxt(i,1) = he2lim(i,1) / 2.
          he2tau(i,1) = he2lim(i,1) / 2.
        end do
      else
        do i=2,nhlvl
          if( iter.eq.1 ) then
*           for initial iteration "zero" of ly a optical
*           scale may have been set to one in routine tauout
            TauOff = TAddHLya * hopac(i,1)/hopac(2,1)
          else
            TauOff = 0.
          endif
*         NB this is the expanding line sphere code
*         htlim(i,1) = (htau(i,1)-TauOff)*f1 * DoubleTau + htlim(i,1) * f2
          htlim(i,1) = 10.**(
     1    log10(max(taumin,(htau(i,1)-TauOff)*DoubleTau))*f1 + 
     1    log10(max(taumin,htlim(i,1)) )*f2 )
          if(htlim(i,1).le.0. ) then
*           this probably due to underflow above
            htlim(i,1) = TauOff / 1e6
          endif
          htnext(i,1) = min(taumin,htlim(i,1)/2.)
          htau(i,1) = min(taumin,htlim(i,1)/2.)
        end do
        do i=2,nhe1lvl
*         DoubleTau is usually 1, set to 2 with the DoubleTau option to
*         simulate two-sided photoionization
          if( iter.eq.1 ) then
            TauOff = TAddHeI * he1opc(i,1)/he1opc(2,1)
          else
            TauOff = 0.
          endif
*         he1lim(i,1) = (he1tau(i,1)-TauOff)*f1*DoubleTau + he1lim(i,1)*f2
          he1lim(i,1) = 10.**(
     1    log10(max(taumin,(he1tau(i,1)-TauOff)*DoubleTau))*f1 + 
     1    log10(max(taumin,he1lim(i,1)) )*f2 )
          if(he1lim(i,1).le.0. ) then
*           this probably due to underflow above
            he1lim(i,1) = TauOff / 1e6
          endif
          he1nxt(i,1) = min(taumin,he1lim(i,1)/2. )
          he1tau(i,1) = min(taumin,he1lim(i,1)/2. )
        end do
        do i=2,nhe2lvl
          if( iter.eq.1 ) then
            TauOff = TAddHeII * he2opc(i,1)/he2opc(2,1)
          else
            TauOff = 0.
          endif
*         he2lim(i,1) = (he2tau(i,1)-TauOff)*f1*DoubleTau + he2lim(i,1)*f2
          he2lim(i,1) = 10.**(
     1    log10(max(taumin,(he2tau(i,1)-TauOff)*DoubleTau))*f1 + 
     1    log10(max(taumin,he2lim(i,1)) )*f2 )
          if(he2lim(i,1).le.0. ) then
*           this probably due to underflow above
            he2lim(i,1) = TauOff / 1e6
          endif
          he2nxt(i,1) = min(taumin,he2lim(i,1)/2.)
          he2tau(i,1) = min(taumin,he2lim(i,1)/2.)
        end do
      endif
*
*     >>chng 96 may 31, commented out below, so use same factors as before
*     if( lgTauOutOn ) then
*       these factors are used for excited H and He lines
*       this is to speed convergence for lines -
*       continuum appeared above in sep statement
*       f1 = 0.75
*     >>chng 96 jan 9, to below by analogy with lyman lines, have not tested
*       this is done in parallel with change from arith to log average
*       f1 = 0.5
*     >>chng 96 jan 12, change back to 0.75 to speed convergence
*       f1 = 0.75
*     else
*       f1 = 1.
*     endif
*     f2 = 1. - f1
*
      if( lgStatic ) then
        do j=2,nhlvl-1
          do i=j+1,nhlvl
*     >>chng 96 jan 9, had been arith average, now log
*           htlim(i,j) = htau(i,j) * f1 * DoubleTau + htlim(i,j) * f2
            htlim(i,j) = 10.**(
     1      log10(max(taumin,(htau(i,j))*DoubleTau))*f1 + 
     1      log10(max(taumin,htlim(i,j)) )*f2 )
            htnext(i,j) = htlim(i,j) / 2.
            htau(i,j) = htlim(i,j) / 2.
          end do
        end do
        do j=2,nhe1lvl-1
          do i=j+1,nhe1lvl
*           he1lim(i,j) = he1tau(i,j)*f1*DoubleTau + he1lim(i,j) * f2
            he1lim(i,j) = 10.**(
     1      log10(max(taumin,(he1tau(i,j))*DoubleTau))*f1 + 
     1      log10(max(taumin,he1lim(i,j)) )*f2 )
            he1nxt(i,j) = he1lim(i,j) / 2.
            he1tau(i,j) = he1lim(i,j) / 2.
          end do
        end do
        do j=2,nhe2lvl-1
          do i=j+1,nhe2lvl
*           he2lim(i,j) = he2tau(i,j)*f1*DoubleTau + he2lim(i,j) * f2
            he2lim(i,j) = 10.**(
     1      log10(max(taumin,(he2tau(i,j))*DoubleTau))*f1 + 
     1      log10(max(taumin,he2lim(i,j)) )*f2 )
            he2nxt(i,j) = he2lim(i,j) / 2.
            he2tau(i,j) = he2lim(i,j) / 2.
          end do
        end do
      else
        do j=2,nhlvl-1
          do i=j+1,nhlvl
*           htlim(i,j) = htau(i,j) * f1 * DoubleTau + htlim(i,j) * F2
            htlim(i,j) = 10.**(
     1      log10(max(taumin,(htau(i,j))*DoubleTau))*f1 + 
     1      log10(max(taumin,htlim(i,j)) )*f2 )
            htnext(i,j) = min(taumin,htlim(i,j)/2.)
            htau(i,j) = min(taumin,htlim(i,j)/2.)
          end do
        end do
        do j=2,nhe1lvl-1
          do i=j+1,nhe1lvl
*           he1lim(i,j) = he1tau(i,j)*f1*DoubleTau + he1lim(i,j) * f2
            he1lim(i,j) = 10.**(
     1      log10(max(taumin,(he1tau(i,j))*DoubleTau))*f1 + 
     1      log10(max(taumin,he1lim(i,j)) )*f2 )
            he1nxt(i,j) = min(taumin,he1lim(i,j)/2.)
            he1tau(i,j) = min(taumin,he1lim(i,j)/2.)
          end do
        end do
        do j=2,nhe2lvl-1
          do i=j+1,nhe2lvl
*           he2lim(i,j) = he2tau(i,j)*f1*DoubleTau + he2lim(i,j) * f2
            he2lim(i,j) = 10.**(
     1      log10(max(taumin,(he2tau(i,j))*DoubleTau))*f1 + 
     1      log10(max(taumin,he2lim(i,j)) )*f2 )
            he2nxt(i,j) = min(taumin,he2lim(i,j)/2.)
            he2tau(i,j) = min(taumin,he2lim(i,j)/2.)
          end do
        end do
      endif
*
*     force hydrogen outward optical depths to be on
      lgTauOutOn = .true.
*
*     possibly fix La optical depths
*     tlamin is set to large number when case b set
      if( tlamin.gt. 1e-5 .and. (.not.lgStatic) .or.lgCaseb) then
        htau(2,1) = tlamin
        htlim(2,1) = tlamin*2.
        htnext(2,1) = tlamin
        f = tlamin / hopac(2,1)
        fhe1 = tlamin / he1opc(2,1)
        he1tau(2,1) = tlamin
        he1lim(2,1) = tlamin*2.
        he1nxt(2,1) = tlamin
        he2tau(2,1) = tlamin
        he2lim(2,1) = tlamin*2.
        he2nxt(2,1) = tlamin
        fhe2 = tlamin / he2opc(2,1)
        do i=3,nhlvl
          htau(i,1) = f * hopac(i,1)
          htnext(i,1) = htau(i,1)
          htlim(i,1) = htau(i,1) * 2.
        end do
        do i=3,nhe1lvl
          he1tau(i,1) = fhe1 * he1opc(i,1)
          he1lim(i,1) = he1tau(i,1)* 2.
          he1nxt(i,1) = he1tau(i,1)
        end do
        do i=3,nhe2lvl
          he2tau(i,1) = fhe1 * he2opc(i,1)
          he2lim(i,1) = he2tau(i,1) * 2.
          he2nxt(i,1) = he2tau(i,1)
        end do
      endif
*
*     following sets (1)=inward optical depth to TAUMIN,
*     (2)=outward = (log) mean of old optical depths,
*     sets (3) to escap prob for first zone
      do i=1,nhetau
        call tav( he3tau(1,i) , AverFac )
      end do
      call tav( t206 , AverFac )
*
      if( lgSphere ) then
        he1rec(1,2) = max( 0. , otsmin )
        he1rec(2,2) = 1.
        he2rec(1,2) = max( 0. , otsmin )
        he2rec(2,2) = 1.
      else
        he1rec(1,2) = receff( nhe1(1) )
        he2rec(1,2) = receff( nhe2(1) )
      endif
*
      telec = taumin
      thmin = taumin
*     all heavy element lines
      do i=1,nTauLines
        call tav( TauLines(1,i) , AverFac )
*     >>chng 96 july 6 following sanity check added
*begin sanity check
        if( abs(TauLines(ipLnTauIn,i)).gt.abs(TauLines(ipLnTauTot,i)))
     1    then
          write(qq,'('' UPDATE finds TauIn>TauOut, line='',i5,1p,
     1    2e10.2)')i , TauLines(ipLnTauIn,i), TauLines(ipLnTauTot,i)
          call ShowMe
          stop
        endif
*end sanity check
      end do
*
*     all heavy element lines not in cooling
      do i=1,NWINDLINE*nWindOn
        call tav( WindLine(1,i) , AverFac )
      end do
*
*     Verner's FeII atom
      if( chFeIIAtom .eq. 'Verner' ) then
        if(.not.lgSimKatya ) call TavFe2
      endif
*
*     now redo escape probabilities, but zero dest prob
      call MakeRT
      do i=1,nTauLines
        TauLines(ipLnDesP,i) = 0.
      end do
*
*     >>chng 96 sep 4, zeroed out dest prob due to DstWght added
      do i=1,nhe1lvl-1
        do j=i+1,nhe1lvl
          he1dst(j,i) = 0.
          he1dst(i,j) = 0.
        end do
      end do
      do i=1,nhe2lvl-1
        do j=i+1,nhe2lvl
          he2dst(j,i) = 0.
          he2dst(i,j) = 0.
        end do
      end do
      do i=1,nhlvl
        do j=i+1,nhlvl
          hdest(j,i) = 0.
          hdest(i,j) = 0.
        end do
      end do
*
      if( lgCaseb ) then
        do i=1,nupper
*         DEPABS and SCT are abs and sct optical depth for depth only
*         we will not change total optical depths, just reset inner to half
*         tauabs(i,2) = 2.*depabs(i)
          tauabs(i,1) = tauabs(i,2)/2.
*         tausct(i,2) = 2.*depsct(i)
          tausct(i,1) = tausct(i,2)/2.
          depsct(i) = taumin
          depabs(i) = taumin
        end do
      else if( lgSphere ) then
        do i=1,nupper
*         DEPABS and SCT are abs and sct optical depth for depth only
          tauabs(i,2) = 2.*depabs(i)
          tauabs(i,1) = depabs(i)
          tausct(i,2) = 2.*depsct(i)
          tausct(i,1) = depsct(i)
          tautot(i,2) = tausct(i,2) + tauabs(i,2)
          tautot(i,1) = tausct(i,1) + tauabs(i,1)
          depsct(i) = taumin
          depabs(i) = taumin
        end do
      else
        do i=1,nupper
          tautot(i,2) = tautot(i,1)
          tautot(i,1) = taumin
          tauabs(i,2) = tauabs(i,1)
          tauabs(i,1) = taumin
          tausct(i,2) = tausct(i,1)
          tausct(i,1) = taumin
          depsct(i) = taumin
          depabs(i) = taumin
        end do
      endif
*
*     this is optical depth at x-ray point defining effective optical depth
      tauxry = tauabs(ipxry,1)
*
      end
