******************************************************************************
      real function xinvrs ( y , a , b , u , v  , ifail ) 
      implicit none
*do inverse function for Cota's three-body recombination
      real y,a,b,u,v
      integer ifail
*
*     local variables
      integer itmax,i
      real xlog,bxu,fxdfx,fx,dfx,xx,x
      data itmax / 10 /
*
* inverts equation of the form :
*
*             Y = A + B * X ** U - V * LOG ( X )
*
      ifail   = 0
      xlog    = ( ( a - y ) / v )
      x       = 10. ** xlog
*
      do i = 1 , itmax
        bxu     = b * x ** u
        fx      = y - a - bxu + v * xlog
        dfx     = v * .4342945 - bxu * u 
*
        if( dfx.ne.0. ) then
          fxdfx = min( 0.2 , abs(fx/dfx) )
          xx = x * (1. - sign( fxdfx , fx/dfx ) )
        else
*     >>chng 96 feb 2 this added in case dfx ever 0
*  suggested by Peter van Hoof
          xx = x * (1. - sign( 0.2 , fx ) )
        endif
        if ( ( abs ( xx - x ) /  x ) .lt. 1.e-4 ) then
          xinvrs = xx
          return
        else
          x = xx
          if( x.lt.1e-30 ) then
             xinvrs = 100.
             ifail = 1
             return
          endif
          xlog = log10 ( x )
        endif
      end do
      xinvrs = xx
      ifail = 1
* 
      end
